/**
 * vis-network - network
 * http://visjs.org/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 6.2.0
 * @date    2019-10-27T16:35:36Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
 *
 * @license 
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
import"core-js/modules/es.array-buffer.slice";import"core-js/modules/es.data-view";import"core-js/modules/es.object.to-string";import"core-js/modules/es.array.for-each";import"core-js/modules/es.array.includes";import"core-js/modules/es.array.index-of";import"core-js/modules/es.array.splice";import"core-js/modules/es.function.name";import"core-js/modules/es.number.constructor";import"core-js/modules/es.regexp.exec";import"core-js/modules/es.string.includes";import"core-js/modules/es.string.split";import"core-js/modules/web.dom-collections.for-each";import"core-js/modules/es.array.map";import"core-js/modules/es.string.fixed";import"core-js/modules/es.array.some";import"core-js/modules/es.parse-float";import"core-js/modules/es.parse-int";import"core-js/modules/es.string.replace";import"core-js/modules/es.array.join";import"core-js/modules/es.array.slice";import"core-js/modules/es.regexp.constructor";import"core-js/modules/es.regexp.to-string";import"core-js/modules/es.string.match";import"core-js/modules/es.string.bold";import"core-js/modules/es.array.iterator";import"core-js/modules/es.object.assign";import"core-js/modules/web.dom-collections.iterator";import"core-js/modules/es.array.fill";import"core-js/modules/es.date.to-string";import"core-js/modules/es.object.keys";import"core-js/modules/es.math.hypot";import"core-js/modules/es.array.reverse";import"core-js/modules/es.number.is-finite";import"core-js/modules/es.array.sort";import"core-js/modules/es.symbol";import"core-js/modules/es.symbol.description";import"core-js/modules/es.symbol.iterator";import"core-js/modules/es.array.every";import"core-js/modules/es.array.filter";import"core-js/modules/es.set";import"core-js/modules/es.string.iterator";"undefined"!=typeof CanvasRenderingContext2D&&(CanvasRenderingContext2D.prototype.circle=function(e,t,i){this.beginPath(),this.arc(e,t,i,0,2*Math.PI,!1),this.closePath()},CanvasRenderingContext2D.prototype.square=function(e,t,i){this.beginPath(),this.rect(e-i,t-i,2*i,2*i),this.closePath()},CanvasRenderingContext2D.prototype.triangle=function(e,t,i){this.beginPath(),t+=.275*(i*=1.15);var n=2*i,o=n/2,s=Math.sqrt(3)/6*n,r=Math.sqrt(n*n-o*o);this.moveTo(e,t-(r-s)),this.lineTo(e+o,t+s),this.lineTo(e-o,t+s),this.lineTo(e,t-(r-s)),this.closePath()},CanvasRenderingContext2D.prototype.triangleDown=function(e,t,i){this.beginPath(),t-=.275*(i*=1.15);var n=2*i,o=n/2,s=Math.sqrt(3)/6*n,r=Math.sqrt(n*n-o*o);this.moveTo(e,t+(r-s)),this.lineTo(e+o,t-s),this.lineTo(e-o,t-s),this.lineTo(e,t+(r-s)),this.closePath()},CanvasRenderingContext2D.prototype.star=function(e,t,i){this.beginPath(),t+=.1*(i*=.82);for(var n=0;n<10;n++){var o=n%2==0?1.3*i:.5*i;this.lineTo(e+o*Math.sin(2*n*Math.PI/10),t-o*Math.cos(2*n*Math.PI/10))}this.closePath()},CanvasRenderingContext2D.prototype.diamond=function(e,t,i){this.beginPath(),this.lineTo(e,t+i),this.lineTo(e+i,t),this.lineTo(e,t-i),this.lineTo(e-i,t),this.closePath()},CanvasRenderingContext2D.prototype.roundRect=function(e,t,i,n,o){var s=Math.PI/180;i-2*o<0&&(o=i/2),n-2*o<0&&(o=n/2),this.beginPath(),this.moveTo(e+o,t),this.lineTo(e+i-o,t),this.arc(e+i-o,t+o,o,270*s,360*s,!1),this.lineTo(e+i,t+n-o),this.arc(e+i-o,t+n-o,o,0,90*s,!1),this.lineTo(e+o,t+n),this.arc(e+o,t+n-o,o,90*s,180*s,!1),this.lineTo(e,t+o),this.arc(e+o,t+o,o,180*s,270*s,!1),this.closePath()},CanvasRenderingContext2D.prototype.ellipse_vis=function(e,t,i,n){var o=i/2*.5522848,s=n/2*.5522848,r=e+i,a=t+n,h=e+i/2,d=t+n/2;this.beginPath(),this.moveTo(e,d),this.bezierCurveTo(e,d-s,h-o,t,h,t),this.bezierCurveTo(h+o,t,r,d-s,r,d),this.bezierCurveTo(r,d+s,h+o,a,h,a),this.bezierCurveTo(h-o,a,e,d+s,e,d),this.closePath()},CanvasRenderingContext2D.prototype.database=function(e,t,i,n){var o=n*(1/3),s=i/2*.5522848,r=o/2*.5522848,a=e+i,h=t+o,d=e+i/2,l=t+o/2,u=t+(n-o/2),c=t+n;this.beginPath(),this.moveTo(a,l),this.bezierCurveTo(a,l+r,d+s,h,d,h),this.bezierCurveTo(d-s,h,e,l+r,e,l),this.bezierCurveTo(e,l-r,d-s,t,d,t),this.bezierCurveTo(d+s,t,a,l-r,a,l),this.lineTo(a,u),this.bezierCurveTo(a,u+r,d+s,c,d,c),this.bezierCurveTo(d-s,c,e,u+r,e,u),this.lineTo(e,l)},CanvasRenderingContext2D.prototype.dashedLine=function(e,t,i,n,o){this.beginPath(),this.moveTo(e,t);for(var s=o.length,r=i-e,a=n-t,h=a/r,d=Math.sqrt(r*r+a*a),l=0,u=!0,c=0,f=+o[0];d>=.1;)(f=+o[l++%s])>d&&(f=d),c=Math.sqrt(f*f/(1+h*h)),e+=c=r<0?-c:c,t+=h*c,!0===u?this.lineTo(e,t):this.moveTo(e,t),d-=f,u=!u},CanvasRenderingContext2D.prototype.hexagon=function(e,t,i){this.beginPath();var n=2*Math.PI/6;this.moveTo(e+i,t);for(var o=1;o<6;o++)this.lineTo(e+i*Math.cos(n*o),t+i*Math.sin(n*o));this.closePath()});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function e(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function t(e,t){return e(t={exports:{}},t.exports),t.exports}var i=t((function(e){function t(e){if(e)return function(e){for(var i in t.prototype)e[i]=t.prototype[i];return e}(e)}e.exports=t,t.prototype.on=t.prototype.addEventListener=function(e,t){return this._callbacks=this._callbacks||{},(this._callbacks["$"+e]=this._callbacks["$"+e]||[]).push(t),this},t.prototype.once=function(e,t){function i(){this.off(e,i),t.apply(this,arguments)}return i.fn=t,this.on(e,i),this},t.prototype.off=t.prototype.removeListener=t.prototype.removeAllListeners=t.prototype.removeEventListener=function(e,t){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+e];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+e],this;for(var o=0;o<n.length;o++)if((i=n[o])===t||i.fn===t){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+e],this},t.prototype.emit=function(e){this._callbacks=this._callbacks||{};for(var t=new Array(arguments.length-1),i=this._callbacks["$"+e],n=1;n<arguments.length;n++)t[n-1]=arguments[n];if(i){n=0;for(var o=(i=i.slice(0)).length;n<o;++n)i[n].apply(this,t)}return this},t.prototype.listeners=function(e){return this._callbacks=this._callbacks||{},this._callbacks["$"+e]||[]},t.prototype.hasListeners=function(e){return!!this.listeners(e).length}}));"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function n(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function o(e,t){return e(t={exports:{}},t.exports),t.exports}var s=o((function(e){var t=e.exports="undefined"!=typeof window&&window.Math==Math?window:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")();"number"==typeof __g&&(__g=t)})),r=o((function(e){var t=e.exports={version:"2.6.9"};"number"==typeof __e&&(__e=t)})),a=(r.version,o((function(e){var t=s["__core-js_shared__"]||(s["__core-js_shared__"]={});(e.exports=function(e,i){return t[e]||(t[e]=void 0!==i?i:{})})("versions",[]).push({version:r.version,mode:"global",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})}))),h=0,d=Math.random(),l=function(e){return"Symbol(".concat(void 0===e?"":e,")_",(++h+d).toString(36))},u=o((function(e){var t=a("wks"),i=s.Symbol,n="function"==typeof i;(e.exports=function(e){return t[e]||(t[e]=n&&i[e]||(n?i:l)("Symbol."+e))}).store=t})),c={f:u},f=function(e){return"object"==typeof e?null!==e:"function"==typeof e},p=function(e){if(!f(e))throw TypeError(e+" is not an object!");return e},v=function(e){try{return!!e()}catch(e){return!0}},m=!v((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),g=s.document,y=f(g)&&f(g.createElement),b=function(e){return y?g.createElement(e):{}},_=!m&&!v((function(){return 7!=Object.defineProperty(b("div"),"a",{get:function(){return 7}}).a})),w=function(e,t){if(!f(e))return e;var i,n;if(t&&"function"==typeof(i=e.toString)&&!f(n=i.call(e)))return n;if("function"==typeof(i=e.valueOf)&&!f(n=i.call(e)))return n;if(!t&&"function"==typeof(i=e.toString)&&!f(n=i.call(e)))return n;throw TypeError("Can't convert object to primitive value")},k=Object.defineProperty,x={f:m?Object.defineProperty:function(e,t,i){if(p(e),t=w(t,!0),p(i),_)try{return k(e,t,i)}catch(e){}if("get"in i||"set"in i)throw TypeError("Accessors not supported!");return"value"in i&&(e[t]=i.value),e}},S=x.f,O=function(e){var t=r.Symbol||(r.Symbol=s.Symbol||{});"_"==e.charAt(0)||e in t||S(t,e,{value:c.f(e)})};O("asyncIterator");var D={}.hasOwnProperty,M=function(e,t){return D.call(e,t)},T=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}},E=m?function(e,t,i){return x.f(e,t,T(1,i))}:function(e,t,i){return e[t]=i,e},C=a("native-function-to-string",Function.toString),P=o((function(e){var t=l("src"),i=(""+C).split("toString");r.inspectSource=function(e){return C.call(e)},(e.exports=function(e,n,o,r){var a="function"==typeof o;a&&(M(o,"name")||E(o,"name",n)),e[n]!==o&&(a&&(M(o,t)||E(o,t,e[n]?""+e[n]:i.join(String(n)))),e===s?e[n]=o:r?e[n]?e[n]=o:E(e,n,o):(delete e[n],E(e,n,o)))})(Function.prototype,"toString",(function(){return"function"==typeof this&&this[t]||C.call(this)}))})),I=function(e){if("function"!=typeof e)throw TypeError(e+" is not a function!");return e},F=function(e,t,i){if(I(e),void 0===t)return e;switch(i){case 1:return function(i){return e.call(t,i)};case 2:return function(i,n){return e.call(t,i,n)};case 3:return function(i,n,o){return e.call(t,i,n,o)}}return function(){return e.apply(t,arguments)}},N=function(e,t,i){var n,o,a,h,d=e&N.F,l=e&N.G,u=e&N.S,c=e&N.P,f=e&N.B,p=l?s:u?s[t]||(s[t]={}):(s[t]||{}).prototype,v=l?r:r[t]||(r[t]={}),m=v.prototype||(v.prototype={});for(n in l&&(i=t),i)a=((o=!d&&p&&void 0!==p[n])?p:i)[n],h=f&&o?F(a,s):c&&"function"==typeof a?F(Function.call,a):a,p&&P(p,n,a,e&N.U),v[n]!=a&&E(v,n,h),c&&m[n]!=a&&(m[n]=a)};s.core=r,N.F=1,N.G=2,N.S=4,N.P=8,N.B=16,N.W=32,N.U=64,N.R=128;var Y,R=N,j=o((function(e){var t=l("meta"),i=x.f,n=0,o=Object.isExtensible||function(){return!0},s=!v((function(){return o(Object.preventExtensions({}))})),r=function(e){i(e,t,{value:{i:"O"+ ++n,w:{}}})},a=e.exports={KEY:t,NEED:!1,fastKey:function(e,i){if(!f(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!M(e,t)){if(!o(e))return"F";if(!i)return"E";r(e)}return e[t].i},getWeak:function(e,i){if(!M(e,t)){if(!o(e))return!0;if(!i)return!1;r(e)}return e[t].w},onFreeze:function(e){return s&&a.NEED&&o(e)&&!M(e,t)&&r(e),e}}})),A=(j.KEY,j.NEED,j.fastKey,j.getWeak,j.onFreeze,x.f),z=u("toStringTag"),B=function(e,t,i){e&&!M(e=i?e:e.prototype,z)&&A(e,z,{configurable:!0,value:t})},L={}.toString,H=function(e){return L.call(e).slice(8,-1)},W=Object("z").propertyIsEnumerable(0)?Object:function(e){return"String"==H(e)?e.split(""):Object(e)},V=function(e){if(null==e)throw TypeError("Can't call method on  "+e);return e},U=function(e){return W(V(e))},G=Math.ceil,q=Math.floor,Z=function(e){return isNaN(e=+e)?0:(e>0?q:G)(e)},X=Math.min,$=function(e){return e>0?X(Z(e),9007199254740991):0},K=Math.max,J=Math.min,Q=a("keys"),ee=function(e){return Q[e]||(Q[e]=l(e))},te=(Y=!1,function(e,t,i){var n,o=U(e),s=$(o.length),r=function(e,t){return(e=Z(e))<0?K(e+t,0):J(e,t)}(i,s);if(Y&&t!=t){for(;s>r;)if((n=o[r++])!=n)return!0}else for(;s>r;r++)if((Y||r in o)&&o[r]===t)return Y||r||0;return!Y&&-1}),ie=ee("IE_PROTO"),ne=function(e,t){var i,n=U(e),o=0,s=[];for(i in n)i!=ie&&M(n,i)&&s.push(i);for(;t.length>o;)M(n,i=t[o++])&&(~te(s,i)||s.push(i));return s},oe="constructor,hasOwnProperty,isPrototypeOf,propertyIsEnumerable,toLocaleString,toString,valueOf".split(","),se=Object.keys||function(e){return ne(e,oe)},re={f:Object.getOwnPropertySymbols},ae={f:{}.propertyIsEnumerable},he=Array.isArray||function(e){return"Array"==H(e)},de=function(e){return Object(V(e))},le=m?Object.defineProperties:function(e,t){p(e);for(var i,n=se(t),o=n.length,s=0;o>s;)x.f(e,i=n[s++],t[i]);return e},ue=s.document,ce=ue&&ue.documentElement,fe=ee("IE_PROTO"),pe=function(){},ve=function(){var e,t=b("iframe"),i=oe.length;for(t.style.display="none",ce.appendChild(t),t.src="javascript:",(e=t.contentWindow.document).open(),e.write("<script>document.F=Object<\/script>"),e.close(),ve=e.F;i--;)delete ve.prototype[oe[i]];return ve()},me=Object.create||function(e,t){var i;return null!==e?(pe.prototype=p(e),i=new pe,pe.prototype=null,i[fe]=e):i=ve(),void 0===t?i:le(i,t)},ge=oe.concat("length","prototype"),ye={f:Object.getOwnPropertyNames||function(e){return ne(e,ge)}},be=ye.f,_e={}.toString,we="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],ke={f:function(e){return we&&"[object Window]"==_e.call(e)?function(e){try{return be(e)}catch(e){return we.slice()}}(e):be(U(e))}},xe=Object.getOwnPropertyDescriptor,Se={f:m?xe:function(e,t){if(e=U(e),t=w(t,!0),_)try{return xe(e,t)}catch(e){}if(M(e,t))return T(!ae.f.call(e,t),e[t])}},Oe=j.KEY,De=Se.f,Me=x.f,Te=ke.f,Ee=s.Symbol,Ce=s.JSON,Pe=Ce&&Ce.stringify,Ie=u("_hidden"),Fe=u("toPrimitive"),Ne={}.propertyIsEnumerable,Ye=a("symbol-registry"),Re=a("symbols"),je=a("op-symbols"),Ae=Object.prototype,ze="function"==typeof Ee&&!!re.f,Be=s.QObject,Le=!Be||!Be.prototype||!Be.prototype.findChild,He=m&&v((function(){return 7!=me(Me({},"a",{get:function(){return Me(this,"a",{value:7}).a}})).a}))?function(e,t,i){var n=De(Ae,t);n&&delete Ae[t],Me(e,t,i),n&&e!==Ae&&Me(Ae,t,n)}:Me,We=function(e){var t=Re[e]=me(Ee.prototype);return t._k=e,t},Ve=ze&&"symbol"==typeof Ee.iterator?function(e){return"symbol"==typeof e}:function(e){return e instanceof Ee},Ue=function(e,t,i){return e===Ae&&Ue(je,t,i),p(e),t=w(t,!0),p(i),M(Re,t)?(i.enumerable?(M(e,Ie)&&e[Ie][t]&&(e[Ie][t]=!1),i=me(i,{enumerable:T(0,!1)})):(M(e,Ie)||Me(e,Ie,T(1,{})),e[Ie][t]=!0),He(e,t,i)):Me(e,t,i)},Ge=function(e,t){p(e);for(var i,n=function(e){var t=se(e),i=re.f;if(i)for(var n,o=i(e),s=ae.f,r=0;o.length>r;)s.call(e,n=o[r++])&&t.push(n);return t}(t=U(t)),o=0,s=n.length;s>o;)Ue(e,i=n[o++],t[i]);return e},qe=function(e){var t=Ne.call(this,e=w(e,!0));return!(this===Ae&&M(Re,e)&&!M(je,e))&&(!(t||!M(this,e)||!M(Re,e)||M(this,Ie)&&this[Ie][e])||t)},Ze=function(e,t){if(e=U(e),t=w(t,!0),e!==Ae||!M(Re,t)||M(je,t)){var i=De(e,t);return!i||!M(Re,t)||M(e,Ie)&&e[Ie][t]||(i.enumerable=!0),i}},Xe=function(e){for(var t,i=Te(U(e)),n=[],o=0;i.length>o;)M(Re,t=i[o++])||t==Ie||t==Oe||n.push(t);return n},$e=function(e){for(var t,i=e===Ae,n=Te(i?je:U(e)),o=[],s=0;n.length>s;)!M(Re,t=n[s++])||i&&!M(Ae,t)||o.push(Re[t]);return o};ze||(P((Ee=function(){if(this instanceof Ee)throw TypeError("Symbol is not a constructor!");var e=l(arguments.length>0?arguments[0]:void 0),t=function(i){this===Ae&&t.call(je,i),M(this,Ie)&&M(this[Ie],e)&&(this[Ie][e]=!1),He(this,e,T(1,i))};return m&&Le&&He(Ae,e,{configurable:!0,set:t}),We(e)}).prototype,"toString",(function(){return this._k})),Se.f=Ze,x.f=Ue,ye.f=ke.f=Xe,ae.f=qe,re.f=$e,m&&P(Ae,"propertyIsEnumerable",qe,!0),c.f=function(e){return We(u(e))}),R(R.G+R.W+R.F*!ze,{Symbol:Ee});for(var Ke="hasInstance,isConcatSpreadable,iterator,match,replace,search,species,split,toPrimitive,toStringTag,unscopables".split(","),Je=0;Ke.length>Je;)u(Ke[Je++]);for(var Qe=se(u.store),et=0;Qe.length>et;)O(Qe[et++]);R(R.S+R.F*!ze,"Symbol",{for:function(e){return M(Ye,e+="")?Ye[e]:Ye[e]=Ee(e)},keyFor:function(e){if(!Ve(e))throw TypeError(e+" is not a symbol!");for(var t in Ye)if(Ye[t]===e)return t},useSetter:function(){Le=!0},useSimple:function(){Le=!1}}),R(R.S+R.F*!ze,"Object",{create:function(e,t){return void 0===t?me(e):Ge(me(e),t)},defineProperty:Ue,defineProperties:Ge,getOwnPropertyDescriptor:Ze,getOwnPropertyNames:Xe,getOwnPropertySymbols:$e});var tt=v((function(){re.f(1)}));function it(e){return(it="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function nt(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function ot(e,t){var i=Object.keys(e);return Object.getOwnPropertySymbols&&i.push.apply(i,Object.getOwnPropertySymbols(e)),t&&(i=i.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),i}function st(e){return function(e){if(Array.isArray(e)){for(var t=0,i=new Array(e.length);t<e.length;t++)i[t]=e[t];return i}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}R(R.S+R.F*tt,"Object",{getOwnPropertySymbols:function(e){return re.f(de(e))}}),Ce&&R(R.S+R.F*(!ze||v((function(){var e=Ee();return"[null]"!=Pe([e])||"{}"!=Pe({a:e})||"{}"!=Pe(Object(e))}))),"JSON",{stringify:function(e){for(var t,i,n=[e],o=1;arguments.length>o;)n.push(arguments[o++]);if(i=t=n[1],(f(t)||void 0!==e)&&!Ve(e))return he(t)||(t=function(e,t){if("function"==typeof i&&(t=i.call(this,e,t)),!Ve(t))return t}),n[1]=t,Pe.apply(Ce,n)}}),Ee.prototype[Fe]||E(Ee.prototype,Fe,Ee.prototype.valueOf),B(Ee,"Symbol"),B(Math,"Math",!0),B(s.JSON,"JSON",!0);var rt,at,ht,dt;rt="keys",at=function(){return function(e){return se(de(e))}},ht=(r.Object||{})[rt]||Object[rt],(dt={})[rt]=at(ht),R(R.S+R.F*v((function(){ht(1)})),"Object",dt);var lt=function(){var e=p(this),t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),e.sticky&&(t+="y"),t};m&&"g"!=/./g.flags&&x.f(RegExp.prototype,"flags",{configurable:!0,get:lt});var ut=/./.toString,ct=function(e){P(RegExp.prototype,"toString",e,!0)};v((function(){return"/a/b"!=ut.call({source:"a",flags:"b"})}))?ct((function(){var e=p(this);return"/".concat(e.source,"/","flags"in e?e.flags:!m&&e instanceof RegExp?lt.call(e):void 0)})):"toString"!=ut.name&&ct((function(){return ut.call(this)}));var ft,pt,vt=function(e){return function(t,i){var n,o,s=String(V(t)),r=Z(i),a=s.length;return r<0||r>=a?e?"":void 0:(n=s.charCodeAt(r))<55296||n>56319||r+1===a||(o=s.charCodeAt(r+1))<56320||o>57343?e?s.charAt(r):n:e?s.slice(r,r+2):o-56320+(n-55296<<10)+65536}}(!0),mt=function(e,t,i){return t+(i?vt(e,t).length:1)},gt=u("toStringTag"),yt="Arguments"==H(function(){return arguments}()),bt=function(e){var t,i,n;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(i=function(e,t){try{return e[t]}catch(e){}}(t=Object(e),gt))?i:yt?H(t):"Object"==(n=H(t))&&"function"==typeof t.callee?"Arguments":n},_t=RegExp.prototype.exec,wt=function(e,t){var i=e.exec;if("function"==typeof i){var n=i.call(e,t);if("object"!=typeof n)throw new TypeError("RegExp exec method returned something other than an Object or null");return n}if("RegExp"!==bt(e))throw new TypeError("RegExp#exec called on incompatible receiver");return _t.call(e,t)},kt=RegExp.prototype.exec,xt=String.prototype.replace,St=kt,Ot=(ft=/a/,pt=/b*/g,kt.call(ft,"a"),kt.call(pt,"a"),0!==ft.lastIndex||0!==pt.lastIndex),Dt=void 0!==/()??/.exec("")[1];(Ot||Dt)&&(St=function(e){var t,i,n,o,s=this;return Dt&&(i=new RegExp("^"+s.source+"$(?!\\s)",lt.call(s))),Ot&&(t=s.lastIndex),n=kt.call(s,e),Ot&&n&&(s.lastIndex=s.global?n.index+n[0].length:t),Dt&&n&&n.length>1&&xt.call(n[0],i,(function(){for(o=1;o<arguments.length-2;o++)void 0===arguments[o]&&(n[o]=void 0)})),n});var Mt=St;R({target:"RegExp",proto:!0,forced:Mt!==/./.exec},{exec:Mt});var Tt=u("species"),Et=!v((function(){var e=/./;return e.exec=function(){var e=[];return e.groups={a:"7"},e},"7"!=="".replace(e,"$<a>")})),Ct=function(){var e=/(?:)/,t=e.exec;e.exec=function(){return t.apply(this,arguments)};var i="ab".split(e);return 2===i.length&&"a"===i[0]&&"b"===i[1]}(),Pt=function(e,t,i){var n=u(e),o=!v((function(){var t={};return t[n]=function(){return 7},7!=""[e](t)})),s=o?!v((function(){var t=!1,i=/a/;return i.exec=function(){return t=!0,null},"split"===e&&(i.constructor={},i.constructor[Tt]=function(){return i}),i[n](""),!t})):void 0;if(!o||!s||"replace"===e&&!Et||"split"===e&&!Ct){var r=/./[n],a=i(V,n,""[e],(function(e,t,i,n,s){return t.exec===Mt?o&&!s?{done:!0,value:r.call(t,i,n)}:{done:!0,value:e.call(i,t,n)}:{done:!1}})),h=a[0],d=a[1];P(String.prototype,e,h),E(RegExp.prototype,n,2==t?function(e,t){return d.call(e,this,t)}:function(e){return d.call(e,this)})}},It=Math.max,Ft=Math.min,Nt=Math.floor,Yt=/\$([$&`']|\d\d?|<[^>]*>)/g,Rt=/\$([$&`']|\d\d?)/g;Pt("replace",2,(function(e,t,i,n){return[function(n,o){var s=e(this),r=null==n?void 0:n[t];return void 0!==r?r.call(n,s,o):i.call(String(s),n,o)},function(e,t){var s=n(i,e,this,t);if(s.done)return s.value;var r=p(e),a=String(this),h="function"==typeof t;h||(t=String(t));var d=r.global;if(d){var l=r.unicode;r.lastIndex=0}for(var u=[];;){var c=wt(r,a);if(null===c)break;if(u.push(c),!d)break;""===String(c[0])&&(r.lastIndex=mt(a,$(r.lastIndex),l))}for(var f,v="",m=0,g=0;g<u.length;g++){c=u[g];for(var y=String(c[0]),b=It(Ft(Z(c.index),a.length),0),_=[],w=1;w<c.length;w++)_.push(void 0===(f=c[w])?f:String(f));var k=c.groups;if(h){var x=[y].concat(_,b,a);void 0!==k&&x.push(k);var S=String(t.apply(void 0,x))}else S=o(y,a,b,_,k,t);b>=m&&(v+=a.slice(m,b)+S,m=b+y.length)}return v+a.slice(m)}];function o(e,t,n,o,s,r){var a=n+e.length,h=o.length,d=Rt;return void 0!==s&&(s=de(s),d=Yt),i.call(r,d,(function(i,r){var d;switch(r.charAt(0)){case"$":return"$";case"&":return e;case"`":return t.slice(0,n);case"'":return t.slice(a);case"<":d=s[r.slice(1,-1)];break;default:var l=+r;if(0===l)return i;if(l>h){var u=Nt(l/10);return 0===u?i:u<=h?void 0===o[u-1]?r.charAt(1):o[u-1]+r.charAt(1):i}d=o[l-1]}return void 0===d?"":d}))}}));var jt=u("unscopables"),At=Array.prototype;null==At[jt]&&E(At,jt,{});var zt=function(e){At[jt][e]=!0},Bt=function(e,t){return{value:t,done:!!e}},Lt={},Ht={};E(Ht,u("iterator"),(function(){return this}));var Wt=function(e,t,i){e.prototype=me(Ht,{next:T(1,i)}),B(e,t+" Iterator")},Vt=ee("IE_PROTO"),Ut=Object.prototype,Gt=Object.getPrototypeOf||function(e){return e=de(e),M(e,Vt)?e[Vt]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?Ut:null},qt=u("iterator"),Zt=!([].keys&&"next"in[].keys()),Xt=function(){return this},$t=function(e,t,i,n,o,s,r){Wt(i,t,n);var a,h,d,l=function(e){if(!Zt&&e in p)return p[e];switch(e){case"keys":case"values":return function(){return new i(this,e)}}return function(){return new i(this,e)}},u=t+" Iterator",c="values"==o,f=!1,p=e.prototype,v=p[qt]||p["@@iterator"]||o&&p[o],m=v||l(o),g=o?c?l("entries"):m:void 0,y="Array"==t&&p.entries||v;if(y&&(d=Gt(y.call(new e)))!==Object.prototype&&d.next&&(B(d,u,!0),"function"!=typeof d[qt]&&E(d,qt,Xt)),c&&v&&"values"!==v.name&&(f=!0,m=function(){return v.call(this)}),(Zt||f||!p[qt])&&E(p,qt,m),Lt[t]=m,Lt[u]=Xt,o)if(a={values:c?m:l("values"),keys:s?m:l("keys"),entries:g},r)for(h in a)h in p||P(p,h,a[h]);else R(R.P+R.F*(Zt||f),t,a);return a}(Array,"Array",(function(e,t){this._t=U(e),this._i=0,this._k=t}),(function(){var e=this._t,t=this._k,i=this._i++;return!e||i>=e.length?(this._t=void 0,Bt(1)):Bt(0,"keys"==t?i:"values"==t?e[i]:[i,e[i]])}),"values");Lt.Arguments=Lt.Array,zt("keys"),zt("values"),zt("entries");for(var Kt=u("iterator"),Jt=u("toStringTag"),Qt=Lt.Array,ei={CSSRuleList:!0,CSSStyleDeclaration:!1,CSSValueList:!1,ClientRectList:!1,DOMRectList:!1,DOMStringList:!1,DOMTokenList:!0,DataTransferItemList:!1,FileList:!1,HTMLAllCollection:!1,HTMLCollection:!1,HTMLFormElement:!1,HTMLSelectElement:!1,MediaList:!0,MimeTypeArray:!1,NamedNodeMap:!1,NodeList:!0,PaintRequestList:!1,Plugin:!1,PluginArray:!1,SVGLengthList:!1,SVGNumberList:!1,SVGPathSegList:!1,SVGPointList:!1,SVGStringList:!1,SVGTransformList:!1,SourceBufferList:!1,StyleSheetList:!0,TextTrackCueList:!1,TextTrackList:!1,TouchList:!1},ti=se(ei),ii=0;ii<ti.length;ii++){var ni,oi=ti[ii],si=ei[oi],ri=s[oi],ai=ri&&ri.prototype;if(ai&&(ai[Kt]||E(ai,Kt,Qt),ai[Jt]||E(ai,Jt,oi),Lt[oi]=Qt,si))for(ni in $t)ai[ni]||P(ai,ni,$t[ni],!0)}var hi={};hi[u("toStringTag")]="z",hi+""!="[object z]"&&P(Object.prototype,"toString",(function(){return"[object "+bt(this)+"]"}),!0);var di,li=ae.f,ui=(di=!1,function(e){for(var t,i=U(e),n=se(i),o=n.length,s=0,r=[];o>s;)t=n[s++],m&&!li.call(i,t)||r.push(di?[t,i[t]]:i[t]);return r});R(R.S,"Object",{values:function(e){return ui(e)}});var ci=u("match"),fi=u("species"),pi=Math.min,vi=[].push,mi=!v((function(){RegExp(4294967295,"y")}));Pt("split",2,(function(e,t,i,n){var o;return o="c"=="abbc".split(/(b)*/)[1]||4!="test".split(/(?:)/,-1).length||2!="ab".split(/(?:ab)*/).length||4!=".".split(/(.?)(.?)/).length||".".split(/()()/).length>1||"".split(/.?/).length?function(e,t){var n,o,s=String(this);if(void 0===e&&0===t)return[];if(!f(n=e)||(void 0!==(o=n[ci])?!o:"RegExp"!=H(n)))return i.call(s,e,t);for(var r,a,h,d=[],l=(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")+(e.sticky?"y":""),u=0,c=void 0===t?4294967295:t>>>0,p=new RegExp(e.source,l+"g");(r=Mt.call(p,s))&&!((a=p.lastIndex)>u&&(d.push(s.slice(u,r.index)),r.length>1&&r.index<s.length&&vi.apply(d,r.slice(1)),h=r[0].length,u=a,d.length>=c));)p.lastIndex===r.index&&p.lastIndex++;return u===s.length?!h&&p.test("")||d.push(""):d.push(s.slice(u)),d.length>c?d.slice(0,c):d}:"0".split(void 0,0).length?function(e,t){return void 0===e&&0===t?[]:i.call(this,e,t)}:i,[function(i,n){var s=e(this),r=null==i?void 0:i[t];return void 0!==r?r.call(i,s,n):o.call(String(s),i,n)},function(e,t){var s=n(o,e,this,t,o!==i);if(s.done)return s.value;var r=p(e),a=String(this),h=function(e,t){var i,n=p(e).constructor;return void 0===n||null==(i=p(n)[fi])?t:I(i)}(r,RegExp),d=r.unicode,l=(r.ignoreCase?"i":"")+(r.multiline?"m":"")+(r.unicode?"u":"")+(mi?"y":"g"),u=new h(mi?r:"^(?:"+r.source+")",l),c=void 0===t?4294967295:t>>>0;if(0===c)return[];if(0===a.length)return null===wt(u,a)?[a]:[];for(var f=0,v=0,m=[];v<a.length;){u.lastIndex=mi?v:0;var g,y=wt(u,mi?a:a.slice(v));if(null===y||(g=pi($(u.lastIndex+(mi?0:v)),a.length))===f)v=mt(a,v,d);else{if(m.push(a.slice(f,v)),m.length===c)return m;for(var b=1;b<=y.length-1;b++)if(m.push(y[b]),m.length===c)return m;v=f=g}}return m.push(a.slice(f)),m}]}));var gi=Object.assign,yi=!gi||v((function(){var e={},t={},i=Symbol(),n="abcdefghijklmnopqrst";return e[i]=7,n.split("").forEach((function(e){t[e]=e})),7!=gi({},e)[i]||Object.keys(gi({},t)).join("")!=n}))?function(e,t){for(var i=de(e),n=arguments.length,o=1,s=re.f,r=ae.f;n>o;)for(var a,h=W(arguments[o++]),d=s?se(h).concat(s(h)):se(h),l=d.length,u=0;l>u;)a=d[u++],m&&!r.call(h,a)||(i[a]=h[a]);return i}:gi;R(R.S+R.F,"Object",{assign:yi});var bi=function(e,t){if(p(e),!f(t)&&null!==t)throw TypeError(t+": can't set as prototype!")},_i={set:Object.setPrototypeOf||("__proto__"in{}?function(e,t,i){try{(i=F(Function.call,Se.f(Object.prototype,"__proto__").set,2))(e,[]),t=!(e instanceof Array)}catch(e){t=!0}return function(e,n){return bi(e,n),t?e.__proto__=n:i(e,n),e}}({},!1):void 0),check:bi}.set,wi=function(e,t,i){var n,o=t.constructor;return o!==i&&"function"==typeof o&&(n=o.prototype)!==i.prototype&&f(n)&&_i&&_i(e,n),e},ki="\t\n\v\f\r   ᠎             　\u2028\u2029\ufeff",xi="["+ki+"]",Si=RegExp("^"+xi+xi+"*"),Oi=RegExp(xi+xi+"*$"),Di=function(e,t,i){var n={},o=v((function(){return!!ki[e]()||"​"!="​"[e]()})),s=n[e]=o?t(Mi):ki[e];i&&(n[i]=s),R(R.P+R.F*o,"String",n)},Mi=Di.trim=function(e,t){return e=String(V(e)),1&t&&(e=e.replace(Si,"")),2&t&&(e=e.replace(Oi,"")),e},Ti=Di,Ei=ye.f,Ci=Se.f,Pi=x.f,Ii=Ti.trim,Fi=s.Number,Ni=Fi,Yi=Fi.prototype,Ri="Number"==H(me(Yi)),ji="trim"in String.prototype,Ai=function(e){var t=w(e,!1);if("string"==typeof t&&t.length>2){var i,n,o,s=(t=ji?t.trim():Ii(t,3)).charCodeAt(0);if(43===s||45===s){if(88===(i=t.charCodeAt(2))||120===i)return NaN}else if(48===s){switch(t.charCodeAt(1)){case 66:case 98:n=2,o=49;break;case 79:case 111:n=8,o=55;break;default:return+t}for(var r,a=t.slice(2),h=0,d=a.length;h<d;h++)if((r=a.charCodeAt(h))<48||r>o)return NaN;return parseInt(a,n)}}return+t};if(!Fi(" 0o1")||!Fi("0b1")||Fi("+0x1")){Fi=function(e){var t=arguments.length<1?0:e,i=this;return i instanceof Fi&&(Ri?v((function(){Yi.valueOf.call(i)})):"Number"!=H(i))?wi(new Ni(Ai(t)),i,Fi):Ai(t)};for(var zi,Bi=m?Ei(Ni):"MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,EPSILON,isFinite,isInteger,isNaN,isSafeInteger,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,parseFloat,parseInt,isInteger".split(","),Li=0;Bi.length>Li;Li++)M(Ni,zi=Bi[Li])&&!M(Fi,zi)&&Pi(Fi,zi,Ci(Ni,zi));Fi.prototype=Yi,Yi.constructor=Fi,P(s,"Number",Fi)}for(var Hi=o((function(e,t){e.exports=function(){var t,i;function o(){return t.apply(null,arguments)}function s(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function r(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function a(e){return void 0===e}function h(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function d(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function l(e,t){var i,n=[];for(i=0;i<e.length;++i)n.push(t(e[i],i));return n}function u(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function c(e,t){for(var i in t)u(t,i)&&(e[i]=t[i]);return u(t,"toString")&&(e.toString=t.toString),u(t,"valueOf")&&(e.valueOf=t.valueOf),e}function f(e,t,i,n){return Ft(e,t,i,n,!0).utc()}function p(e){return null==e._pf&&(e._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),e._pf}function v(e){if(null==e._isValid){var t=p(e),n=i.call(t.parsedDateParts,(function(e){return null!=e})),o=!isNaN(e._d.getTime())&&t.overflow<0&&!t.empty&&!t.invalidMonth&&!t.invalidWeekday&&!t.weekdayMismatch&&!t.nullInput&&!t.invalidFormat&&!t.userInvalidated&&(!t.meridiem||t.meridiem&&n);if(e._strict&&(o=o&&0===t.charsLeftOver&&0===t.unusedTokens.length&&void 0===t.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return o;e._isValid=o}return e._isValid}function m(e){var t=f(NaN);return null!=e?c(p(t),e):p(t).userInvalidated=!0,t}i=Array.prototype.some?Array.prototype.some:function(e){for(var t=Object(this),i=t.length>>>0,n=0;n<i;n++)if(n in t&&e.call(this,t[n],n,t))return!0;return!1};var g=o.momentProperties=[];function y(e,t){var i,n,o;if(a(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),a(t._i)||(e._i=t._i),a(t._f)||(e._f=t._f),a(t._l)||(e._l=t._l),a(t._strict)||(e._strict=t._strict),a(t._tzm)||(e._tzm=t._tzm),a(t._isUTC)||(e._isUTC=t._isUTC),a(t._offset)||(e._offset=t._offset),a(t._pf)||(e._pf=p(t)),a(t._locale)||(e._locale=t._locale),g.length>0)for(i=0;i<g.length;i++)a(o=t[n=g[i]])||(e[n]=o);return e}var b=!1;function _(e){y(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===b&&(b=!0,o.updateOffset(this),b=!1)}function w(e){return e instanceof _||null!=e&&null!=e._isAMomentObject}function k(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function x(e){var t=+e,i=0;return 0!==t&&isFinite(t)&&(i=k(t)),i}function S(e,t,i){var n,o=Math.min(e.length,t.length),s=Math.abs(e.length-t.length),r=0;for(n=0;n<o;n++)(i&&e[n]!==t[n]||!i&&x(e[n])!==x(t[n]))&&r++;return r+s}function O(e){!1===o.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function D(e,t){var i=!0;return c((function(){if(null!=o.deprecationHandler&&o.deprecationHandler(null,e),i){for(var n,s=[],r=0;r<arguments.length;r++){if(n="","object"==typeof arguments[r]){for(var a in n+="\n["+r+"] ",arguments[0])n+=a+": "+arguments[0][a]+", ";n=n.slice(0,-2)}else n=arguments[r];s.push(n)}O(e+"\nArguments: "+Array.prototype.slice.call(s).join("")+"\n"+(new Error).stack),i=!1}return t.apply(this,arguments)}),t)}var M,T={};function E(e,t){null!=o.deprecationHandler&&o.deprecationHandler(e,t),T[e]||(O(t),T[e]=!0)}function C(e){return e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function P(e,t){var i,n=c({},e);for(i in t)u(t,i)&&(r(e[i])&&r(t[i])?(n[i]={},c(n[i],e[i]),c(n[i],t[i])):null!=t[i]?n[i]=t[i]:delete n[i]);for(i in e)u(e,i)&&!u(t,i)&&r(e[i])&&(n[i]=c({},n[i]));return n}function I(e){null!=e&&this.set(e)}o.suppressDeprecationWarnings=!1,o.deprecationHandler=null,M=Object.keys?Object.keys:function(e){var t,i=[];for(t in e)u(e,t)&&i.push(t);return i};var F={};function N(e,t){var i=e.toLowerCase();F[i]=F[i+"s"]=F[t]=e}function Y(e){return"string"==typeof e?F[e]||F[e.toLowerCase()]:void 0}function R(e){var t,i,n={};for(i in e)u(e,i)&&(t=Y(i))&&(n[t]=e[i]);return n}var j={};function A(e,t){j[e]=t}function z(e,t,i){var n=""+Math.abs(e),o=t-n.length;return(e>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,o)).toString().substr(1)+n}var B=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,L=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,H={},W={};function V(e,t,i,n){var o=n;"string"==typeof n&&(o=function(){return this[n]()}),e&&(W[e]=o),t&&(W[t[0]]=function(){return z(o.apply(this,arguments),t[1],t[2])}),i&&(W[i]=function(){return this.localeData().ordinal(o.apply(this,arguments),e)})}function U(e,t){return e.isValid()?(t=G(t,e.localeData()),H[t]=H[t]||function(e){var t,i,n,o=e.match(B);for(t=0,i=o.length;t<i;t++)W[o[t]]?o[t]=W[o[t]]:o[t]=(n=o[t]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(t){var n,s="";for(n=0;n<i;n++)s+=C(o[n])?o[n].call(t,e):o[n];return s}}(t),H[t](e)):e.localeData().invalidDate()}function G(e,t){var i=5;function n(e){return t.longDateFormat(e)||e}for(L.lastIndex=0;i>=0&&L.test(e);)e=e.replace(L,n),L.lastIndex=0,i-=1;return e}var q=/\d/,Z=/\d\d/,X=/\d{3}/,$=/\d{4}/,K=/[+-]?\d{6}/,J=/\d\d?/,Q=/\d\d\d\d?/,ee=/\d\d\d\d\d\d?/,te=/\d{1,3}/,ie=/\d{1,4}/,ne=/[+-]?\d{1,6}/,oe=/\d+/,se=/[+-]?\d+/,re=/Z|[+-]\d\d:?\d\d/gi,ae=/Z|[+-]\d\d(?::?\d\d)?/gi,he=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,de={};function le(e,t,i){de[e]=C(t)?t:function(e,n){return e&&i?i:t}}function ue(e,t){return u(de,e)?de[e](t._strict,t._locale):new RegExp(ce(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(e,t,i,n,o){return t||i||n||o}))))}function ce(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var fe={};function pe(e,t){var i,n=t;for("string"==typeof e&&(e=[e]),h(t)&&(n=function(e,i){i[t]=x(e)}),i=0;i<e.length;i++)fe[e[i]]=n}function ve(e,t){pe(e,(function(e,i,n,o){n._w=n._w||{},t(e,n._w,n,o)}))}function me(e,t,i){null!=t&&u(fe,e)&&fe[e](t,i._a,i,e)}var ge=0,ye=1,be=2,_e=3,we=4,ke=5,xe=6,Se=7,Oe=8;function De(e){return Me(e)?366:365}function Me(e){return e%4==0&&e%100!=0||e%400==0}V("Y",0,0,(function(){var e=this.year();return e<=9999?""+e:"+"+e})),V(0,["YY",2],0,(function(){return this.year()%100})),V(0,["YYYY",4],0,"year"),V(0,["YYYYY",5],0,"year"),V(0,["YYYYYY",6,!0],0,"year"),N("year","y"),A("year",1),le("Y",se),le("YY",J,Z),le("YYYY",ie,$),le("YYYYY",ne,K),le("YYYYYY",ne,K),pe(["YYYYY","YYYYYY"],ge),pe("YYYY",(function(e,t){t[ge]=2===e.length?o.parseTwoDigitYear(e):x(e)})),pe("YY",(function(e,t){t[ge]=o.parseTwoDigitYear(e)})),pe("Y",(function(e,t){t[ge]=parseInt(e,10)})),o.parseTwoDigitYear=function(e){return x(e)+(x(e)>68?1900:2e3)};var Te,Ee=Ce("FullYear",!0);function Ce(e,t){return function(i){return null!=i?(Ie(this,e,i),o.updateOffset(this,t),this):Pe(this,e)}}function Pe(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function Ie(e,t,i){e.isValid()&&!isNaN(i)&&("FullYear"===t&&Me(e.year())&&1===e.month()&&29===e.date()?e._d["set"+(e._isUTC?"UTC":"")+t](i,e.month(),Fe(i,e.month())):e._d["set"+(e._isUTC?"UTC":"")+t](i))}function Fe(e,t){if(isNaN(e)||isNaN(t))return NaN;var i,n=(t%(i=12)+i)%i;return e+=(t-n)/12,1===n?Me(e)?29:28:31-n%7%2}Te=Array.prototype.indexOf?Array.prototype.indexOf:function(e){var t;for(t=0;t<this.length;++t)if(this[t]===e)return t;return-1},V("M",["MM",2],"Mo",(function(){return this.month()+1})),V("MMM",0,0,(function(e){return this.localeData().monthsShort(this,e)})),V("MMMM",0,0,(function(e){return this.localeData().months(this,e)})),N("month","M"),A("month",8),le("M",J),le("MM",J,Z),le("MMM",(function(e,t){return t.monthsShortRegex(e)})),le("MMMM",(function(e,t){return t.monthsRegex(e)})),pe(["M","MM"],(function(e,t){t[ye]=x(e)-1})),pe(["MMM","MMMM"],(function(e,t,i,n){var o=i._locale.monthsParse(e,n,i._strict);null!=o?t[ye]=o:p(i).invalidMonth=e}));var Ne=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Ye="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Re="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function je(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)s=f([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(s,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(s,"").toLocaleLowerCase();return i?"MMM"===t?-1!==(o=Te.call(this._shortMonthsParse,r))?o:null:-1!==(o=Te.call(this._longMonthsParse,r))?o:null:"MMM"===t?-1!==(o=Te.call(this._shortMonthsParse,r))?o:-1!==(o=Te.call(this._longMonthsParse,r))?o:null:-1!==(o=Te.call(this._longMonthsParse,r))?o:-1!==(o=Te.call(this._shortMonthsParse,r))?o:null}function Ae(e,t){var i;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=x(t);else if(!h(t=e.localeData().monthsParse(t)))return e;return i=Math.min(e.date(),Fe(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,i),e}function ze(e){return null!=e?(Ae(this,e),o.updateOffset(this,!0),this):Pe(this,"Month")}var Be=he,Le=he;function He(){function e(e,t){return t.length-e.length}var t,i,n=[],o=[],s=[];for(t=0;t<12;t++)i=f([2e3,t]),n.push(this.monthsShort(i,"")),o.push(this.months(i,"")),s.push(this.months(i,"")),s.push(this.monthsShort(i,""));for(n.sort(e),o.sort(e),s.sort(e),t=0;t<12;t++)n[t]=ce(n[t]),o[t]=ce(o[t]);for(t=0;t<24;t++)s[t]=ce(s[t]);this._monthsRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function We(e,t,i,n,o,s,r){var a;return e<100&&e>=0?(a=new Date(e+400,t,i,n,o,s,r),isFinite(a.getFullYear())&&a.setFullYear(e)):a=new Date(e,t,i,n,o,s,r),a}function Ve(e){var t;if(e<100&&e>=0){var i=Array.prototype.slice.call(arguments);i[0]=e+400,t=new Date(Date.UTC.apply(null,i)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)}else t=new Date(Date.UTC.apply(null,arguments));return t}function Ue(e,t,i){var n=7+t-i;return-(7+Ve(e,0,n).getUTCDay()-t)%7+n-1}function Ge(e,t,i,n,o){var s,r,a=1+7*(t-1)+(7+i-n)%7+Ue(e,n,o);return a<=0?r=De(s=e-1)+a:a>De(e)?(s=e+1,r=a-De(e)):(s=e,r=a),{year:s,dayOfYear:r}}function qe(e,t,i){var n,o,s=Ue(e.year(),t,i),r=Math.floor((e.dayOfYear()-s-1)/7)+1;return r<1?n=r+Ze(o=e.year()-1,t,i):r>Ze(e.year(),t,i)?(n=r-Ze(e.year(),t,i),o=e.year()+1):(o=e.year(),n=r),{week:n,year:o}}function Ze(e,t,i){var n=Ue(e,t,i),o=Ue(e+1,t,i);return(De(e)-n+o)/7}function Xe(e,t){return e.slice(t,7).concat(e.slice(0,t))}V("w",["ww",2],"wo","week"),V("W",["WW",2],"Wo","isoWeek"),N("week","w"),N("isoWeek","W"),A("week",5),A("isoWeek",5),le("w",J),le("ww",J,Z),le("W",J),le("WW",J,Z),ve(["w","ww","W","WW"],(function(e,t,i,n){t[n.substr(0,1)]=x(e)})),V("d",0,"do","day"),V("dd",0,0,(function(e){return this.localeData().weekdaysMin(this,e)})),V("ddd",0,0,(function(e){return this.localeData().weekdaysShort(this,e)})),V("dddd",0,0,(function(e){return this.localeData().weekdays(this,e)})),V("e",0,0,"weekday"),V("E",0,0,"isoWeekday"),N("day","d"),N("weekday","e"),N("isoWeekday","E"),A("day",11),A("weekday",11),A("isoWeekday",11),le("d",J),le("e",J),le("E",J),le("dd",(function(e,t){return t.weekdaysMinRegex(e)})),le("ddd",(function(e,t){return t.weekdaysShortRegex(e)})),le("dddd",(function(e,t){return t.weekdaysRegex(e)})),ve(["dd","ddd","dddd"],(function(e,t,i,n){var o=i._locale.weekdaysParse(e,n,i._strict);null!=o?t.d=o:p(i).invalidWeekday=e})),ve(["d","e","E"],(function(e,t,i,n){t[n]=x(e)}));var $e="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ke="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Je="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Qe(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)s=f([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(s,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(s,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(s,"").toLocaleLowerCase();return i?"dddd"===t?-1!==(o=Te.call(this._weekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:null:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:"dddd"===t?-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:null}var et=he,tt=he,it=he;function nt(){function e(e,t){return t.length-e.length}var t,i,n,o,s,r=[],a=[],h=[],d=[];for(t=0;t<7;t++)i=f([2e3,1]).day(t),n=this.weekdaysMin(i,""),o=this.weekdaysShort(i,""),s=this.weekdays(i,""),r.push(n),a.push(o),h.push(s),d.push(n),d.push(o),d.push(s);for(r.sort(e),a.sort(e),h.sort(e),d.sort(e),t=0;t<7;t++)a[t]=ce(a[t]),h[t]=ce(h[t]),d[t]=ce(d[t]);this._weekdaysRegex=new RegExp("^("+d.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+r.join("|")+")","i")}function ot(){return this.hours()%12||12}function st(e,t){V(e,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)}))}function rt(e,t){return t._meridiemParse}V("H",["HH",2],0,"hour"),V("h",["hh",2],0,ot),V("k",["kk",2],0,(function(){return this.hours()||24})),V("hmm",0,0,(function(){return""+ot.apply(this)+z(this.minutes(),2)})),V("hmmss",0,0,(function(){return""+ot.apply(this)+z(this.minutes(),2)+z(this.seconds(),2)})),V("Hmm",0,0,(function(){return""+this.hours()+z(this.minutes(),2)})),V("Hmmss",0,0,(function(){return""+this.hours()+z(this.minutes(),2)+z(this.seconds(),2)})),st("a",!0),st("A",!1),N("hour","h"),A("hour",13),le("a",rt),le("A",rt),le("H",J),le("h",J),le("k",J),le("HH",J,Z),le("hh",J,Z),le("kk",J,Z),le("hmm",Q),le("hmmss",ee),le("Hmm",Q),le("Hmmss",ee),pe(["H","HH"],_e),pe(["k","kk"],(function(e,t,i){var n=x(e);t[_e]=24===n?0:n})),pe(["a","A"],(function(e,t,i){i._isPm=i._locale.isPM(e),i._meridiem=e})),pe(["h","hh"],(function(e,t,i){t[_e]=x(e),p(i).bigHour=!0})),pe("hmm",(function(e,t,i){var n=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n)),p(i).bigHour=!0})),pe("hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n,2)),t[ke]=x(e.substr(o)),p(i).bigHour=!0})),pe("Hmm",(function(e,t,i){var n=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n))})),pe("Hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n,2)),t[ke]=x(e.substr(o))}));var at,ht=Ce("Hours",!0),dt={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Ye,monthsShort:Re,week:{dow:0,doy:6},weekdays:$e,weekdaysMin:Je,weekdaysShort:Ke,meridiemParse:/[ap]\.?m?\.?/i},lt={},ut={};function ct(e){return e?e.toLowerCase().replace("_","-"):e}function ft(t){var i=null;if(!lt[t]&&e&&e.exports)try{i=at._abbr,n(),pt(i)}catch(e){}return lt[t]}function pt(e,t){var i;return e&&((i=a(t)?mt(e):vt(e,t))?at=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),at._abbr}function vt(e,t){if(null!==t){var i,n=dt;if(t.abbr=e,null!=lt[e])E("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=lt[e]._config;else if(null!=t.parentLocale)if(null!=lt[t.parentLocale])n=lt[t.parentLocale]._config;else{if(null==(i=ft(t.parentLocale)))return ut[t.parentLocale]||(ut[t.parentLocale]=[]),ut[t.parentLocale].push({name:e,config:t}),null;n=i._config}return lt[e]=new I(P(n,t)),ut[e]&&ut[e].forEach((function(e){vt(e.name,e.config)})),pt(e),lt[e]}return delete lt[e],null}function mt(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return at;if(!s(e)){if(t=ft(e))return t;e=[e]}return function(e){for(var t,i,n,o,s=0;s<e.length;){for(t=(o=ct(e[s]).split("-")).length,i=(i=ct(e[s+1]))?i.split("-"):null;t>0;){if(n=ft(o.slice(0,t).join("-")))return n;if(i&&i.length>=t&&S(o,i,!0)>=t-1)break;t--}s++}return at}(e)}function gt(e){var t,i=e._a;return i&&-2===p(e).overflow&&(t=i[ye]<0||i[ye]>11?ye:i[be]<1||i[be]>Fe(i[ge],i[ye])?be:i[_e]<0||i[_e]>24||24===i[_e]&&(0!==i[we]||0!==i[ke]||0!==i[xe])?_e:i[we]<0||i[we]>59?we:i[ke]<0||i[ke]>59?ke:i[xe]<0||i[xe]>999?xe:-1,p(e)._overflowDayOfYear&&(t<ge||t>be)&&(t=be),p(e)._overflowWeeks&&-1===t&&(t=Se),p(e)._overflowWeekday&&-1===t&&(t=Oe),p(e).overflow=t),e}function yt(e,t,i){return null!=e?e:null!=t?t:i}function bt(e){var t,i,n,s,r,a=[];if(!e._d){for(n=function(e){var t=new Date(o.now());return e._useUTC?[t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()]:[t.getFullYear(),t.getMonth(),t.getDate()]}(e),e._w&&null==e._a[be]&&null==e._a[ye]&&function(e){var t,i,n,o,s,r,a,h;if(null!=(t=e._w).GG||null!=t.W||null!=t.E)s=1,r=4,i=yt(t.GG,e._a[ge],qe(Nt(),1,4).year),n=yt(t.W,1),((o=yt(t.E,1))<1||o>7)&&(h=!0);else{s=e._locale._week.dow,r=e._locale._week.doy;var d=qe(Nt(),s,r);i=yt(t.gg,e._a[ge],d.year),n=yt(t.w,d.week),null!=t.d?((o=t.d)<0||o>6)&&(h=!0):null!=t.e?(o=t.e+s,(t.e<0||t.e>6)&&(h=!0)):o=s}n<1||n>Ze(i,s,r)?p(e)._overflowWeeks=!0:null!=h?p(e)._overflowWeekday=!0:(a=Ge(i,n,o,s,r),e._a[ge]=a.year,e._dayOfYear=a.dayOfYear)}(e),null!=e._dayOfYear&&(r=yt(e._a[ge],n[ge]),(e._dayOfYear>De(r)||0===e._dayOfYear)&&(p(e)._overflowDayOfYear=!0),i=Ve(r,0,e._dayOfYear),e._a[ye]=i.getUTCMonth(),e._a[be]=i.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=a[t]=n[t];for(;t<7;t++)e._a[t]=a[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[_e]&&0===e._a[we]&&0===e._a[ke]&&0===e._a[xe]&&(e._nextDay=!0,e._a[_e]=0),e._d=(e._useUTC?Ve:We).apply(null,a),s=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[_e]=24),e._w&&void 0!==e._w.d&&e._w.d!==s&&(p(e).weekdayMismatch=!0)}}var _t=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,wt=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,kt=/Z|[+-]\d\d(?::?\d\d)?/,xt=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],St=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ot=/^\/?Date\((\-?\d+)/i;function Dt(e){var t,i,n,o,s,r,a=e._i,h=_t.exec(a)||wt.exec(a);if(h){for(p(e).iso=!0,t=0,i=xt.length;t<i;t++)if(xt[t][1].exec(h[1])){o=xt[t][0],n=!1!==xt[t][2];break}if(null==o)return void(e._isValid=!1);if(h[3]){for(t=0,i=St.length;t<i;t++)if(St[t][1].exec(h[3])){s=(h[2]||" ")+St[t][0];break}if(null==s)return void(e._isValid=!1)}if(!n&&null!=s)return void(e._isValid=!1);if(h[4]){if(!kt.exec(h[4]))return void(e._isValid=!1);r="Z"}e._f=o+(s||"")+(r||""),Pt(e)}else e._isValid=!1}var Mt=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Tt(e){var t=parseInt(e,10);return t<=49?2e3+t:t<=999?1900+t:t}var Et={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ct(e){var t,i,n,o,s,r,a,h=Mt.exec(e._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var d=(t=h[4],i=h[3],n=h[2],o=h[5],s=h[6],r=h[7],a=[Tt(t),Re.indexOf(i),parseInt(n,10),parseInt(o,10),parseInt(s,10)],r&&a.push(parseInt(r,10)),a);if(!function(e,t,i){return!e||Ke.indexOf(e)===new Date(t[0],t[1],t[2]).getDay()||(p(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],d,e))return;e._a=d,e._tzm=function(e,t,i){if(e)return Et[e];if(t)return 0;var n=parseInt(i,10),o=n%100;return(n-o)/100*60+o}(h[8],h[9],h[10]),e._d=Ve.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),p(e).rfc2822=!0}else e._isValid=!1}function Pt(e){if(e._f!==o.ISO_8601)if(e._f!==o.RFC_2822){e._a=[],p(e).empty=!0;var t,i,n,s,r,a=""+e._i,h=a.length,d=0;for(n=G(e._f,e._locale).match(B)||[],t=0;t<n.length;t++)s=n[t],(i=(a.match(ue(s,e))||[])[0])&&((r=a.substr(0,a.indexOf(i))).length>0&&p(e).unusedInput.push(r),a=a.slice(a.indexOf(i)+i.length),d+=i.length),W[s]?(i?p(e).empty=!1:p(e).unusedTokens.push(s),me(s,i,e)):e._strict&&!i&&p(e).unusedTokens.push(s);p(e).charsLeftOver=h-d,a.length>0&&p(e).unusedInput.push(a),e._a[_e]<=12&&!0===p(e).bigHour&&e._a[_e]>0&&(p(e).bigHour=void 0),p(e).parsedDateParts=e._a.slice(0),p(e).meridiem=e._meridiem,e._a[_e]=function(e,t,i){var n;return null==i?t:null!=e.meridiemHour?e.meridiemHour(t,i):null!=e.isPM?((n=e.isPM(i))&&t<12&&(t+=12),n||12!==t||(t=0),t):t}(e._locale,e._a[_e],e._meridiem),bt(e),gt(e)}else Ct(e);else Dt(e)}function It(e){var t=e._i,i=e._f;return e._locale=e._locale||mt(e._l),null===t||void 0===i&&""===t?m({nullInput:!0}):("string"==typeof t&&(e._i=t=e._locale.preparse(t)),w(t)?new _(gt(t)):(d(t)?e._d=t:s(i)?function(e){var t,i,n,o,s;if(0===e._f.length)return p(e).invalidFormat=!0,void(e._d=new Date(NaN));for(o=0;o<e._f.length;o++)s=0,t=y({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[o],Pt(t),v(t)&&(s+=p(t).charsLeftOver,s+=10*p(t).unusedTokens.length,p(t).score=s,(null==n||s<n)&&(n=s,i=t));c(e,i||t)}(e):i?Pt(e):function(e){var t=e._i;a(t)?e._d=new Date(o.now()):d(t)?e._d=new Date(t.valueOf()):"string"==typeof t?function(e){var t=Ot.exec(e._i);null===t?(Dt(e),!1===e._isValid&&(delete e._isValid,Ct(e),!1===e._isValid&&(delete e._isValid,o.createFromInputFallback(e)))):e._d=new Date(+t[1])}(e):s(t)?(e._a=l(t.slice(0),(function(e){return parseInt(e,10)})),bt(e)):r(t)?function(e){if(!e._d){var t=R(e._i);e._a=l([t.year,t.month,t.day||t.date,t.hour,t.minute,t.second,t.millisecond],(function(e){return e&&parseInt(e,10)})),bt(e)}}(e):h(t)?e._d=new Date(t):o.createFromInputFallback(e)}(e),v(e)||(e._d=null),e))}function Ft(e,t,i,n,o){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(r(e)&&function(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;var t;for(t in e)if(e.hasOwnProperty(t))return!1;return!0}(e)||s(e)&&0===e.length)&&(e=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=o,h._l=i,h._i=e,h._f=t,h._strict=n,(a=new _(gt(It(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Nt(e,t,i,n){return Ft(e,t,i,n,!1)}o.createFromInputFallback=D("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))})),o.ISO_8601=function(){},o.RFC_2822=function(){};var Yt=D("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Nt.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:m()})),Rt=D("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Nt.apply(null,arguments);return this.isValid()&&e.isValid()?e>this?this:e:m()}));function jt(e,t){var i,n;if(1===t.length&&s(t[0])&&(t=t[0]),!t.length)return Nt();for(i=t[0],n=1;n<t.length;++n)t[n].isValid()&&!t[n][e](i)||(i=t[n]);return i}var At=["year","quarter","month","week","day","hour","minute","second","millisecond"];function zt(e){var t=R(e),i=t.year||0,n=t.quarter||0,o=t.month||0,s=t.week||t.isoWeek||0,r=t.day||0,a=t.hour||0,h=t.minute||0,d=t.second||0,l=t.millisecond||0;this._isValid=function(e){for(var t in e)if(-1===Te.call(At,t)||null!=e[t]&&isNaN(e[t]))return!1;for(var i=!1,n=0;n<At.length;++n)if(e[At[n]]){if(i)return!1;parseFloat(e[At[n]])!==x(e[At[n]])&&(i=!0)}return!0}(t),this._milliseconds=+l+1e3*d+6e4*h+1e3*a*60*60,this._days=+r+7*s,this._months=+o+3*n+12*i,this._data={},this._locale=mt(),this._bubble()}function Bt(e){return e instanceof zt}function Lt(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function Ht(e,t){V(e,0,0,(function(){var e=this.utcOffset(),i="+";return e<0&&(e=-e,i="-"),i+z(~~(e/60),2)+t+z(~~e%60,2)}))}Ht("Z",":"),Ht("ZZ",""),le("Z",ae),le("ZZ",ae),pe(["Z","ZZ"],(function(e,t,i){i._useUTC=!0,i._tzm=Vt(ae,e)}));var Wt=/([\+\-]|\d\d)/gi;function Vt(e,t){var i=(t||"").match(e);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Wt)||["-",0,0],o=60*n[1]+x(n[2]);return 0===o?0:"+"===n[0]?o:-o}function Ut(e,t){var i,n;return t._isUTC?(i=t.clone(),n=(w(e)||d(e)?e.valueOf():Nt(e).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+n),o.updateOffset(i,!1),i):Nt(e).local()}function Gt(e){return 15*-Math.round(e._d.getTimezoneOffset()/15)}function qt(){return!!this.isValid()&&this._isUTC&&0===this._offset}o.updateOffset=function(){};var Zt=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Xt=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function $t(e,t){var i,n,o,s,r,a,d=e,l=null;return Bt(e)?d={ms:e._milliseconds,d:e._days,M:e._months}:h(e)?(d={},t?d[t]=e:d.milliseconds=e):(l=Zt.exec(e))?(i="-"===l[1]?-1:1,d={y:0,d:x(l[be])*i,h:x(l[_e])*i,m:x(l[we])*i,s:x(l[ke])*i,ms:x(Lt(1e3*l[xe]))*i}):(l=Xt.exec(e))?(i="-"===l[1]?-1:1,d={y:Kt(l[2],i),M:Kt(l[3],i),w:Kt(l[4],i),d:Kt(l[5],i),h:Kt(l[6],i),m:Kt(l[7],i),s:Kt(l[8],i)}):null==d?d={}:"object"==typeof d&&("from"in d||"to"in d)&&(s=Nt(d.from),r=Nt(d.to),o=s.isValid()&&r.isValid()?(r=Ut(r,s),s.isBefore(r)?a=Jt(s,r):((a=Jt(r,s)).milliseconds=-a.milliseconds,a.months=-a.months),a):{milliseconds:0,months:0},(d={}).ms=o.milliseconds,d.M=o.months),n=new zt(d),Bt(e)&&u(e,"_locale")&&(n._locale=e._locale),n}function Kt(e,t){var i=e&&parseFloat(e.replace(",","."));return(isNaN(i)?0:i)*t}function Jt(e,t){var i={};return i.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(i.months,"M").isAfter(t)&&--i.months,i.milliseconds=+t-+e.clone().add(i.months,"M"),i}function Qt(e,t){return function(i,n){var o;return null===n||isNaN(+n)||(E(t,"moment()."+t+"(period, number) is deprecated. Please use moment()."+t+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),o=i,i=n,n=o),ei(this,$t(i="string"==typeof i?+i:i,n),e),this}}function ei(e,t,i,n){var s=t._milliseconds,r=Lt(t._days),a=Lt(t._months);e.isValid()&&(n=null==n||n,a&&Ae(e,Pe(e,"Month")+a*i),r&&Ie(e,"Date",Pe(e,"Date")+r*i),s&&e._d.setTime(e._d.valueOf()+s*i),n&&o.updateOffset(e,r||a))}$t.fn=zt.prototype,$t.invalid=function(){return $t(NaN)};var ti=Qt(1,"add"),ii=Qt(-1,"subtract");function ni(e,t){var i=12*(t.year()-e.year())+(t.month()-e.month()),n=e.clone().add(i,"months");return-(i+(t-n<0?(t-n)/(n-e.clone().add(i-1,"months")):(t-n)/(e.clone().add(i+1,"months")-n)))||0}function oi(e){var t;return void 0===e?this._locale._abbr:(null!=(t=mt(e))&&(this._locale=t),this)}o.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",o.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var si=D("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(e){return void 0===e?this.localeData():this.locale(e)}));function ri(){return this._locale}var ai=1e3,hi=60*ai,di=60*hi,li=3506328*di;function ui(e,t){return(e%t+t)%t}function ci(e,t,i){return e<100&&e>=0?new Date(e+400,t,i)-li:new Date(e,t,i).valueOf()}function fi(e,t,i){return e<100&&e>=0?Date.UTC(e+400,t,i)-li:Date.UTC(e,t,i)}function pi(e,t){V(0,[e,e.length],0,t)}function vi(e,t,i,n,o){var s;return null==e?qe(this,n,o).year:(t>(s=Ze(e,n,o))&&(t=s),mi.call(this,e,t,i,n,o))}function mi(e,t,i,n,o){var s=Ge(e,t,i,n,o),r=Ve(s.year,0,s.dayOfYear);return this.year(r.getUTCFullYear()),this.month(r.getUTCMonth()),this.date(r.getUTCDate()),this}V(0,["gg",2],0,(function(){return this.weekYear()%100})),V(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),pi("gggg","weekYear"),pi("ggggg","weekYear"),pi("GGGG","isoWeekYear"),pi("GGGGG","isoWeekYear"),N("weekYear","gg"),N("isoWeekYear","GG"),A("weekYear",1),A("isoWeekYear",1),le("G",se),le("g",se),le("GG",J,Z),le("gg",J,Z),le("GGGG",ie,$),le("gggg",ie,$),le("GGGGG",ne,K),le("ggggg",ne,K),ve(["gggg","ggggg","GGGG","GGGGG"],(function(e,t,i,n){t[n.substr(0,2)]=x(e)})),ve(["gg","GG"],(function(e,t,i,n){t[n]=o.parseTwoDigitYear(e)})),V("Q",0,"Qo","quarter"),N("quarter","Q"),A("quarter",7),le("Q",q),pe("Q",(function(e,t){t[ye]=3*(x(e)-1)})),V("D",["DD",2],"Do","date"),N("date","D"),A("date",9),le("D",J),le("DD",J,Z),le("Do",(function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient})),pe(["D","DD"],be),pe("Do",(function(e,t){t[be]=x(e.match(J)[0])}));var gi=Ce("Date",!0);V("DDD",["DDDD",3],"DDDo","dayOfYear"),N("dayOfYear","DDD"),A("dayOfYear",4),le("DDD",te),le("DDDD",X),pe(["DDD","DDDD"],(function(e,t,i){i._dayOfYear=x(e)})),V("m",["mm",2],0,"minute"),N("minute","m"),A("minute",14),le("m",J),le("mm",J,Z),pe(["m","mm"],we);var yi=Ce("Minutes",!1);V("s",["ss",2],0,"second"),N("second","s"),A("second",15),le("s",J),le("ss",J,Z),pe(["s","ss"],ke);var bi,_i=Ce("Seconds",!1);for(V("S",0,0,(function(){return~~(this.millisecond()/100)})),V(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),V(0,["SSS",3],0,"millisecond"),V(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),V(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),V(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),V(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),V(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),V(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),N("millisecond","ms"),A("millisecond",16),le("S",te,q),le("SS",te,Z),le("SSS",te,X),bi="SSSS";bi.length<=9;bi+="S")le(bi,oe);function wi(e,t){t[xe]=x(1e3*("0."+e))}for(bi="S";bi.length<=9;bi+="S")pe(bi,wi);var ki=Ce("Milliseconds",!1);V("z",0,0,"zoneAbbr"),V("zz",0,0,"zoneName");var xi=_.prototype;function Si(e){return e}xi.add=ti,xi.calendar=function(e,t){var i=e||Nt(),n=Ut(i,this).startOf("day"),s=o.calendarFormat(this,n)||"sameElse",r=t&&(C(t[s])?t[s].call(this,i):t[s]);return this.format(r||this.localeData().calendar(s,this,Nt(i)))},xi.clone=function(){return new _(this)},xi.diff=function(e,t,i){var n,o,s;if(!this.isValid())return NaN;if(!(n=Ut(e,this)).isValid())return NaN;switch(o=6e4*(n.utcOffset()-this.utcOffset()),t=Y(t)){case"year":s=ni(this,n)/12;break;case"month":s=ni(this,n);break;case"quarter":s=ni(this,n)/3;break;case"second":s=(this-n)/1e3;break;case"minute":s=(this-n)/6e4;break;case"hour":s=(this-n)/36e5;break;case"day":s=(this-n-o)/864e5;break;case"week":s=(this-n-o)/6048e5;break;default:s=this-n}return i?s:k(s)},xi.endOf=function(e){var t;if(void 0===(e=Y(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(e){case"year":t=i(this.year()+1,0,1)-1;break;case"quarter":t=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=i(this.year(),this.month()+1,1)-1;break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=di-ui(t+(this._isUTC?0:this.utcOffset()*hi),di)-1;break;case"minute":t=this._d.valueOf(),t+=hi-ui(t,hi)-1;break;case"second":t=this._d.valueOf(),t+=ai-ui(t,ai)-1}return this._d.setTime(t),o.updateOffset(this,!0),this},xi.format=function(e){e||(e=this.isUtc()?o.defaultFormatUtc:o.defaultFormat);var t=U(this,e);return this.localeData().postformat(t)},xi.from=function(e,t){return this.isValid()&&(w(e)&&e.isValid()||Nt(e).isValid())?$t({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},xi.fromNow=function(e){return this.from(Nt(),e)},xi.to=function(e,t){return this.isValid()&&(w(e)&&e.isValid()||Nt(e).isValid())?$t({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},xi.toNow=function(e){return this.to(Nt(),e)},xi.get=function(e){return C(this[e=Y(e)])?this[e]():this},xi.invalidAt=function(){return p(this).overflow},xi.isAfter=function(e,t){var i=w(e)?e:Nt(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(t).valueOf())},xi.isBefore=function(e,t){var i=w(e)?e:Nt(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(t).valueOf()<i.valueOf())},xi.isBetween=function(e,t,i,n){var o=w(e)?e:Nt(e),s=w(t)?t:Nt(t);return!!(this.isValid()&&o.isValid()&&s.isValid())&&("("===(n=n||"()")[0]?this.isAfter(o,i):!this.isBefore(o,i))&&(")"===n[1]?this.isBefore(s,i):!this.isAfter(s,i))},xi.isSame=function(e,t){var i,n=w(e)?e:Nt(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(t).valueOf()<=i&&i<=this.clone().endOf(t).valueOf()))},xi.isSameOrAfter=function(e,t){return this.isSame(e,t)||this.isAfter(e,t)},xi.isSameOrBefore=function(e,t){return this.isSame(e,t)||this.isBefore(e,t)},xi.isValid=function(){return v(this)},xi.lang=si,xi.locale=oi,xi.localeData=ri,xi.max=Rt,xi.min=Yt,xi.parsingFlags=function(){return c({},p(this))},xi.set=function(e,t){if("object"==typeof e)for(var i=function(e){var t=[];for(var i in e)t.push({unit:i,priority:j[i]});return t.sort((function(e,t){return e.priority-t.priority})),t}(e=R(e)),n=0;n<i.length;n++)this[i[n].unit](e[i[n].unit]);else if(C(this[e=Y(e)]))return this[e](t);return this},xi.startOf=function(e){var t;if(void 0===(e=Y(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(e){case"year":t=i(this.year(),0,1);break;case"quarter":t=i(this.year(),this.month()-this.month()%3,1);break;case"month":t=i(this.year(),this.month(),1);break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=i(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=ui(t+(this._isUTC?0:this.utcOffset()*hi),di);break;case"minute":t=this._d.valueOf(),t-=ui(t,hi);break;case"second":t=this._d.valueOf(),t-=ui(t,ai)}return this._d.setTime(t),o.updateOffset(this,!0),this},xi.subtract=ii,xi.toArray=function(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]},xi.toObject=function(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}},xi.toDate=function(){return new Date(this.valueOf())},xi.toISOString=function(e){if(!this.isValid())return null;var t=!0!==e,i=t?this.clone().utc():this;return i.year()<0||i.year()>9999?U(i,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):C(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",U(i,"Z")):U(i,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},xi.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e="moment",t="";this.isLocal()||(e=0===this.utcOffset()?"moment.utc":"moment.parseZone",t="Z");var i="["+e+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",o=t+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+o)},xi.toJSON=function(){return this.isValid()?this.toISOString():null},xi.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},xi.unix=function(){return Math.floor(this.valueOf()/1e3)},xi.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},xi.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},xi.year=Ee,xi.isLeapYear=function(){return Me(this.year())},xi.weekYear=function(e){return vi.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},xi.isoWeekYear=function(e){return vi.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)},xi.quarter=xi.quarters=function(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)},xi.month=ze,xi.daysInMonth=function(){return Fe(this.year(),this.month())},xi.week=xi.weeks=function(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")},xi.isoWeek=xi.isoWeeks=function(e){var t=qe(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")},xi.weeksInYear=function(){var e=this.localeData()._week;return Ze(this.year(),e.dow,e.doy)},xi.isoWeeksInYear=function(){return Ze(this.year(),1,4)},xi.date=gi,xi.day=xi.days=function(e){if(!this.isValid())return null!=e?this:NaN;var t=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(e=function(e,t){return"string"!=typeof e?e:isNaN(e)?"number"==typeof(e=t.weekdaysParse(e))?e:null:parseInt(e,10)}(e,this.localeData()),this.add(e-t,"d")):t},xi.weekday=function(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")},xi.isoWeekday=function(e){if(!this.isValid())return null!=e?this:NaN;if(null!=e){var t=function(e,t){return"string"==typeof e?t.weekdaysParse(e)%7||7:isNaN(e)?null:e}(e,this.localeData());return this.day(this.day()%7?t:t-7)}return this.day()||7},xi.dayOfYear=function(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")},xi.hour=xi.hours=ht,xi.minute=xi.minutes=yi,xi.second=xi.seconds=_i,xi.millisecond=xi.milliseconds=ki,xi.utcOffset=function(e,t,i){var n,s=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null!=e){if("string"==typeof e){if(null===(e=Vt(ae,e)))return this}else Math.abs(e)<16&&!i&&(e*=60);return!this._isUTC&&t&&(n=Gt(this)),this._offset=e,this._isUTC=!0,null!=n&&this.add(n,"m"),s!==e&&(!t||this._changeInProgress?ei(this,$t(e-s,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,o.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?s:Gt(this)},xi.utc=function(e){return this.utcOffset(0,e)},xi.local=function(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(Gt(this),"m")),this},xi.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var e=Vt(re,this._i);null!=e?this.utcOffset(e):this.utcOffset(0,!0)}return this},xi.hasAlignedHourOffset=function(e){return!!this.isValid()&&(e=e?Nt(e).utcOffset():0,(this.utcOffset()-e)%60==0)},xi.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},xi.isLocal=function(){return!!this.isValid()&&!this._isUTC},xi.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},xi.isUtc=qt,xi.isUTC=qt,xi.zoneAbbr=function(){return this._isUTC?"UTC":""},xi.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},xi.dates=D("dates accessor is deprecated. Use date instead.",gi),xi.months=D("months accessor is deprecated. Use month instead",ze),xi.years=D("years accessor is deprecated. Use year instead",Ee),xi.zone=D("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()})),xi.isDSTShifted=D("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!a(this._isDSTShifted))return this._isDSTShifted;var e={};if(y(e,this),(e=It(e))._a){var t=e._isUTC?f(e._a):Nt(e._a);this._isDSTShifted=this.isValid()&&S(e._a,t.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var Oi=I.prototype;function Di(e,t,i,n){var o=mt(),s=f().set(n,t);return o[i](s,e)}function Mi(e,t,i){if(h(e)&&(t=e,e=void 0),e=e||"",null!=t)return Di(e,t,i,"month");var n,o=[];for(n=0;n<12;n++)o[n]=Di(e,n,i,"month");return o}function Ti(e,t,i,n){"boolean"==typeof e?(h(t)&&(i=t,t=void 0),t=t||""):(i=t=e,e=!1,h(t)&&(i=t,t=void 0),t=t||"");var o,s=mt(),r=e?s._week.dow:0;if(null!=i)return Di(t,(i+r)%7,n,"day");var a=[];for(o=0;o<7;o++)a[o]=Di(t,(o+r)%7,n,"day");return a}Oi.calendar=function(e,t,i){var n=this._calendar[e]||this._calendar.sameElse;return C(n)?n.call(t,i):n},Oi.longDateFormat=function(e){var t=this._longDateFormat[e],i=this._longDateFormat[e.toUpperCase()];return t||!i?t:(this._longDateFormat[e]=i.replace(/MMMM|MM|DD|dddd/g,(function(e){return e.slice(1)})),this._longDateFormat[e])},Oi.invalidDate=function(){return this._invalidDate},Oi.ordinal=function(e){return this._ordinal.replace("%d",e)},Oi.preparse=Si,Oi.postformat=Si,Oi.relativeTime=function(e,t,i,n){var o=this._relativeTime[i];return C(o)?o(e,t,i,n):o.replace(/%d/i,e)},Oi.pastFuture=function(e,t){var i=this._relativeTime[e>0?"future":"past"];return C(i)?i(t):i.replace(/%s/i,t)},Oi.set=function(e){var t,i;for(i in e)C(t=e[i])?this[i]=t:this["_"+i]=t;this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Oi.months=function(e,t){return e?s(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||Ne).test(t)?"format":"standalone"][e.month()]:s(this._months)?this._months:this._months.standalone},Oi.monthsShort=function(e,t){return e?s(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[Ne.test(t)?"format":"standalone"][e.month()]:s(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Oi.monthsParse=function(e,t,i){var n,o,s;if(this._monthsParseExact)return je.call(this,e,t,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(o=f([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(o,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(o,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(s="^"+this.months(o,"")+"|^"+this.monthsShort(o,""),this._monthsParse[n]=new RegExp(s.replace(".",""),"i")),i&&"MMMM"===t&&this._longMonthsParse[n].test(e))return n;if(i&&"MMM"===t&&this._shortMonthsParse[n].test(e))return n;if(!i&&this._monthsParse[n].test(e))return n}},Oi.monthsRegex=function(e){return this._monthsParseExact?(u(this,"_monthsRegex")||He.call(this),e?this._monthsStrictRegex:this._monthsRegex):(u(this,"_monthsRegex")||(this._monthsRegex=Le),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)},Oi.monthsShortRegex=function(e){return this._monthsParseExact?(u(this,"_monthsRegex")||He.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(u(this,"_monthsShortRegex")||(this._monthsShortRegex=Be),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)},Oi.week=function(e){return qe(e,this._week.dow,this._week.doy).week},Oi.firstDayOfYear=function(){return this._week.doy},Oi.firstDayOfWeek=function(){return this._week.dow},Oi.weekdays=function(e,t){var i=s(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Xe(i,this._week.dow):e?i[e.day()]:i},Oi.weekdaysMin=function(e){return!0===e?Xe(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin},Oi.weekdaysShort=function(e){return!0===e?Xe(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort},Oi.weekdaysParse=function(e,t,i){var n,o,s;if(this._weekdaysParseExact)return Qe.call(this,e,t,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(o=f([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(o,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(o,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(o,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(s="^"+this.weekdays(o,"")+"|^"+this.weekdaysShort(o,"")+"|^"+this.weekdaysMin(o,""),this._weekdaysParse[n]=new RegExp(s.replace(".",""),"i")),i&&"dddd"===t&&this._fullWeekdaysParse[n].test(e))return n;if(i&&"ddd"===t&&this._shortWeekdaysParse[n].test(e))return n;if(i&&"dd"===t&&this._minWeekdaysParse[n].test(e))return n;if(!i&&this._weekdaysParse[n].test(e))return n}},Oi.weekdaysRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(u(this,"_weekdaysRegex")||(this._weekdaysRegex=et),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)},Oi.weekdaysShortRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(u(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=tt),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Oi.weekdaysMinRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(u(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=it),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Oi.isPM=function(e){return"p"===(e+"").toLowerCase().charAt(0)},Oi.meridiem=function(e,t,i){return e>11?i?"pm":"PM":i?"am":"AM"},pt("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===x(e%100/10)?"th":1===t?"st":2===t?"nd":3===t?"rd":"th")}}),o.lang=D("moment.lang is deprecated. Use moment.locale instead.",pt),o.langData=D("moment.langData is deprecated. Use moment.localeData instead.",mt);var Ei=Math.abs;function Ci(e,t,i,n){var o=$t(t,i);return e._milliseconds+=n*o._milliseconds,e._days+=n*o._days,e._months+=n*o._months,e._bubble()}function Pi(e){return e<0?Math.floor(e):Math.ceil(e)}function Ii(e){return 4800*e/146097}function Fi(e){return 146097*e/4800}function Ni(e){return function(){return this.as(e)}}var Yi=Ni("ms"),Ri=Ni("s"),ji=Ni("m"),Ai=Ni("h"),zi=Ni("d"),Bi=Ni("w"),Li=Ni("M"),Hi=Ni("Q"),Wi=Ni("y");function Vi(e){return function(){return this.isValid()?this._data[e]:NaN}}var Ui=Vi("milliseconds"),Gi=Vi("seconds"),qi=Vi("minutes"),Zi=Vi("hours"),Xi=Vi("days"),$i=Vi("months"),Ki=Vi("years"),Ji=Math.round,Qi={ss:44,s:45,m:45,h:22,d:26,M:11};function en(e,t,i,n,o){return o.relativeTime(t||1,!!i,e,n)}var tn=Math.abs;function nn(e){return(e>0)-(e<0)||+e}function on(){if(!this.isValid())return this.localeData().invalidDate();var e,t,i=tn(this._milliseconds)/1e3,n=tn(this._days),o=tn(this._months);e=k(i/60),t=k(e/60),i%=60,e%=60;var s=k(o/12),r=o%=12,a=n,h=t,d=e,l=i?i.toFixed(3).replace(/\.?0+$/,""):"",u=this.asSeconds();if(!u)return"P0D";var c=u<0?"-":"",f=nn(this._months)!==nn(u)?"-":"",p=nn(this._days)!==nn(u)?"-":"",v=nn(this._milliseconds)!==nn(u)?"-":"";return c+"P"+(s?f+s+"Y":"")+(r?f+r+"M":"")+(a?p+a+"D":"")+(h||d||l?"T":"")+(h?v+h+"H":"")+(d?v+d+"M":"")+(l?v+l+"S":"")}var sn=zt.prototype;return sn.isValid=function(){return this._isValid},sn.abs=function(){var e=this._data;return this._milliseconds=Ei(this._milliseconds),this._days=Ei(this._days),this._months=Ei(this._months),e.milliseconds=Ei(e.milliseconds),e.seconds=Ei(e.seconds),e.minutes=Ei(e.minutes),e.hours=Ei(e.hours),e.months=Ei(e.months),e.years=Ei(e.years),this},sn.add=function(e,t){return Ci(this,e,t,1)},sn.subtract=function(e,t){return Ci(this,e,t,-1)},sn.as=function(e){if(!this.isValid())return NaN;var t,i,n=this._milliseconds;if("month"===(e=Y(e))||"quarter"===e||"year"===e)switch(t=this._days+n/864e5,i=this._months+Ii(t),e){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(t=this._days+Math.round(Fi(this._months)),e){case"week":return t/7+n/6048e5;case"day":return t+n/864e5;case"hour":return 24*t+n/36e5;case"minute":return 1440*t+n/6e4;case"second":return 86400*t+n/1e3;case"millisecond":return Math.floor(864e5*t)+n;default:throw new Error("Unknown unit "+e)}},sn.asMilliseconds=Yi,sn.asSeconds=Ri,sn.asMinutes=ji,sn.asHours=Ai,sn.asDays=zi,sn.asWeeks=Bi,sn.asMonths=Li,sn.asQuarters=Hi,sn.asYears=Wi,sn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*x(this._months/12):NaN},sn._bubble=function(){var e,t,i,n,o,s=this._milliseconds,r=this._days,a=this._months,h=this._data;return s>=0&&r>=0&&a>=0||s<=0&&r<=0&&a<=0||(s+=864e5*Pi(Fi(a)+r),r=0,a=0),h.milliseconds=s%1e3,e=k(s/1e3),h.seconds=e%60,t=k(e/60),h.minutes=t%60,i=k(t/60),h.hours=i%24,r+=k(i/24),o=k(Ii(r)),a+=o,r-=Pi(Fi(o)),n=k(a/12),a%=12,h.days=r,h.months=a,h.years=n,this},sn.clone=function(){return $t(this)},sn.get=function(e){return e=Y(e),this.isValid()?this[e+"s"]():NaN},sn.milliseconds=Ui,sn.seconds=Gi,sn.minutes=qi,sn.hours=Zi,sn.days=Xi,sn.weeks=function(){return k(this.days()/7)},sn.months=$i,sn.years=Ki,sn.humanize=function(e){if(!this.isValid())return this.localeData().invalidDate();var t=this.localeData(),i=function(e,t,i){var n=$t(e).abs(),o=Ji(n.as("s")),s=Ji(n.as("m")),r=Ji(n.as("h")),a=Ji(n.as("d")),h=Ji(n.as("M")),d=Ji(n.as("y")),l=o<=Qi.ss&&["s",o]||o<Qi.s&&["ss",o]||s<=1&&["m"]||s<Qi.m&&["mm",s]||r<=1&&["h"]||r<Qi.h&&["hh",r]||a<=1&&["d"]||a<Qi.d&&["dd",a]||h<=1&&["M"]||h<Qi.M&&["MM",h]||d<=1&&["y"]||["yy",d];return l[2]=t,l[3]=+e>0,l[4]=i,en.apply(null,l)}(this,!e,t);return e&&(i=t.pastFuture(+this,i)),t.postformat(i)},sn.toISOString=on,sn.toString=on,sn.toJSON=on,sn.locale=oi,sn.localeData=ri,sn.toIsoString=D("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",on),sn.lang=si,V("X",0,0,"unix"),V("x",0,0,"valueOf"),le("x",se),le("X",/[+-]?\d+(\.\d{1,3})?/),pe("X",(function(e,t,i){i._d=new Date(1e3*parseFloat(e,10))})),pe("x",(function(e,t,i){i._d=new Date(x(e))})),o.version="2.24.0",t=Nt,o.fn=xi,o.min=function(){return jt("isBefore",[].slice.call(arguments,0))},o.max=function(){return jt("isAfter",[].slice.call(arguments,0))},o.now=function(){return Date.now?Date.now():+new Date},o.utc=f,o.unix=function(e){return Nt(1e3*e)},o.months=function(e,t){return Mi(e,t,"months")},o.isDate=d,o.locale=pt,o.invalid=m,o.duration=$t,o.isMoment=w,o.weekdays=function(e,t,i){return Ti(e,t,i,"weekdays")},o.parseZone=function(){return Nt.apply(null,arguments).parseZone()},o.localeData=mt,o.isDuration=Bt,o.monthsShort=function(e,t){return Mi(e,t,"monthsShort")},o.weekdaysMin=function(e,t,i){return Ti(e,t,i,"weekdaysMin")},o.defineLocale=vt,o.updateLocale=function(e,t){if(null!=t){var i,n,o=dt;null!=(n=ft(e))&&(o=n._config),t=P(o,t),(i=new I(t)).parentLocale=lt[e],lt[e]=i,pt(e)}else null!=lt[e]&&(null!=lt[e].parentLocale?lt[e]=lt[e].parentLocale:null!=lt[e]&&delete lt[e]);return lt[e]},o.locales=function(){return M(lt)},o.weekdaysShort=function(e,t,i){return Ti(e,t,i,"weekdaysShort")},o.normalizeUnits=Y,o.relativeTimeRounding=function(e){return void 0===e?Ji:"function"==typeof e&&(Ji=e,!0)},o.relativeTimeThreshold=function(e,t){return void 0!==Qi[e]&&(void 0===t?Qi[e]:(Qi[e]=t,"s"===e&&(Qi.ss=t-1),!0))},o.calendarFormat=function(e,t){var i=e.diff(t,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},o.prototype=xi,o.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},o}()})),Wi=[],Vi=0;Vi<256;Vi++)Wi[Vi]=(Vi+256).toString(16).substr(1);for(var Ui=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var e=new Uint8Array(16);return function(){return crypto.getRandomValues(e),e}}var t=new Array(16);return function(){for(var e,i=0;i<16;i++)0==(3&i)&&(e=4294967296*Math.random()),t[i]=e>>>((3&i)<<3)&255;return t}}(),Gi=[],qi=0;qi<256;qi++)Gi[qi]=(qi+256).toString(16).substr(1);var Zi=Ui();Zi[0],Zi[1],Zi[2],Zi[3],Zi[4],Zi[5],Zi[6],Zi[7];function Xi(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0,i=arguments.length>2?arguments[2]:void 0,n=t&&i||0;"string"==typeof e&&(t="binary"===e?new Array(16):void 0,e={});var o=e.random||(e.rng||Ui)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,t)for(var s=0;s<16;s++)t[n+s]=o[s];return t||function(e,t){var i=t||0,n=Wi;return n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]}(o)}var $i=/^\/?Date\((-?\d+)/i,Ki=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Ji=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Qi=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,en=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function tn(e){return e instanceof Number||"number"==typeof e}function nn(e){if(e)for(;!0===e.hasChildNodes();){var t=e.firstChild;t&&(nn(t),e.removeChild(t))}}function on(e){return e instanceof String||"string"==typeof e}function sn(e){return"object"===it(e)&&null!==e}function rn(e){if(e instanceof Date)return!0;if(on(e)){if($i.exec(e))return!0;if(!isNaN(Date.parse(e)))return!0}return!1}function an(e){return Hi.isMoment(e)}function hn(e,t,i,n){var o=!1;!0===n&&(o=null===t[i]&&void 0!==e[i]),o?delete e[i]:e[i]=t[i]}function dn(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var n in e)if(void 0!==t[n])if(null===t[n]||"object"!==it(t[n]))hn(e,t,n,i);else{var o=e[n],s=t[n];sn(o)&&sn(s)&&dn(o,s,i)}}var ln=Object.assign;function un(e,t){if(!Array.isArray(e))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var s=0,r=n;s<r.length;s++)for(var a=r[s],h=0;h<e.length;h++){var d=e[h];a&&Object.prototype.hasOwnProperty.call(a,d)&&(t[d]=a[d])}return t}function cn(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<e.length;o++){var s=e[o];if(Object.prototype.hasOwnProperty.call(i,s))if(i[s]&&i[s].constructor===Object)void 0===t[s]&&(t[s]={}),t[s].constructor===Object?pn(t[s],i[s],!1,n):hn(t,i,s,n);else{if(Array.isArray(i[s]))throw new TypeError("Arrays are not supported by deepExtend");hn(t,i,s,n)}}return t}function fn(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Array.isArray(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&-1===e.indexOf(o))if(i[o]&&i[o].constructor===Object)void 0===t[o]&&(t[o]={}),t[o].constructor===Object?pn(t[o],i[o]):hn(t,i,o,n);else if(Array.isArray(i[o])){t[o]=[];for(var s=0;s<i[o].length;s++)t[o].push(i[o][s])}else hn(t,i,o,n);return t}function pn(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in t)(Object.prototype.hasOwnProperty.call(t,o)||!0===i)&&(t[o]&&Object.getPrototypeOf(t[o])===Object.prototype?void 0===e[o]?e[o]=pn({},t[o],i):e[o]&&Object.getPrototypeOf(e[o])===Object.prototype?pn(e[o],t[o],i):hn(e,t,o,n):Array.isArray(t[o])?e[o]=t[o].slice():hn(e,t,o,n));return e}function vn(e,t){if(e.length!==t.length)return!1;for(var i=0,n=e.length;i<n;i++)if(e[i]!=t[i])return!1;return!0}function mn(e,t){var i;if(void 0!==e){if(null===e)return null;if(!t)return e;if("string"!=typeof t&&!(t instanceof String))throw new Error("Type must be a string");switch(t){case"boolean":case"Boolean":return Boolean(e);case"number":case"Number":return on(e)&&!isNaN(Date.parse(e))?Hi(e).valueOf():Number(e.valueOf());case"string":case"String":return String(e);case"Date":if(tn(e))return new Date(e);if(e instanceof Date)return new Date(e.valueOf());if(an(e))return new Date(e.valueOf());if(on(e))return(i=$i.exec(e))?new Date(Number(i[1])):Hi(new Date(e)).toDate();throw new Error("Cannot convert object of type "+gn(e)+" to type Date");case"Moment":if(tn(e))return Hi(e);if(e instanceof Date)return Hi(e.valueOf());if(an(e))return Hi(e);if(on(e))return i=$i.exec(e),Hi(i?Number(i[1]):e);throw new Error("Cannot convert object of type "+gn(e)+" to type Date");case"ISODate":if(tn(e))return new Date(e);if(e instanceof Date)return e.toISOString();if(an(e))return e.toDate().toISOString();if(on(e))return(i=$i.exec(e))?new Date(Number(i[1])).toISOString():Hi(e).format();throw new Error("Cannot convert object of type "+gn(e)+" to type ISODate");case"ASPDate":if(tn(e))return"/Date("+e+")/";if(e instanceof Date||an(e))return"/Date("+e.valueOf()+")/";if(on(e))return"/Date("+((i=$i.exec(e))?new Date(Number(i[1])).valueOf():new Date(e).valueOf())+")/";throw new Error("Cannot convert object of type "+gn(e)+" to type ASPDate");default:throw new Error("Unknown type ".concat(t))}}}function gn(e){var t=it(e);return"object"===t?null===e?"null":e instanceof Boolean?"Boolean":e instanceof Number?"Number":e instanceof String?"String":Array.isArray(e)?"Array":e instanceof Date?"Date":"Object":"number"===t?"Number":"boolean"===t?"Boolean":"string"===t?"String":void 0===t?"undefined":t}function yn(e,t){return[].concat(st(e),[t])}function bn(e){return e.slice()}function _n(e){return e.getBoundingClientRect().left}function wn(e){return e.getBoundingClientRect().right}function kn(e){return e.getBoundingClientRect().top}function xn(e,t){var i=e.className.split(" "),n=t.split(" ");i=i.concat(n.filter((function(e){return i.indexOf(e)<0}))),e.className=i.join(" ")}function Sn(e,t){var i=e.className.split(" "),n=t.split(" ");i=i.filter((function(e){return n.indexOf(e)<0})),e.className=i.join(" ")}function On(e,t){if(Array.isArray(e))for(var i=e.length,n=0;n<i;n++)t(e[n],n,e);else for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t(e[o],o,e)}var Dn=Object.values;function Mn(e,t,i){return e[t]!==i&&(e[t]=i,!0)}function Tn(e){var t=!1;return function(){t||(t=!0,requestAnimationFrame((function(){t=!1,e()})))}}function En(e,t,i,n){e.addEventListener?(void 0===n&&(n=!1),"mousewheel"===t&&navigator.userAgent.indexOf("Firefox")>=0&&(t="DOMMouseScroll"),e.addEventListener(t,i,n)):e.attachEvent("on"+t,i)}function Cn(e,t,i,n){e.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===t&&navigator.userAgent.indexOf("Firefox")>=0&&(t="DOMMouseScroll"),e.removeEventListener(t,i,n)):e.detachEvent("on"+t,i)}function Pn(e){e||(e=window.event),e&&(e.preventDefault?e.preventDefault():e.returnValue=!1)}function In(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,t=null;return e&&(e.target?t=e.target:e.srcElement&&(t=e.srcElement)),t instanceof Element&&(null==t.nodeType||3!=t.nodeType||(t=t.parentNode)instanceof Element)?t:null}function Fn(e,t){for(var i=e;i;){if(i===t)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1}var Nn={asBoolean:function(e,t){return"function"==typeof e&&(e=e()),null!=e?0!=e:t||null},asNumber:function(e,t){return"function"==typeof e&&(e=e()),null!=e?Number(e)||t||null:t||null},asString:function(e,t){return"function"==typeof e&&(e=e()),null!=e?String(e):t||null},asSize:function(e,t){return"function"==typeof e&&(e=e()),on(e)?e:tn(e)?e+"px":t||null},asElement:function(e,t){return"function"==typeof e&&(e=e()),e||t||null}};function Yn(e){var t;switch(e.length){case 3:case 4:return(t=Ji.exec(e))?{r:parseInt(t[1]+t[1],16),g:parseInt(t[2]+t[2],16),b:parseInt(t[3]+t[3],16)}:null;case 6:case 7:return(t=Ki.exec(e))?{r:parseInt(t[1],16),g:parseInt(t[2],16),b:parseInt(t[3],16)}:null;default:return null}}function Rn(e,t){if(-1!==e.indexOf("rgba"))return e;if(-1!==e.indexOf("rgb")){var i=e.substr(e.indexOf("(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+t+")"}var n=Yn(e);return null==n?e:"rgba("+n.r+","+n.g+","+n.b+","+t+")"}function jn(e,t,i){return"#"+((1<<24)+(e<<16)+(t<<8)+i).toString(16).slice(1)}function An(e,t){if(on(e)){var i=e;if(qn(i)){var n=i.substr(4).substr(0,i.length-5).split(",").map((function(e){return parseInt(e)}));i=jn(n[0],n[1],n[2])}if(!0===Gn(i)){var o=Un(i),s={h:o.h,s:.8*o.s,v:Math.min(1,1.02*o.v)},r={h:o.h,s:Math.min(1,1.25*o.s),v:.8*o.v},a=Vn(r.h,r.s,r.v),h=Vn(s.h,s.s,s.v);return{background:i,border:a,highlight:{background:h,border:a},hover:{background:h,border:a}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return t?{background:e.background||t.background,border:e.border||t.border,highlight:on(e.highlight)?{border:e.highlight,background:e.highlight}:{background:e.highlight&&e.highlight.background||t.highlight.background,border:e.highlight&&e.highlight.border||t.highlight.border},hover:on(e.hover)?{border:e.hover,background:e.hover}:{border:e.hover&&e.hover.border||t.hover.border,background:e.hover&&e.hover.background||t.hover.background}}:{background:e.background||void 0,border:e.border||void 0,highlight:on(e.highlight)?{border:e.highlight,background:e.highlight}:{background:e.highlight&&e.highlight.background||void 0,border:e.highlight&&e.highlight.border||void 0},hover:on(e.hover)?{border:e.hover,background:e.hover}:{border:e.hover&&e.hover.border||void 0,background:e.hover&&e.hover.background||void 0}}}function zn(e,t,i){e/=255,t/=255,i/=255;var n=Math.min(e,Math.min(t,i)),o=Math.max(e,Math.max(t,i));return n===o?{h:0,s:0,v:n}:{h:60*((e===n?3:i===n?1:5)-(e===n?t-i:i===n?e-t:i-e)/(o-n))/360,s:(o-n)/o,v:o}}var Bn={split:function(e){var t={};return e.split(";").forEach((function(e){if(""!=e.trim()){var i=e.split(":"),n=i[0].trim(),o=i[1].trim();t[n]=o}})),t},join:function(e){return Object.keys(e).map((function(t){return t+": "+e[t]})).join("; ")}};function Ln(e,t){var i=function(e){for(var t=1;t<arguments.length;t++){var i=null!=arguments[t]?arguments[t]:{};t%2?ot(i,!0).forEach((function(t){nt(e,t,i[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(i)):ot(i).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(i,t))}))}return e}({},Bn.split(e.style.cssText),{},Bn.split(t));e.style.cssText=Bn.join(i)}function Hn(e,t){var i=Bn.split(e.style.cssText),n=Bn.split(t);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];e.style.cssText=Bn.join(i)}function Wn(e,t,i){var n,o,s,r=Math.floor(6*e),a=6*e-r,h=i*(1-t),d=i*(1-a*t),l=i*(1-(1-a)*t);switch(r%6){case 0:n=i,o=l,s=h;break;case 1:n=d,o=i,s=h;break;case 2:n=h,o=i,s=l;break;case 3:n=h,o=d,s=i;break;case 4:n=l,o=h,s=i;break;case 5:n=i,o=h,s=d}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*s)}}function Vn(e,t,i){var n=Wn(e,t,i);return jn(n.r,n.g,n.b)}function Un(e){var t=Yn(e);if(!t)throw new TypeError("'".concat(e,"' is not a valid color."));return zn(t.r,t.g,t.b)}function Gn(e){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(e)}function qn(e){return Qi.test(e)}function Zn(e){return en.test(e)}function Xn(e,t){if(null!==t&&"object"===it(t)){for(var i=Object.create(t),n=0;n<e.length;n++)Object.prototype.hasOwnProperty.call(t,e[n])&&"object"==it(t[e[n]])&&(i[e[n]]=$n(t[e[n]]));return i}return null}function $n(e){if(null===e||"object"!==it(e))return null;if(e instanceof Element)return e;var t=Object.create(e);for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&"object"==it(e[i])&&(t[i]=$n(e[i]));return t}function Kn(e,t){for(var i=0;i<e.length;i++){var n=e[i],o=void 0;for(o=i;o>0&&t(n,e[o-1])<0;o--)e[o]=e[o-1];e[o]=n}return e}function Jn(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(e){return null!=e},s=function(e){return null!==e&&"object"===it(e)};if(!s(e))throw new Error("Parameter mergeTarget must be an object");if(!s(t))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!s(n))throw new Error("Parameter globalOptions must be an object");var r=t[i],a=s(n)&&!function(e){for(var t in e)if(Object.prototype.hasOwnProperty.call(e,t))return!1;return!0}(n)?n[i]:void 0,h=a?a.enabled:void 0;if(void 0!==r){if("boolean"==typeof r)return s(e[i])||(e[i]={}),void(e[i].enabled=r);if(null===r&&!s(e[i])){if(!o(a))return;e[i]=Object.create(a)}if(s(r)){var d=!0;void 0!==r.enabled?d=r.enabled:void 0!==h&&(d=a.enabled),function(e,t,i){s(e[i])||(e[i]={});var n=t[i],o=e[i];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(o[r]=n[r])}(e,t,i),e[i].enabled=d}}}function Qn(e,t,i,n){for(var o=0,s=0,r=e.length-1;s<=r&&o<1e4;){var a=Math.floor((s+r)/2),h=e[a],d=t(void 0===n?h[i]:h[i][n]);if(0==d)return a;-1==d?s=a+1:r=a-1,o++}return-1}function eo(e,t,i,n,o){var s,r,a,h,d=0,l=0,u=e.length-1;for(o=null!=o?o:function(e,t){return e==t?0:e<t?-1:1};l<=u&&d<1e4;){if(h=Math.floor(.5*(u+l)),s=e[Math.max(0,h-1)][i],r=e[h][i],a=e[Math.min(e.length-1,h+1)][i],0==o(r,t))return h;if(o(s,t)<0&&o(r,t)>0)return"before"==n?Math.max(0,h-1):h;if(o(r,t)<0&&o(a,t)>0)return"before"==n?h:Math.min(e.length-1,h+1);o(r,t)<0?l=h+1:u=h-1,d++}return-1}var to={linear:function(e){return e},easeInQuad:function(e){return e*e},easeOutQuad:function(e){return e*(2-e)},easeInOutQuad:function(e){return e<.5?2*e*e:(4-2*e)*e-1},easeInCubic:function(e){return e*e*e},easeOutCubic:function(e){return--e*e*e+1},easeInOutCubic:function(e){return e<.5?4*e*e*e:(e-1)*(2*e-2)*(2*e-2)+1},easeInQuart:function(e){return e*e*e*e},easeOutQuart:function(e){return 1- --e*e*e*e},easeInOutQuart:function(e){return e<.5?8*e*e*e*e:1-8*--e*e*e*e},easeInQuint:function(e){return e*e*e*e*e},easeOutQuint:function(e){return 1+--e*e*e*e*e},easeInOutQuint:function(e){return e<.5?16*e*e*e*e*e:1+16*--e*e*e*e*e}};function io(){var e=document.createElement("p");e.style.width="100%",e.style.height="200px";var t=document.createElement("div");t.style.position="absolute",t.style.top="0px",t.style.left="0px",t.style.visibility="hidden",t.style.width="200px",t.style.height="150px",t.style.overflow="hidden",t.appendChild(e),document.body.appendChild(t);var i=e.offsetWidth;t.style.overflow="scroll";var n=e.offsetWidth;return i==n&&(n=t.clientWidth),document.body.removeChild(t),i-n}function no(e,t){var i;Array.isArray(t)||(t=[t]);var n=!0,o=!1,s=void 0;try{for(var r,a=e[Symbol.iterator]();!(n=(r=a.next()).done);n=!0){var h=r.value;if(h){i=h[t[0]];for(var d=1;d<t.length;d++)i&&(i=i[t[d]]);if(void 0!==i)break}}}catch(e){o=!0,s=e}finally{try{n||null==a.return||a.return()}finally{if(o)throw s}}return i}var oo=Object.freeze({isNumber:tn,recursiveDOMDelete:nn,isString:on,isObject:sn,isDate:rn,isMoment:an,fillIfDefined:dn,extend:ln,selectiveExtend:un,selectiveDeepExtend:cn,selectiveNotDeepExtend:fn,deepExtend:pn,equalArray:vn,convert:mn,getType:gn,copyAndExtendArray:yn,copyArray:bn,getAbsoluteLeft:_n,getAbsoluteRight:wn,getAbsoluteTop:kn,addClassName:xn,removeClassName:Sn,forEach:On,toArray:Dn,updateProperty:Mn,throttle:Tn,addEventListener:En,removeEventListener:Cn,preventDefault:Pn,getTarget:In,hasParent:Fn,option:Nn,hexToRGB:Yn,overrideOpacity:Rn,RGBToHex:jn,parseColor:An,RGBToHSV:zn,addCssText:Ln,removeCssText:Hn,HSVToRGB:Wn,HSVToHex:Vn,hexToHSV:Un,isValidHex:Gn,isValidRGB:qn,isValidRGBA:Zn,selectiveBridgeObject:Xn,bridgeObject:$n,insertSort:Kn,mergeOptions:Jn,binarySearchCustom:Qn,binarySearchValue:eo,easingFunctions:to,getScrollBarWidth:io,topMost:no,randomUUID:Xi}),so=Object.freeze({__proto__:null,default:oo,HSVToHex:Vn,HSVToRGB:Wn,RGBToHSV:zn,RGBToHex:jn,addClassName:xn,addCssText:Ln,addEventListener:En,binarySearchCustom:Qn,binarySearchValue:eo,bridgeObject:$n,convert:mn,copyAndExtendArray:yn,copyArray:bn,deepExtend:pn,easingFunctions:to,equalArray:vn,extend:ln,fillIfDefined:dn,forEach:On,getAbsoluteLeft:_n,getAbsoluteRight:wn,getAbsoluteTop:kn,getScrollBarWidth:io,getTarget:In,getType:gn,hasParent:Fn,hexToHSV:Un,hexToRGB:Yn,insertSort:Kn,isDate:rn,isMoment:an,isNumber:tn,isObject:sn,isString:on,isValidHex:Gn,isValidRGB:qn,isValidRGBA:Zn,mergeOptions:Jn,option:Nn,overrideOpacity:Rn,parseColor:An,preventDefault:Pn,randomUUID:Xi,recursiveDOMDelete:nn,removeClassName:Sn,removeCssText:Hn,removeEventListener:Cn,selectiveBridgeObject:Xn,selectiveDeepExtend:cn,selectiveExtend:un,selectiveNotDeepExtend:fn,throttle:Tn,toArray:Dn,topMost:no,updateProperty:Mn});function ro(e){return co=e,function(){var e={};fo=0,void(po=co.charAt(0)),Do(),"strict"===vo&&(e.strict=!0,Do());"graph"!==vo&&"digraph"!==vo||(e.type=vo,Do());mo===lo.IDENTIFIER&&(e.id=vo,Do());if("{"!=vo)throw Io("Angle bracket { expected");if(Do(),Mo(e),"}"!=vo)throw Io("Angle bracket } expected");if(Do(),""!==vo)throw Io("End of file expected");return Do(),delete e.node,delete e.edge,delete e.graph,e}()}var ao={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},ho=Object.create(ao);ho.color="color.color",ho.style="dashes";var lo={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},uo={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},co="",fo=0,po="",vo="",mo=lo.NULL;function go(){fo++,po=co.charAt(fo)}function yo(){return co.charAt(fo+1)}var bo=/[a-zA-Z_0-9.:#]/;function _o(e){return bo.test(e)}function wo(e,t){if(e||(e={}),t)for(var i in t)t.hasOwnProperty(i)&&(e[i]=t[i]);return e}function ko(e,t,i){for(var n=t.split("."),o=e;n.length;){var s=n.shift();n.length?(o[s]||(o[s]={}),o=o[s]):o[s]=i}}function xo(e,t){for(var i,n,o=null,s=[e],r=e;r.parent;)s.push(r.parent),r=r.parent;if(r.nodes)for(i=0,n=r.nodes.length;i<n;i++)if(t.id===r.nodes[i].id){o=r.nodes[i];break}for(o||(o={id:t.id},e.node&&(o.attr=wo(o.attr,e.node))),i=s.length-1;i>=0;i--){var a=s[i];a.nodes||(a.nodes=[]),-1===a.nodes.indexOf(o)&&a.nodes.push(o)}t.attr&&(o.attr=wo(o.attr,t.attr))}function So(e,t){if(e.edges||(e.edges=[]),e.edges.push(t),e.edge){var i=wo({},e.edge);t.attr=wo(i,t.attr)}}function Oo(e,t,i,n,o){var s={from:t,to:i,type:n};return e.edge&&(s.attr=wo({},e.edge)),s.attr=wo(s.attr||{},o),null!=o&&o.hasOwnProperty("arrows")&&null!=o.arrows&&(s.arrows={to:{enabled:!0,type:o.arrows.type}},o.arrows=null),s}function Do(){for(mo=lo.NULL,vo="";" "===po||"\t"===po||"\n"===po||"\r"===po;)go();do{var e=!1;if("#"===po){for(var t=fo-1;" "===co.charAt(t)||"\t"===co.charAt(t);)t--;if("\n"===co.charAt(t)||""===co.charAt(t)){for(;""!=po&&"\n"!=po;)go();e=!0}}if("/"===po&&"/"===yo()){for(;""!=po&&"\n"!=po;)go();e=!0}if("/"===po&&"*"===yo()){for(;""!=po;){if("*"===po&&"/"===yo()){go(),go();break}go()}e=!0}for(;" "===po||"\t"===po||"\n"===po||"\r"===po;)go()}while(e);if(""!==po){var i=po+yo();if(uo[i])return mo=lo.DELIMITER,vo=i,go(),void go();if(uo[po])return mo=lo.DELIMITER,vo=po,void go();if(_o(po)||"-"===po){for(vo+=po,go();_o(po);)vo+=po,go();return"false"===vo?vo=!1:"true"===vo?vo=!0:isNaN(Number(vo))||(vo=Number(vo)),void(mo=lo.IDENTIFIER)}if('"'===po){for(go();""!=po&&('"'!=po||'"'===po&&'"'===yo());)'"'===po?(vo+=po,go()):"\\"===po&&"n"===yo()?(vo+="\n",go()):vo+=po,go();if('"'!=po)throw Io('End of string " expected');return go(),void(mo=lo.IDENTIFIER)}for(mo=lo.UNKNOWN;""!=po;)vo+=po,go();throw new SyntaxError('Syntax error in part "'+Fo(vo,30)+'"')}mo=lo.DELIMITER}function Mo(e){for(;""!==vo&&"}"!=vo;)To(e),";"===vo&&Do()}function To(e){var t=Eo(e);if(t)Co(e,t);else if(!function(e){if("node"===vo)return Do(),e.node=Po(),"node";if("edge"===vo)return Do(),e.edge=Po(),"edge";if("graph"===vo)return Do(),e.graph=Po(),"graph";return null}(e)){if(mo!=lo.IDENTIFIER)throw Io("Identifier expected");var i=vo;if(Do(),"="===vo){if(Do(),mo!=lo.IDENTIFIER)throw Io("Identifier expected");e[i]=vo,Do()}else!function(e,t){var i={id:t},n=Po();n&&(i.attr=n);xo(e,i),Co(e,t)}(e,i)}}function Eo(e){var t=null;if("subgraph"===vo&&((t={}).type="subgraph",Do(),mo===lo.IDENTIFIER&&(t.id=vo,Do())),"{"===vo){if(Do(),t||(t={}),t.parent=e,t.node=e.node,t.edge=e.edge,t.graph=e.graph,Mo(t),"}"!=vo)throw Io("Angle bracket } expected");Do(),delete t.node,delete t.edge,delete t.graph,delete t.parent,e.subgraphs||(e.subgraphs=[]),e.subgraphs.push(t)}return t}function Co(e,t){for(;"->"===vo||"--"===vo;){var i,n=vo;Do();var o=Eo(e);if(o)i=o;else{if(mo!=lo.IDENTIFIER)throw Io("Identifier or subgraph expected");xo(e,{id:i=vo}),Do()}So(e,Oo(e,t,i,n,Po())),t=i}}function Po(){for(var e,t,i=null,n={dashed:!0,solid:!1,dotted:[1,5]},o={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},s=new Array,r=new Array;"["===vo;){for(Do(),i={};""!==vo&&"]"!=vo;){if(mo!=lo.IDENTIFIER)throw Io("Attribute name expected");var a=vo;if(Do(),"="!=vo)throw Io("Equal sign = expected");if(Do(),mo!=lo.IDENTIFIER)throw Io("Attribute value expected");var h=vo;"style"===a&&(h=n[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:o[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:o[h]}}),s.push({attr:i,name:a,value:h}),r.push(a),Do(),","==vo&&Do()}if("]"!=vo)throw Io("Bracket ] expected");Do()}if(r.includes("dir")){var d={arrows:{}};for(e=0;e<s.length;e++)if("arrows"===s[e].name)if(null!=s[e].value.to)d.arrows.to=e;else{if(null==s[e].value.from)throw Io("Invalid value of arrows");d.arrows.from=e}else"dir"===s[e].name&&(d.dir=e);var l,u,c=s[d.dir].value;if(!r.includes("arrows"))if("both"===c)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1,s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else if("forward"===c)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1;else if("back"===c)s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else{if("none"!==c)throw Io('Invalid dir type "'+c+'"');s.push({attr:s[d.dir].attr,name:"arrows",value:""}),d.arrows.to=s.length-1}if("both"===c)d.arrows.to&&d.arrows.from?(u=s[d.arrows.to].value.to.type,l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}},s.splice(d.arrows.from,1)):d.arrows.to?(u=s[d.arrows.to].value.to.type,l="arrow",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}):d.arrows.from&&(u="arrow",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}});else if("back"===c)d.arrows.to&&d.arrows.from?(u="",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}):d.arrows.to?(u="",l="arrow",d.arrows.from=d.arrows.to,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}):d.arrows.from&&(u="",l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}),s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{from:{enabled:!0,type:s[d.arrows.from].value.from.type}}};else if("none"===c){var f;s[f=d.arrows.to?d.arrows.to:d.arrows.from]={attr:s[f].attr,name:s[f].name,value:""}}else{if("forward"!==c)throw Io('Invalid dir type "'+c+'"');d.arrows.to&&d.arrows.from?(u=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}):d.arrows.to?(u=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}):d.arrows.from&&(u="arrow",l="",d.arrows.to=d.arrows.from,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:l}}}),s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:s[d.arrows.to].value.to.type}}}}s.splice(d.dir,1)}if(r.includes("penwidth")){var p=[];for(t=s.length,e=0;e<t;e++)"width"!==s[e].name&&("penwidth"===s[e].name&&(s[e].name="width"),p.push(s[e]));s=p}for(t=s.length,e=0;e<t;e++)ko(s[e].attr,s[e].name,s[e].value);return i}function Io(e){return new SyntaxError(e+', got "'+Fo(vo,30)+'" (char '+fo+")")}function Fo(e,t){return e.length<=t?e:e.substr(0,27)+"..."}function No(e,t,i){for(var n=t.split("."),o=n.pop(),s=e,r=0;r<n.length;r++){var a=n[r];a in s||(s[a]={}),s=s[a]}return s[o]=i,e}function Yo(e,t){var i={};for(var n in e)if(e.hasOwnProperty(n)){var o=t[n];Array.isArray(o)?o.forEach((function(t){No(i,t,e[n])})):No(i,"string"==typeof o?o:n,e[n])}return i}var Ro=ro,jo=function(e){var t=ro(e),i={nodes:[],edges:[],options:{}};if(t.nodes&&t.nodes.forEach((function(e){var t={id:e.id,label:String(e.label||e.id)};wo(t,Yo(e.attr,ao)),t.image&&(t.shape="image"),i.nodes.push(t)})),t.edges){var n=function(e){var t={from:e.from,to:e.to};return wo(t,Yo(e.attr,ho)),null==t.arrows&&"->"===e.type&&(t.arrows="to"),t};t.edges.forEach((function(e){var t,o;t=e.from instanceof Object?e.from.nodes:{id:e.from},o=e.to instanceof Object?e.to.nodes:{id:e.to},e.from instanceof Object&&e.from.edges&&e.from.edges.forEach((function(e){var t=n(e);i.edges.push(t)})),function(e,t,i){Array.isArray(e)?e.forEach((function(e){Array.isArray(t)?t.forEach((function(t){i(e,t)})):i(e,t)})):Array.isArray(t)?t.forEach((function(t){i(e,t)})):i(e,t)}(t,o,(function(t,o){var s=Oo(i,t.id,o.id,e.type,e.attr),r=n(s);i.edges.push(r)})),e.to instanceof Object&&e.to.edges&&e.to.edges.forEach((function(e){var t=n(e);i.edges.push(t)}))}))}return t.attr&&(i.options=t.attr),i},Ao={parseDOT:Ro,DOTToGraph:jo},zo=Object.freeze({__proto__:null,default:Ao,__moduleExports:Ao,parseDOT:Ro,DOTToGraph:jo});function Bo(e,t){var i={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=t&&(null!=t.fixed&&(i.nodes.fixed=t.fixed),null!=t.parseColor&&(i.nodes.parseColor=t.parseColor),null!=t.inheritColor&&(i.edges.inheritColor=t.inheritColor));var n=e.edges.map((function(e){var t={from:e.source,id:e.id,to:e.target};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),"Directed"===e.type&&(t.arrows="to"),e.color&&!1===i.edges.inheritColor&&(t.color=e.color),t}));return{nodes:e.nodes.map((function(e){var t={id:e.id,fixed:i.nodes.fixed&&null!=e.x&&null!=e.y};return null!=e.attributes&&(t.attributes=e.attributes),null!=e.label&&(t.label=e.label),null!=e.size&&(t.size=e.size),null!=e.attributes&&null!=e.attributes.title&&(t.title=e.attributes.title),null!=e.title&&(t.title=e.title),null!=e.x&&(t.x=e.x),null!=e.y&&(t.y=e.y),null!=e.color&&(!0===i.nodes.parseColor?t.color=e.color:t.color={background:e.color,border:e.color,highlight:{background:e.color,border:e.color},hover:{background:e.color,border:e.color}}),t})),edges:n}}var Lo=Object.freeze({__proto__:null,parseGephi:Bo}),Ho=Object.freeze({__proto__:null}),Wo=t((function(e,t){e.exports=function(e){var t,i=e&&e.preventDefault||!1,n=e&&e.container||window,o={},s={keydown:{},keyup:{}},r={};for(t=97;t<=122;t++)r[String.fromCharCode(t)]={code:t-97+65,shift:!1};for(t=65;t<=90;t++)r[String.fromCharCode(t)]={code:t,shift:!0};for(t=0;t<=9;t++)r[""+t]={code:48+t,shift:!1};for(t=1;t<=12;t++)r["F"+t]={code:111+t,shift:!1};for(t=0;t<=9;t++)r["num"+t]={code:96+t,shift:!1};r["num*"]={code:106,shift:!1},r["num+"]={code:107,shift:!1},r["num-"]={code:109,shift:!1},r["num/"]={code:111,shift:!1},r["num."]={code:110,shift:!1},r.left={code:37,shift:!1},r.up={code:38,shift:!1},r.right={code:39,shift:!1},r.down={code:40,shift:!1},r.space={code:32,shift:!1},r.enter={code:13,shift:!1},r.shift={code:16,shift:void 0},r.esc={code:27,shift:!1},r.backspace={code:8,shift:!1},r.tab={code:9,shift:!1},r.ctrl={code:17,shift:!1},r.alt={code:18,shift:!1},r.delete={code:46,shift:!1},r.pageup={code:33,shift:!1},r.pagedown={code:34,shift:!1},r["="]={code:187,shift:!1},r["-"]={code:189,shift:!1},r["]"]={code:221,shift:!1},r["["]={code:219,shift:!1};var a=function(e){d(e,"keydown")},h=function(e){d(e,"keyup")},d=function(e,t){if(void 0!==s[t][e.keyCode]){for(var n=s[t][e.keyCode],o=0;o<n.length;o++)void 0===n[o].shift?n[o].fn(e):1==n[o].shift&&1==e.shiftKey?n[o].fn(e):0==n[o].shift&&0==e.shiftKey&&n[o].fn(e);1==i&&e.preventDefault()}};return o.bind=function(e,t,i){if(void 0===i&&(i="keydown"),void 0===r[e])throw new Error("unsupported key: "+e);void 0===s[i][r[e].code]&&(s[i][r[e].code]=[]),s[i][r[e].code].push({fn:t,shift:r[e].shift})},o.bindAll=function(e,t){for(var i in void 0===t&&(t="keydown"),r)r.hasOwnProperty(i)&&o.bind(i,e,t)},o.getKey=function(e){for(var t in r)if(r.hasOwnProperty(t)){if(1==e.shiftKey&&1==r[t].shift&&e.keyCode==r[t].code)return t;if(0==e.shiftKey&&0==r[t].shift&&e.keyCode==r[t].code)return t;if(e.keyCode==r[t].code&&"shift"==t)return t}return"unknown key, currently not supported"},o.unbind=function(e,t,i){if(void 0===i&&(i="keydown"),void 0===r[e])throw new Error("unsupported key: "+e);if(void 0!==t){var n=[],o=s[i][r[e].code];if(void 0!==o)for(var a=0;a<o.length;a++)o[a].fn==t&&o[a].shift==r[e].shift||n.push(s[i][r[e].code][a]);s[i][r[e].code]=n}else s[i][r[e].code]=[]},o.reset=function(){s={keydown:{},keyup:{}}},o.destroy=function(){s={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",h,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",h,!0),o}})),Vo=Object.freeze({__proto__:null,default:Wo,__moduleExports:Wo});function Uo(){return(Uo=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var i=arguments[t];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(e[n]=i[n])}return e}).apply(this,arguments)}function Go(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,e.__proto__=t}function qo(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}var Zo,Xo="function"!=typeof Object.assign?function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var t=Object(e),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(t[o]=n[o])}return t}:Object.assign,$o=["","webkit","Moz","MS","ms","o"],Ko="undefined"==typeof document?{style:{}}:document.createElement("div"),Jo="function",Qo=Math.round,es=Math.abs,ts=Date.now;function is(e,t){for(var i,n,o=t[0].toUpperCase()+t.slice(1),s=0;s<$o.length;){if((n=(i=$o[s])?i+o:t)in e)return n;s++}}Zo="undefined"==typeof window?{}:window;var ns=is(Ko.style,"touchAction"),os=void 0!==ns;var ss="auto",rs="manipulation",as="none",hs="pan-x",ds="pan-y",ls=function(){if(!os)return!1;var e={},t=Zo.CSS&&Zo.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return e[i]=!t||Zo.CSS.supports("touch-action",i)})),e}(),us="ontouchstart"in Zo,cs=void 0!==is(Zo,"PointerEvent"),fs=us&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),ps="touch",vs="mouse",ms=25,gs=1,ys=2,bs=4,_s=8,ws=1,ks=2,xs=4,Ss=8,Os=16,Ds=ks|xs,Ms=Ss|Os,Ts=Ds|Ms,Es=["x","y"],Cs=["clientX","clientY"];function Ps(e,t,i){var n;if(e)if(e.forEach)e.forEach(t,i);else if(void 0!==e.length)for(n=0;n<e.length;)t.call(i,e[n],n,e),n++;else for(n in e)e.hasOwnProperty(n)&&t.call(i,e[n],n,e)}function Is(e,t){return typeof e===Jo?e.apply(t&&t[0]||void 0,t):e}function Fs(e,t){return e.indexOf(t)>-1}var Ns=function(){function e(e,t){this.manager=e,this.set(t)}var t=e.prototype;return t.set=function(e){"compute"===e&&(e=this.compute()),os&&this.manager.element.style&&ls[e]&&(this.manager.element.style[ns]=e),this.actions=e.toLowerCase().trim()},t.update=function(){this.set(this.manager.options.touchAction)},t.compute=function(){var e=[];return Ps(this.manager.recognizers,(function(t){Is(t.options.enable,[t])&&(e=e.concat(t.getTouchAction()))})),function(e){if(Fs(e,as))return as;var t=Fs(e,hs),i=Fs(e,ds);return t&&i?as:t||i?t?hs:ds:Fs(e,rs)?rs:ss}(e.join(" "))},t.preventDefaults=function(e){var t=e.srcEvent,i=e.offsetDirection;if(this.manager.session.prevented)t.preventDefault();else{var n=this.actions,o=Fs(n,as)&&!ls[as],s=Fs(n,ds)&&!ls[ds],r=Fs(n,hs)&&!ls[hs];if(o){var a=1===e.pointers.length,h=e.distance<2,d=e.deltaTime<250;if(a&&h&&d)return}if(!r||!s)return o||s&&i&Ds||r&&i&Ms?this.preventSrc(t):void 0}},t.preventSrc=function(e){this.manager.session.prevented=!0,e.preventDefault()},e}();function Ys(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1}function Rs(e){var t=e.length;if(1===t)return{x:Qo(e[0].clientX),y:Qo(e[0].clientY)};for(var i=0,n=0,o=0;o<t;)i+=e[o].clientX,n+=e[o].clientY,o++;return{x:Qo(i/t),y:Qo(n/t)}}function js(e){for(var t=[],i=0;i<e.pointers.length;)t[i]={clientX:Qo(e.pointers[i].clientX),clientY:Qo(e.pointers[i].clientY)},i++;return{timeStamp:ts(),pointers:t,center:Rs(t),deltaX:e.deltaX,deltaY:e.deltaY}}function As(e,t,i){i||(i=Es);var n=t[i[0]]-e[i[0]],o=t[i[1]]-e[i[1]];return Math.sqrt(n*n+o*o)}function zs(e,t,i){i||(i=Es);var n=t[i[0]]-e[i[0]],o=t[i[1]]-e[i[1]];return 180*Math.atan2(o,n)/Math.PI}function Bs(e,t){return e===t?ws:es(e)>=es(t)?e<0?ks:xs:t<0?Ss:Os}function Ls(e,t,i){return{x:t/e||0,y:i/e||0}}function Hs(e,t){var i=e.session,n=t.pointers,o=n.length;i.firstInput||(i.firstInput=js(t)),o>1&&!i.firstMultiple?i.firstMultiple=js(t):1===o&&(i.firstMultiple=!1);var s=i.firstInput,r=i.firstMultiple,a=r?r.center:s.center,h=t.center=Rs(n);t.timeStamp=ts(),t.deltaTime=t.timeStamp-s.timeStamp,t.angle=zs(a,h),t.distance=As(a,h),function(e,t){var i=t.center,n=e.offsetDelta||{},o=e.prevDelta||{},s=e.prevInput||{};t.eventType!==gs&&s.eventType!==bs||(o=e.prevDelta={x:s.deltaX||0,y:s.deltaY||0},n=e.offsetDelta={x:i.x,y:i.y}),t.deltaX=o.x+(i.x-n.x),t.deltaY=o.y+(i.y-n.y)}(i,t),t.offsetDirection=Bs(t.deltaX,t.deltaY);var d,l,u=Ls(t.deltaTime,t.deltaX,t.deltaY);t.overallVelocityX=u.x,t.overallVelocityY=u.y,t.overallVelocity=es(u.x)>es(u.y)?u.x:u.y,t.scale=r?(d=r.pointers,As((l=n)[0],l[1],Cs)/As(d[0],d[1],Cs)):1,t.rotation=r?function(e,t){return zs(t[1],t[0],Cs)+zs(e[1],e[0],Cs)}(r.pointers,n):0,t.maxPointers=i.prevInput?t.pointers.length>i.prevInput.maxPointers?t.pointers.length:i.prevInput.maxPointers:t.pointers.length,function(e,t){var i,n,o,s,r=e.lastInterval||t,a=t.timeStamp-r.timeStamp;if(t.eventType!==_s&&(a>ms||void 0===r.velocity)){var h=t.deltaX-r.deltaX,d=t.deltaY-r.deltaY,l=Ls(a,h,d);n=l.x,o=l.y,i=es(l.x)>es(l.y)?l.x:l.y,s=Bs(h,d),e.lastInterval=t}else i=r.velocity,n=r.velocityX,o=r.velocityY,s=r.direction;t.velocity=i,t.velocityX=n,t.velocityY=o,t.direction=s}(i,t);var c=e.element;Ys(t.srcEvent.target,c)&&(c=t.srcEvent.target),t.target=c}function Ws(e,t,i){var n=i.pointers.length,o=i.changedPointers.length,s=t&gs&&n-o==0,r=t&(bs|_s)&&n-o==0;i.isFirst=!!s,i.isFinal=!!r,s&&(e.session={}),i.eventType=t,Hs(e,i),e.emit("hammer.input",i),e.recognize(i),e.session.prevInput=i}function Vs(e){return e.trim().split(/\s+/g)}function Us(e,t,i){Ps(Vs(t),(function(t){e.addEventListener(t,i,!1)}))}function Gs(e,t,i){Ps(Vs(t),(function(t){e.removeEventListener(t,i,!1)}))}function qs(e){var t=e.ownerDocument||e;return t.defaultView||t.parentWindow||window}var Zs=function(){function e(e,t){var i=this;this.manager=e,this.callback=t,this.element=e.element,this.target=e.options.inputTarget,this.domHandler=function(t){Is(e.options.enable,[e])&&i.handler(t)},this.init()}var t=e.prototype;return t.handler=function(){},t.init=function(){this.evEl&&Us(this.element,this.evEl,this.domHandler),this.evTarget&&Us(this.target,this.evTarget,this.domHandler),this.evWin&&Us(qs(this.element),this.evWin,this.domHandler)},t.destroy=function(){this.evEl&&Gs(this.element,this.evEl,this.domHandler),this.evTarget&&Gs(this.target,this.evTarget,this.domHandler),this.evWin&&Gs(qs(this.element),this.evWin,this.domHandler)},e}();function Xs(e,t,i){if(e.indexOf&&!i)return e.indexOf(t);for(var n=0;n<e.length;){if(i&&e[n][i]==t||!i&&e[n]===t)return n;n++}return-1}var $s={pointerdown:gs,pointermove:ys,pointerup:bs,pointercancel:_s,pointerout:_s},Ks={2:ps,3:"pen",4:vs,5:"kinect"},Js="pointerdown",Qs="pointermove pointerup pointercancel";Zo.MSPointerEvent&&!Zo.PointerEvent&&(Js="MSPointerDown",Qs="MSPointerMove MSPointerUp MSPointerCancel");var er=function(e){function t(){var i,n=t.prototype;return n.evEl=Js,n.evWin=Qs,(i=e.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return Go(t,e),t.prototype.handler=function(e){var t=this.store,i=!1,n=e.type.toLowerCase().replace("ms",""),o=$s[n],s=Ks[e.pointerType]||e.pointerType,r=s===ps,a=Xs(t,e.pointerId,"pointerId");o&gs&&(0===e.button||r)?a<0&&(t.push(e),a=t.length-1):o&(bs|_s)&&(i=!0),a<0||(t[a]=e,this.callback(this.manager,o,{pointers:t,changedPointers:[e],pointerType:s,srcEvent:e}),i&&t.splice(a,1))},t}(Zs);function tr(e){return Array.prototype.slice.call(e,0)}function ir(e,t,i){for(var n=[],o=[],s=0;s<e.length;){var r=t?e[s][t]:e[s];Xs(o,r)<0&&n.push(e[s]),o[s]=r,s++}return i&&(n=t?n.sort((function(e,i){return e[t]>i[t]})):n.sort()),n}var nr={touchstart:gs,touchmove:ys,touchend:bs,touchcancel:_s},or="touchstart touchmove touchend touchcancel",sr=function(e){function t(){var i;return t.prototype.evTarget=or,(i=e.apply(this,arguments)||this).targetIds={},i}return Go(t,e),t.prototype.handler=function(e){var t=nr[e.type],i=rr.call(this,e,t);i&&this.callback(this.manager,t,{pointers:i[0],changedPointers:i[1],pointerType:ps,srcEvent:e})},t}(Zs);function rr(e,t){var i,n,o=tr(e.touches),s=this.targetIds;if(t&(gs|ys)&&1===o.length)return s[o[0].identifier]=!0,[o,o];var r=tr(e.changedTouches),a=[],h=this.target;if(n=o.filter((function(e){return Ys(e.target,h)})),t===gs)for(i=0;i<n.length;)s[n[i].identifier]=!0,i++;for(i=0;i<r.length;)s[r[i].identifier]&&a.push(r[i]),t&(bs|_s)&&delete s[r[i].identifier],i++;return a.length?[ir(n.concat(a),"identifier",!0),a]:void 0}var ar={mousedown:gs,mousemove:ys,mouseup:bs},hr="mousedown",dr="mousemove mouseup",lr=function(e){function t(){var i,n=t.prototype;return n.evEl=hr,n.evWin=dr,(i=e.apply(this,arguments)||this).pressed=!1,i}return Go(t,e),t.prototype.handler=function(e){var t=ar[e.type];t&gs&&0===e.button&&(this.pressed=!0),t&ys&&1!==e.which&&(t=bs),this.pressed&&(t&bs&&(this.pressed=!1),this.callback(this.manager,t,{pointers:[e],changedPointers:[e],pointerType:vs,srcEvent:e}))},t}(Zs),ur=2500,cr=25;function fr(e){var t=e.changedPointers[0];if(t.identifier===this.primaryTouch){var i={x:t.clientX,y:t.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var e=n.indexOf(i);e>-1&&n.splice(e,1)}),ur)}}function pr(e,t){e&gs?(this.primaryTouch=t.changedPointers[0].identifier,fr.call(this,t)):e&(bs|_s)&&fr.call(this,t)}function vr(e){for(var t=e.srcEvent.clientX,i=e.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],s=Math.abs(t-o.x),r=Math.abs(i-o.y);if(s<=cr&&r<=cr)return!0}return!1}var mr=function(){return function(e){function t(t,i){var n;return(n=e.call(this,t,i)||this).handler=function(e,t,i){var o=i.pointerType===ps,s=i.pointerType===vs;if(!(s&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(o)pr.call(qo(qo(n)),t,i);else if(s&&vr.call(qo(qo(n)),i))return;n.callback(e,t,i)}},n.touch=new sr(n.manager,n.handler),n.mouse=new lr(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return Go(t,e),t.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},t}(Zs)}();function gr(e,t,i){return!!Array.isArray(e)&&(Ps(e,i[t],i),!0)}var yr=1,br=2,_r=4,wr=8,kr=wr,xr=16,Sr=1;function Or(e,t){var i=t.manager;return i?i.get(e):e}function Dr(e){return e&xr?"cancel":e&wr?"end":e&_r?"move":e&br?"start":""}var Mr=function(){function e(e){void 0===e&&(e={}),this.options=Uo({enable:!0},e),this.id=Sr++,this.manager=null,this.state=yr,this.simultaneous={},this.requireFail=[]}var t=e.prototype;return t.set=function(e){return Xo(this.options,e),this.manager&&this.manager.touchAction.update(),this},t.recognizeWith=function(e){if(gr(e,"recognizeWith",this))return this;var t=this.simultaneous;return t[(e=Or(e,this)).id]||(t[e.id]=e,e.recognizeWith(this)),this},t.dropRecognizeWith=function(e){return gr(e,"dropRecognizeWith",this)?this:(e=Or(e,this),delete this.simultaneous[e.id],this)},t.requireFailure=function(e){if(gr(e,"requireFailure",this))return this;var t=this.requireFail;return-1===Xs(t,e=Or(e,this))&&(t.push(e),e.requireFailure(this)),this},t.dropRequireFailure=function(e){if(gr(e,"dropRequireFailure",this))return this;e=Or(e,this);var t=Xs(this.requireFail,e);return t>-1&&this.requireFail.splice(t,1),this},t.hasRequireFailures=function(){return this.requireFail.length>0},t.canRecognizeWith=function(e){return!!this.simultaneous[e.id]},t.emit=function(e){var t=this,i=this.state;function n(i){t.manager.emit(i,e)}i<wr&&n(t.options.event+Dr(i)),n(t.options.event),e.additionalEvent&&n(e.additionalEvent),i>=wr&&n(t.options.event+Dr(i))},t.tryEmit=function(e){if(this.canEmit())return this.emit(e);this.state=32},t.canEmit=function(){for(var e=0;e<this.requireFail.length;){if(!(this.requireFail[e].state&(32|yr)))return!1;e++}return!0},t.recognize=function(e){var t=Xo({},e);if(!Is(this.options.enable,[this,t]))return this.reset(),void(this.state=32);this.state&(kr|xr|32)&&(this.state=yr),this.state=this.process(t),this.state&(br|_r|wr|xr)&&this.tryEmit(t)},t.process=function(e){},t.getTouchAction=function(){},t.reset=function(){},e}(),Tr={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,preset:[],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function Er(e,t){var i,n=e.element;n.style&&(Ps(e.options.cssProps,(function(o,s){i=is(n.style,s),t?(e.oldCssProps[i]=n.style[i],n.style[i]=o):n.style[i]=e.oldCssProps[i]||""})),t||(e.oldCssProps={}))}var Cr=function(){function e(e,t){var i,n=this;this.options=Xo({},Tr,t||{}),this.options.inputTarget=this.options.inputTarget||e,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=e,this.input=new((i=this).options.inputClass||(cs?er:fs?sr:us?mr:lr))(i,Ws),this.touchAction=new Ns(this,this.options.touchAction),Er(this,!0),Ps(this.options.recognizers,(function(e){var t=n.add(new e[0](e[1]));e[2]&&t.recognizeWith(e[2]),e[3]&&t.requireFailure(e[3])}),this)}var t=e.prototype;return t.set=function(e){return Xo(this.options,e),e.touchAction&&this.touchAction.update(),e.inputTarget&&(this.input.destroy(),this.input.target=e.inputTarget,this.input.init()),this},t.stop=function(e){this.session.stopped=e?2:1},t.recognize=function(e){var t=this.session;if(!t.stopped){var i;this.touchAction.preventDefaults(e);var n=this.recognizers,o=t.curRecognizer;(!o||o&&o.state&kr)&&(t.curRecognizer=null,o=null);for(var s=0;s<n.length;)i=n[s],2===t.stopped||o&&i!==o&&!i.canRecognizeWith(o)?i.reset():i.recognize(e),!o&&i.state&(br|_r|wr)&&(t.curRecognizer=i,o=i),s++}},t.get=function(e){if(e instanceof Mr)return e;for(var t=this.recognizers,i=0;i<t.length;i++)if(t[i].options.event===e)return t[i];return null},t.add=function(e){if(gr(e,"add",this))return this;var t=this.get(e.options.event);return t&&this.remove(t),this.recognizers.push(e),e.manager=this,this.touchAction.update(),e},t.remove=function(e){if(gr(e,"remove",this))return this;var t=this.get(e);if(e){var i=this.recognizers,n=Xs(i,t);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},t.on=function(e,t){if(void 0===e||void 0===t)return this;var i=this.handlers;return Ps(Vs(e),(function(e){i[e]=i[e]||[],i[e].push(t)})),this},t.off=function(e,t){if(void 0===e)return this;var i=this.handlers;return Ps(Vs(e),(function(e){t?i[e]&&i[e].splice(Xs(i[e],t),1):delete i[e]})),this},t.emit=function(e,t){this.options.domEvents&&function(e,t){var i=document.createEvent("Event");i.initEvent(e,!0,!0),i.gesture=t,t.target.dispatchEvent(i)}(e,t);var i=this.handlers[e]&&this.handlers[e].slice();if(i&&i.length){t.type=e,t.preventDefault=function(){t.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](t),n++}},t.destroy=function(){this.element&&Er(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},e}(),Pr={touchstart:gs,touchmove:ys,touchend:bs,touchcancel:_s},Ir="touchstart",Fr="touchstart touchmove touchend touchcancel",Nr=function(e){function t(){var i,n=t.prototype;return n.evTarget=Ir,n.evWin=Fr,(i=e.apply(this,arguments)||this).started=!1,i}return Go(t,e),t.prototype.handler=function(e){var t=Pr[e.type];if(t===gs&&(this.started=!0),this.started){var i=Yr.call(this,e,t);t&(bs|_s)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,t,{pointers:i[0],changedPointers:i[1],pointerType:ps,srcEvent:e})}},t}(Zs);function Yr(e,t){var i=tr(e.touches),n=tr(e.changedTouches);return t&(bs|_s)&&(i=ir(i.concat(n),"identifier",!0)),[i,n]}var Rr=function(e){function t(t){return void 0===t&&(t={}),e.call(this,Uo({pointers:1},t))||this}Go(t,e);var i=t.prototype;return i.attrTest=function(e){var t=this.options.pointers;return 0===t||e.pointers.length===t},i.process=function(e){var t=this.state,i=e.eventType,n=t&(br|_r),o=this.attrTest(e);return n&&(i&_s||!o)?t|xr:n||o?i&bs?t|wr:t&br?t|_r:br:32},t}(Mr),jr=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,Uo({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},t))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){return[rs]},i.process=function(e){var t=this,i=this.options,n=e.pointers.length===i.pointers,o=e.distance<i.threshold,s=e.deltaTime<i.time;if(this.reset(),e.eventType&gs&&0===this.count)return this.failTimeout();if(o&&s&&n){if(e.eventType!==bs)return this.failTimeout();var r=!this.pTime||e.timeStamp-this.pTime<i.interval,a=!this.pCenter||As(this.pCenter,e.center)<i.posThreshold;if(this.pTime=e.timeStamp,this.pCenter=e.center,a&&r?this.count+=1:this.count=1,this._input=e,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){t.state=kr,t.tryEmit()}),i.interval),br):kr}return 32},i.failTimeout=function(){var e=this;return this._timer=setTimeout((function(){e.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===kr&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},t}(Mr);function Ar(e){return e===Os?"down":e===Ss?"up":e===ks?"left":e===xs?"right":""}var zr=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,Uo({event:"pan",threshold:10,pointers:1,direction:Ts},t))||this).pX=null,i.pY=null,i}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){var e=this.options.direction,t=[];return e&Ds&&t.push(ds),e&Ms&&t.push(hs),t},i.directionTest=function(e){var t=this.options,i=!0,n=e.distance,o=e.direction,s=e.deltaX,r=e.deltaY;return o&t.direction||(t.direction&Ds?(o=0===s?ws:s<0?ks:xs,i=s!==this.pX,n=Math.abs(e.deltaX)):(o=0===r?ws:r<0?Ss:Os,i=r!==this.pY,n=Math.abs(e.deltaY))),e.direction=o,i&&n>t.threshold&&o&t.direction},i.attrTest=function(e){return Rr.prototype.attrTest.call(this,e)&&(this.state&br||!(this.state&br)&&this.directionTest(e))},i.emit=function(t){this.pX=t.deltaX,this.pY=t.deltaY;var i=Ar(t.direction);i&&(t.additionalEvent=this.options.event+i),e.prototype.emit.call(this,t)},t}(Rr),Br=function(e){function t(t){return void 0===t&&(t={}),e.call(this,Uo({event:"swipe",threshold:10,velocity:.3,direction:Ds|Ms,pointers:1},t))||this}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){return zr.prototype.getTouchAction.call(this)},i.attrTest=function(t){var i,n=this.options.direction;return n&(Ds|Ms)?i=t.overallVelocity:n&Ds?i=t.overallVelocityX:n&Ms&&(i=t.overallVelocityY),e.prototype.attrTest.call(this,t)&&n&t.offsetDirection&&t.distance>this.options.threshold&&t.maxPointers===this.options.pointers&&es(i)>this.options.velocity&&t.eventType&bs},i.emit=function(e){var t=Ar(e.offsetDirection);t&&this.manager.emit(this.options.event+t,e),this.manager.emit(this.options.event,e)},t}(Rr),Lr=function(e){function t(t){return void 0===t&&(t={}),e.call(this,Uo({event:"pinch",threshold:0,pointers:2},t))||this}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){return[as]},i.attrTest=function(t){return e.prototype.attrTest.call(this,t)&&(Math.abs(t.scale-1)>this.options.threshold||this.state&br)},i.emit=function(t){if(1!==t.scale){var i=t.scale<1?"in":"out";t.additionalEvent=this.options.event+i}e.prototype.emit.call(this,t)},t}(Rr),Hr=function(e){function t(t){return void 0===t&&(t={}),e.call(this,Uo({event:"rotate",threshold:0,pointers:2},t))||this}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){return[as]},i.attrTest=function(t){return e.prototype.attrTest.call(this,t)&&(Math.abs(t.rotation)>this.options.threshold||this.state&br)},t}(Rr),Wr=function(e){function t(t){var i;return void 0===t&&(t={}),(i=e.call(this,Uo({event:"press",pointers:1,time:251,threshold:9},t))||this)._timer=null,i._input=null,i}Go(t,e);var i=t.prototype;return i.getTouchAction=function(){return[ss]},i.process=function(e){var t=this,i=this.options,n=e.pointers.length===i.pointers,o=e.distance<i.threshold,s=e.deltaTime>i.time;if(this._input=e,!o||!n||e.eventType&(bs|_s)&&!s)this.reset();else if(e.eventType&gs)this.reset(),this._timer=setTimeout((function(){t.state=kr,t.tryEmit()}),i.time);else if(e.eventType&bs)return kr;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(e){this.state===kr&&(e&&e.eventType&bs?this.manager.emit(this.options.event+"up",e):(this._input.timeStamp=ts(),this.manager.emit(this.options.event,this._input)))},t}(Mr);function Vr(e,t,i){var n="DEPRECATED METHOD: "+t+"\n"+i+" AT \n";return function(){var t=new Error("get-stack-trace"),i=t&&t.stack?t.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,i),e.apply(this,arguments)}}var Ur=Vr((function(e,t,i){for(var n=Object.keys(t),o=0;o<n.length;)(!i||i&&void 0===e[n[o]])&&(e[n[o]]=t[n[o]]),o++;return e}),"extend","Use `assign`."),Gr=Vr((function(e,t){return Ur(e,t,!0)}),"merge","Use `assign`.");function qr(e,t,i){var n,o=t.prototype;(n=e.prototype=Object.create(o)).constructor=e,n._super=o,i&&Xo(n,i)}function Zr(e,t){return function(){return e.apply(t,arguments)}}var Xr,$r=function(){var e=function(e,t){return void 0===t&&(t={}),new Cr(e,Uo({recognizers:[[Hr,{enable:!1}],[Lr,{enable:!1},["rotate"]],[Br,{direction:Ds}],[zr,{direction:Ds},["swipe"]],[jr],[jr,{event:"doubletap",taps:2},["tap"]],[Wr]]},t))};return e.VERSION="2.0.15",e.DIRECTION_ALL=Ts,e.DIRECTION_DOWN=Os,e.DIRECTION_LEFT=ks,e.DIRECTION_RIGHT=xs,e.DIRECTION_UP=Ss,e.DIRECTION_HORIZONTAL=Ds,e.DIRECTION_VERTICAL=Ms,e.DIRECTION_NONE=ws,e.DIRECTION_DOWN=Os,e.INPUT_START=gs,e.INPUT_MOVE=ys,e.INPUT_END=bs,e.INPUT_CANCEL=_s,e.STATE_POSSIBLE=yr,e.STATE_BEGAN=br,e.STATE_CHANGED=_r,e.STATE_ENDED=wr,e.STATE_RECOGNIZED=kr,e.STATE_CANCELLED=xr,e.STATE_FAILED=32,e.Manager=Cr,e.Input=Zs,e.TouchAction=Ns,e.TouchInput=sr,e.MouseInput=lr,e.PointerEventInput=er,e.TouchMouseInput=mr,e.SingleTouchInput=Nr,e.Recognizer=Mr,e.AttrRecognizer=Rr,e.Tap=jr,e.Pan=zr,e.Swipe=Br,e.Pinch=Lr,e.Rotate=Hr,e.Press=Wr,e.on=Us,e.off=Gs,e.each=Ps,e.merge=Gr,e.extend=Ur,e.bindFn=Zr,e.assign=Xo,e.inherit=qr,e.bindFn=Zr,e.prefixed=is,e.toArray=tr,e.inArray=Xs,e.uniqueArray=ir,e.splitStr=Vs,e.boolOrFn=Is,e.hasParent=Ys,e.addEventListeners=Us,e.removeEventListeners=Gs,e.defaults=Tr,e}(),Kr=t((function(e){if("undefined"!=typeof window){var t=window.Hammer||$r;e.exports=t}else e.exports=function(){return{on:e=function(){},off:e,destroy:e,emit:e,get:function(t){return{set:e}}};var e}})),Jr=Object.freeze({__proto__:null,default:Kr,__moduleExports:Kr});function Qr(e){var t=this;this.active=!1,this.dom={container:e},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=Kr(this.dom.overlay),this.hammer.on("tap",this._onTapOverlay.bind(this));["tap","doubletap","press","pinch","pan","panstart","panmove","panend"].forEach((function(e){t.hammer.on(e,(function(e){e.srcEvent.stopPropagation()}))})),document&&document.body&&(this.onClick=function(i){(function(e,t){for(;e;){if(e===t)return!0;e=e.parentNode}return!1})(i.target,e)||t.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=Wo(),this.escListener=this.deactivate.bind(this)}(Xr=Ho)&&Xr.default,i(Qr.prototype),Qr.current=null,Qr.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},Qr.prototype.activate=function(){Qr.current&&Qr.current.deactivate(),Qr.current=this,this.active=!0,this.dom.overlay.style.display="none",oo.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),this.keycharm.bind("esc",this.escListener)},Qr.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="block",oo.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},Qr.prototype._onTapOverlay=function(e){this.activate(),e.srcEvent.stopPropagation()};var ea=Qr,ta=t((function(e,t){t.en={edit:"Edit",del:"Delete selected",back:"Back",addNode:"Add Node",addEdge:"Add Edge",editNode:"Edit Node",editEdge:"Edit Edge",addDescription:"Click in an empty space to place a new node.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",createEdgeError:"Cannot link edges to a cluster.",deleteClusterError:"Clusters cannot be deleted.",editClusterError:"Clusters cannot be edited."},t.en_EN=t.en,t.en_US=t.en,t.de={edit:"Editieren",del:"Lösche Auswahl",back:"Zurück",addNode:"Knoten hinzufügen",addEdge:"Kante hinzufügen",editNode:"Knoten editieren",editEdge:"Kante editieren",addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",deleteClusterError:"Cluster können nicht gelöscht werden.",editClusterError:"Cluster können nicht editiert werden."},t.de_DE=t.de,t.es={edit:"Editar",del:"Eliminar selección",back:"Atrás",addNode:"Añadir nodo",addEdge:"Añadir arista",editNode:"Editar nodo",editEdge:"Editar arista",addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",createEdgeError:"No se puede conectar una arista a un grupo.",deleteClusterError:"No es posible eliminar grupos.",editClusterError:"No es posible editar grupos."},t.es_ES=t.es,t.it={edit:"Modifica",del:"Cancella la selezione",back:"Indietro",addNode:"Aggiungi un nodo",addEdge:"Aggiungi un vertice",editNode:"Modifica il nodo",editEdge:"Modifica il vertice",addDescription:"Clicca per aggiungere un nuovo nodo",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",createEdgeError:"Non si possono collegare vertici ad un cluster",deleteClusterError:"I cluster non possono essere cancellati",editClusterError:"I clusters non possono essere modificati."},t.it_IT=t.it,t.nl={edit:"Wijzigen",del:"Selectie verwijderen",back:"Terug",addNode:"Node toevoegen",addEdge:"Link toevoegen",editNode:"Node wijzigen",editEdge:"Link wijzigen",addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",createEdgeError:"Kan geen link maken naar een cluster.",deleteClusterError:"Clusters kunnen niet worden verwijderd.",editClusterError:"Clusters kunnen niet worden aangepast."},t.nl_NL=t.nl,t.nl_BE=t.nl,t["pt-br"]={edit:"Editar",del:"Remover selecionado",back:"Voltar",addNode:"Adicionar nó",addEdge:"Adicionar aresta",editNode:"Editar nó",editEdge:"Editar aresta",addDescription:"Clique em um espaço em branco para adicionar um novo nó",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",createEdgeError:"Não foi possível linkar arestas a um cluster.",deleteClusterError:"Clusters não puderam ser removidos.",editClusterError:"Clusters não puderam ser editados."},t["pt-BR"]=t["pt-br"],t.pt_BR=t["pt-br"],t.pt_br=t["pt-br"],t.ru={edit:"Редактировать",del:"Удалить выбранное",back:"Назад",addNode:"Добавить узел",addEdge:"Добавить ребро",editNode:"Редактировать узел",editEdge:"Редактировать ребро",addDescription:"Кликните в свободное место, чтобы добавить новый узел.",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",createEdgeError:"Невозможно соединить ребра в кластер.",deleteClusterError:"Кластеры не могут быть удалены",editClusterError:"Кластеры недоступны для редактирования."},t.ru_RU=t.ru,t.cn={edit:"编辑",del:"删除选定",back:"返回",addNode:"添加节点",addEdge:"添加连接线",editNode:"编辑节点",editEdge:"编辑连接线",addDescription:"单击空白处放置新节点。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",createEdgeError:"无法将连接线连接到群集。",deleteClusterError:"无法删除群集。",editClusterError:"无法编辑群集。"},t.zh_CN=t.cn,t.uk={edit:"Редагувати",del:"Видалити обране",back:"Назад",addNode:"Додати вузол",addEdge:"Додати край",editNode:"Редагувати вузол",editEdge:"Редагувати край",addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",createEdgeError:"Не можливо об'єднати краї в групу.",deleteClusterError:"Групи не можуть бути видалені.",editClusterError:"Групи недоступні для редагування."},t.uk_UA=t.uk,t.fr={edit:"Editer",del:"Effacer la selection",back:"Retour",addNode:"Ajouter un noeud",addEdge:"Ajouter un lien",editNode:"Editer le noeud",editEdge:"Editer le lien",addDescription:"Cliquez dans un endroit vide pour placer un noeud.",edgeDescription:"Cliquez sur un noeud et glissez le lien vers un autre noeud pour les connecter.",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un noeud.",createEdgeError:"Impossible de créer un lien vers un cluster.",deleteClusterError:"Les clusters ne peuvent pas être éffacés.",editClusterError:"Les clusters ne peuvent pas être édites."},t.fr_FR=t.fr,t.cs={edit:"Upravit",del:"Smazat výběr",back:"Zpět",addNode:"Přidat vrchol",addEdge:"Přidat hranu",editNode:"Upravit vrchol",editEdge:"Upravit hranu",addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",createEdgeError:"Nelze připojit hranu ke shluku.",deleteClusterError:"Nelze mazat shluky.",editClusterError:"Nelze upravovat shluky."},t.cs_CZ=t.cs}));function ia(e){return(ia="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function na(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function oa(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function sa(e,t,i){return t&&oa(e.prototype,t),i&&oa(e,i),e}function ra(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function aa(e,t){var i=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),i.push.apply(i,n)}return i}function ha(e){for(var t=1;t<arguments.length;t++){var i=null!=arguments[t]?arguments[t]:{};t%2?aa(i,!0).forEach((function(t){ra(e,t,i[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(i)):aa(i).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(i,t))}))}return e}function da(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&ua(e,t)}function la(e){return(la=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function ua(e,t){return(ua=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function ca(e,t){return!t||"object"!=typeof t&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function fa(e,t,i){return(fa="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(e,t,i){var n=function(e,t){for(;!Object.prototype.hasOwnProperty.call(e,t)&&null!==(e=la(e)););return e}(e,t);if(n){var o=Object.getOwnPropertyDescriptor(n,t);return o.get?o.get.call(i):o.value}})(e,t,i||e)}function pa(e){throw new Error('"'+e+'" is read-only')}function va(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){if(!(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e)))return;var i=[],n=!0,o=!1,s=void 0;try{for(var r,a=e[Symbol.iterator]();!(n=(r=a.next()).done)&&(i.push(r.value),!t||i.length!==t);n=!0);}catch(e){o=!0,s=e}finally{try{n||null==a.return||a.return()}finally{if(o)throw s}}return i}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")}()}var ma=function(){function e(){na(this,e),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return sa(e,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var e=this.image.width,t=this.image.height;this.width=e,this.height=t;var i=Math.floor(t/2),n=Math.floor(t/4),o=Math.floor(t/8),s=Math.floor(t/16),r=Math.floor(e/2),a=Math.floor(e/4),h=Math.floor(e/8),d=Math.floor(e/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,r,i],[r,0,a,n],[r,n,h,o],[5*h,n,d,s]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var e=this.canvas.getContext("2d"),t=this.coordinates[0];e.drawImage(this.image,t[0],t[1],t[2],t[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var n=this.coordinates[i-1],o=this.coordinates[i];e.drawImage(this.canvas,n[0],n[1],n[2],n[3],o[0],o[1],o[2],o[3])}}},{key:"drawImageAtPosition",value:function(e,t,i,n,o,s){if(this.initialized())if(t>2){t*=.5;for(var r=0;t>2&&r<this.NUM_ITERATIONS;)t*=.5,r+=1;r>=this.NUM_ITERATIONS&&(r=this.NUM_ITERATIONS-1);var a=this.coordinates[r];e.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,n,o,s)}else e.drawImage(this.image,i,n,o,s)}}]),e}(),ga=function(){function e(t){na(this,e),this.images={},this.imageBroken={},this.callback=t}return sa(e,[{key:"_tryloadBrokenUrl",value:function(e,t,i){void 0!==e&&void 0!==i&&(void 0!==t?(i.image.onerror=function(){console.error("Could not load brokenImage:",t)},i.image.src=t):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(e){this.callback&&this.callback(e)}},{key:"load",value:function(e,t){var i=this,n=this.images[e];if(n)return n;var o=new ma;return this.images[e]=o,o.image.onload=function(){i._fixImageCoordinates(o.image),o.init(),i._redrawWithImage(o)},o.image.onerror=function(){console.error("Could not load image:",e),i._tryloadBrokenUrl(e,t,o)},o.image.src=e,o}},{key:"_fixImageCoordinates",value:function(e){0===e.width&&(document.body.appendChild(e),e.width=e.offsetWidth,e.height=e.offsetHeight,document.body.removeChild(e))}}]),e}(),ya=function(){function e(){na(this,e),this.clear(),this.defaultIndex=0,this.groupsArray=[],this.groupIndex=0,this.defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},ln(this.options,this.defaultOptions)}return sa(e,[{key:"setOptions",value:function(e){var t=["useDefaultGroups"];if(void 0!==e)for(var i in e)if(e.hasOwnProperty(i)&&-1===t.indexOf(i)){var n=e[i];this.add(i,n)}}},{key:"clear",value:function(){this.groups={},this.groupsArray=[]}},{key:"get",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.groups[e];if(void 0===i&&t)if(!1===this.options.useDefaultGroups&&this.groupsArray.length>0){var n=this.groupIndex%this.groupsArray.length;this.groupIndex++,(i={}).color=this.groups[this.groupsArray[n]],this.groups[e]=i}else{var o=this.defaultIndex%this.defaultGroups.length;this.defaultIndex++,(i={}).color=this.defaultGroups[o],this.groups[e]=i}return i}},{key:"add",value:function(e,t){return this.groups[e]=t,this.groupsArray.push(e),t}}]),e}();var ba=
/** 
 * vis-data - data
 * http://visjs.org/
 * 
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 * 
 * @version 6.1.0
 * @date    2019-07-16T13:37:00Z
 * 
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
 * 
 * @license 
 * vis.js is dual licensed under both
 * 
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 *   and
 * 
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 * 
 * vis.js may be distributed under either license.
 */
function(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e};function _a(e,t){return e(t={exports:{}},t.exports),t.exports}var wa=_a((function(e){function t(e){return(t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(n){return"function"==typeof Symbol&&"symbol"===t(Symbol.iterator)?e.exports=i=function(e){return t(e)}:e.exports=i=function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":t(e)},i(n)}e.exports=i}));var ka=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")};function xa(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var Sa=function(e,t,i){return t&&xa(e.prototype,t),i&&xa(e,i),e};var Oa=function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e};var Da=function(e,t){return!t||"object"!==wa(t)&&"function"!=typeof t?Oa(e):t},Ma=_a((function(e){function t(i){return e.exports=t=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},t(i)}e.exports=t})),Ta=_a((function(e){function t(i,n){return e.exports=t=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},t(i,n)}e.exports=t}));for(var Ea=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&Ta(e,t)},Ca=[],Pa=0;Pa<256;Pa++)Ca[Pa]=(Pa+256).toString(16).substr(1);for(var Ia=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var e=new Uint8Array(16);return function(){return crypto.getRandomValues(e),e}}var t=new Array(16);return function(){for(var e,i=0;i<16;i++)0==(3&i)&&(e=4294967296*Math.random()),t[i]=e>>>((3&i)<<3)&255;return t}}(),Fa=[],Na=0;Na<256;Na++)Fa[Na]=(Na+256).toString(16).substr(1);var Ya=Ia();Ya[0],Ya[1],Ya[2],Ya[3],Ya[4],Ya[5],Ya[6],Ya[7];function Ra(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0,i=arguments.length>2?arguments[2]:void 0,n=t&&i||0;"string"==typeof e&&(t="binary"===e?new Array(16):void 0,e={});var o=e.random||(e.rng||Ia)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,t)for(var s=0;s<16;s++)t[n+s]=o[s];return t||function(e,t){var i=t||0,n=Ca;return n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+"-"+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]+n[e[i++]]}(o)}function ja(e){return(ja="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Aa(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}for(var za=function(e,t){return e(t={exports:{}},t.exports),t.exports}((function(e,t){e.exports=function(){var t,i;function n(){return t.apply(null,arguments)}function o(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function s(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function r(e){return void 0===e}function a(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function h(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function d(e,t){var i,n=[];for(i=0;i<e.length;++i)n.push(t(e[i],i));return n}function l(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function u(e,t){for(var i in t)l(t,i)&&(e[i]=t[i]);return l(t,"toString")&&(e.toString=t.toString),l(t,"valueOf")&&(e.valueOf=t.valueOf),e}function c(e,t,i,n){return It(e,t,i,n,!0).utc()}function f(e){return null==e._pf&&(e._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),e._pf}function p(e){if(null==e._isValid){var t=f(e),n=i.call(t.parsedDateParts,(function(e){return null!=e})),o=!isNaN(e._d.getTime())&&t.overflow<0&&!t.empty&&!t.invalidMonth&&!t.invalidWeekday&&!t.weekdayMismatch&&!t.nullInput&&!t.invalidFormat&&!t.userInvalidated&&(!t.meridiem||t.meridiem&&n);if(e._strict&&(o=o&&0===t.charsLeftOver&&0===t.unusedTokens.length&&void 0===t.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return o;e._isValid=o}return e._isValid}function v(e){var t=c(NaN);return null!=e?u(f(t),e):f(t).userInvalidated=!0,t}i=Array.prototype.some?Array.prototype.some:function(e){for(var t=Object(this),i=t.length>>>0,n=0;n<i;n++)if(n in t&&e.call(this,t[n],n,t))return!0;return!1};var m=n.momentProperties=[];function g(e,t){var i,n,o;if(r(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),r(t._i)||(e._i=t._i),r(t._f)||(e._f=t._f),r(t._l)||(e._l=t._l),r(t._strict)||(e._strict=t._strict),r(t._tzm)||(e._tzm=t._tzm),r(t._isUTC)||(e._isUTC=t._isUTC),r(t._offset)||(e._offset=t._offset),r(t._pf)||(e._pf=f(t)),r(t._locale)||(e._locale=t._locale),m.length>0)for(i=0;i<m.length;i++)r(o=t[n=m[i]])||(e[n]=o);return e}var y=!1;function b(e){g(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===y&&(y=!0,n.updateOffset(this),y=!1)}function _(e){return e instanceof b||null!=e&&null!=e._isAMomentObject}function w(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function k(e){var t=+e,i=0;return 0!==t&&isFinite(t)&&(i=w(t)),i}function x(e,t,i){var n,o=Math.min(e.length,t.length),s=Math.abs(e.length-t.length),r=0;for(n=0;n<o;n++)(i&&e[n]!==t[n]||!i&&k(e[n])!==k(t[n]))&&r++;return r+s}function S(e){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function O(e,t){var i=!0;return u((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,e),i){for(var o,s=[],r=0;r<arguments.length;r++){if(o="","object"==typeof arguments[r]){for(var a in o+="\n["+r+"] ",arguments[0])o+=a+": "+arguments[0][a]+", ";o=o.slice(0,-2)}else o=arguments[r];s.push(o)}S(e+"\nArguments: "+Array.prototype.slice.call(s).join("")+"\n"+(new Error).stack),i=!1}return t.apply(this,arguments)}),t)}var D,M={};function T(e,t){null!=n.deprecationHandler&&n.deprecationHandler(e,t),M[e]||(S(t),M[e]=!0)}function E(e){return e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function C(e,t){var i,n=u({},e);for(i in t)l(t,i)&&(s(e[i])&&s(t[i])?(n[i]={},u(n[i],e[i]),u(n[i],t[i])):null!=t[i]?n[i]=t[i]:delete n[i]);for(i in e)l(e,i)&&!l(t,i)&&s(e[i])&&(n[i]=u({},n[i]));return n}function P(e){null!=e&&this.set(e)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,D=Object.keys?Object.keys:function(e){var t,i=[];for(t in e)l(e,t)&&i.push(t);return i};var I={};function F(e,t){var i=e.toLowerCase();I[i]=I[i+"s"]=I[t]=e}function N(e){return"string"==typeof e?I[e]||I[e.toLowerCase()]:void 0}function Y(e){var t,i,n={};for(i in e)l(e,i)&&(t=N(i))&&(n[t]=e[i]);return n}var R={};function j(e,t){R[e]=t}function A(e,t,i){var n=""+Math.abs(e),o=t-n.length;return(e>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,o)).toString().substr(1)+n}var z=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,B=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,L={},H={};function W(e,t,i,n){var o=n;"string"==typeof n&&(o=function(){return this[n]()}),e&&(H[e]=o),t&&(H[t[0]]=function(){return A(o.apply(this,arguments),t[1],t[2])}),i&&(H[i]=function(){return this.localeData().ordinal(o.apply(this,arguments),e)})}function V(e,t){return e.isValid()?(t=U(t,e.localeData()),L[t]=L[t]||function(e){var t,i,n,o=e.match(z);for(t=0,i=o.length;t<i;t++)H[o[t]]?o[t]=H[o[t]]:o[t]=(n=o[t]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(t){var n,s="";for(n=0;n<i;n++)s+=E(o[n])?o[n].call(t,e):o[n];return s}}(t),L[t](e)):e.localeData().invalidDate()}function U(e,t){var i=5;function n(e){return t.longDateFormat(e)||e}for(B.lastIndex=0;i>=0&&B.test(e);)e=e.replace(B,n),B.lastIndex=0,i-=1;return e}var G=/\d/,q=/\d\d/,Z=/\d{3}/,X=/\d{4}/,$=/[+-]?\d{6}/,K=/\d\d?/,J=/\d\d\d\d?/,Q=/\d\d\d\d\d\d?/,ee=/\d{1,3}/,te=/\d{1,4}/,ie=/[+-]?\d{1,6}/,ne=/\d+/,oe=/[+-]?\d+/,se=/Z|[+-]\d\d:?\d\d/gi,re=/Z|[+-]\d\d(?::?\d\d)?/gi,ae=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,he={};function de(e,t,i){he[e]=E(t)?t:function(e,n){return e&&i?i:t}}function le(e,t){return l(he,e)?he[e](t._strict,t._locale):new RegExp(ue(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(e,t,i,n,o){return t||i||n||o}))))}function ue(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var ce={};function fe(e,t){var i,n=t;for("string"==typeof e&&(e=[e]),a(t)&&(n=function(e,i){i[t]=k(e)}),i=0;i<e.length;i++)ce[e[i]]=n}function pe(e,t){fe(e,(function(e,i,n,o){n._w=n._w||{},t(e,n._w,n,o)}))}function ve(e,t,i){null!=t&&l(ce,e)&&ce[e](t,i._a,i,e)}var me=0,ge=1,ye=2,be=3,_e=4,we=5,ke=6,xe=7,Se=8;function Oe(e){return De(e)?366:365}function De(e){return e%4==0&&e%100!=0||e%400==0}W("Y",0,0,(function(){var e=this.year();return e<=9999?""+e:"+"+e})),W(0,["YY",2],0,(function(){return this.year()%100})),W(0,["YYYY",4],0,"year"),W(0,["YYYYY",5],0,"year"),W(0,["YYYYYY",6,!0],0,"year"),F("year","y"),j("year",1),de("Y",oe),de("YY",K,q),de("YYYY",te,X),de("YYYYY",ie,$),de("YYYYYY",ie,$),fe(["YYYYY","YYYYYY"],me),fe("YYYY",(function(e,t){t[me]=2===e.length?n.parseTwoDigitYear(e):k(e)})),fe("YY",(function(e,t){t[me]=n.parseTwoDigitYear(e)})),fe("Y",(function(e,t){t[me]=parseInt(e,10)})),n.parseTwoDigitYear=function(e){return k(e)+(k(e)>68?1900:2e3)};var Me,Te=Ee("FullYear",!0);function Ee(e,t){return function(i){return null!=i?(Pe(this,e,i),n.updateOffset(this,t),this):Ce(this,e)}}function Ce(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function Pe(e,t,i){e.isValid()&&!isNaN(i)&&("FullYear"===t&&De(e.year())&&1===e.month()&&29===e.date()?e._d["set"+(e._isUTC?"UTC":"")+t](i,e.month(),Ie(i,e.month())):e._d["set"+(e._isUTC?"UTC":"")+t](i))}function Ie(e,t){if(isNaN(e)||isNaN(t))return NaN;var i=function(e,t){return(e%t+t)%t}(t,12);return e+=(t-i)/12,1===i?De(e)?29:28:31-i%7%2}Me=Array.prototype.indexOf?Array.prototype.indexOf:function(e){var t;for(t=0;t<this.length;++t)if(this[t]===e)return t;return-1},W("M",["MM",2],"Mo",(function(){return this.month()+1})),W("MMM",0,0,(function(e){return this.localeData().monthsShort(this,e)})),W("MMMM",0,0,(function(e){return this.localeData().months(this,e)})),F("month","M"),j("month",8),de("M",K),de("MM",K,q),de("MMM",(function(e,t){return t.monthsShortRegex(e)})),de("MMMM",(function(e,t){return t.monthsRegex(e)})),fe(["M","MM"],(function(e,t){t[ge]=k(e)-1})),fe(["MMM","MMMM"],(function(e,t,i,n){var o=i._locale.monthsParse(e,n,i._strict);null!=o?t[ge]=o:f(i).invalidMonth=e}));var Fe=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Ne="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Ye="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function Re(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)s=c([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(s,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(s,"").toLocaleLowerCase();return i?"MMM"===t?-1!==(o=Me.call(this._shortMonthsParse,r))?o:null:-1!==(o=Me.call(this._longMonthsParse,r))?o:null:"MMM"===t?-1!==(o=Me.call(this._shortMonthsParse,r))?o:-1!==(o=Me.call(this._longMonthsParse,r))?o:null:-1!==(o=Me.call(this._longMonthsParse,r))?o:-1!==(o=Me.call(this._shortMonthsParse,r))?o:null}function je(e,t){var i;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=k(t);else if(!a(t=e.localeData().monthsParse(t)))return e;return i=Math.min(e.date(),Ie(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,i),e}function Ae(e){return null!=e?(je(this,e),n.updateOffset(this,!0),this):Ce(this,"Month")}var ze=ae,Be=ae;function Le(){function e(e,t){return t.length-e.length}var t,i,n=[],o=[],s=[];for(t=0;t<12;t++)i=c([2e3,t]),n.push(this.monthsShort(i,"")),o.push(this.months(i,"")),s.push(this.months(i,"")),s.push(this.monthsShort(i,""));for(n.sort(e),o.sort(e),s.sort(e),t=0;t<12;t++)n[t]=ue(n[t]),o[t]=ue(o[t]);for(t=0;t<24;t++)s[t]=ue(s[t]);this._monthsRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function He(e,t,i,n,o,s,r){var a;return e<100&&e>=0?(a=new Date(e+400,t,i,n,o,s,r),isFinite(a.getFullYear())&&a.setFullYear(e)):a=new Date(e,t,i,n,o,s,r),a}function We(e){var t;if(e<100&&e>=0){var i=Array.prototype.slice.call(arguments);i[0]=e+400,t=new Date(Date.UTC.apply(null,i)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)}else t=new Date(Date.UTC.apply(null,arguments));return t}function Ve(e,t,i){var n=7+t-i;return-(7+We(e,0,n).getUTCDay()-t)%7+n-1}function Ue(e,t,i,n,o){var s,r,a=1+7*(t-1)+(7+i-n)%7+Ve(e,n,o);return a<=0?r=Oe(s=e-1)+a:a>Oe(e)?(s=e+1,r=a-Oe(e)):(s=e,r=a),{year:s,dayOfYear:r}}function Ge(e,t,i){var n,o,s=Ve(e.year(),t,i),r=Math.floor((e.dayOfYear()-s-1)/7)+1;return r<1?n=r+qe(o=e.year()-1,t,i):r>qe(e.year(),t,i)?(n=r-qe(e.year(),t,i),o=e.year()+1):(o=e.year(),n=r),{week:n,year:o}}function qe(e,t,i){var n=Ve(e,t,i),o=Ve(e+1,t,i);return(Oe(e)-n+o)/7}function Ze(e,t){return e.slice(t,7).concat(e.slice(0,t))}W("w",["ww",2],"wo","week"),W("W",["WW",2],"Wo","isoWeek"),F("week","w"),F("isoWeek","W"),j("week",5),j("isoWeek",5),de("w",K),de("ww",K,q),de("W",K),de("WW",K,q),pe(["w","ww","W","WW"],(function(e,t,i,n){t[n.substr(0,1)]=k(e)})),W("d",0,"do","day"),W("dd",0,0,(function(e){return this.localeData().weekdaysMin(this,e)})),W("ddd",0,0,(function(e){return this.localeData().weekdaysShort(this,e)})),W("dddd",0,0,(function(e){return this.localeData().weekdays(this,e)})),W("e",0,0,"weekday"),W("E",0,0,"isoWeekday"),F("day","d"),F("weekday","e"),F("isoWeekday","E"),j("day",11),j("weekday",11),j("isoWeekday",11),de("d",K),de("e",K),de("E",K),de("dd",(function(e,t){return t.weekdaysMinRegex(e)})),de("ddd",(function(e,t){return t.weekdaysShortRegex(e)})),de("dddd",(function(e,t){return t.weekdaysRegex(e)})),pe(["dd","ddd","dddd"],(function(e,t,i,n){var o=i._locale.weekdaysParse(e,n,i._strict);null!=o?t.d=o:f(i).invalidWeekday=e})),pe(["d","e","E"],(function(e,t,i,n){t[n]=k(e)}));var Xe="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),$e="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Ke="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Je(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)s=c([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(s,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(s,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(s,"").toLocaleLowerCase();return i?"dddd"===t?-1!==(o=Me.call(this._weekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Me.call(this._shortWeekdaysParse,r))?o:null:-1!==(o=Me.call(this._minWeekdaysParse,r))?o:null:"dddd"===t?-1!==(o=Me.call(this._weekdaysParse,r))?o:-1!==(o=Me.call(this._shortWeekdaysParse,r))?o:-1!==(o=Me.call(this._minWeekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Me.call(this._shortWeekdaysParse,r))?o:-1!==(o=Me.call(this._weekdaysParse,r))?o:-1!==(o=Me.call(this._minWeekdaysParse,r))?o:null:-1!==(o=Me.call(this._minWeekdaysParse,r))?o:-1!==(o=Me.call(this._weekdaysParse,r))?o:-1!==(o=Me.call(this._shortWeekdaysParse,r))?o:null}var Qe=ae,et=ae,tt=ae;function it(){function e(e,t){return t.length-e.length}var t,i,n,o,s,r=[],a=[],h=[],d=[];for(t=0;t<7;t++)i=c([2e3,1]).day(t),n=this.weekdaysMin(i,""),o=this.weekdaysShort(i,""),s=this.weekdays(i,""),r.push(n),a.push(o),h.push(s),d.push(n),d.push(o),d.push(s);for(r.sort(e),a.sort(e),h.sort(e),d.sort(e),t=0;t<7;t++)a[t]=ue(a[t]),h[t]=ue(h[t]),d[t]=ue(d[t]);this._weekdaysRegex=new RegExp("^("+d.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+r.join("|")+")","i")}function nt(){return this.hours()%12||12}function ot(e,t){W(e,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)}))}function st(e,t){return t._meridiemParse}W("H",["HH",2],0,"hour"),W("h",["hh",2],0,nt),W("k",["kk",2],0,(function(){return this.hours()||24})),W("hmm",0,0,(function(){return""+nt.apply(this)+A(this.minutes(),2)})),W("hmmss",0,0,(function(){return""+nt.apply(this)+A(this.minutes(),2)+A(this.seconds(),2)})),W("Hmm",0,0,(function(){return""+this.hours()+A(this.minutes(),2)})),W("Hmmss",0,0,(function(){return""+this.hours()+A(this.minutes(),2)+A(this.seconds(),2)})),ot("a",!0),ot("A",!1),F("hour","h"),j("hour",13),de("a",st),de("A",st),de("H",K),de("h",K),de("k",K),de("HH",K,q),de("hh",K,q),de("kk",K,q),de("hmm",J),de("hmmss",Q),de("Hmm",J),de("Hmmss",Q),fe(["H","HH"],be),fe(["k","kk"],(function(e,t,i){var n=k(e);t[be]=24===n?0:n})),fe(["a","A"],(function(e,t,i){i._isPm=i._locale.isPM(e),i._meridiem=e})),fe(["h","hh"],(function(e,t,i){t[be]=k(e),f(i).bigHour=!0})),fe("hmm",(function(e,t,i){var n=e.length-2;t[be]=k(e.substr(0,n)),t[_e]=k(e.substr(n)),f(i).bigHour=!0})),fe("hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[be]=k(e.substr(0,n)),t[_e]=k(e.substr(n,2)),t[we]=k(e.substr(o)),f(i).bigHour=!0})),fe("Hmm",(function(e,t,i){var n=e.length-2;t[be]=k(e.substr(0,n)),t[_e]=k(e.substr(n))})),fe("Hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[be]=k(e.substr(0,n)),t[_e]=k(e.substr(n,2)),t[we]=k(e.substr(o))}));var rt,at=Ee("Hours",!0),ht={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Ne,monthsShort:Ye,week:{dow:0,doy:6},weekdays:Xe,weekdaysMin:Ke,weekdaysShort:$e,meridiemParse:/[ap]\.?m?\.?/i},dt={},lt={};function ut(e){return e?e.toLowerCase().replace("_","-"):e}function ct(t){var i=null;if(!dt[t]&&e&&e.exports)try{i=rt._abbr,Aa(),ft(i)}catch(e){}return dt[t]}function ft(e,t){var i;return e&&((i=r(t)?vt(e):pt(e,t))?rt=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),rt._abbr}function pt(e,t){if(null!==t){var i,n=ht;if(t.abbr=e,null!=dt[e])T("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=dt[e]._config;else if(null!=t.parentLocale)if(null!=dt[t.parentLocale])n=dt[t.parentLocale]._config;else{if(null==(i=ct(t.parentLocale)))return lt[t.parentLocale]||(lt[t.parentLocale]=[]),lt[t.parentLocale].push({name:e,config:t}),null;n=i._config}return dt[e]=new P(C(n,t)),lt[e]&&lt[e].forEach((function(e){pt(e.name,e.config)})),ft(e),dt[e]}return delete dt[e],null}function vt(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return rt;if(!o(e)){if(t=ct(e))return t;e=[e]}return function(e){for(var t,i,n,o,s=0;s<e.length;){for(t=(o=ut(e[s]).split("-")).length,i=(i=ut(e[s+1]))?i.split("-"):null;t>0;){if(n=ct(o.slice(0,t).join("-")))return n;if(i&&i.length>=t&&x(o,i,!0)>=t-1)break;t--}s++}return rt}(e)}function mt(e){var t,i=e._a;return i&&-2===f(e).overflow&&(t=i[ge]<0||i[ge]>11?ge:i[ye]<1||i[ye]>Ie(i[me],i[ge])?ye:i[be]<0||i[be]>24||24===i[be]&&(0!==i[_e]||0!==i[we]||0!==i[ke])?be:i[_e]<0||i[_e]>59?_e:i[we]<0||i[we]>59?we:i[ke]<0||i[ke]>999?ke:-1,f(e)._overflowDayOfYear&&(t<me||t>ye)&&(t=ye),f(e)._overflowWeeks&&-1===t&&(t=xe),f(e)._overflowWeekday&&-1===t&&(t=Se),f(e).overflow=t),e}function gt(e,t,i){return null!=e?e:null!=t?t:i}function yt(e){var t,i,o,s,r,a=[];if(!e._d){for(o=function(e){var t=new Date(n.now());return e._useUTC?[t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()]:[t.getFullYear(),t.getMonth(),t.getDate()]}(e),e._w&&null==e._a[ye]&&null==e._a[ge]&&function(e){var t,i,n,o,s,r,a,h;if(null!=(t=e._w).GG||null!=t.W||null!=t.E)s=1,r=4,i=gt(t.GG,e._a[me],Ge(Ft(),1,4).year),n=gt(t.W,1),((o=gt(t.E,1))<1||o>7)&&(h=!0);else{s=e._locale._week.dow,r=e._locale._week.doy;var d=Ge(Ft(),s,r);i=gt(t.gg,e._a[me],d.year),n=gt(t.w,d.week),null!=t.d?((o=t.d)<0||o>6)&&(h=!0):null!=t.e?(o=t.e+s,(t.e<0||t.e>6)&&(h=!0)):o=s}n<1||n>qe(i,s,r)?f(e)._overflowWeeks=!0:null!=h?f(e)._overflowWeekday=!0:(a=Ue(i,n,o,s,r),e._a[me]=a.year,e._dayOfYear=a.dayOfYear)}(e),null!=e._dayOfYear&&(r=gt(e._a[me],o[me]),(e._dayOfYear>Oe(r)||0===e._dayOfYear)&&(f(e)._overflowDayOfYear=!0),i=We(r,0,e._dayOfYear),e._a[ge]=i.getUTCMonth(),e._a[ye]=i.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=a[t]=o[t];for(;t<7;t++)e._a[t]=a[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[be]&&0===e._a[_e]&&0===e._a[we]&&0===e._a[ke]&&(e._nextDay=!0,e._a[be]=0),e._d=(e._useUTC?We:He).apply(null,a),s=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[be]=24),e._w&&void 0!==e._w.d&&e._w.d!==s&&(f(e).weekdayMismatch=!0)}}var bt=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,_t=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,wt=/Z|[+-]\d\d(?::?\d\d)?/,kt=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],xt=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],St=/^\/?Date\((\-?\d+)/i;function Ot(e){var t,i,n,o,s,r,a=e._i,h=bt.exec(a)||_t.exec(a);if(h){for(f(e).iso=!0,t=0,i=kt.length;t<i;t++)if(kt[t][1].exec(h[1])){o=kt[t][0],n=!1!==kt[t][2];break}if(null==o)return void(e._isValid=!1);if(h[3]){for(t=0,i=xt.length;t<i;t++)if(xt[t][1].exec(h[3])){s=(h[2]||" ")+xt[t][0];break}if(null==s)return void(e._isValid=!1)}if(!n&&null!=s)return void(e._isValid=!1);if(h[4]){if(!wt.exec(h[4]))return void(e._isValid=!1);r="Z"}e._f=o+(s||"")+(r||""),Ct(e)}else e._isValid=!1}var Dt=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Mt(e){var t=parseInt(e,10);return t<=49?2e3+t:t<=999?1900+t:t}var Tt={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Et(e){var t,i,n,o,s,r,a,h=Dt.exec(e._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var d=(t=h[4],i=h[3],n=h[2],o=h[5],s=h[6],r=h[7],a=[Mt(t),Ye.indexOf(i),parseInt(n,10),parseInt(o,10),parseInt(s,10)],r&&a.push(parseInt(r,10)),a);if(!function(e,t,i){return!e||$e.indexOf(e)===new Date(t[0],t[1],t[2]).getDay()||(f(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],d,e))return;e._a=d,e._tzm=function(e,t,i){if(e)return Tt[e];if(t)return 0;var n=parseInt(i,10),o=n%100;return(n-o)/100*60+o}(h[8],h[9],h[10]),e._d=We.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),f(e).rfc2822=!0}else e._isValid=!1}function Ct(e){if(e._f!==n.ISO_8601)if(e._f!==n.RFC_2822){e._a=[],f(e).empty=!0;var t,i,o,s,r,a=""+e._i,h=a.length,d=0;for(o=U(e._f,e._locale).match(z)||[],t=0;t<o.length;t++)s=o[t],(i=(a.match(le(s,e))||[])[0])&&((r=a.substr(0,a.indexOf(i))).length>0&&f(e).unusedInput.push(r),a=a.slice(a.indexOf(i)+i.length),d+=i.length),H[s]?(i?f(e).empty=!1:f(e).unusedTokens.push(s),ve(s,i,e)):e._strict&&!i&&f(e).unusedTokens.push(s);f(e).charsLeftOver=h-d,a.length>0&&f(e).unusedInput.push(a),e._a[be]<=12&&!0===f(e).bigHour&&e._a[be]>0&&(f(e).bigHour=void 0),f(e).parsedDateParts=e._a.slice(0),f(e).meridiem=e._meridiem,e._a[be]=function(e,t,i){var n;return null==i?t:null!=e.meridiemHour?e.meridiemHour(t,i):null!=e.isPM?((n=e.isPM(i))&&t<12&&(t+=12),n||12!==t||(t=0),t):t}(e._locale,e._a[be],e._meridiem),yt(e),mt(e)}else Et(e);else Ot(e)}function Pt(e){var t=e._i,i=e._f;return e._locale=e._locale||vt(e._l),null===t||void 0===i&&""===t?v({nullInput:!0}):("string"==typeof t&&(e._i=t=e._locale.preparse(t)),_(t)?new b(mt(t)):(h(t)?e._d=t:o(i)?function(e){var t,i,n,o,s;if(0===e._f.length)return f(e).invalidFormat=!0,void(e._d=new Date(NaN));for(o=0;o<e._f.length;o++)s=0,t=g({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[o],Ct(t),p(t)&&(s+=f(t).charsLeftOver,s+=10*f(t).unusedTokens.length,f(t).score=s,(null==n||s<n)&&(n=s,i=t));u(e,i||t)}(e):i?Ct(e):function(e){var t=e._i;r(t)?e._d=new Date(n.now()):h(t)?e._d=new Date(t.valueOf()):"string"==typeof t?function(e){var t=St.exec(e._i);null===t?(Ot(e),!1===e._isValid&&(delete e._isValid,Et(e),!1===e._isValid&&(delete e._isValid,n.createFromInputFallback(e)))):e._d=new Date(+t[1])}(e):o(t)?(e._a=d(t.slice(0),(function(e){return parseInt(e,10)})),yt(e)):s(t)?function(e){if(!e._d){var t=Y(e._i);e._a=d([t.year,t.month,t.day||t.date,t.hour,t.minute,t.second,t.millisecond],(function(e){return e&&parseInt(e,10)})),yt(e)}}(e):a(t)?e._d=new Date(t):n.createFromInputFallback(e)}(e),p(e)||(e._d=null),e))}function It(e,t,i,n,r){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(s(e)&&function(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;var t;for(t in e)if(e.hasOwnProperty(t))return!1;return!0}(e)||o(e)&&0===e.length)&&(e=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=r,h._l=i,h._i=e,h._f=t,h._strict=n,(a=new b(mt(Pt(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Ft(e,t,i,n){return It(e,t,i,n,!1)}n.createFromInputFallback=O("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Nt=O("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Ft.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:v()})),Yt=O("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Ft.apply(null,arguments);return this.isValid()&&e.isValid()?e>this?this:e:v()}));function Rt(e,t){var i,n;if(1===t.length&&o(t[0])&&(t=t[0]),!t.length)return Ft();for(i=t[0],n=1;n<t.length;++n)t[n].isValid()&&!t[n][e](i)||(i=t[n]);return i}var jt=["year","quarter","month","week","day","hour","minute","second","millisecond"];function At(e){var t=Y(e),i=t.year||0,n=t.quarter||0,o=t.month||0,s=t.week||t.isoWeek||0,r=t.day||0,a=t.hour||0,h=t.minute||0,d=t.second||0,l=t.millisecond||0;this._isValid=function(e){for(var t in e)if(-1===Me.call(jt,t)||null!=e[t]&&isNaN(e[t]))return!1;for(var i=!1,n=0;n<jt.length;++n)if(e[jt[n]]){if(i)return!1;parseFloat(e[jt[n]])!==k(e[jt[n]])&&(i=!0)}return!0}(t),this._milliseconds=+l+1e3*d+6e4*h+1e3*a*60*60,this._days=+r+7*s,this._months=+o+3*n+12*i,this._data={},this._locale=vt(),this._bubble()}function zt(e){return e instanceof At}function Bt(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function Lt(e,t){W(e,0,0,(function(){var e=this.utcOffset(),i="+";return e<0&&(e=-e,i="-"),i+A(~~(e/60),2)+t+A(~~e%60,2)}))}Lt("Z",":"),Lt("ZZ",""),de("Z",re),de("ZZ",re),fe(["Z","ZZ"],(function(e,t,i){i._useUTC=!0,i._tzm=Wt(re,e)}));var Ht=/([\+\-]|\d\d)/gi;function Wt(e,t){var i=(t||"").match(e);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Ht)||["-",0,0],o=60*n[1]+k(n[2]);return 0===o?0:"+"===n[0]?o:-o}function Vt(e,t){var i,o;return t._isUTC?(i=t.clone(),o=(_(e)||h(e)?e.valueOf():Ft(e).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+o),n.updateOffset(i,!1),i):Ft(e).local()}function Ut(e){return 15*-Math.round(e._d.getTimezoneOffset()/15)}function Gt(){return!!this.isValid()&&this._isUTC&&0===this._offset}n.updateOffset=function(){};var qt=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Zt=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Xt(e,t){var i,n,o,s,r,h,d=e,u=null;return zt(e)?d={ms:e._milliseconds,d:e._days,M:e._months}:a(e)?(d={},t?d[t]=e:d.milliseconds=e):(u=qt.exec(e))?(i="-"===u[1]?-1:1,d={y:0,d:k(u[ye])*i,h:k(u[be])*i,m:k(u[_e])*i,s:k(u[we])*i,ms:k(Bt(1e3*u[ke]))*i}):(u=Zt.exec(e))?(i="-"===u[1]?-1:1,d={y:$t(u[2],i),M:$t(u[3],i),w:$t(u[4],i),d:$t(u[5],i),h:$t(u[6],i),m:$t(u[7],i),s:$t(u[8],i)}):null==d?d={}:"object"==typeof d&&("from"in d||"to"in d)&&(s=Ft(d.from),r=Ft(d.to),o=s.isValid()&&r.isValid()?(r=Vt(r,s),s.isBefore(r)?h=Kt(s,r):((h=Kt(r,s)).milliseconds=-h.milliseconds,h.months=-h.months),h):{milliseconds:0,months:0},(d={}).ms=o.milliseconds,d.M=o.months),n=new At(d),zt(e)&&l(e,"_locale")&&(n._locale=e._locale),n}function $t(e,t){var i=e&&parseFloat(e.replace(",","."));return(isNaN(i)?0:i)*t}function Kt(e,t){var i={};return i.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(i.months,"M").isAfter(t)&&--i.months,i.milliseconds=+t-+e.clone().add(i.months,"M"),i}function Jt(e,t){return function(i,n){var o;return null===n||isNaN(+n)||(T(t,"moment()."+t+"(period, number) is deprecated. Please use moment()."+t+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),o=i,i=n,n=o),Qt(this,Xt(i="string"==typeof i?+i:i,n),e),this}}function Qt(e,t,i,o){var s=t._milliseconds,r=Bt(t._days),a=Bt(t._months);e.isValid()&&(o=null==o||o,a&&je(e,Ce(e,"Month")+a*i),r&&Pe(e,"Date",Ce(e,"Date")+r*i),s&&e._d.setTime(e._d.valueOf()+s*i),o&&n.updateOffset(e,r||a))}Xt.fn=At.prototype,Xt.invalid=function(){return Xt(NaN)};var ei=Jt(1,"add"),ti=Jt(-1,"subtract");function ii(e,t){var i=12*(t.year()-e.year())+(t.month()-e.month()),n=e.clone().add(i,"months");return-(i+(t-n<0?(t-n)/(n-e.clone().add(i-1,"months")):(t-n)/(e.clone().add(i+1,"months")-n)))||0}function ni(e){var t;return void 0===e?this._locale._abbr:(null!=(t=vt(e))&&(this._locale=t),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var oi=O("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(e){return void 0===e?this.localeData():this.locale(e)}));function si(){return this._locale}var ri=1e3,ai=60*ri,hi=60*ai,di=3506328*hi;function li(e,t){return(e%t+t)%t}function ui(e,t,i){return e<100&&e>=0?new Date(e+400,t,i)-di:new Date(e,t,i).valueOf()}function ci(e,t,i){return e<100&&e>=0?Date.UTC(e+400,t,i)-di:Date.UTC(e,t,i)}function fi(e,t){W(0,[e,e.length],0,t)}function pi(e,t,i,n,o){var s;return null==e?Ge(this,n,o).year:(t>(s=qe(e,n,o))&&(t=s),vi.call(this,e,t,i,n,o))}function vi(e,t,i,n,o){var s=Ue(e,t,i,n,o),r=We(s.year,0,s.dayOfYear);return this.year(r.getUTCFullYear()),this.month(r.getUTCMonth()),this.date(r.getUTCDate()),this}W(0,["gg",2],0,(function(){return this.weekYear()%100})),W(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),fi("gggg","weekYear"),fi("ggggg","weekYear"),fi("GGGG","isoWeekYear"),fi("GGGGG","isoWeekYear"),F("weekYear","gg"),F("isoWeekYear","GG"),j("weekYear",1),j("isoWeekYear",1),de("G",oe),de("g",oe),de("GG",K,q),de("gg",K,q),de("GGGG",te,X),de("gggg",te,X),de("GGGGG",ie,$),de("ggggg",ie,$),pe(["gggg","ggggg","GGGG","GGGGG"],(function(e,t,i,n){t[n.substr(0,2)]=k(e)})),pe(["gg","GG"],(function(e,t,i,o){t[o]=n.parseTwoDigitYear(e)})),W("Q",0,"Qo","quarter"),F("quarter","Q"),j("quarter",7),de("Q",G),fe("Q",(function(e,t){t[ge]=3*(k(e)-1)})),W("D",["DD",2],"Do","date"),F("date","D"),j("date",9),de("D",K),de("DD",K,q),de("Do",(function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient})),fe(["D","DD"],ye),fe("Do",(function(e,t){t[ye]=k(e.match(K)[0])}));var mi=Ee("Date",!0);W("DDD",["DDDD",3],"DDDo","dayOfYear"),F("dayOfYear","DDD"),j("dayOfYear",4),de("DDD",ee),de("DDDD",Z),fe(["DDD","DDDD"],(function(e,t,i){i._dayOfYear=k(e)})),W("m",["mm",2],0,"minute"),F("minute","m"),j("minute",14),de("m",K),de("mm",K,q),fe(["m","mm"],_e);var gi=Ee("Minutes",!1);W("s",["ss",2],0,"second"),F("second","s"),j("second",15),de("s",K),de("ss",K,q),fe(["s","ss"],we);var yi,bi=Ee("Seconds",!1);for(W("S",0,0,(function(){return~~(this.millisecond()/100)})),W(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),W(0,["SSS",3],0,"millisecond"),W(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),W(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),W(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),W(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),W(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),W(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),F("millisecond","ms"),j("millisecond",16),de("S",ee,G),de("SS",ee,q),de("SSS",ee,Z),yi="SSSS";yi.length<=9;yi+="S")de(yi,ne);function _i(e,t){t[ke]=k(1e3*("0."+e))}for(yi="S";yi.length<=9;yi+="S")fe(yi,_i);var wi=Ee("Milliseconds",!1);W("z",0,0,"zoneAbbr"),W("zz",0,0,"zoneName");var ki=b.prototype;function xi(e){return e}ki.add=ei,ki.calendar=function(e,t){var i=e||Ft(),o=Vt(i,this).startOf("day"),s=n.calendarFormat(this,o)||"sameElse",r=t&&(E(t[s])?t[s].call(this,i):t[s]);return this.format(r||this.localeData().calendar(s,this,Ft(i)))},ki.clone=function(){return new b(this)},ki.diff=function(e,t,i){var n,o,s;if(!this.isValid())return NaN;if(!(n=Vt(e,this)).isValid())return NaN;switch(o=6e4*(n.utcOffset()-this.utcOffset()),t=N(t)){case"year":s=ii(this,n)/12;break;case"month":s=ii(this,n);break;case"quarter":s=ii(this,n)/3;break;case"second":s=(this-n)/1e3;break;case"minute":s=(this-n)/6e4;break;case"hour":s=(this-n)/36e5;break;case"day":s=(this-n-o)/864e5;break;case"week":s=(this-n-o)/6048e5;break;default:s=this-n}return i?s:w(s)},ki.endOf=function(e){var t;if(void 0===(e=N(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?ci:ui;switch(e){case"year":t=i(this.year()+1,0,1)-1;break;case"quarter":t=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=i(this.year(),this.month()+1,1)-1;break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=hi-li(t+(this._isUTC?0:this.utcOffset()*ai),hi)-1;break;case"minute":t=this._d.valueOf(),t+=ai-li(t,ai)-1;break;case"second":t=this._d.valueOf(),t+=ri-li(t,ri)-1}return this._d.setTime(t),n.updateOffset(this,!0),this},ki.format=function(e){e||(e=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var t=V(this,e);return this.localeData().postformat(t)},ki.from=function(e,t){return this.isValid()&&(_(e)&&e.isValid()||Ft(e).isValid())?Xt({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},ki.fromNow=function(e){return this.from(Ft(),e)},ki.to=function(e,t){return this.isValid()&&(_(e)&&e.isValid()||Ft(e).isValid())?Xt({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},ki.toNow=function(e){return this.to(Ft(),e)},ki.get=function(e){return E(this[e=N(e)])?this[e]():this},ki.invalidAt=function(){return f(this).overflow},ki.isAfter=function(e,t){var i=_(e)?e:Ft(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=N(t)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(t).valueOf())},ki.isBefore=function(e,t){var i=_(e)?e:Ft(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=N(t)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(t).valueOf()<i.valueOf())},ki.isBetween=function(e,t,i,n){var o=_(e)?e:Ft(e),s=_(t)?t:Ft(t);return!!(this.isValid()&&o.isValid()&&s.isValid())&&("("===(n=n||"()")[0]?this.isAfter(o,i):!this.isBefore(o,i))&&(")"===n[1]?this.isBefore(s,i):!this.isAfter(s,i))},ki.isSame=function(e,t){var i,n=_(e)?e:Ft(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=N(t)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(t).valueOf()<=i&&i<=this.clone().endOf(t).valueOf()))},ki.isSameOrAfter=function(e,t){return this.isSame(e,t)||this.isAfter(e,t)},ki.isSameOrBefore=function(e,t){return this.isSame(e,t)||this.isBefore(e,t)},ki.isValid=function(){return p(this)},ki.lang=oi,ki.locale=ni,ki.localeData=si,ki.max=Yt,ki.min=Nt,ki.parsingFlags=function(){return u({},f(this))},ki.set=function(e,t){if("object"==typeof e)for(var i=function(e){var t=[];for(var i in e)t.push({unit:i,priority:R[i]});return t.sort((function(e,t){return e.priority-t.priority})),t}(e=Y(e)),n=0;n<i.length;n++)this[i[n].unit](e[i[n].unit]);else if(E(this[e=N(e)]))return this[e](t);return this},ki.startOf=function(e){var t;if(void 0===(e=N(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?ci:ui;switch(e){case"year":t=i(this.year(),0,1);break;case"quarter":t=i(this.year(),this.month()-this.month()%3,1);break;case"month":t=i(this.year(),this.month(),1);break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=i(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=li(t+(this._isUTC?0:this.utcOffset()*ai),hi);break;case"minute":t=this._d.valueOf(),t-=li(t,ai);break;case"second":t=this._d.valueOf(),t-=li(t,ri)}return this._d.setTime(t),n.updateOffset(this,!0),this},ki.subtract=ti,ki.toArray=function(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]},ki.toObject=function(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}},ki.toDate=function(){return new Date(this.valueOf())},ki.toISOString=function(e){if(!this.isValid())return null;var t=!0!==e,i=t?this.clone().utc():this;return i.year()<0||i.year()>9999?V(i,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",V(i,"Z")):V(i,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},ki.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e="moment",t="";this.isLocal()||(e=0===this.utcOffset()?"moment.utc":"moment.parseZone",t="Z");var i="["+e+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",o=t+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+o)},ki.toJSON=function(){return this.isValid()?this.toISOString():null},ki.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},ki.unix=function(){return Math.floor(this.valueOf()/1e3)},ki.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},ki.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},ki.year=Te,ki.isLeapYear=function(){return De(this.year())},ki.weekYear=function(e){return pi.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},ki.isoWeekYear=function(e){return pi.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)},ki.quarter=ki.quarters=function(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)},ki.month=Ae,ki.daysInMonth=function(){return Ie(this.year(),this.month())},ki.week=ki.weeks=function(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")},ki.isoWeek=ki.isoWeeks=function(e){var t=Ge(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")},ki.weeksInYear=function(){var e=this.localeData()._week;return qe(this.year(),e.dow,e.doy)},ki.isoWeeksInYear=function(){return qe(this.year(),1,4)},ki.date=mi,ki.day=ki.days=function(e){if(!this.isValid())return null!=e?this:NaN;var t=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(e=function(e,t){return"string"!=typeof e?e:isNaN(e)?"number"==typeof(e=t.weekdaysParse(e))?e:null:parseInt(e,10)}(e,this.localeData()),this.add(e-t,"d")):t},ki.weekday=function(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")},ki.isoWeekday=function(e){if(!this.isValid())return null!=e?this:NaN;if(null!=e){var t=function(e,t){return"string"==typeof e?t.weekdaysParse(e)%7||7:isNaN(e)?null:e}(e,this.localeData());return this.day(this.day()%7?t:t-7)}return this.day()||7},ki.dayOfYear=function(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")},ki.hour=ki.hours=at,ki.minute=ki.minutes=gi,ki.second=ki.seconds=bi,ki.millisecond=ki.milliseconds=wi,ki.utcOffset=function(e,t,i){var o,s=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null!=e){if("string"==typeof e){if(null===(e=Wt(re,e)))return this}else Math.abs(e)<16&&!i&&(e*=60);return!this._isUTC&&t&&(o=Ut(this)),this._offset=e,this._isUTC=!0,null!=o&&this.add(o,"m"),s!==e&&(!t||this._changeInProgress?Qt(this,Xt(e-s,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?s:Ut(this)},ki.utc=function(e){return this.utcOffset(0,e)},ki.local=function(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(Ut(this),"m")),this},ki.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var e=Wt(se,this._i);null!=e?this.utcOffset(e):this.utcOffset(0,!0)}return this},ki.hasAlignedHourOffset=function(e){return!!this.isValid()&&(e=e?Ft(e).utcOffset():0,(this.utcOffset()-e)%60==0)},ki.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},ki.isLocal=function(){return!!this.isValid()&&!this._isUTC},ki.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},ki.isUtc=Gt,ki.isUTC=Gt,ki.zoneAbbr=function(){return this._isUTC?"UTC":""},ki.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},ki.dates=O("dates accessor is deprecated. Use date instead.",mi),ki.months=O("months accessor is deprecated. Use month instead",Ae),ki.years=O("years accessor is deprecated. Use year instead",Te),ki.zone=O("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()})),ki.isDSTShifted=O("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!r(this._isDSTShifted))return this._isDSTShifted;var e={};if(g(e,this),(e=Pt(e))._a){var t=e._isUTC?c(e._a):Ft(e._a);this._isDSTShifted=this.isValid()&&x(e._a,t.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var Si=P.prototype;function Oi(e,t,i,n){var o=vt(),s=c().set(n,t);return o[i](s,e)}function Di(e,t,i){if(a(e)&&(t=e,e=void 0),e=e||"",null!=t)return Oi(e,t,i,"month");var n,o=[];for(n=0;n<12;n++)o[n]=Oi(e,n,i,"month");return o}function Mi(e,t,i,n){"boolean"==typeof e?(a(t)&&(i=t,t=void 0),t=t||""):(i=t=e,e=!1,a(t)&&(i=t,t=void 0),t=t||"");var o,s=vt(),r=e?s._week.dow:0;if(null!=i)return Oi(t,(i+r)%7,n,"day");var h=[];for(o=0;o<7;o++)h[o]=Oi(t,(o+r)%7,n,"day");return h}Si.calendar=function(e,t,i){var n=this._calendar[e]||this._calendar.sameElse;return E(n)?n.call(t,i):n},Si.longDateFormat=function(e){var t=this._longDateFormat[e],i=this._longDateFormat[e.toUpperCase()];return t||!i?t:(this._longDateFormat[e]=i.replace(/MMMM|MM|DD|dddd/g,(function(e){return e.slice(1)})),this._longDateFormat[e])},Si.invalidDate=function(){return this._invalidDate},Si.ordinal=function(e){return this._ordinal.replace("%d",e)},Si.preparse=xi,Si.postformat=xi,Si.relativeTime=function(e,t,i,n){var o=this._relativeTime[i];return E(o)?o(e,t,i,n):o.replace(/%d/i,e)},Si.pastFuture=function(e,t){var i=this._relativeTime[e>0?"future":"past"];return E(i)?i(t):i.replace(/%s/i,t)},Si.set=function(e){var t,i;for(i in e)E(t=e[i])?this[i]=t:this["_"+i]=t;this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Si.months=function(e,t){return e?o(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||Fe).test(t)?"format":"standalone"][e.month()]:o(this._months)?this._months:this._months.standalone},Si.monthsShort=function(e,t){return e?o(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[Fe.test(t)?"format":"standalone"][e.month()]:o(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Si.monthsParse=function(e,t,i){var n,o,s;if(this._monthsParseExact)return Re.call(this,e,t,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(o=c([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(o,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(o,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(s="^"+this.months(o,"")+"|^"+this.monthsShort(o,""),this._monthsParse[n]=new RegExp(s.replace(".",""),"i")),i&&"MMMM"===t&&this._longMonthsParse[n].test(e))return n;if(i&&"MMM"===t&&this._shortMonthsParse[n].test(e))return n;if(!i&&this._monthsParse[n].test(e))return n}},Si.monthsRegex=function(e){return this._monthsParseExact?(l(this,"_monthsRegex")||Le.call(this),e?this._monthsStrictRegex:this._monthsRegex):(l(this,"_monthsRegex")||(this._monthsRegex=Be),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)},Si.monthsShortRegex=function(e){return this._monthsParseExact?(l(this,"_monthsRegex")||Le.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(l(this,"_monthsShortRegex")||(this._monthsShortRegex=ze),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)},Si.week=function(e){return Ge(e,this._week.dow,this._week.doy).week},Si.firstDayOfYear=function(){return this._week.doy},Si.firstDayOfWeek=function(){return this._week.dow},Si.weekdays=function(e,t){var i=o(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Ze(i,this._week.dow):e?i[e.day()]:i},Si.weekdaysMin=function(e){return!0===e?Ze(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin},Si.weekdaysShort=function(e){return!0===e?Ze(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort},Si.weekdaysParse=function(e,t,i){var n,o,s;if(this._weekdaysParseExact)return Je.call(this,e,t,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(o=c([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(o,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(o,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(o,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(s="^"+this.weekdays(o,"")+"|^"+this.weekdaysShort(o,"")+"|^"+this.weekdaysMin(o,""),this._weekdaysParse[n]=new RegExp(s.replace(".",""),"i")),i&&"dddd"===t&&this._fullWeekdaysParse[n].test(e))return n;if(i&&"ddd"===t&&this._shortWeekdaysParse[n].test(e))return n;if(i&&"dd"===t&&this._minWeekdaysParse[n].test(e))return n;if(!i&&this._weekdaysParse[n].test(e))return n}},Si.weekdaysRegex=function(e){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||it.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(l(this,"_weekdaysRegex")||(this._weekdaysRegex=Qe),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)},Si.weekdaysShortRegex=function(e){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||it.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(l(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=et),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Si.weekdaysMinRegex=function(e){return this._weekdaysParseExact?(l(this,"_weekdaysRegex")||it.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(l(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=tt),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Si.isPM=function(e){return"p"===(e+"").toLowerCase().charAt(0)},Si.meridiem=function(e,t,i){return e>11?i?"pm":"PM":i?"am":"AM"},ft("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===k(e%100/10)?"th":1===t?"st":2===t?"nd":3===t?"rd":"th")}}),n.lang=O("moment.lang is deprecated. Use moment.locale instead.",ft),n.langData=O("moment.langData is deprecated. Use moment.localeData instead.",vt);var Ti=Math.abs;function Ei(e,t,i,n){var o=Xt(t,i);return e._milliseconds+=n*o._milliseconds,e._days+=n*o._days,e._months+=n*o._months,e._bubble()}function Ci(e){return e<0?Math.floor(e):Math.ceil(e)}function Pi(e){return 4800*e/146097}function Ii(e){return 146097*e/4800}function Fi(e){return function(){return this.as(e)}}var Ni=Fi("ms"),Yi=Fi("s"),Ri=Fi("m"),ji=Fi("h"),Ai=Fi("d"),zi=Fi("w"),Bi=Fi("M"),Li=Fi("Q"),Hi=Fi("y");function Wi(e){return function(){return this.isValid()?this._data[e]:NaN}}var Vi=Wi("milliseconds"),Ui=Wi("seconds"),Gi=Wi("minutes"),qi=Wi("hours"),Zi=Wi("days"),Xi=Wi("months"),$i=Wi("years"),Ki=Math.round,Ji={ss:44,s:45,m:45,h:22,d:26,M:11};function Qi(e,t,i,n,o){return o.relativeTime(t||1,!!i,e,n)}var en=Math.abs;function tn(e){return(e>0)-(e<0)||+e}function nn(){if(!this.isValid())return this.localeData().invalidDate();var e,t,i=en(this._milliseconds)/1e3,n=en(this._days),o=en(this._months);e=w(i/60),t=w(e/60),i%=60,e%=60;var s=w(o/12),r=o%=12,a=n,h=t,d=e,l=i?i.toFixed(3).replace(/\.?0+$/,""):"",u=this.asSeconds();if(!u)return"P0D";var c=u<0?"-":"",f=tn(this._months)!==tn(u)?"-":"",p=tn(this._days)!==tn(u)?"-":"",v=tn(this._milliseconds)!==tn(u)?"-":"";return c+"P"+(s?f+s+"Y":"")+(r?f+r+"M":"")+(a?p+a+"D":"")+(h||d||l?"T":"")+(h?v+h+"H":"")+(d?v+d+"M":"")+(l?v+l+"S":"")}var on=At.prototype;return on.isValid=function(){return this._isValid},on.abs=function(){var e=this._data;return this._milliseconds=Ti(this._milliseconds),this._days=Ti(this._days),this._months=Ti(this._months),e.milliseconds=Ti(e.milliseconds),e.seconds=Ti(e.seconds),e.minutes=Ti(e.minutes),e.hours=Ti(e.hours),e.months=Ti(e.months),e.years=Ti(e.years),this},on.add=function(e,t){return Ei(this,e,t,1)},on.subtract=function(e,t){return Ei(this,e,t,-1)},on.as=function(e){if(!this.isValid())return NaN;var t,i,n=this._milliseconds;if("month"===(e=N(e))||"quarter"===e||"year"===e)switch(t=this._days+n/864e5,i=this._months+Pi(t),e){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(t=this._days+Math.round(Ii(this._months)),e){case"week":return t/7+n/6048e5;case"day":return t+n/864e5;case"hour":return 24*t+n/36e5;case"minute":return 1440*t+n/6e4;case"second":return 86400*t+n/1e3;case"millisecond":return Math.floor(864e5*t)+n;default:throw new Error("Unknown unit "+e)}},on.asMilliseconds=Ni,on.asSeconds=Yi,on.asMinutes=Ri,on.asHours=ji,on.asDays=Ai,on.asWeeks=zi,on.asMonths=Bi,on.asQuarters=Li,on.asYears=Hi,on.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*k(this._months/12):NaN},on._bubble=function(){var e,t,i,n,o,s=this._milliseconds,r=this._days,a=this._months,h=this._data;return s>=0&&r>=0&&a>=0||s<=0&&r<=0&&a<=0||(s+=864e5*Ci(Ii(a)+r),r=0,a=0),h.milliseconds=s%1e3,e=w(s/1e3),h.seconds=e%60,t=w(e/60),h.minutes=t%60,i=w(t/60),h.hours=i%24,r+=w(i/24),o=w(Pi(r)),a+=o,r-=Ci(Ii(o)),n=w(a/12),a%=12,h.days=r,h.months=a,h.years=n,this},on.clone=function(){return Xt(this)},on.get=function(e){return e=N(e),this.isValid()?this[e+"s"]():NaN},on.milliseconds=Vi,on.seconds=Ui,on.minutes=Gi,on.hours=qi,on.days=Zi,on.weeks=function(){return w(this.days()/7)},on.months=Xi,on.years=$i,on.humanize=function(e){if(!this.isValid())return this.localeData().invalidDate();var t=this.localeData(),i=function(e,t,i){var n=Xt(e).abs(),o=Ki(n.as("s")),s=Ki(n.as("m")),r=Ki(n.as("h")),a=Ki(n.as("d")),h=Ki(n.as("M")),d=Ki(n.as("y")),l=o<=Ji.ss&&["s",o]||o<Ji.s&&["ss",o]||s<=1&&["m"]||s<Ji.m&&["mm",s]||r<=1&&["h"]||r<Ji.h&&["hh",r]||a<=1&&["d"]||a<Ji.d&&["dd",a]||h<=1&&["M"]||h<Ji.M&&["MM",h]||d<=1&&["y"]||["yy",d];return l[2]=t,l[3]=+e>0,l[4]=i,Qi.apply(null,l)}(this,!e,t);return e&&(i=t.pastFuture(+this,i)),t.postformat(i)},on.toISOString=nn,on.toString=nn,on.toJSON=nn,on.locale=ni,on.localeData=si,on.toIsoString=O("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",nn),on.lang=oi,W("X",0,0,"unix"),W("x",0,0,"valueOf"),de("x",oe),de("X",/[+-]?\d+(\.\d{1,3})?/),fe("X",(function(e,t,i){i._d=new Date(1e3*parseFloat(e,10))})),fe("x",(function(e,t,i){i._d=new Date(k(e))})),n.version="2.24.0",t=Ft,n.fn=ki,n.min=function(){return Rt("isBefore",[].slice.call(arguments,0))},n.max=function(){return Rt("isAfter",[].slice.call(arguments,0))},n.now=function(){return Date.now?Date.now():+new Date},n.utc=c,n.unix=function(e){return Ft(1e3*e)},n.months=function(e,t){return Di(e,t,"months")},n.isDate=h,n.locale=ft,n.invalid=v,n.duration=Xt,n.isMoment=_,n.weekdays=function(e,t,i){return Mi(e,t,i,"weekdays")},n.parseZone=function(){return Ft.apply(null,arguments).parseZone()},n.localeData=vt,n.isDuration=zt,n.monthsShort=function(e,t){return Di(e,t,"monthsShort")},n.weekdaysMin=function(e,t,i){return Mi(e,t,i,"weekdaysMin")},n.defineLocale=pt,n.updateLocale=function(e,t){if(null!=t){var i,n,o=ht;null!=(n=ct(e))&&(o=n._config),t=C(o,t),(i=new P(t)).parentLocale=dt[e],dt[e]=i,ft(e)}else null!=dt[e]&&(null!=dt[e].parentLocale?dt[e]=dt[e].parentLocale:null!=dt[e]&&delete dt[e]);return dt[e]},n.locales=function(){return D(dt)},n.weekdaysShort=function(e,t,i){return Mi(e,t,i,"weekdaysShort")},n.normalizeUnits=N,n.relativeTimeRounding=function(e){return void 0===e?Ki:"function"==typeof e&&(Ki=e,!0)},n.relativeTimeThreshold=function(e,t){return void 0!==Ji[e]&&(void 0===t?Ji[e]:(Ji[e]=t,"s"===e&&(Ji.ss=t-1),!0))},n.calendarFormat=function(e,t){var i=e.diff(t,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},n.prototype=ki,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n}()})),Ba=[],La=0;La<256;La++)Ba[La]=(La+256).toString(16).substr(1);for(var Ha=function(){if("undefined"!=typeof crypto&&crypto.getRandomValues){var e=new Uint8Array(16);return function(){return crypto.getRandomValues(e),e}}var t=new Array(16);return function(){for(var e,i=0;i<16;i++)0==(3&i)&&(e=4294967296*Math.random()),t[i]=e>>>((3&i)<<3)&255;return t}}(),Wa=[],Va=0;Va<256;Va++)Wa[Va]=(Va+256).toString(16).substr(1);var Ua=Ha(),Ga=(Ua[0],Ua[1],Ua[2],Ua[3],Ua[4],Ua[5],Ua[6],Ua[7],/^\/?Date\((-?\d+)/i);function qa(e){return e instanceof Number||"number"==typeof e}function Za(e){return e instanceof String||"string"==typeof e}function Xa(e){return za.isMoment(e)}function $a(e,t){var i;if(void 0!==e){if(null===e)return null;if(!t)return e;if("string"!=typeof t&&!(t instanceof String))throw new Error("Type must be a string");switch(t){case"boolean":case"Boolean":return Boolean(e);case"number":case"Number":return Za(e)&&!isNaN(Date.parse(e))?za(e).valueOf():Number(e.valueOf());case"string":case"String":return String(e);case"Date":if(qa(e))return new Date(e);if(e instanceof Date)return new Date(e.valueOf());if(Xa(e))return new Date(e.valueOf());if(Za(e))return(i=Ga.exec(e))?new Date(Number(i[1])):za(new Date(e)).toDate();throw new Error("Cannot convert object of type "+Ka(e)+" to type Date");case"Moment":if(qa(e))return za(e);if(e instanceof Date)return za(e.valueOf());if(Xa(e))return za(e);if(Za(e))return i=Ga.exec(e),za(i?Number(i[1]):e);throw new Error("Cannot convert object of type "+Ka(e)+" to type Date");case"ISODate":if(qa(e))return new Date(e);if(e instanceof Date)return e.toISOString();if(Xa(e))return e.toDate().toISOString();if(Za(e))return(i=Ga.exec(e))?new Date(Number(i[1])).toISOString():za(e).format();throw new Error("Cannot convert object of type "+Ka(e)+" to type ISODate");case"ASPDate":if(qa(e))return"/Date("+e+")/";if(e instanceof Date)return"/Date("+e.valueOf()+")/";if(Za(e))return"/Date("+((i=Ga.exec(e))?new Date(Number(i[1])).valueOf():new Date(e).valueOf())+")/";throw new Error("Cannot convert object of type "+Ka(e)+" to type ASPDate");default:throw new Error("Unknown type ".concat(t))}}}function Ka(e){var t=ja(e);return"object"===t?null===e?"null":e instanceof Boolean?"Boolean":e instanceof Number?"Number":e instanceof String?"String":Array.isArray(e)?"Array":e instanceof Date?"Date":"Object":"number"===t?"Number":"boolean"===t?"Boolean":"string"===t?"String":void 0===t?"undefined":t}function Ja(e){return"string"==typeof e||"number"==typeof e}var Qa=function(){function e(t){ka(this,e),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(t)}return Sa(e,[{key:"setOptions",value:function(e){e&&void 0!==e.delay&&(this.delay=e.delay),e&&void 0!==e.max&&(this.max=e.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var e=this._extended.object,t=this._extended.methods,i=0;i<t.length;i++){var n=t[i];n.original?e[n.name]=n.original:delete e[n.name]}this._extended=null}}},{key:"replace",value:function(e,t){var i=this,n=e[t];if(!n)throw new Error("Method "+t+" undefined");e[t]=function(){for(var e=arguments.length,t=new Array(e),o=0;o<e;o++)t[o]=arguments[o];i.queue({args:t,fn:n,context:this})}}},{key:"queue",value:function(e){"function"==typeof e?this._queue.push({fn:e}):this._queue.push(e),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var e=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=setTimeout((function(){e.flush()}),this.delay))}},{key:"flush",value:function(){this._queue.splice(0).forEach((function(e){e.fn.apply(e.context||e.fn,e.args||[])}))}}],[{key:"extend",value:function(t,i){var n=new e(i);if(void 0!==t.flush)throw new Error("Target object already has a property flush");t.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(i&&i.replace)for(var s=0;s<i.replace.length;s++){var r=i.replace[s];o.push({name:r,original:t[r]}),n.replace(t,r)}return n._extended={object:t,methods:o},n}}]),e}();var eh=function(e){if(Array.isArray(e)){for(var t=0,i=new Array(e.length);t<e.length;t++)i[t]=e[t];return i}};var th=function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)};var ih=function(){throw new TypeError("Invalid attempt to spread non-iterable instance")};var nh=function(e){return eh(e)||th(e)||ih()},oh=function(){function e(){ka(this,e),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=e.prototype.on,this.unsubscribe=e.prototype.off}return Sa(e,[{key:"_trigger",value:function(e,t,i){if("*"===e)throw new Error("Cannot trigger event *");for(var n=[].concat(nh(this._subscribers[e]),nh(this._subscribers["*"])),o=0,s=n.length;o<s;o++){var r=n[o];r.callback&&r.callback(e,t,null!=i?i:null)}}},{key:"on",value:function(e,t){this._subscribers[e].push({callback:t})}},{key:"off",value:function(e,t){this._subscribers[e]=this._subscribers[e].filter((function(e){return e.callback!==t}))}}]),e}();function sh(e,t){var i=Object.keys(e);return Object.getOwnPropertySymbols&&i.push.apply(i,Object.getOwnPropertySymbols(e)),t&&(i=i.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),i}var rh,ah=function(e){function t(e,i){var n;if(ka(this,t),n=Da(this,Ma(t).call(this)),e&&!Array.isArray(e)&&(i=e,e=[]),n._options=i||{},n._data=Object.create({}),n.length=0,n._idProp=n._options.fieldId||"id",n._type={},n._options.type)for(var o=Object.keys(n._options.type),s=0,r=o.length;s<r;s++){var a=o[s],h=n._options.type[a];n._type[a]="Date"==h||"ISODate"==h||"ASPDate"==h?"Date":h}return e&&e.length&&n.add(e),n.setOptions(i),n}return Ea(t,oh),Sa(t,[{key:"setOptions",value:function(e){e&&void 0!==e.queue&&(!1===e.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=Qa.extend(this,{replace:["add","update","remove"]})),e.queue&&"object"===wa(e.queue)&&this._queue.setOptions(e.queue)))}},{key:"add",value:function(e,t){var i,n=[];if(Array.isArray(e))for(var o=0,s=e.length;o<s;o++)i=this._addItem(e[o]),n.push(i);else{if(!e||"object"!==wa(e))throw new Error("Unknown dataType");i=this._addItem(e),n.push(i)}return n.length&&this._trigger("add",{items:n},t),n}},{key:"update",value:function(e,t){var i=this,n=[],o=[],s=[],r=[],a=this._idProp,h=function(e){var t=e[a];if(null!=t&&i._data[t]){var h=e,d=Object.assign({},i._data[t]),l=i._updateItem(h);o.push(l),r.push(h),s.push(d)}else{var u=i._addItem(e);n.push(u)}};if(Array.isArray(e))for(var d=0,l=e.length;d<l;d++)e[d]&&"object"===wa(e[d])?h(e[d]):console.warn("Ignoring input item, which is not an object at index "+d);else{if(!e||"object"!==wa(e))throw new Error("Unknown dataType");h(e)}if(n.length&&this._trigger("add",{items:n},t),o.length){var u={items:o,oldData:s,data:r};this._trigger("update",u,t)}return n.concat(o)}},{key:"get",value:function(e,t){var i=void 0,n=void 0,o=void 0;Ja(e)?(i=e,o=t):Array.isArray(e)?(n=e,o=t):o=e;var s=o&&"Object"===o.returnType?"Object":"Array",r=o&&o.type||this._options.type,a=o&&o.filter,h=[],d=null,l=null,u=null;if(null!=i)(d=this._getItem(i,r))&&a&&!a(d)&&(d=null);else if(null!=n)for(var c=0,f=n.length;c<f;c++)null==(d=this._getItem(n[c],r))||a&&!a(d)||h.push(d);else for(var p=0,v=(l=Object.keys(this._data)).length;p<v;p++)u=l[p],null==(d=this._getItem(u,r))||a&&!a(d)||h.push(d);if(o&&o.order&&null==i&&this._sort(h,o.order),o&&o.fields){var m=o.fields;if(null!=i&&null!=d)d=this._filterFields(d,m);else for(var g=0,y=h.length;g<y;g++)h[g]=this._filterFields(h[g],m)}if("Object"==s){for(var b={},_=0,w=h.length;_<w;_++){var k=h[_];b[k[this._idProp]]=k}return b}return null!=i?d:h}},{key:"getIds",value:function(e){var t,i,n=this._data,o=e&&e.filter,s=e&&e.order,r=e&&e.type||this._options.type,a=Object.keys(n),h=[];if(o)if(s){i=[];for(var d=0,l=a.length;d<l;d++){var u=a[d];o(t=this._getItem(u,r))&&i.push(t)}this._sort(i,s);for(var c=0,f=i.length;c<f;c++)h.push(i[c][this._idProp])}else for(var p=0,v=a.length;p<v;p++){var m=a[p];o(t=this._getItem(m,r))&&h.push(t[this._idProp])}else if(s){i=[];for(var g=0,y=a.length;g<y;g++){var b=a[g];i.push(n[b])}this._sort(i,s);for(var _=0,w=i.length;_<w;_++)h.push(i[_][this._idProp])}else for(var k=0,x=a.length;k<x;k++){t=n[a[k]],h.push(t[this._idProp])}return h}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(e,t){var i=t&&t.filter,n=t&&t.type||this._options.type,o=this._data,s=Object.keys(o);if(t&&t.order)for(var r=this.get(t),a=0,h=r.length;a<h;a++){var d=r[a];e(d,d[this._idProp])}else for(var l=0,u=s.length;l<u;l++){var c=s[l],f=this._getItem(c,n);i&&!i(f)||e(f,c)}}},{key:"map",value:function(e,t){for(var i=t&&t.filter,n=t&&t.type||this._options.type,o=[],s=this._data,r=Object.keys(s),a=0,h=r.length;a<h;a++){var d=r[a],l=this._getItem(d,n);i&&!i(l)||o.push(e(l,d))}return t&&t.order&&this._sort(o,t.order),o}},{key:"_filterFields",value:function(e,t){return e?(Array.isArray(t)?t:Object.keys(t)).reduce((function(t,i){return t[i]=e[i],t}),{}):e}},{key:"_sort",value:function(e,t){if("string"==typeof t){var i=t;e.sort((function(e,t){var n=e[i],o=t[i];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof t)throw new TypeError("Order must be a function or a string");e.sort(t)}}},{key:"remove",value:function(e,t){for(var i=[],n=[],o=Array.isArray(e)?e:[e],s=0,r=o.length;s<r;s++){var a=this._remove(o[s]);if(a){var h=a[this._idProp];null!=h&&(i.push(h),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},t),i}},{key:"_remove",value:function(e){var t;if(Ja(e)?t=e:e&&"object"===wa(e)&&(t=e[this._idProp]),null!=t&&this._data[t]){var i=this._data[t];return delete this._data[t],--this.length,i}return null}},{key:"clear",value:function(e){for(var t=Object.keys(this._data),i=[],n=0,o=t.length;n<o;n++)i.push(this._data[t[n]]);return this._data={},this.length=0,this._trigger("remove",{items:t,oldData:i},e),t}},{key:"max",value:function(e){for(var t=this._data,i=Object.keys(t),n=null,o=null,s=0,r=i.length;s<r;s++){var a=t[i[s]],h=a[e];null!=h&&(null==o||h>o)&&(n=a,o=h)}return n}},{key:"min",value:function(e){for(var t=this._data,i=Object.keys(t),n=null,o=null,s=0,r=i.length;s<r;s++){var a=t[i[s]],h=a[e];null!=h&&(null==o||h<o)&&(n=a,o=h)}return n}},{key:"distinct",value:function(e){for(var t=this._data,i=Object.keys(t),n=[],o=this._options.type&&this._options.type[e]||null,s=0,r=0,a=i.length;r<a;r++){for(var h=t[i[r]][e],d=!1,l=0;l<s;l++)if(n[l]==h){d=!0;break}d||void 0===h||(n[s]=h,s++)}if(o)for(var u=0,c=n.length;u<c;u++)n[u]=$a(n[u],o);return n}},{key:"_addItem",value:function(e){var t=e[this._idProp];if(null!=t){if(this._data[t])throw new Error("Cannot add item: item with id "+t+" already exists")}else t=Ra(),e[this._idProp]=t;for(var i={},n=Object.keys(e),o=0,s=n.length;o<s;o++){var r=n[o],a=this._type[r];i[r]=$a(e[r],a)}return this._data[t]=i,this.length++,t}},{key:"_getItem",value:function(e,t){var i,n=this._data[e];if(!n)return null;var o=Object.keys(n);if(t){i={};for(var s=0,r=o.length;s<r;s++){var a=o[s],h=n[a];i[a]=$a(h,t[a])}}else i=function(e){for(var t=1;t<arguments.length;t++){var i=null!=arguments[t]?arguments[t]:{};t%2?sh(i,!0).forEach((function(t){ba(e,t,i[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(i)):sh(i).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(i,t))}))}return e}({},n);return null==i[this._idProp]&&(i[this._idProp]=n.id),i}},{key:"_updateItem",value:function(e){var t=e[this._idProp];if(null==t)throw new Error("Cannot update item: item has no id (item: "+JSON.stringify(e)+")");var i=this._data[t];if(!i)throw new Error("Cannot update item: no item with id "+t+" found");for(var n=Object.keys(e),o=0,s=n.length;o<s;o++){var r=n[o],a=this._type[r];i[r]=$a(e[r],a)}return t}}]),t}(),hh=function(e){function t(e,i){var n;return ka(this,t),(n=Da(this,Ma(t).call(this))).length=0,n._ids={},n._options=i||{},n.listener=n._onEvent.bind(Oa(n)),n.setData(e),n}return Ea(t,oh),Sa(t,[{key:"setData",value:function(e){if(this._data){this._data.off&&this._data.off("*",this.listener);var t=this._data.getIds({filter:this._options.filter}),i=this._data.get(t);this._ids={},this.length=0,this._trigger("remove",{items:t,oldData:i})}if(null!=e){this._data=e;for(var n=this._data.getIds({filter:this._options.filter}),o=0,s=n.length;o<s;o++){var r=n[o];this._ids[r]=!0}this.length=n.length,this._trigger("add",{items:n})}else this._data=new ah;this._data.on&&this._data.on("*",this.listener)}},{key:"refresh",value:function(){for(var e=this._data.getIds({filter:this._options.filter}),t=Object.keys(this._ids),i={},n=[],o=[],s=[],r=0,a=e.length;r<a;r++){var h=e[r];i[h]=!0,this._ids[h]||(n.push(h),this._ids[h]=!0)}for(var d=0,l=t.length;d<l;d++){var u=t[d],c=this._data.get(u);null==c?console.error("If you see this, report it please."):i[u]||(o.push(u),s.push(c),delete this._ids[u])}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:s})}},{key:"get",value:function(e,t){if(null==this._data)return null;var i,n=null;Ja(e)||Array.isArray(e)?(n=e,i=t):i=e;var o=Object.assign({},this._options,i),s=this._options.filter,r=i&&i.filter;return s&&r&&(o.filter=function(e){return s(e)&&r(e)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(e){if(this._data.length){var t,i=this._options.filter,n=null!=e?e.filter:null;return t=n?i?function(e){return i(e)&&n(e)}:n:i,this._data.getIds({filter:t,order:e&&e.order})}return[]}},{key:"forEach",value:function(e,t){if(this._data){var i,n=this._options.filter,o=t&&t.filter;i=o?n?function(e){return n(e)&&o(e)}:o:n,this._data.forEach(e,{filter:i,order:t&&t.order})}}},{key:"map",value:function(e,t){if(this._data){var i,n=this._options.filter,o=t&&t.filter;return i=o?n?function(e){return n(e)&&o(e)}:o:n,this._data.map(e,{filter:i,order:t&&t.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"_onEvent",value:function(e,t,i){if(t&&t.items&&this._data){var n=t.items,o=[],s=[],r=[],a=[],h=[],d=[];switch(e){case"add":for(var l=0,u=n.length;l<u;l++){var c=n[l];this.get(c)&&(this._ids[c]=!0,o.push(c))}break;case"update":for(var f=0,p=n.length;f<p;f++){var v=n[f];this.get(v)?this._ids[v]?(s.push(v),h.push(t.data[f]),a.push(t.oldData[f])):(this._ids[v]=!0,o.push(v)):this._ids[v]&&(delete this._ids[v],r.push(v),d.push(t.oldData[f]))}break;case"remove":for(var m=0,g=n.length;m<g;m++){var y=n[m];this._ids[y]&&(delete this._ids[y],r.push(y),d.push(t.oldData[m]))}}this.length+=o.length-r.length,o.length&&this._trigger("add",{items:o},i),s.length&&this._trigger("update",{items:s,oldData:a,data:h},i),r.length&&this._trigger("remove",{items:r,oldData:d},i)}}}]),t}(),dh={DataSet:ah,DataView:hh,Queue:Qa},lh=Object.freeze({__proto__:null,default:dh,DataSet:ah,DataView:hh,Queue:Qa}),uh=function(){function e(){na(this,e)}return sa(e,null,[{key:"choosify",value:function(e,t){var i=["node","edge","label"],n=!0,o=no(t,"chosen");if("boolean"==typeof o)n=o;else if("object"===ia(o)){if(-1===i.indexOf(e))throw new Error("choosify: subOption '"+e+"' should be one of '"+i.join("', '")+"'");var s=no(t,["chosen",e]);"boolean"!=typeof s&&"function"!=typeof s||(n=s)}return n}},{key:"pointInRect",value:function(e,t,i){if(e.width<=0||e.height<=0)return!1;if(void 0!==i){var n={x:t.x-i.x,y:t.y-i.y};if(0!==i.angle){var o=-i.angle;t={x:Math.cos(o)*n.x-Math.sin(o)*n.y,y:Math.sin(o)*n.x+Math.cos(o)*n.y}}else t=n}var s=e.x+e.width,r=e.y+e.width;return e.left<t.x&&s>t.x&&e.top<t.y&&r>t.y}},{key:"isValidLabel",value:function(e){return"string"==typeof e&&""!==e}}]),e}(),ch=function(){function e(t){na(this,e),this.measureText=t,this.current=0,this.width=0,this.height=0,this.lines=[]}return sa(e,[{key:"_add",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[e]&&(this.lines[e]={width:0,height:0,blocks:[]});var n=t;void 0!==t&&""!==t||(n=" ");var o=this.measureText(n,i),s=Object.assign({},o.values);s.text=t,s.width=o.width,s.mod=i,void 0!==t&&""!==t||(s.width=0),this.lines[e].blocks.push(s),this.lines[e].width+=s.width}},{key:"curWidth",value:function(){var e=this.lines[this.current];return void 0===e?0:e.width}},{key:"append",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,e,t)}},{key:"newLine",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,e,t),this.current++}},{key:"determineLineHeights",value:function(){for(var e=0;e<this.lines.length;e++){var t=this.lines[e],i=0;if(void 0!==t.blocks)for(var n=0;n<t.blocks.length;n++){var o=t.blocks[n];i<o.height&&(i=o.height)}t.height=i}}},{key:"determineLabelSize",value:function(){for(var e=0,t=0,i=0;i<this.lines.length;i++){var n=this.lines[i];n.width>e&&(e=n.width),t+=n.height}this.width=e,this.height=t}},{key:"removeEmptyBlocks",value:function(){for(var e=[],t=0;t<this.lines.length;t++){var i=this.lines[t];if(0!==i.blocks.length&&(t!==this.lines.length-1||0!==i.width)){var n={};Object.assign(n,i),n.blocks=[];for(var o=void 0,s=[],r=0;r<i.blocks.length;r++){var a=i.blocks[r];0!==a.width?s.push(a):void 0===o&&(o=a)}0===s.length&&void 0!==o&&s.push(o),n.blocks=s,e.push(n)}}return e}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var e=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:e}}}]),e}(),fh={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/\_/,"`":/`/,afterBold:/[^\*]/,afterItal:/[^_]/,afterMono:/[^`]/},ph=function(){function e(t){na(this,e),this.text=t,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return sa(e,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(e){" "===e&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=e&&(this.buffer+=e)}},{key:"parseWS",value:function(e){return!!/[ \t]/.test(e)&&(this.mono?this.add(e):this.spacing=!0,!0)}},{key:"setTag",value:function(e){this.emitBlock(),this[e]=!0,this.modStack.unshift(e)}},{key:"unsetTag",value:function(e){this.emitBlock(),this[e]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(e,t){return!(this.mono||this[e]||!this.match(t))&&(this.setTag(e),!0)}},{key:"match",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.prepareRegExp(e),n=va(i,2),o=n[0],s=n[1],r=o.test(this.text.substr(this.position,s));return r&&t&&(this.position+=s-1),r}},{key:"parseEndTag",value:function(e,t,i){var n=this.mod()===e;return!(!(n="mono"===e?n&&this.mono:n&&!this.mono)||!this.match(t))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(e):this.unsetTag(e),!0)}},{key:"replace",value:function(e,t){return!!this.match(e)&&(this.add(t),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(e){var t,i;if(e instanceof RegExp)i=e,t=1;else{var n=fh[e];i=void 0!==n?n:new RegExp(e),t=e.length}return[i,t]}}]),e}(),vh=function(){function e(t,i,n,o){var s=this;na(this,e),this.ctx=t,this.parent=i,this.selected=n,this.hover=o;this.lines=new ch((function(e,i){if(void 0===e)return 0;var r=s.parent.getFormattingValues(t,n,o,i),a=0;""!==e&&(a=s.ctx.measureText(e).width);return{width:a,values:r}}))}return sa(e,[{key:"process",value:function(e){if(!uh.isValidLabel(e))return this.lines.finalize();var t=this.parent.fontOptions;e=(e=e.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(e).split("\n"),n=i.length;if(t.multi)for(var o=0;o<n;o++){var s=this.splitBlocks(i[o],t.multi);if(void 0!==s)if(0!==s.length){if(t.maxWdt>0)for(var r=0;r<s.length;r++){var a=s[r].mod,h=s[r].text;this.splitStringIntoLines(h,a,!0)}else for(var d=0;d<s.length;d++){var l=s[d].mod,u=s[d].text;this.lines.append(u,l)}this.lines.newLine()}else this.lines.newLine("")}else if(t.maxWdt>0)for(var c=0;c<n;c++)this.splitStringIntoLines(i[c]);else for(var f=0;f<n;f++)this.lines.newLine(i[f]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(e){var t="none";return"markdown"===e||"md"===e?t="markdown":!0!==e&&"html"!==e||(t="html"),t}},{key:"splitHtmlBlocks",value:function(e){for(var t=new ph(e),i=function(e){return!!/&/.test(e)&&(t.replace(t.text,"&lt;","<")||t.replace(t.text,"&amp;","&")||t.add("&"),!0)};t.position<t.text.length;){var n=t.text.charAt(t.position);t.parseWS(n)||/</.test(n)&&(t.parseStartTag("bold","<b>")||t.parseStartTag("ital","<i>")||t.parseStartTag("mono","<code>")||t.parseEndTag("bold","</b>")||t.parseEndTag("ital","</i>")||t.parseEndTag("mono","</code>"))||i(n)||t.add(n),t.position++}return t.emitBlock(),t.blocks}},{key:"splitMarkdownBlocks",value:function(e){for(var t=this,i=new ph(e),n=!0,o=function(e){return!!/\\/.test(e)&&(i.position<t.text.length+1&&(i.position++,e=t.text.charAt(i.position),/ \t/.test(e)?i.spacing=!0:(i.add(e),n=!1)),!0)};i.position<i.text.length;){var s=i.text.charAt(i.position);i.parseWS(s)||o(s)||(n||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(s),n=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(e,t){var i=this.decodeMarkupSystem(t);return"none"===i?[{text:e,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(e):"html"===i?this.splitHtmlBlocks(e):void 0}},{key:"overMaxWidth",value:function(e){var t=this.ctx.measureText(e).width;return this.lines.curWidth()+t>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(e){for(var t="",i=0;i<e.length;){var n=t+(""===t?"":" ")+e[i];if(this.overMaxWidth(n))break;t=n,i++}return i}},{key:"getLongestFitWord",value:function(e){for(var t=0;t<e.length&&!this.overMaxWidth(e.slice(0,t));)t++;return t}},{key:"splitStringIntoLines",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,t);for(var n=(e=(e=e.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");n.length>0;){var o=this.getLongestFit(n);if(0===o){var s=n[0],r=this.getLongestFitWord(s);this.lines.newLine(s.slice(0,r),t),n[0]=s.slice(r)}else{var a=o;" "===n[o-1]?o--:" "===n[a]&&a++;var h=n.slice(0,o).join("");o==n.length&&i?this.lines.append(h,t):this.lines.newLine(h,t),n=n.slice(a)}}}}]),e}(),mh=["bold","ital","boldital","mono"],gh=function(){function e(t,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];na(this,e),this.body=t,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=n}return sa(e,[{key:"setOptions",value:function(e){if(this.elementOptions=e,this.initFontOptions(e.font),uh.isValidLabel(e.label)?this.labelDirty=!0:e.label=void 0,void 0!==e.font&&null!==e.font)if("string"==typeof e.font)this.baseSize=this.fontOptions.size;else if("object"===ia(e.font)){var t=e.font.size;void 0!==t&&(this.baseSize=t)}}},{key:"initFontOptions",value:function(t){var i=this;On(mh,(function(e){i.fontOptions[e]={}})),e.parseFontString(this.fontOptions,t)?this.fontOptions.vadjust=0:On(t,(function(e,t){null!=e&&"object"!==ia(e)&&(i.fontOptions[t]=e)}))}},{key:"constrain",value:function(e){var t={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},i=no(e,"widthConstraint");if("number"==typeof i)t.maxWdt=Number(i),t.minWdt=Number(i);else if("object"===ia(i)){var n=no(e,["widthConstraint","maximum"]);"number"==typeof n&&(t.maxWdt=Number(n));var o=no(e,["widthConstraint","minimum"]);"number"==typeof o&&(t.minWdt=Number(o))}var s=no(e,"heightConstraint");if("number"==typeof s)t.minHgt=Number(s);else if("object"===ia(s)){var r=no(e,["heightConstraint","minimum"]);"number"==typeof r&&(t.minHgt=Number(r));var a=no(e,["heightConstraint","valign"]);"string"==typeof a&&("top"!==a&&"bottom"!==a||(t.valign=a))}return t}},{key:"update",value:function(e,t){this.setOptions(e,!0),this.propagateFonts(t),pn(this.fontOptions,this.constrain(t)),this.fontOptions.chooser=uh.choosify("label",t)}},{key:"adjustSizes",value:function(e){var t=e?e.right+e.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=t,this.fontOptions.minWdt-=t);var i=e?e.top+e.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(e,t){for(var i=0;i<t.length;++i)this.addFontToPile(e,t[i])}},{key:"addFontToPile",value:function(e,t){if(void 0!==t&&void 0!==t.font&&null!==t.font){var i=t.font;e.push(i)}}},{key:"getBasicOptions",value:function(t){for(var i={},n=0;n<t.length;++n){var o=t[n],s={};e.parseFontString(s,o)&&(o=s),On(o,(function(e,t){void 0!==e&&(i.hasOwnProperty(t)||(-1!==mh.indexOf(t)?i[t]={}:i[t]=e))}))}return i}},{key:"getFontOption",value:function(t,i,n){for(var o,s=0;s<t.length;++s){var r=t[s];if(r.hasOwnProperty(i)){if(null==(o=r[i]))continue;var a={};if(e.parseFontString(a,o)&&(o=a),o.hasOwnProperty(n))return o[n]}}if(this.fontOptions.hasOwnProperty(n))return this.fontOptions[n];throw new Error("Did not find value for multi-font for property: '"+n+"'")}},{key:"getFontOptions",value:function(e,t){for(var i={},n=["color","size","face","mod","vadjust"],o=0;o<n.length;++o){var s=n[o];i[s]=this.getFontOption(e,t,s)}return i}},{key:"propagateFonts",value:function(e){var t=this,i=[];this.addFontOptionsToPile(i,e),this.fontOptions=this.getBasicOptions(i);for(var n=function(e){var n=mh[e],o=t.fontOptions[n];On(t.getFontOptions(i,n),(function(e,t){o[t]=e})),o.size=Number(o.size),o.vadjust=Number(o.vadjust)},o=0;o<mh.length;++o)n(o)}},{key:"draw",value:function(e,t,i,n,o){var s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var r=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&r<this.elementOptions.scaling.label.drawThreshold-1||(r>=this.elementOptions.scaling.label.maxVisible&&(r=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(e,n,o,t,i,s),this._drawBackground(e),this._drawText(e,t,this.size.yLine,s,r))}}},{key:"_drawBackground",value:function(e){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){e.fillStyle=this.fontOptions.background;var t=this.getSize();e.fillRect(t.left,t.top,t.width,t.height)}}},{key:"_drawText",value:function(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",o=arguments.length>4?arguments[4]:void 0,s=this._setAlignment(e,t,i,n),r=va(s,2);t=r[0],i=r[1],e.textAlign="left",t-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var a=0;a<this.lineCount;a++){var h=this.lines[a];if(h&&h.blocks){var d=0;this.isEdgeLabel||"center"===this.fontOptions.align?d+=(this.size.width-h.width)/2:"right"===this.fontOptions.align&&(d+=this.size.width-h.width);for(var l=0;l<h.blocks.length;l++){var u=h.blocks[l];e.font=u.font;var c=this._getColor(u.color,o,u.strokeColor),f=va(c,2),p=f[0],v=f[1];u.strokeWidth>0&&(e.lineWidth=u.strokeWidth,e.strokeStyle=v,e.lineJoin="round"),e.fillStyle=p,u.strokeWidth>0&&e.strokeText(u.text,t+d,i+u.vadjust),e.fillText(u.text,t+d,i+u.vadjust),d+=u.width}i+=h.height}}}},{key:"_setAlignment",value:function(e,t,i,n){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){t=0,i=0;"top"===this.fontOptions.align?(e.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(e.textBaseline="hanging",i+=4):e.textBaseline="middle"}else e.textBaseline=n;return[t,i]}},{key:"_getColor",value:function(e,t,i){var n=e||"#000000",o=i||"#ffffff";if(t<=this.elementOptions.scaling.label.drawThreshold){var s=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-t)));n=Rn(n,s),o=Rn(o,s)}return[n,o]}},{key:"getTextSize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(e,t,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var e=this.size.left,t=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":e=i,t=.5*-this.size.height;break;case"top":e=i,t=-(this.size.height+2);break;case"bottom":e=i,t=2}}return{left:e,top:t,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(e,t,i),this.size.left=n-.5*this.size.width,this.size.top=o-.5*this.size.height,this.size.yLine=o+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===s&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(e,t,i,n){var o=function(e,t,i){return"normal"===t?"mod"===i?"":e[i]:void 0!==e[t][i]?e[t][i]:e[i]},s={color:o(this.fontOptions,n,"color"),size:o(this.fontOptions,n,"size"),face:o(this.fontOptions,n,"face"),mod:o(this.fontOptions,n,"mod"),vadjust:o(this.fontOptions,n,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(t||i)&&("normal"===n&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?s.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(s,this.elementOptions.id,t,i));var r="";return void 0!==s.mod&&""!==s.mod&&(r+=s.mod+" "),r+=s.size+"px "+s.face,e.font=r.replace(/"/g,""),s.font=e.font,s.height=s.size,s}},{key:"differentState",value:function(e,t){return e!==this.selectedState||t!==this.hoverState}},{key:"_processLabelText",value:function(e,t,i,n){return new vh(e,this,t,i).process(n)}},{key:"_processLabel",value:function(e,t,i){if(!1!==this.labelDirty||this.differentState(t,i)){var n=this._processLabelText(e,t,i,this.elementOptions.label);this.fontOptions.minWdt>0&&n.width<this.fontOptions.minWdt&&(n.width=this.fontOptions.minWdt),this.size.labelHeight=n.height,this.fontOptions.minHgt>0&&n.height<this.fontOptions.minHgt&&(n.height=this.fontOptions.minHgt),this.lines=n.lines,this.lineCount=n.lines.length,this.size.width=n.width,this.size.height=n.height,this.selectedState=t,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(e,t){if(!t||"string"!=typeof t)return!1;var i=t.split(" ");return e.size=+i[0].replace("px",""),e.face=i[1],e.color=i[2],!0}}]),e}(),yh=function(){function e(t,i,n){na(this,e),this.body=i,this.labelModule=n,this.setOptions(t),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return sa(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"_setMargins",value:function(e){this.margin={},this.options.margin&&("object"==ia(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),e.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(e,t){var i=this.options.borderWidth;return this.resize(e),Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}},{key:"enableShadow",value:function(e,t){t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(e,t){if(!1!==t.borderDashes)if(void 0!==e.setLineDash){var i=t.borderDashes;!0===i&&(i=[5,15]),e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1}},{key:"disableBorderDashes",value:function(e,t){!1!==t.borderDashes&&(void 0!==e.setLineDash?e.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1))}},{key:"needsRefresh",value:function(e,t){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(e,t)}},{key:"initContextForDraw",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.lineWidth=Math.min(this.width,i),e.strokeStyle=t.borderColor,e.fillStyle=t.color}},{key:"performStroke",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.save(),i>0&&(this.enableBorderDashes(e,t),e.stroke(),this.disableBorderDashes(e,t)),e.restore()}},{key:"performFill",value:function(e,t){this.enableShadow(e,t),e.fill(),this.disableShadow(e,t),this.performStroke(e,t)}},{key:"_addBoundingBoxMargin",value:function(e){this.boundingBox.left-=e,this.boundingBox.top-=e,this.boundingBox.bottom+=e,this.boundingBox.right+=e}},{key:"_updateBoundingBox",value:function(e,t,i,n,o){void 0!==i&&this.resize(i,n,o),this.left=e-this.width/2,this.top=t-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(e,t,i,n,o){this._updateBoundingBox(e,t,i,n,o)}},{key:"getDimensionsFromLabel",value:function(e,t,i){this.textSize=this.labelModule.getTextSize(e,t,i);var n=this.textSize.width,o=this.textSize.height;return 0===n&&(n=14,o=14),{width:n,height:o}}}]),e}(),bh=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n)))._setMargins(n),o}return da(t,yh),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var n=this.getDimensionsFromLabel(e,t,i);this.width=n.width+this.margin.right+this.margin.left,this.height=n.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,n,o,s){this.resize(e,n,o),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,s),e.roundRect(this.left,this.top,this.width,this.height,s.borderRadius),this.performFill(e,s),this.updateBoundingBox(t,i,e,n,o),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"updateBoundingBox",value:function(e,t,i,n,o){this._updateBoundingBox(e,t,i,n,o);var s=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(s)}},{key:"distanceToBorder",value:function(e,t){this.resize(e);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}}]),t}(),_h=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n))).labelOffset=0,o.selected=!1,o}return da(t,yh),sa(t,[{key:"setOptions",value:function(e,t,i){this.options=e,void 0===t&&void 0===i||this.setImages(t,i)}},{key:"setImages",value:function(e,t){t&&this.selected?(this.imageObj=t,this.imageObjAlt=e):(this.imageObj=e,this.imageObjAlt=t)}},{key:"switchImages",value:function(e){var t=e&&!this.selected||!e&&this.selected;if(this.selected=e,void 0!==this.imageObjAlt&&t){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var e={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var t=this.options.imagePadding;"object"==ia(t)?(e.top=t.top,e.right=t.right,e.bottom=t.bottom,e.left=t.left):(e.top=t,e.right=t,e.bottom=t,e.left=t)}return e}},{key:"_resizeImage",value:function(){var e,t;if(!1===this.options.shapeProperties.useImageSize){var i=1,n=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:n=this.imageObj.height/this.imageObj.width),e=2*this.options.size*i,t=2*this.options.size*n}else{var o=this._getImagePadding();e=this.imageObj.width+o.left+o.right,t=this.imageObj.height+o.top+o.bottom}this.width=e,this.height=t,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(e,t,i,n){this.initContextForDraw(e,n),e.circle(t,i,n.size),this.performFill(e,n)}},{key:"_drawImageAtPosition",value:function(e,t){if(0!=this.imageObj.width){e.globalAlpha=1,this.enableShadow(e,t);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var n=this._getImagePadding(),o=this.left+n.left,s=this.top+n.top,r=this.width-n.left-n.right,a=this.height-n.top-n.bottom;this.imageObj.drawImageAtPosition(e,i,o,s,r,a),this.disableShadow(e,t)}}},{key:"_drawImageLabel",value:function(e,t,i,n,o){var s,r=0;if(void 0!==this.height){r=.5*this.height;var a=this.labelModule.getTextSize(e,n,o);a.lineCount>=1&&(r+=a.height/2)}s=i+r,this.options.label&&(this.labelOffset=r),this.labelModule.draw(e,t,s,n,o,"hanging")}}]),t}(),wh=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n)))._setMargins(n),o}return da(t,_h),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var n=this.getDimensionsFromLabel(e,t,i),o=Math.max(n.width+this.margin.right+this.margin.left,n.height+this.margin.top+this.margin.bottom);this.options.size=o/2,this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,n,o,s){this.resize(e,n,o),this.left=t-this.width/2,this.top=i-this.height/2,this._drawRawCircle(e,t,i,s),this.updateBoundingBox(t,i),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,i,n,o)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size}},{key:"distanceToBorder",value:function(e,t){return this.resize(e),.5*this.width}}]),t}(),kh=function(e){function t(e,i,n,o,s){var r;return na(this,t),(r=ca(this,la(t).call(this,e,i,n))).setImages(o,s),r}return da(t,_h),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(n){var o=2*this.options.size;return this.width=o,this.height=o,void(this.radius=.5*this.width)}this.needsRefresh(t,i)&&this._resizeImage()}},{key:"draw",value:function(e,t,i,n,o,s){this.switchImages(n),this.resize(),this.left=t-this.width/2,this.top=i-this.height/2,this._drawRawCircle(e,t,i,s),e.save(),e.clip(),this._drawImageAtPosition(e,s),e.restore(),this._drawImageLabel(e,t,i,n,o),this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size,this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(e,t){return this.resize(e),.5*this.width}}]),t}(),xh=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n)))._setMargins(n),o}return da(t,yh),sa(t,[{key:"resize",value:function(e,t,i){if(this.needsRefresh(t,i)){var n=this.getDimensionsFromLabel(e,t,i).width+this.margin.right+this.margin.left;this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(e,t,i,n,o,s){this.resize(e,n,o),this.left=t-this.width/2,this.top=i-this.height/2,this.initContextForDraw(e,s),e.database(t-this.width/2,i-this.height/2,this.width,this.height),this.performFill(e,s),this.updateBoundingBox(t,i,e,n,o),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Sh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,yh),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(t,i)){this.labelModule.getTextSize(e,t,i);var o=2*n.size;this.width=o,this.height=o,this.radius=.5*this.width}}},{key:"_drawShape",value:function(e,t,i,n,o,s,r,a){if(this.resize(e,s,r,a),this.left=n-this.width/2,this.top=o-this.height/2,this.initContextForDraw(e,a),e[t](n,o,a.size),this.performFill(e,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(e.font=(s?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",e.fillText(this.options.icon.code,n,o)),void 0!==this.options.label){this.labelModule.calculateLabelSize(e,s,r,n,o,"hanging");var h=o+.5*this.height+.5*this.labelModule.size.height;this.labelModule.draw(e,n,h,s,r,"hanging")}this.updateBoundingBox(n,o)}},{key:"updateBoundingBox",value:function(e,t){this.boundingBox.top=t-this.options.size,this.boundingBox.left=e-this.options.size,this.boundingBox.right=e+this.options.size,this.boundingBox.bottom=t+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),t}(),Oh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"diamond",4,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Dh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"circle",2,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this.resize(e),this.options.size}}]),t}(),Mh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,yh),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(t,i)){var n=this.getDimensionsFromLabel(e,t,i);this.height=2*n.height,this.width=n.width+n.height,this.radius=.5*this.width}}},{key:"draw",value:function(e,t,i,n,o,s){this.resize(e,n,o),this.left=t-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(e,s),e.ellipse_vis(this.left,this.top,this.width,this.height),this.performFill(e,s),this.updateBoundingBox(t,i,e,n,o),this.labelModule.draw(e,t,i,n,o)}},{key:"distanceToBorder",value:function(e,t){this.resize(e);var i=.5*this.width,n=.5*this.height,o=Math.sin(t)*i,s=Math.cos(t)*n;return i*n/Math.sqrt(o*o+s*s)}}]),t}(),Th=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n)))._setMargins(n),o}return da(t,yh),sa(t,[{key:"resize",value:function(e,t,i){this.needsRefresh(t,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(e,t,i,n,o,s){if(this.resize(e,n,o),this.options.icon.size=this.options.icon.size||50,this.left=t-this.width/2,this.top=i-this.height/2,this._icon(e,t,i,n,o,s),void 0!==this.options.label){this.labelModule.draw(e,this.left+this.iconSize.width/2+this.margin.left,i+this.height/2+5,n)}this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){if(this.boundingBox.top=t-.5*this.options.icon.size,this.boundingBox.left=e-.5*this.options.icon.size,this.boundingBox.right=e+.5*this.options.icon.size,this.boundingBox.bottom=t+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(e,t,i,n,o,s){var r=Number(this.options.icon.size);void 0!==this.options.icon.code?(e.font=[null!=this.options.icon.weight?this.options.icon.weight:n?"bold":"",(null!=this.options.icon.weight&&n?5:0)+r+"px",this.options.icon.face].join(" "),e.fillStyle=this.options.icon.color||"black",e.textAlign="center",e.textBaseline="middle",this.enableShadow(e,s),e.fillText(this.options.icon.code,t,i),this.disableShadow(e,s)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Eh=function(e){function t(e,i,n,o,s){var r;return na(this,t),(r=ca(this,la(t).call(this,e,i,n))).setImages(o,s),r}return da(t,_h),sa(t,[{key:"resize",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(n){var o=2*this.options.size;return this.width=o,void(this.height=o)}this.needsRefresh(t,i)&&this._resizeImage()}},{key:"draw",value:function(e,t,i,n,o,s){if(this.switchImages(n),this.resize(),this.left=t-this.width/2,this.top=i-this.height/2,!0===this.options.shapeProperties.useBorderWithImage){var r=this.options.borderWidth,a=this.options.borderWidthSelected||2*this.options.borderWidth,h=(n?a:r)/this.body.view.scale;e.lineWidth=Math.min(this.width,h),e.beginPath(),e.strokeStyle=n?this.options.color.highlight.border:o?this.options.color.hover.border:this.options.color.border,e.fillStyle=n?this.options.color.highlight.background:o?this.options.color.hover.background:this.options.color.background,e.rect(this.left-.5*e.lineWidth,this.top-.5*e.lineWidth,this.width+e.lineWidth,this.height+e.lineWidth),e.fill(),this.performStroke(e,s),e.closePath()}this._drawImageAtPosition(e,s),this._drawImageLabel(e,t,i,n,o),this.updateBoundingBox(t,i)}},{key:"updateBoundingBox",value:function(e,t){this.resize(),this._updateBoundingBox(e,t),void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Ch=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"square",2,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Ph=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"hexagon",4,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Ih=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"star",4,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Fh=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n)))._setMargins(n),o}return da(t,yh),sa(t,[{key:"resize",value:function(e,t,i){this.needsRefresh(t,i)&&(this.textSize=this.labelModule.getTextSize(e,t,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(e,t,i,n,o,s){this.resize(e,n,o),this.left=t-this.width/2,this.top=i-this.height/2,this.enableShadow(e,s),this.labelModule.draw(e,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o),this.disableShadow(e,s),this.updateBoundingBox(t,i,e,n,o)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Nh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"triangle",3,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Yh=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,Sh),sa(t,[{key:"draw",value:function(e,t,i,n,o,s){this._drawShape(e,"triangleDown",3,t,i,n,o,s)}},{key:"distanceToBorder",value:function(e,t){return this._distanceToBorder(e,t)}}]),t}(),Rh=!1,jh="background: #FFeeee; color: #dd0000",Ah=function(){function e(){na(this,e)}return sa(e,null,[{key:"validate",value:function(t,i,n){Rh=!1,rh=i;var o=i;return void 0!==n&&(o=i[n]),e.parse(t,o,[]),Rh}},{key:"parse",value:function(t,i,n){for(var o in t)t.hasOwnProperty(o)&&e.check(o,t,i,n)}},{key:"check",value:function(t,i,n,o){if(void 0!==n[t]||void 0!==n.__any__){var s=t,r=!0;void 0===n[t]&&void 0!==n.__any__&&(s="__any__",r="object"===e.getType(i[t]));var a=n[s];r&&void 0!==a.__type__&&(a=a.__type__),e.checkFields(t,i,n,s,a,o)}else e.getSuggestion(t,n,o)}},{key:"checkFields",value:function(t,i,n,o,s,r){var a=function(i){console.log("%c"+i+e.printLocation(r,t),jh)},h=e.getType(i[t]),d=s[h];void 0!==d?"array"===e.getType(d)&&-1===d.indexOf(i[t])?(a('Invalid option detected in "'+t+'". Allowed values are:'+e.print(d)+' not "'+i[t]+'". '),Rh=!0):"object"===h&&"__any__"!==o&&(r=yn(r,t),e.parse(i[t],n[o],r)):void 0===s.any&&(a('Invalid type received for "'+t+'". Expected: '+e.print(Object.keys(s))+". Received ["+h+'] "'+i[t]+'"'),Rh=!0)}},{key:"getType",value:function(e){var t=ia(e);return"object"===t?null===e?"null":e instanceof Boolean?"boolean":e instanceof Number?"number":e instanceof String?"string":Array.isArray(e)?"array":e instanceof Date?"date":void 0!==e.nodeType?"dom":!0===e._isAMomentObject?"moment":"object":"number"===t?"number":"boolean"===t?"boolean":"string"===t?"string":void 0===t?"undefined":t}},{key:"getSuggestion",value:function(t,i,n){var o,s=e.findInOptions(t,i,n,!1),r=e.findInOptions(t,rh,[],!0);o=void 0!==s.indexMatch?" in "+e.printLocation(s.path,t,"")+'Perhaps it was incomplete? Did you mean: "'+s.indexMatch+'"?\n\n':r.distance<=4&&s.distance>r.distance?" in "+e.printLocation(s.path,t,"")+"Perhaps it was misplaced? Matching option found at: "+e.printLocation(r.path,r.closestMatch,""):s.distance<=8?'. Did you mean "'+s.closestMatch+'"?'+e.printLocation(s.path,t):". Did you mean one of these: "+e.print(Object.keys(i))+e.printLocation(n,t),console.log('%cUnknown option detected: "'+t+'"'+o,jh),Rh=!0}},{key:"findInOptions",value:function(t,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],s=1e9,r="",a=[],h=t.toLowerCase(),d=void 0;for(var l in i){var u=void 0;if(void 0!==i[l].__type__&&!0===o){var c=e.findInOptions(t,i[l],yn(n,l));s>c.distance&&(r=c.closestMatch,a=c.path,s=c.distance,d=c.indexMatch)}else-1!==l.toLowerCase().indexOf(h)&&(d=l),s>(u=e.levenshteinDistance(t,l))&&(r=l,a=bn(n),s=u)}return{closestMatch:r,path:a,distance:s,indexMatch:d}}},{key:"printLocation",value:function(e,t){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+i+"options = {\n",o=0;o<e.length;o++){for(var s=0;s<o+1;s++)n+="  ";n+=e[o]+": {\n"}for(var r=0;r<e.length+1;r++)n+="  ";n+=t+"\n";for(var a=0;a<e.length+1;a++){for(var h=0;h<e.length-a;h++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(e){return JSON.stringify(e).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(e,t){if(0===e.length)return t.length;if(0===t.length)return e.length;var i,n,o=[];for(i=0;i<=t.length;i++)o[i]=[i];for(n=0;n<=e.length;n++)o[0][n]=n;for(i=1;i<=t.length;i++)for(n=1;n<=e.length;n++)t.charAt(i-1)==e.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[t.length][e.length]}}]),e}(),zh=function(){function e(t,i,n,o,s,r){na(this,e),this.options=$n(s),this.globalOptions=s,this.defaultOptions=r,this.body=i,this.edges=[],this.id=void 0,this.imagelist=n,this.grouplist=o,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new gh(this.body,this.options,!1),this.setOptions(t)}return sa(e,[{key:"attachEdge",value:function(e){-1===this.edges.indexOf(e)&&this.edges.push(e)}},{key:"detachEdge",value:function(e){var t=this.edges.indexOf(e);-1!=t&&this.edges.splice(t,1)}},{key:"setOptions",value:function(t){var i=this.options.shape;if(t){if(void 0!==t.color&&(this._localColor=t.color),void 0!==t.id&&(this.id=t.id),void 0===this.id)throw new Error("Node must have an id");e.checkMass(t,this.id),void 0!==t.x&&(null===t.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=parseInt(t.x),this.predefinedPosition=!0)),void 0!==t.y&&(null===t.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=parseInt(t.y),this.predefinedPosition=!0)),void 0!==t.size&&(this.baseSize=t.size),void 0!==t.value&&(t.value=parseFloat(t.value)),e.parseOptions(this.options,t,!0,this.globalOptions,this.grouplist);var n=[t,this.options,this.defaultOptions];return this.chooser=uh.choosify("node",n),this._load_images(),this.updateLabelModule(t),this.updateShape(i),void 0!==t.hidden||void 0!==t.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var e={color:this.options.color.background,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};return this.selected||this.hover?!0===this.chooser?this.selected?(e.borderWidth*=2,e.color=this.options.color.highlight.background,e.borderColor=this.options.color.highlight.border,e.shadow=this.options.shadow.enabled):this.hover&&(e.color=this.options.color.hover.background,e.borderColor=this.options.color.hover.border,e.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(e,this.options.id,this.selected,this.hover),!1===e.shadow&&(e.shadowColor===this.options.shadow.color&&e.shadowSize===this.options.shadow.size&&e.shadowX===this.options.shadow.x&&e.shadowY===this.options.shadow.y||(e.shadow=!0))):e.shadow=this.options.shadow.enabled,e}},{key:"updateLabelModule",value:function(t){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),e.updateGroupOptions(this.options,ha({},t,{color:t&&t.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),n=[t,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,n),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(e){if(e===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new bh(this.options,this.body,this.labelModule);break;case"circle":this.shape=new wh(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new kh(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"database":this.shape=new xh(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new Oh(this.options,this.body,this.labelModule);break;case"dot":this.shape=new Dh(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Mh(this.options,this.body,this.labelModule);break;case"icon":this.shape=new Th(this.options,this.body,this.labelModule);break;case"image":this.shape=new Eh(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new Ch(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new Ph(this.options,this.body,this.labelModule);break;case"star":this.shape=new Ih(this.options,this.body,this.labelModule);break;case"text":this.shape=new Fh(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new Nh(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new Yh(this.options,this.body,this.labelModule);break;default:this.shape=new Mh(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(e,t){return this.shape.distanceToBorder(e,t)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(e,t,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(e,t,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*s}this.options.size=this.options.scaling.min+n*o}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(e){var t=this.getFormattingValues();this.shape.draw(e,this.x,this.y,this.selected,this.hover,t)}},{key:"updateBoundingBox",value:function(e){this.shape.updateBoundingBox(this.x,this.y,e)}},{key:"resize",value:function(e){var t=this.getFormattingValues();this.shape.resize(e,this.selected,this.hover,t)}},{key:"getItemsOnPoint",value:function(e){var t=[];return this.labelModule.visible()&&uh.pointInRect(this.labelModule.getSize(),e)&&t.push({nodeId:this.id,labelId:0}),uh.pointInRect(this.shape.boundingBox,e)&&t.push({nodeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){return this.shape.left<e.right&&this.shape.left+this.shape.width>e.left&&this.shape.top<e.bottom&&this.shape.top+this.shape.height>e.top}},{key:"isBoundingBoxOverlappingWith",value:function(e){return this.shape.boundingBox.left<e.right&&this.shape.boundingBox.right>e.left&&this.shape.boundingBox.top<e.bottom&&this.shape.boundingBox.bottom>e.top}}],[{key:"updateGroupOptions",value:function(e,t,i){if(void 0!==i){var n=e.group;if(void 0!==t&&void 0!==t.group&&n!==t.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof n||"string"==typeof n&&""!=n){var o=i.get(n),s=["font"];void 0!==t&&void 0!==t.color&&null!=t.color&&s.push("color"),fn(s,e,o),e.color=An(e.color)}}}},{key:"parseOptions",value:function(t,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},s=arguments.length>4?arguments[4]:void 0,r=["color","fixed","shadow"];if(fn(r,t,i,n),e.checkMass(i),Jn(t,i,"shadow",o),void 0!==i.color&&null!==i.color){var a=An(i.color);dn(t.color,a)}else!0===n&&null===i.color&&(t.color=$n(o.color));void 0!==i.fixed&&null!==i.fixed&&("boolean"==typeof i.fixed?(t.fixed.x=i.fixed,t.fixed.y=i.fixed):(void 0!==i.fixed.x&&"boolean"==typeof i.fixed.x&&(t.fixed.x=i.fixed.x),void 0!==i.fixed.y&&"boolean"==typeof i.fixed.y&&(t.fixed.y=i.fixed.y))),!0===n&&null===i.font&&(t.font=$n(o.font)),e.updateGroupOptions(t,i,s),void 0!==i.scaling&&Jn(t.scaling,i.scaling,"label",o.scaling)}},{key:"checkMass",value:function(e,t){if(void 0!==e.mass&&e.mass<=0){var i="";void 0!==t&&(i=" in node id: "+t),console.log("%cNegative or zero mass disallowed"+i+", setting mass to 1.",jh),e.mass=1}}}]),e}(),Bh=function(){function e(t,i,n,o){var s=this;if(na(this,e),this.body=t,this.images=i,this.groups=n,this.layoutEngine=o,this.body.functions.createNode=this.create.bind(this),this.nodesListeners={add:function(e,t){s.add(t.items)},update:function(e,t){s.update(t.items,t.data,t.oldData)},remove:function(e,t){s.remove(t.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:2,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,n){if(t===e)return.5;var o=1/(t-e);return Math.max(0,(n-e)*o)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=$n(this.defaultOptions),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("refreshNodes",this.refresh.bind(this)),this.body.emitter.on("refresh",this.refresh.bind(this)),this.body.emitter.on("destroy",(function(){On(e.nodesListeners,(function(t,i){e.body.data.nodes&&e.body.data.nodes.off(i,t)})),delete e.body.functions.createNode,delete e.nodesListeners.add,delete e.nodesListeners.update,delete e.nodesListeners.remove,delete e.nodesListeners}))}},{key:"setOptions",value:function(e){if(void 0!==e){if(zh.parseOptions(this.options,e),void 0!==e.shape)for(var t in this.body.nodes)this.body.nodes.hasOwnProperty(t)&&this.body.nodes[t].updateShape();if(void 0!==e.font)for(var i in this.body.nodes)this.body.nodes.hasOwnProperty(i)&&(this.body.nodes[i].updateLabelModule(),this.body.nodes[i].needsRefresh());if(void 0!==e.size)for(var n in this.body.nodes)this.body.nodes.hasOwnProperty(n)&&this.body.nodes[n].needsRefresh();void 0===e.hidden&&void 0===e.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.data.nodes;if(e instanceof ah||e instanceof hh)this.body.data.nodes=e;else if(Array.isArray(e))this.body.data.nodes=new ah,this.body.data.nodes.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new ah}if(i&&On(this.nodesListeners,(function(e,t){i.off(t,e)})),this.body.nodes={},this.body.data.nodes){var n=this;On(this.nodesListeners,(function(e,t){n.body.data.nodes.on(t,e)}));var o=this.body.data.nodes.getIds();this.add(o,!0)}!1===t&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=[],o=0;o<e.length;o++){t=e[o];var s=this.body.data.nodes.get(t),r=this.create(s);n.push(r),this.body.nodes[t]=r}this.layoutEngine.positionInitially(n),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e,t,i){for(var n=this.body.nodes,o=!1,s=0;s<e.length;s++){var r=e[s],a=n[r],h=t[s];void 0!==a?a.setOptions(h)&&(o=!0):(o=!0,a=this.create(h),n[r]=a)}o||void 0===i||(o=t.some((function(e,t){var n=i[t];return n&&n.level!==e.level}))),!0===o?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){for(var t=this.body.nodes,i=0;i<e.length;i++){delete t[e[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:zh;return new t(e,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];On(this.body.nodes,(function(i,n){var o=e.body.data.nodes.get(n);void 0!==o&&(!0===t&&i.setOptions({x:null,y:null}),i.setOptions({fixed:!1}),i.setOptions(o))}))}},{key:"getPositions",value:function(e){var t={};if(void 0!==e){if(!0===Array.isArray(e)){for(var i=0;i<e.length;i++)if(void 0!==this.body.nodes[e[i]]){var n=this.body.nodes[e[i]];t[e[i]]={x:Math.round(n.x),y:Math.round(n.y)}}}else if(void 0!==this.body.nodes[e]){var o=this.body.nodes[e];t[e]={x:Math.round(o.x),y:Math.round(o.y)}}}else for(var s=0;s<this.body.nodeIndices.length;s++){var r=this.body.nodes[this.body.nodeIndices[s]];t[this.body.nodeIndices[s]]={x:Math.round(r.x),y:Math.round(r.y)}}return t}},{key:"storePositions",value:function(){var e=[],t=this.body.data.nodes.getDataSet();for(var i in t._data)if(t._data.hasOwnProperty(i)){var n=this.body.nodes[i];t._data[i].x==Math.round(n.x)&&t._data[i].y==Math.round(n.y)||e.push({id:n.id,x:Math.round(n.x),y:Math.round(n.y)})}t.update(e)}},{key:"getBoundingBox",value:function(e){if(void 0!==this.body.nodes[e])return this.body.nodes[e].shape.boundingBox}},{key:"getConnectedNodes",value:function(e,t){var i=[];if(void 0!==this.body.nodes[e])for(var n=this.body.nodes[e],o={},s=0;s<n.edges.length;s++){var r=n.edges[s];"to"!==t&&r.toId==n.id?void 0===o[r.fromId]&&(i.push(r.fromId),o[r.fromId]=!0):"from"!==t&&r.fromId==n.id&&void 0===o[r.toId]&&(i.push(r.toId),o[r.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(e){var t=[];if(void 0!==this.body.nodes[e])for(var i=this.body.nodes[e],n=0;n<i.edges.length;n++)t.push(i.edges[n].id);else console.log("NodeId provided for getConnectedEdges does not exist. Provided: ",e);return t}},{key:"moveNode",value:function(e,t,i){var n=this;void 0!==this.body.nodes[e]?(this.body.nodes[e].x=Number(t),this.body.nodes[e].y=Number(i),setTimeout((function(){n.body.emitter.emit("startSimulation")}),0)):console.log("Node id supplied to moveNode does not exist. Provided: ",e)}}]),e}(),Lh=function(){function e(){na(this,e)}return sa(e,null,[{key:"transform",value:function(e,t){Array.isArray(e)||(e=[e]);for(var i=t.point.x,n=t.point.y,o=t.angle,s=t.length,r=0;r<e.length;++r){var a=e[r],h=a.x*Math.cos(o)-a.y*Math.sin(o),d=a.x*Math.sin(o)+a.y*Math.cos(o);a.x=i+s*h,a.y=n+s*d}}},{key:"drawPath",value:function(e,t){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(var i=1;i<t.length;++i)e.lineTo(t[i].x,t[i].y);e.closePath()}}]),e}(),Hh=function(e){function t(){return na(this,t),ca(this,la(t).apply(this,arguments))}return da(t,Lh),sa(t,null,[{key:"draw",value:function(e,t){if(t.image){e.save(),e.translate(t.point.x,t.point.y),e.rotate(Math.PI/2+t.angle);var i=null!=t.imageWidth?t.imageWidth:t.image.width,n=null!=t.imageHeight?t.imageHeight:t.image.height;t.image.drawImageAtPosition(e,1,-i/2,0,i,n),e.restore()}return!1}}]),t}(),Wh=function(e){function t(){return na(this,t),ca(this,la(t).apply(this,arguments))}return da(t,Lh),sa(t,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),t}(),Vh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Uh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};Lh.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=t.angle-n/2,s=t.angle+n/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,o,s,!1),e.stroke(),!0}}]),e}(),Gh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i={x:-.3,y:0};Lh.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=t.angle+n/2,s=t.angle+3*n/2;return e.beginPath(),e.arc(i.x,i.y,.4*t.length,o,s,!1),e.stroke(),!0}}]),e}(),qh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Zh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Xh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};return Lh.transform(i,t),e.circle(i.x,i.y,.4*t.length),!0}}]),e}(),$h=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Kh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Jh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),Qh=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return Lh.transform(i,t),Lh.drawPath(e,i),!0}}]),e}(),ed=function(){function e(){na(this,e)}return sa(e,null,[{key:"draw",value:function(e,t){var i;switch(t.type&&(i=t.type.toLowerCase()),i){case"image":return Hh.draw(e,t);case"circle":return Xh.draw(e,t);case"box":return Kh.draw(e,t);case"crow":return Vh.draw(e,t);case"curve":return Uh.draw(e,t);case"diamond":return Jh.draw(e,t);case"inv_curve":return Gh.draw(e,t);case"triangle":return qh.draw(e,t);case"inv_triangle":return Zh.draw(e,t);case"bar":return $h.draw(e,t);case"vee":return Qh.draw(e,t);case"arrow":default:return Wh.draw(e,t)}}}]),e}(),td=function(){function e(t,i,n){na(this,e),this._body=i,this._labelModule=n,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(t),this.fromPoint=this.from,this.toPoint=this.to}return sa(e,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(e){this.options=e,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(e,t,i,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();e.strokeStyle=this.getColor(e,t),e.lineWidth=t.width,!1!==t.dashes?this._drawDashedLine(e,t,o):this._drawLine(e,t,o)}},{key:"_drawLine",value:function(e,t,i,n,o){if(this.from!=this.to)this._line(e,t,i,n,o);else{var s=va(this._getCircleData(e),3),r=s[0],a=s[1],h=s[2];this._circle(e,t,r,a,h)}}},{key:"_drawDashedLine",value:function(e,t,i,n,o){e.lineCap="round";var s=Array.isArray(t.dashes)?t.dashes:[5,5];if(void 0!==e.setLineDash){if(e.save(),e.setLineDash(s),e.lineDashOffset=0,this.from!=this.to)this._line(e,t,i);else{var r=va(this._getCircleData(e),3),a=r[0],h=r[1],d=r[2];this._circle(e,t,a,h,d)}e.setLineDash([0]),e.lineDashOffset=0,e.restore()}else{if(this.from!=this.to)e.dashedLine(this.from.x,this.from.y,this.to.x,this.to.y,s);else{var l=va(this._getCircleData(e),3),u=l[0],c=l[1],f=l[2];this._circle(e,t,u,c,f)}this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}}},{key:"findBorderPosition",value:function(e,t,i){return this.from!=this.to?this._findBorderPosition(e,t,i):this._findBorderPositionCircle(e,t,i)}},{key:"findBorderPositions",value:function(e){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,e),to:this._findBorderPosition(this.to,e)};var t=va(this._getCircleData(e).slice(0,2),2),i=t[0],n=t[1];return{from:this._findBorderPositionCircle(this.from,e,{x:i,y:n,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,e,{x:i,y:n,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(e){var t,i,n=this.from,o=this.options.selfReferenceSize;return void 0!==e&&void 0===n.shape.width&&n.shape.resize(e),n.shape.width>n.shape.height?(t=n.x+.5*n.shape.width,i=n.y-o):(t=n.x+o,i=n.y-.5*n.shape.height),[t,i,o]}},{key:"_pointOnCircle",value:function(e,t,i,n){var o=2*n*Math.PI;return{x:e+i*Math.cos(o),y:t-i*Math.sin(o)}}},{key:"_findBorderPositionCircle",value:function(e,t,i){var n,o=i.x,s=i.y,r=i.low,a=i.high,h=i.direction,d=this.options.selfReferenceSize,l=.5*(r+a),u=0;do{l=.5*(r+a),n=this._pointOnCircle(o,s,d,l);var c=Math.atan2(e.y-n.y,e.x-n.x),f=e.distanceToBorder(t,c)-Math.sqrt(Math.pow(n.x-e.x,2)+Math.pow(n.y-e.y,2));if(Math.abs(f)<.05)break;f>0?h>0?r=l:a=l:h>0?a=l:r=l,++u}while(r<=a&&u<10);return ha({},n,{t:l})}},{key:"getLineWidth",value:function(e,t){return!0===e?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===t?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(e,t){if(!1!==t.inheritsColor){if("both"===t.inheritsColor&&this.from.id!==this.to.id){var i=e.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),n=this.from.options.color.highlight.border,o=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(n=Rn(this.from.options.color.border,t.opacity),o=Rn(this.to.options.color.border,t.opacity)):!0===this.from.selected&&!1===this.to.selected?o=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(n=this.from.options.color.border),i.addColorStop(0,n),i.addColorStop(1,o),i}return"to"===t.inheritsColor?Rn(this.to.options.color.border,t.opacity):Rn(this.from.options.color.border,t.opacity)}return Rn(t.color,t.opacity)}},{key:"_circle",value:function(e,t,i,n,o){this.enableShadow(e,t),e.beginPath(),e.arc(i,n,o,0,2*Math.PI,!1),e.stroke(),this.disableShadow(e,t)}},{key:"getDistanceToEdge",value:function(e,t,i,n,o,s){if(this.from!=this.to)return this._getDistanceToEdge(e,t,i,n,o,s);var r=va(this._getCircleData(void 0),3),a=r[0],h=r[1],d=r[2],l=a-o,u=h-s;return Math.abs(Math.sqrt(l*l+u*u)-d)}},{key:"_getDistanceToLine",value:function(e,t,i,n,o,s){var r=i-e,a=n-t,h=((o-e)*r+(s-t)*a)/(r*r+a*a);h>1?h=1:h<0&&(h=0);var d=e+h*r-o,l=t+h*a-s;return Math.sqrt(d*d+l*l)}},{key:"getArrowData",value:function(e,t,i,n,o,s){var r,a,h,d,l,u,c,f=s.width;"from"===t?(h=this.from,d=this.to,l=s.fromArrowScale<0,u=Math.abs(s.fromArrowScale),c=s.fromArrowType):"to"===t?(h=this.to,d=this.from,l=s.toArrowScale<0,u=Math.abs(s.toArrowScale),c=s.toArrowType):(h=this.to,d=this.from,l=s.middleArrowScale<0,u=Math.abs(s.middleArrowScale),c=s.middleArrowType);var p=15*u+3*f;if(h!=d){var v=p/Math.hypot(h.x-d.x,h.y-d.y);if("middle"!==t)if(!0===this.options.smooth.enabled){var m=this._findBorderPosition(h,e,{via:i}),g=this.getPoint(m.t+v*("from"===t?1:-1),i);r=Math.atan2(m.y-g.y,m.x-g.x),a=m}else r=Math.atan2(h.y-d.y,h.x-d.x),a=this._findBorderPosition(h,e);else{var y=(l?-v:v)/2,b=this.getPoint(.5+y,i),_=this.getPoint(.5-y,i);r=Math.atan2(b.y-_.y,b.x-_.x),a=this.getPoint(.5,i)}}else{var w=va(this._getCircleData(e),3),k=w[0],x=w[1],S=w[2];if("from"===t){var O=this._findBorderPositionCircle(this.from,e,{x:k,y:x,low:.25,high:.6,direction:-1});r=-2*O.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=O}else if("to"===t){var D=this._findBorderPositionCircle(this.from,e,{x:k,y:x,low:.6,high:1,direction:1});r=-2*D.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=D}else a=this._pointOnCircle(k,x,S,.175),r=3.9269908169872414}return{point:a,core:{x:a.x-.9*p*Math.cos(r),y:a.y-.9*p*Math.sin(r)},angle:r,length:p,type:c}}},{key:"drawArrowHead",value:function(e,t,i,n,o){e.strokeStyle=this.getColor(e,t),e.fillStyle=e.strokeStyle,e.lineWidth=t.width,ed.draw(e,o)&&(this.enableShadow(e,t),e.fill(),this.disableShadow(e,t))}},{key:"enableShadow",value:function(e,t){!0===t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){!0===t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"drawBackground",value:function(e,t){if(!1!==t.background){var i={strokeStyle:e.strokeStyle,lineWidth:e.lineWidth,dashes:e.dashes};e.strokeStyle=t.backgroundColor,e.lineWidth=t.backgroundSize,this.setStrokeDashed(e,t.backgroundDashes),e.stroke(),e.strokeStyle=i.strokeStyle,e.lineWidth=i.lineWidth,e.dashes=i.dashes,this.setStrokeDashed(e,t.dashes)}}},{key:"setStrokeDashed",value:function(e,t){if(!1!==t)if(void 0!==e.setLineDash){var i=Array.isArray(t)?t:[5,5];e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==e.setLineDash?e.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),e}(),id=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,td),sa(t,[{key:"_findBorderPositionBezier",value:function(e,t){var i,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),s=10,r=.2,a=!1,h=1,d=0,l=this.to;e.id===this.from.id&&(l=this.from,a=!0);var u=0;do{n=.5*(d+h),i=this.getPoint(n,o);var c=Math.atan2(l.y-i.y,l.x-i.x),f=l.distanceToBorder(t,c),p=Math.sqrt(Math.pow(i.x-l.x,2)+Math.pow(i.y-l.y,2)),v=f-p;if(Math.abs(v)<r)break;v<0?!1===a?d=n:h=n:!1===a?h=n:d=n,++u}while(d<=h&&u<s);return ha({},i,{t:n})}},{key:"_getDistanceToBezierEdge",value:function(e,t,i,n,o,s,r){var a,h,d,l,u,c=1e9,f=e,p=t;for(h=1;h<10;h++)d=.1*h,l=Math.pow(1-d,2)*e+2*d*(1-d)*r.x+Math.pow(d,2)*i,u=Math.pow(1-d,2)*t+2*d*(1-d)*r.y+Math.pow(d,2)*n,h>0&&(c=(a=this._getDistanceToLine(f,p,l,u,o,s))<c?a:c),f=l,p=u;return c}},{key:"_bezierCurve",value:function(e,t,i,n){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=n&&null!=n.x?e.bezierCurveTo(i.x,i.y,n.x,n.y,this.toPoint.x,this.toPoint.y):e.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):e.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(e,t),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),t}(),nd=function(e){function t(e,i,n){var o;return na(this,t),(o=ca(this,la(t).call(this,e,i,n))).via=o.via,o._boundFunction=function(){o.positionBezierNode()},o._body.emitter.on("_repositionBezierNodes",o._boundFunction),o}return da(t,id),sa(t,[{key:"setOptions",value:function(e){fa(la(t.prototype),"setOptions",this).call(this,e);var i=!1;this.options.physics!==e.physics&&(i=!0),this.options=e,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===i&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics?this.via.setOptions({physics:!1}):this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var e="edgeId:"+this.id,t=this._body.functions.createNode({id:e,shape:"circle",physics:!0,hidden:!0});this._body.nodes[e]=t,this.via=t,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(e,t,i){this._bezierCurve(e,t,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=this._getCircleData(),n=va(i,3),o=n[0],s=n[1],r=n[2],a=2*Math.PI*(1-e);return{x:o+r*Math.sin(a),y:s+r-r*(1-Math.cos(a))}}return{x:Math.pow(1-e,2)*this.fromPoint.x+2*e*(1-e)*t.x+Math.pow(e,2)*this.toPoint.x,y:Math.pow(1-e,2)*this.fromPoint.y+2*e*(1-e)*t.y+Math.pow(e,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(e,t){return this._findBorderPositionBezier(e,t,this.via)}},{key:"_getDistanceToEdge",value:function(e,t,i,n,o,s){return this._getDistanceToBezierEdge(e,t,i,n,o,s,this.via)}}]),t}(),od=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,id),sa(t,[{key:"_line",value:function(e,t,i){this._bezierCurve(e,t,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var e,t,i=this.options.smooth.roundness,n=this.options.smooth.type,o=Math.abs(this.from.x-this.to.x),s=Math.abs(this.from.y-this.to.y);if("discrete"===n||"diagonalCross"===n){var r,a;r=a=o<=s?i*s:i*o,this.from.x>this.to.x&&(r=-r),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+r,d=this.from.y+a;return"discrete"===n&&(o<=s?h=o<i*s?this.from.x:h:d=s<i*o?this.from.y:d),{x:h,y:d}}if("straightCross"===n){var l=(1-i)*o,u=(1-i)*s;return o<=s?(l=0,this.from.y<this.to.y&&(u=-u)):(this.from.x<this.to.x&&(l=-l),u=0),{x:this.to.x+l,y:this.to.y+u}}if("horizontal"===n){var c=(1-i)*o;return this.from.x<this.to.x&&(c=-c),{x:this.to.x+c,y:this.from.y}}if("vertical"===n){var f=(1-i)*s;return this.from.y<this.to.y&&(f=-f),{x:this.from.x,y:this.to.y+f}}if("curvedCW"===n){o=this.to.x-this.from.x,s=this.from.y-this.to.y;var p=Math.sqrt(o*o+s*s),v=Math.PI,m=(Math.atan2(s,o)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*p*Math.sin(m),y:this.from.y+(.5*i+.5)*p*Math.cos(m)}}if("curvedCCW"===n){o=this.to.x-this.from.x,s=this.from.y-this.to.y;var g=Math.sqrt(o*o+s*s),y=Math.PI,b=(Math.atan2(s,o)+(.5*-i+.5)*y)%(2*y);return{x:this.from.x+(.5*i+.5)*g*Math.sin(b),y:this.from.y+(.5*i+.5)*g*Math.cos(b)}}e=t=o<=s?i*s:i*o,this.from.x>this.to.x&&(e=-e),this.from.y>=this.to.y&&(t=-t);var _=this.from.x+e,w=this.from.y+t;return o<=s?_=this.from.x<=this.to.x?this.to.x<_?this.to.x:_:this.to.x>_?this.to.x:_:w=this.from.y>=this.to.y?this.to.y>w?this.to.y:w:this.to.y<w?this.to.y:w,{x:_,y:w}}},{key:"_findBorderPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(e,t,i.via)}},{key:"_getDistanceToEdge",value:function(e,t,i,n,o,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(e,t,i,n,o,s,r)}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=e,n=Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*t.x+Math.pow(i,2)*this.toPoint.x,o=Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*t.y+Math.pow(i,2)*this.toPoint.y;return{x:n,y:o}}}]),t}(),sd=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,id),sa(t,[{key:"_getDistanceToBezierEdge2",value:function(e,t,i,n,o,s,r,a){for(var h=1e9,d=e,l=t,u=[0,0,0,0],c=1;c<10;c++){var f=.1*c;u[0]=Math.pow(1-f,3),u[1]=3*f*Math.pow(1-f,2),u[2]=3*Math.pow(f,2)*(1-f),u[3]=Math.pow(f,3);var p=u[0]*e+u[1]*r.x+u[2]*a.x+u[3]*i,v=u[0]*t+u[1]*r.y+u[2]*a.y+u[3]*n;if(c>0){var m=this._getDistanceToLine(d,l,p,v,o,s);h=m<h?m:h}d=p,l=v}return h}}]),t}(),rd=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,sd),sa(t,[{key:"_line",value:function(e,t,i){var n=i[0],o=i[1];this._bezierCurve(e,t,n,o)}},{key:"_getViaCoordinates",value:function(){var e,t,i,n,o=this.from.x-this.to.x,s=this.from.y-this.to.y,r=this.options.smooth.roundness;return(Math.abs(o)>Math.abs(s)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(t=this.from.y,n=this.to.y,e=this.from.x-r*o,i=this.to.x+r*o):(t=this.from.y-r*s,n=this.to.y+r*s,e=this.from.x,i=this.to.x),[{x:e,y:t},{x:i,y:n}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(e,t){return this._findBorderPositionBezier(e,t)}},{key:"_getDistanceToEdge",value:function(e,t,i,n,o,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),a=va(r,2),h=a[0],d=a[1];return this._getDistanceToBezierEdge2(e,t,i,n,o,s,h,d)}},{key:"getPoint",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=va(t,2),n=i[0],o=i[1],s=e,r=[Math.pow(1-s,3),3*s*Math.pow(1-s,2),3*Math.pow(s,2)*(1-s),Math.pow(s,3)],a=r[0]*this.fromPoint.x+r[1]*n.x+r[2]*o.x+r[3]*this.toPoint.x,h=r[0]*this.fromPoint.y+r[1]*n.y+r[2]*o.y+r[3]*this.toPoint.y;return{x:a,y:h}}}]),t}(),ad=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,td),sa(t,[{key:"_line",value:function(e,t){e.beginPath(),e.moveTo(this.fromPoint.x,this.fromPoint.y),e.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(e){return{x:(1-e)*this.fromPoint.x+e*this.toPoint.x,y:(1-e)*this.fromPoint.y+e*this.toPoint.y}}},{key:"_findBorderPosition",value:function(e,t){var i=this.to,n=this.from;e.id===this.from.id&&(i=this.from,n=this.to);var o=Math.atan2(i.y-n.y,i.x-n.x),s=i.x-n.x,r=i.y-n.y,a=Math.sqrt(s*s+r*r),h=(a-e.distanceToBorder(t,o))/a;return{x:(1-h)*n.x+h*i.x,y:(1-h)*n.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(e,t,i,n,o,s){return this._getDistanceToLine(e,t,i,n,o,s)}}]),t}(),hd=function(){function e(t,i,n,o,s){if(na(this,e),void 0===i)throw new Error("No body provided");this.options=$n(o),this.globalOptions=o,this.defaultOptions=s,this.body=i,this.imagelist=n,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new gh(this.body,this.options,!0),this.setOptions(t)}return sa(e,[{key:"setOptions",value:function(t){if(t){var i=void 0!==t.physics&&this.options.physics!==t.physics||void 0!==t.hidden&&(this.options.hidden||!1)!==(t.hidden||!1)||void 0!==t.from&&this.options.from!==t.from||void 0!==t.to&&this.options.to!==t.to;e.parseOptions(this.options,t,!0,this.globalOptions),void 0!==t.id&&(this.id=t.id),void 0!==t.from&&(this.fromId=t.from),void 0!==t.to&&(this.toId=t.to),void 0!==t.title&&(this.title=t.title),void 0!==t.value&&(t.value=parseFloat(t.value));var n=[t,this.options,this.defaultOptions];return this.chooser=uh.choosify("edge",n),this.updateLabelModule(t),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var e=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,t=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,n=this.options.color.inherit,o={toArrow:e,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:t,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:n?void 0:this.options.color.color,inheritsColor:n,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var s=this.options.selectionWidth;"function"==typeof s?o.width=s(o.width):"number"==typeof s&&(o.width+=s),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.highlight,o.shadow=this.options.shadow.enabled}else if(this.hover){var r=this.options.hoverWidth;"function"==typeof r?o.width=r(o.width):"number"==typeof r&&(o.width+=r),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.hover,o.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(o,this.options.id,this.selected,this.hover),void 0!==o.color&&(o.inheritsColor=!1),!1===o.shadow&&(o.shadowColor===this.options.shadow.color&&o.shadowSize===this.options.shadow.size&&o.shadowX===this.options.shadow.x&&o.shadowY===this.options.shadow.y||(o.shadow=!0)));else o.shadow=this.options.shadow.enabled,o.width=Math.max(o.width,.3/this.body.view.scale);return o}},{key:"updateLabelModule",value:function(e){var t=[e,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,t),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var e=this.options.smooth,t=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof nd&&!0===e.enabled&&"dynamic"===e.type||this.edgeType instanceof rd&&!0===e.enabled&&"cubicBezier"===e.type||this.edgeType instanceof od&&!0===e.enabled&&"dynamic"!==e.type&&"cubicBezier"!==e.type||this.edgeType instanceof ad&&!1===e.type.enabled)&&(i=!1),!0===i&&(t=this.cleanup())),!0===i?!0===e.enabled?"dynamic"===e.type?(t=!0,this.edgeType=new nd(this.options,this.body,this.labelModule)):"cubicBezier"===e.type?this.edgeType=new rd(this.options,this.body,this.labelModule):this.edgeType=new od(this.options,this.body,this.labelModule):this.edgeType=new ad(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),t}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(e,t,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(e,t,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*s}this.options.width=this.options.scaling.min+n*o}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(e){var t=this.getFormattingValues();if(!t.hidden){var i=this.edgeType.getViaNode(),n={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,t.fromArrow&&(n.from=this.edgeType.getArrowData(e,"from",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.fromPoint=n.from.core),t.fromArrowSrc&&(n.from.image=this.imagelist.load(t.fromArrowSrc)),t.fromArrowImageWidth&&(n.from.imageWidth=t.fromArrowImageWidth),t.fromArrowImageHeight&&(n.from.imageHeight=t.fromArrowImageHeight)),t.toArrow&&(n.to=this.edgeType.getArrowData(e,"to",i,this.selected,this.hover,t),!1===t.arrowStrikethrough&&(this.edgeType.toPoint=n.to.core),t.toArrowSrc&&(n.to.image=this.imagelist.load(t.toArrowSrc)),t.toArrowImageWidth&&(n.to.imageWidth=t.toArrowImageWidth),t.toArrowImageHeight&&(n.to.imageHeight=t.toArrowImageHeight)),t.middleArrow&&(n.middle=this.edgeType.getArrowData(e,"middle",i,this.selected,this.hover,t),t.middleArrowSrc&&(n.middle.image=this.imagelist.load(t.middleArrowSrc)),t.middleArrowImageWidth&&(n.middle.imageWidth=t.middleArrowImageWidth),t.middleArrowImageHeight&&(n.middle.imageHeight=t.middleArrowImageHeight)),this.edgeType.drawLine(e,t,this.selected,this.hover,i),this.drawArrows(e,n,t),this.drawLabel(e,i)}}},{key:"drawArrows",value:function(e,t,i){i.fromArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.from),i.middleArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.middle),i.toArrow&&this.edgeType.drawArrowHead(e,i,this.selected,this.hover,t.to)}},{key:"drawLabel",value:function(e,t){if(void 0!==this.options.label){var i=this.from,n=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(e,this.selected,this.hover),i.id!=n.id){this.labelModule.pointToSelf=!1;var o=this.edgeType.getPoint(.5,t);e.save();var s=this._getRotation(e);0!=s.angle&&(e.translate(s.x,s.y),e.rotate(s.angle)),this.labelModule.draw(e,o.x,o.y,this.selected,this.hover),e.restore()}else{var r,a;this.labelModule.pointToSelf=!0;var h=this.options.selfReferenceSize;i.shape.width>i.shape.height?(r=i.x+.5*i.shape.width,a=i.y-h):(r=i.x+h,a=i.y-.5*i.shape.height),o=this._pointOnCircle(r,a,h,.125),this.labelModule.draw(e,o.x,o.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(e){var t=[];if(this.labelModule.visible()){var i=this._getRotation();uh.pointInRect(this.labelModule.getSize(),e,i)&&t.push({edgeId:this.id,labelId:0})}var n={left:e.x,top:e.y};return this.isOverlappingWith(n)&&t.push({edgeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){if(this.connected){var t=this.from.x,i=this.from.y,n=this.to.x,o=this.to.y,s=e.left,r=e.top;return this.edgeType.getDistanceToEdge(t,i,n,o,s,r)<10}return!1}},{key:"_getRotation",value:function(e){var t=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,t);void 0!==e&&this.labelModule.calculateLabelSize(e,this.selected,this.hover,i.x,i.y);var n={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return n;if("horizontal"===this.options.font.align)return n;var o=this.from.y-this.to.y,s=this.from.x-this.to.x,r=Math.atan2(o,s);return(r<-1&&s<0||r>0&&s<0)&&(r+=Math.PI),n.angle=r,n}},{key:"_pointOnCircle",value:function(e,t,i,n){var o=2*n*Math.PI;return{x:e+i*Math.cos(o),y:t-i*Math.sin(o)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],s=["arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","to","title","value","width","font","chosen","widthConstraint"];if(cn(s,e,t,i),uh.isValidLabel(t.label)?e.label=t.label:uh.isValidLabel(e.label)||(e.label=void 0),Jn(e,t,"smooth",n),Jn(e,t,"shadow",n),Jn(e,t,"background",n),void 0!==t.dashes&&null!==t.dashes?e.dashes=t.dashes:!0===i&&null===t.dashes&&(e.dashes=Object.create(n.dashes)),void 0!==t.scaling&&null!==t.scaling?(void 0!==t.scaling.min&&(e.scaling.min=t.scaling.min),void 0!==t.scaling.max&&(e.scaling.max=t.scaling.max),Jn(e.scaling,t.scaling,"label",n.scaling)):!0===i&&null===t.scaling&&(e.scaling=Object.create(n.scaling)),void 0!==t.arrows&&null!==t.arrows)if("string"==typeof t.arrows){var r=t.arrows.toLowerCase();e.arrows.to.enabled=-1!=r.indexOf("to"),e.arrows.middle.enabled=-1!=r.indexOf("middle"),e.arrows.from.enabled=-1!=r.indexOf("from")}else{if("object"!==ia(t.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+JSON.stringify(t.arrows));Jn(e.arrows,t.arrows,"to",n.arrows),Jn(e.arrows,t.arrows,"middle",n.arrows),Jn(e.arrows,t.arrows,"from",n.arrows)}else!0===i&&null===t.arrows&&(e.arrows=Object.create(n.arrows));if(void 0!==t.color&&null!==t.color){var a=on(t.color)?{color:t.color,highlight:t.color,hover:t.color,inherit:!1,opacity:1}:t.color,h=e.color;if(o)pn(h,n.color,!1,i);else for(var d in h)h.hasOwnProperty(d)&&delete h[d];if(on(h))h.color=h,h.highlight=h,h.hover=h,h.inherit=!1,void 0===a.opacity&&(h.opacity=1);else{var l=!1;void 0!==a.color&&(h.color=a.color,l=!0),void 0!==a.highlight&&(h.highlight=a.highlight,l=!0),void 0!==a.hover&&(h.hover=a.hover,l=!0),void 0!==a.inherit&&(h.inherit=a.inherit),void 0!==a.opacity&&(h.opacity=Math.min(1,Math.max(0,a.opacity))),!0===l?h.inherit=!1:void 0===h.inherit&&(h.inherit="from")}}else!0===i&&null===t.color&&(e.color=$n(n.color));!0===i&&null===t.font&&(e.font=$n(n.font))}}]),e}(),dd=function(){function e(t,i,n){var o=this;na(this,e),this.body=t,this.images=i,this.groups=n,this.body.functions.createEdge=this.create.bind(this),this.edgesListeners={add:function(e,t){o.add(t.items)},update:function(e,t){o.update(t.items)},remove:function(e,t){o.remove(t.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(e,t,i,n){if(t===e)return.5;var o=1/(t-e);return Math.max(0,(n-e)*o)}},selectionWidth:1.5,selfReferenceSize:20,shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},pn(this.options,this.defaultOptions),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(t){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===t&&(t="continuous");var n=!1;for(var o in e.body.edges)if(e.body.edges.hasOwnProperty(o)){var s=e.body.edges[o],r=e.body.data.edges._data[o];if(void 0!==r){var a=r.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===t?s.setOptions({smooth:!1}):s.setOptions({smooth:{type:t}}),n=!0)}}!0===i&&!0===n&&e.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){e.reconnectEdges()})),this.body.emitter.on("refreshEdges",this.refresh.bind(this)),this.body.emitter.on("refresh",this.refresh.bind(this)),this.body.emitter.on("destroy",(function(){On(e.edgesListeners,(function(t,i){e.body.data.edges&&e.body.data.edges.off(i,t)})),delete e.body.functions.createEdge,delete e.edgesListeners.add,delete e.edgesListeners.update,delete e.edgesListeners.remove,delete e.edgesListeners}))}},{key:"setOptions",value:function(e){if(void 0!==e){hd.parseOptions(this.options,e,!0,this.defaultOptions,!0);var t=!1;if(void 0!==e.smooth)for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&(t=this.body.edges[i].updateEdgeType()||t);if(void 0!==e.font)for(var n in this.body.edges)this.body.edges.hasOwnProperty(n)&&this.body.edges[n].updateLabelModule();void 0===e.hidden&&void 0===e.physics&&!0!==t||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var t=this,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.data.edges;if(e instanceof ah||e instanceof hh)this.body.data.edges=e;else if(Array.isArray(e))this.body.data.edges=new ah,this.body.data.edges.add(e);else{if(e)throw new TypeError("Array or DataSet expected");this.body.data.edges=new ah}if(n&&On(this.edgesListeners,(function(e,t){n.off(t,e)})),this.body.edges={},this.body.data.edges){On(this.edgesListeners,(function(e,i){t.body.data.edges.on(i,e)}));var o=this.body.data.edges.getIds();this.add(o,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,n=this.body.data.edges,o=0;o<e.length;o++){var s=e[o],r=i[s];r&&r.disconnect();var a=n.get(s,{showInternalIds:!0});i[s]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===t&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e){for(var t=this.body.edges,i=this.body.data.edges,n=!1,o=0;o<e.length;o++){var s=e[o],r=i.get(s),a=t[s];void 0!==a?(a.disconnect(),n=a.setOptions(r)||n,a.connect()):(this.body.edges[s]=this.create(r),n=!0)}!0===n?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==e.length){var i=this.body.edges;On(e,(function(e){var t=i[e];void 0!==t&&t.remove()})),t&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var e=this;On(this.body.edges,(function(t,i){var n=e.body.data.edges._data[i];void 0!==n&&t.setOptions(n)}))}},{key:"create",value:function(e){return new hd(e,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var e,t=this.body.nodes,i=this.body.edges;for(e in t)t.hasOwnProperty(e)&&(t[e].edges=[]);for(e in i)if(i.hasOwnProperty(e)){var n=i[e];n.from=null,n.to=null,n.connect()}}},{key:"getConnectedNodes",value:function(e){var t=[];if(void 0!==this.body.edges[e]){var i=this.body.edges[e];void 0!==i.fromId&&t.push(i.fromId),void 0!==i.toId&&t.push(i.toId)}return t}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var e=this,t=[];On(this.body.edges,(function(i,n){var o=e.body.nodes[i.toId],s=e.body.nodes[i.fromId];void 0!==o&&!0===o.isCluster||void 0!==s&&!0===s.isCluster||void 0!==o&&void 0!==s||t.push(n)})),this.remove(t,!1)}},{key:"_addMissingEdges",value:function(){var e=this.body.data.edges;if(null!=e){var t=this.body.edges,i=[];e.forEach((function(e,n){void 0===t[n]&&i.push(n)})),this.add(i,!0)}}}]),e}(),ld=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.barnesHutTree,this.setOptions(n),this.randomSeed=5}return sa(e,[{key:"setOptions",value:function(e){this.options=e,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"seededRandom",value:function(){var e=1e4*Math.sin(this.randomSeed++);return e-Math.floor(e)}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var e,t=this.body.nodes,i=this.physicsBody.physicsNodeIndices,n=i.length,o=this._formBarnesHutTree(t,i);this.barnesHutTree=o;for(var s=0;s<n;s++)(e=t[i[s]]).options.mass>0&&this._getForceContributions(o.root,e)}}},{key:"_getForceContributions",value:function(e,t){this._getForceContribution(e.children.NW,t),this._getForceContribution(e.children.NE,t),this._getForceContribution(e.children.SW,t),this._getForceContribution(e.children.SE,t)}},{key:"_getForceContribution",value:function(e,t){var i,n,o;e.childrenCount>0&&(i=e.centerOfMass.x-t.x,n=e.centerOfMass.y-t.y,(o=Math.sqrt(i*i+n*n))*e.calcSize>this.thetaInversed?this._calculateForces(o,i,n,t,e):4===e.childrenCount?this._getForceContributions(e,t):e.children.data.id!=t.id&&this._calculateForces(o,i,n,t,e))}},{key:"_calculateForces",value:function(e,t,i,n,o){0===e&&(t=e=.1),this.overlapAvoidanceFactor<1&&n.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,e-n.shape.radius));var s=this.options.gravitationalConstant*o.mass*n.options.mass/Math.pow(e,3),r=t*s,a=i*s;this.physicsBody.forces[n.id].x+=r,this.physicsBody.forces[n.id].y+=a}},{key:"_formBarnesHutTree",value:function(e,t){for(var i,n=t.length,o=e[t[0]].x,s=e[t[0]].y,r=e[t[0]].x,a=e[t[0]].y,h=1;h<n;h++){var d=e[t[h]],l=d.x,u=d.y;d.options.mass>0&&(l<o&&(o=l),l>r&&(r=l),u<s&&(s=u),u>a&&(a=u))}var c=Math.abs(r-o)-Math.abs(a-s);c>0?(s-=.5*c,a+=.5*c):(o+=.5*c,r-=.5*c);var f=Math.max(1e-5,Math.abs(r-o)),p=.5*f,v=.5*(o+r),m=.5*(s+a),g={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-p,maxX:v+p,minY:m-p,maxY:m+p},size:f,calcSize:1/f,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(g.root);for(var y=0;y<n;y++)(i=e[t[y]]).options.mass>0&&this._placeInTree(g.root,i);return g}},{key:"_updateBranchMass",value:function(e,t){var i=e.centerOfMass,n=e.mass+t.options.mass,o=1/n;i.x=i.x*e.mass+t.x*t.options.mass,i.x*=o,i.y=i.y*e.mass+t.y*t.options.mass,i.y*=o,e.mass=n;var s=Math.max(Math.max(t.height,t.radius),t.width);e.maxWidth=e.maxWidth<s?s:e.maxWidth}},{key:"_placeInTree",value:function(e,t,i){1==i&&void 0!==i||this._updateBranchMass(e,t);var n,o=e.children.NW.range;n=o.maxX>t.x?o.maxY>t.y?"NW":"SW":o.maxY>t.y?"NE":"SE",this._placeInRegion(e,t,n)}},{key:"_placeInRegion",value:function(e,t,i){var n=e.children[i];switch(n.childrenCount){case 0:n.children.data=t,n.childrenCount=1,this._updateBranchMass(n,t);break;case 1:n.children.data.x===t.x&&n.children.data.y===t.y?(t.x+=this.seededRandom(),t.y+=this.seededRandom()):(this._splitBranch(n),this._placeInTree(n,t));break;case 4:this._placeInTree(n,t)}}},{key:"_splitBranch",value:function(e){var t=null;1===e.childrenCount&&(t=e.children.data,e.mass=0,e.centerOfMass.x=0,e.centerOfMass.y=0),e.childrenCount=4,e.children.data=null,this._insertRegion(e,"NW"),this._insertRegion(e,"NE"),this._insertRegion(e,"SW"),this._insertRegion(e,"SE"),null!=t&&this._placeInTree(e,t)}},{key:"_insertRegion",value:function(e,t){var i,n,o,s,r=.5*e.size;switch(t){case"NW":i=e.range.minX,n=e.range.minX+r,o=e.range.minY,s=e.range.minY+r;break;case"NE":i=e.range.minX+r,n=e.range.maxX,o=e.range.minY,s=e.range.minY+r;break;case"SW":i=e.range.minX,n=e.range.minX+r,o=e.range.minY+r,s=e.range.maxY;break;case"SE":i=e.range.minX+r,n=e.range.maxX,o=e.range.minY+r,s=e.range.maxY}e.children[t]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:n,minY:o,maxY:s},size:.5*e.size,calcSize:2*e.calcSize,children:{data:null},maxWidth:0,level:e.level+1,childrenCount:0}}},{key:"_debug",value:function(e,t){void 0!==this.barnesHutTree&&(e.lineWidth=1,this._drawBranch(this.barnesHutTree.root,e,t))}},{key:"_drawBranch",value:function(e,t,i){void 0===i&&(i="#FF0000"),4===e.childrenCount&&(this._drawBranch(e.children.NW,t),this._drawBranch(e.children.NE,t),this._drawBranch(e.children.SE,t),this._drawBranch(e.children.SW,t)),t.strokeStyle=i,t.beginPath(),t.moveTo(e.range.minX,e.range.minY),t.lineTo(e.range.maxX,e.range.minY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.minY),t.lineTo(e.range.maxX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.maxY),t.lineTo(e.range.minX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.minX,e.range.maxY),t.lineTo(e.range.minX,e.range.minY),t.stroke()}}]),e}(),ud=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.setOptions(n)}return sa(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,n,o,s,r,a,h=this.body.nodes,d=this.physicsBody.physicsNodeIndices,l=this.physicsBody.forces,u=this.options.nodeDistance,c=-2/3/u,f=0;f<d.length-1;f++){r=h[d[f]];for(var p=f+1;p<d.length;p++)e=(a=h[d[p]]).x-r.x,t=a.y-r.y,0===(i=Math.sqrt(e*e+t*t))&&(e=i=.1*Math.random()),i<2*u&&(s=i<.5*u?1:c*i+4/3,n=e*(s/=i),o=t*s,l[r.id].x-=n,l[r.id].y-=o,l[a.id].x+=n,l[a.id].y+=o)}}}]),e}(),cd=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.setOptions(n)}return sa(e,[{key:"setOptions",value:function(e){this.options=e,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var e=this.body.nodes,t=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,n=this.options.nodeDistance,o=0;o<t.length-1;o++)for(var s=e[t[o]],r=o+1;r<t.length;r++){var a=e[t[r]];if(s.level===a.level){var h=n+this.overlapAvoidanceFactor*((s.shape.radius||0)/2+(a.shape.radius||0)/2),d=a.x-s.x,l=a.y-s.y,u=Math.sqrt(d*d+l*l),c=void 0;c=u<h?-Math.pow(.05*u,2)+Math.pow(.05*h,2):0,0===u?(pa("distance"),u=.01):c/=u;var f=d*c,p=l*c;i[s.id].x-=f,i[s.id].y-=p,i[a.id].x+=f,i[a.id].y+=p}}}}]),e}(),fd=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.setOptions(n)}return sa(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,n,o,s=this.physicsBody.physicsEdgeIndices,r=this.body.edges,a=0;a<s.length;a++)!0===(t=r[s[a]]).connected&&t.toId!==t.fromId&&void 0!==this.body.nodes[t.toId]&&void 0!==this.body.nodes[t.fromId]&&(void 0!==t.edgeType.via?(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.to,n=t.edgeType.via,o=t.from,this._calculateSpringForce(i,n,.5*e),this._calculateSpringForce(n,o,.5*e)):(e=void 0===t.options.length?1.5*this.options.springLength:t.options.length,this._calculateSpringForce(t.from,t.to,e)))}},{key:"_calculateSpringForce",value:function(e,t,i){var n=e.x-t.x,o=e.y-t.y,s=Math.max(Math.sqrt(n*n+o*o),.01),r=this.options.springConstant*(i-s)/s,a=n*r,h=o*r;void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x+=a,this.physicsBody.forces[e.id].y+=h),void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x-=a,this.physicsBody.forces[t.id].y-=h)}}]),e}(),pd=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.setOptions(n)}return sa(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,n,o,s,r,a,h,d,l=this.body.edges,u=this.physicsBody.physicsEdgeIndices,c=this.physicsBody.physicsNodeIndices,f=this.physicsBody.forces,p=0;p<c.length;p++){var v=c[p];f[v].springFx=0,f[v].springFy=0}for(var m=0;m<u.length;m++)!0===(t=l[u[m]]).connected&&(e=void 0===t.options.length?this.options.springLength:t.options.length,i=t.from.x-t.to.x,n=t.from.y-t.to.y,a=0===(a=Math.sqrt(i*i+n*n))?.01:a,o=i*(r=this.options.springConstant*(e-a)/a),s=n*r,t.to.level!=t.from.level?(void 0!==f[t.toId]&&(f[t.toId].springFx-=o,f[t.toId].springFy-=s),void 0!==f[t.fromId]&&(f[t.fromId].springFx+=o,f[t.fromId].springFy+=s)):(void 0!==f[t.toId]&&(f[t.toId].x-=.5*o,f[t.toId].y-=.5*s),void 0!==f[t.fromId]&&(f[t.fromId].x+=.5*o,f[t.fromId].y+=.5*s)));r=1;for(var g=0;g<c.length;g++){var y=c[g];h=Math.min(r,Math.max(-r,f[y].springFx)),d=Math.min(r,Math.max(-r,f[y].springFy)),f[y].x+=h,f[y].y+=d}for(var b=0,_=0,w=0;w<c.length;w++){var k=c[w];b+=f[k].x,_+=f[k].y}for(var x=b/c.length,S=_/c.length,O=0;O<c.length;O++){var D=c[O];f[D].x-=x,f[D].y-=S}}}]),e}(),vd=function(){function e(t,i,n){na(this,e),this.body=t,this.physicsBody=i,this.setOptions(n)}return sa(e,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,n,o=this.body.nodes,s=this.physicsBody.physicsNodeIndices,r=this.physicsBody.forces,a=0;a<s.length;a++){e=-(n=o[s[a]]).x,t=-n.y,i=Math.sqrt(e*e+t*t),this._calculateForces(i,e,t,r,n)}}},{key:"_calculateForces",value:function(e,t,i,n,o){var s=0===e?0:this.options.centralGravity/e;n[o.id].x=t*s,n[o.id].y=i*s}}]),e}(),md=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,ld),sa(t,[{key:"_calculateForces",value:function(e,t,i,n,o){0===e&&(t=e=.1*Math.random()),this.overlapAvoidanceFactor<1&&n.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,e-n.shape.radius));var s=n.edges.length+1,r=this.options.gravitationalConstant*o.mass*n.options.mass*s/Math.pow(e,2),a=t*r,h=i*r;this.physicsBody.forces[n.id].x+=a,this.physicsBody.forces[n.id].y+=h}}]),t}(),gd=function(e){function t(e,i,n){return na(this,t),ca(this,la(t).call(this,e,i,n))}return da(t,vd),sa(t,[{key:"_calculateForces",value:function(e,t,i,n,o){if(e>0){var s=o.edges.length+1,r=this.options.centralGravity*s*o.options.mass;n[o.id].x=t*r,n[o.id].y=i*r}}}]),t}(),yd=function(){function e(t){na(this,e),this.body=t,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0},ln(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("initPhysics",(function(){e.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){e.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){e.stopSimulation(),e.ready=!1})),this.body.emitter.on("disablePhysics",(function(){e.physicsEnabled=!1,e.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){e.setOptions(e.options),!0===e.ready&&e.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===e.ready&&e.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){e.stopSimulation()})),this.body.emitter.on("destroy",(function(){e.stopSimulation(!1),e.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){e.updatePhysicsData()}))}},{key:"setOptions",value:function(e){void 0!==e&&(!1===e?(this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation()):!0===e?(this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation()):(this.physicsEnabled=!0,fn(["stabilization"],this.options,e),Jn(this.options,e,"stabilization"),void 0===e.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation()),this.timestep=this.options.timestep)),this.init()}},{key:"init",value:function(){var e;"forceAtlas2Based"===this.options.solver?(e=this.options.forceAtlas2Based,this.nodesSolver=new md(this.body,this.physicsBody,e),this.edgesSolver=new fd(this.body,this.physicsBody,e),this.gravitySolver=new gd(this.body,this.physicsBody,e)):"repulsion"===this.options.solver?(e=this.options.repulsion,this.nodesSolver=new ud(this.body,this.physicsBody,e),this.edgesSolver=new fd(this.body,this.physicsBody,e),this.gravitySolver=new vd(this.body,this.physicsBody,e)):"hierarchicalRepulsion"===this.options.solver?(e=this.options.hierarchicalRepulsion,this.nodesSolver=new cd(this.body,this.physicsBody,e),this.edgesSolver=new pd(this.body,this.physicsBody,e),this.gravitySolver=new vd(this.body,this.physicsBody,e)):(e=this.options.barnesHut,this.nodesSolver=new ld(this.body,this.physicsBody,e),this.edgesSolver=new fd(this.body,this.physicsBody,e),this.gravitySolver=new vd(this.body,this.physicsBody,e)),this.modelOptions=e}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=this.simulationStep.bind(this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===e&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===e&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var e=Date.now();this.physicsTick(),(Date.now()-e<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&setTimeout((function(){e.body.emitter.emit("stabilized",{iterations:t}),e.startedStabilization=!1,e.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var e=this.body.nodes,t=this.body.edges;for(var i in e)e.hasOwnProperty(i)&&!0===e[i].options.physics&&this.physicsBody.physicsNodeIndices.push(e[i].id);for(var n in t)t.hasOwnProperty(n)&&!0===t[n].options.physics&&this.physicsBody.physicsEdgeIndices.push(t[n].id);for(var o=0;o<this.physicsBody.physicsNodeIndices.length;o++){var s=this.physicsBody.physicsNodeIndices[o];this.physicsBody.forces[s]={x:0,y:0},void 0===this.physicsBody.velocities[s]&&(this.physicsBody.velocities[s]={x:0,y:0})}for(var r in this.physicsBody.velocities)void 0===e[r]&&delete this.physicsBody.velocities[r]}},{key:"revert",value:function(){var e=Object.keys(this.previousStates),t=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var n=0;n<e.length;n++){var o=e[n];void 0!==t[o]?!0===t[o].options.physics&&(this.referenceState[o]={positions:{x:t[o].x,y:t[o].y}},i[o].x=this.previousStates[o].vx,i[o].y=this.previousStates[o].vy,t[o].x=this.previousStates[o].x,t[o].y=this.previousStates[o].y):delete this.previousStates[o]}}},{key:"_evaluateStepQuality",value:function(){var e,t,i=this.body.nodes,n=this.referenceState;for(var o in this.referenceState)if(this.referenceState.hasOwnProperty(o)&&void 0!==i[o]&&(e=i[o].x-n[o].positions.x,t=i[o].y-n[o].positions.y,Math.sqrt(Math.pow(e,2)+Math.pow(t,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var e=this.physicsBody.physicsNodeIndices,t=0,i=0,n=0;n<e.length;n++){var o=e[n],s=this._performStep(o);t=Math.max(t,s),i+=s}this.adaptiveTimestepEnabled=i/e.length<5,this.stabilized=t<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(e,t,i){e+=(t-this.modelOptions.damping*e)/i*this.timestep;var n=this.options.maxVelocity||1e9;return Math.abs(e)>n&&(e=e>0?n:-n),e}},{key:"_performStep",value:function(e){var t=this.body.nodes[e],i=this.physicsBody.forces[e],n=this.physicsBody.velocities[e];return this.previousStates[e]={x:t.x,y:t.y,vx:n.x,vy:n.y},!1===t.options.fixed.x?(n.x=this.calculateComponentVelocity(n.x,i.x,t.options.mass),t.x+=n.x*this.timestep):(i.x=0,n.x=0),!1===t.options.fixed.y?(n.y=this.calculateComponentVelocity(n.y,i.y,t.options.mass),t.y+=n.y*this.timestep):(i.y=0,n.y=0),Math.sqrt(Math.pow(n.x,2)+Math.pow(n.y,2))}},{key:"_freezeNodes",value:function(){var e=this.body.nodes;for(var t in e)if(e.hasOwnProperty(t)&&e[t].x&&e[t].y){var i=e[t].options.fixed;this.freezeCache[t]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var e=this.body.nodes;for(var t in e)e.hasOwnProperty(t)&&void 0!==this.freezeCache[t]&&(e[t].options.fixed.x=this.freezeCache[t].x,e[t].options.fixed.y=this.freezeCache[t].y);this.freezeCache={}}},{key:"stabilize",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof t&&(t=this.options.stabilization.iterations,console.log("The stabilize method needs a numeric amount of iterations. Switching to default: ",t)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=t,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,setTimeout((function(){return e._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var e=this,t=function(){return!1===e.stabilized&&e.stabilizationIterations<e.targetIterations},i=function(){e.body.emitter.emit("stabilizationProgress",{iterations:e.stabilizationIterations,total:e.targetIterations})};this._startStabilizing()&&i();for(var n=0;t()&&n<this.options.stabilization.updateInterval;)this.physicsTick(),n++;i(),t()?setTimeout(this._stabilizationBatch.bind(this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(e){for(var t=0;t<this.physicsBody.physicsNodeIndices.length;t++){var i=this.physicsBody.physicsNodeIndices[t],n=this.body.nodes[i],o=this.physicsBody.forces[i],s=Math.sqrt(Math.pow(o.x,2)+Math.pow(o.x,2)),r=Math.min(Math.max(5,s),15),a=3*r,h=Vn((180-180*Math.min(1,Math.max(0,.03*s)))/360,1,1),d={x:n.x+20*o.x,y:n.y+20*o.y};e.lineWidth=r,e.strokeStyle=h,e.beginPath(),e.moveTo(n.x,n.y),e.lineTo(d.x,d.y),e.stroke();var l=Math.atan2(o.y,o.x);e.fillStyle=h,ed.draw(e,{type:"arrow",point:d,angle:l,length:a}),e.fill()}}}]),e}(),bd=function(){function e(){na(this,e)}return sa(e,null,[{key:"getRange",value:function(e){var t,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(t=e[i[a]]).shape.boundingBox.left&&(s=t.shape.boundingBox.left),r<t.shape.boundingBox.right&&(r=t.shape.boundingBox.right),n>t.shape.boundingBox.top&&(n=t.shape.boundingBox.top),o<t.shape.boundingBox.bottom&&(o=t.shape.boundingBox.bottom);return 1e9===s&&-1e9===r&&1e9===n&&-1e9===o&&(n=0,o=0,s=0,r=0),{minX:s,maxX:r,minY:n,maxY:o}}},{key:"getRangeCore",value:function(e){var t,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(t=e[i[a]]).x&&(s=t.x),r<t.x&&(r=t.x),n>t.y&&(n=t.y),o<t.y&&(o=t.y);return 1e9===s&&-1e9===r&&1e9===n&&-1e9===o&&(n=0,o=0,s=0,r=0),{minX:s,maxX:r,minY:n,maxY:o}}},{key:"findCenter",value:function(e){return{x:.5*(e.maxX+e.minX),y:.5*(e.maxY+e.minY)}}},{key:"cloneOptions",value:function(e,t){var i={};return void 0===t||"node"===t?(pn(i,e.options,!0),i.x=e.x,i.y=e.y,i.amountOfConnections=e.edges.length):pn(i,e.options,!0),i}}]),e}(),_d=function(e){function t(e,i,n,o,s,r){var a;return na(this,t),(a=ca(this,la(t).call(this,e,i,n,o,s,r))).isCluster=!0,a.containedNodes={},a.containedEdges={},a}return da(t,zh),sa(t,[{key:"_openChildCluster",value:function(e){var t=this,i=this.body.nodes[e];if(void 0===this.containedNodes[e])throw new Error("node with id: "+e+" not in current cluster");if(!i.isCluster)throw new Error("node with id: "+e+" is not a cluster");delete this.containedNodes[e],On(i.edges,(function(e){delete t.containedEdges[e.id]})),On(i.containedNodes,(function(e,i){t.containedNodes[i]=e})),i.containedNodes={},On(i.containedEdges,(function(e,i){t.containedEdges[i]=e})),i.containedEdges={},On(i.edges,(function(e){On(t.edges,(function(i){var n=i.clusteringEdgeReplacingIds.indexOf(e.id);-1!==n&&(On(e.clusteringEdgeReplacingIds,(function(e){i.clusteringEdgeReplacingIds.push(e),t.body.edges[e].edgeReplacedById=i.id})),i.clusteringEdgeReplacingIds.splice(n,1))}))})),i.edges=[]}}]),t}(),wd=function(){function e(t){var i=this;na(this,e),this.body=t,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},ln(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){i.clusteredNodes={},i.clusteredEdges={}}))}return sa(e,[{key:"clusterByHubsize",value:function(e,t){void 0===e?e=this._getHubSize():"object"===ia(e)&&(t=this._checkOptions(e),e=this._getHubSize());for(var i=[],n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodes[this.body.nodeIndices[n]];o.edges.length>=e&&i.push(o.id)}for(var s=0;s<i.length;s++)this.clusterByConnection(i[s],t,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===t.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");t=this._checkOptions(t);var n={},o={};On(this.body.nodes,(function(i,s){i.options&&!0===t.joinCondition(i.options)&&(n[s]=i,On(i.edges,(function(t){void 0===e.clusteredEdges[t.id]&&(o[t.id]=t)})))})),this._cluster(n,o,t,i)}},{key:"clusterByEdgeCount",value:function(e,t){var i=this,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];t=this._checkOptions(t);for(var o,s,r,a=[],h={},d=function(n){var d={},l={},f=i.body.nodeIndices[n],p=i.body.nodes[f];if(void 0===h[f]){r=0,s=[];for(var v=0;v<p.edges.length;v++)o=p.edges[v],void 0===i.clusteredEdges[o.id]&&(o.toId!==o.fromId&&r++,s.push(o));if(r===e){u=function(e){if(void 0===t.joinCondition||null===t.joinCondition)return!0;var i=bd.cloneOptions(e);return t.joinCondition(i)};for(var m=!0,g=0;g<s.length;g++){o=s[g];var y=i._getConnectedId(o,f);if(!u(p)){m=!1;break}l[o.id]=o,d[f]=p,d[y]=i.body.nodes[y],h[f]=!0}if(Object.keys(d).length>0&&Object.keys(l).length>0&&!0===m)if(void 0!==(c=function(){for(var e=0;e<a.length;++e)for(var t in d)if(void 0!==a[e].nodes[t])return a[e]}())){for(var b in d)void 0===c.nodes[b]&&(c.nodes[b]=d[b]);for(var _ in l)void 0===c.edges[_]&&(c.edges[_]=l[_])}else a.push({nodes:d,edges:l})}}},l=0;l<this.body.nodeIndices.length;l++){var u,c;d(l)}for(var f=0;f<a.length;f++)this._cluster(a[f].nodes,a[f].edges,t,!1);!0===n&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,e,t)}},{key:"clusterBridges",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,e,t)}},{key:"clusterByConnection",value:function(e,t){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===e)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[e])throw new Error("The nodeId given to clusterByConnection does not exist!");var n=this.body.nodes[e];void 0===(t=this._checkOptions(t,n)).clusterNodeProperties.x&&(t.clusterNodeProperties.x=n.x),void 0===t.clusterNodeProperties.y&&(t.clusterNodeProperties.y=n.y),void 0===t.clusterNodeProperties.fixed&&(t.clusterNodeProperties.fixed={},t.clusterNodeProperties.fixed.x=n.options.fixed.x,t.clusterNodeProperties.fixed.y=n.options.fixed.y);var o={},s={},r=n.id,a=bd.cloneOptions(n);o[r]=n;for(var h=0;h<n.edges.length;h++){var d=n.edges[h];if(void 0===this.clusteredEdges[d.id]){var l=this._getConnectedId(d,r);if(void 0===this.clusteredNodes[l])if(l!==r)if(void 0===t.joinCondition)s[d.id]=d,o[l]=this.body.nodes[l];else{var u=bd.cloneOptions(this.body.nodes[l]);!0===t.joinCondition(a,u)&&(s[d.id]=d,o[l]=this.body.nodes[l])}else s[d.id]=d}}var c=Object.keys(o).map((function(e){return o[e].id}));for(f in o)if(o.hasOwnProperty(f))for(var f=o[f],p=0;p<f.edges.length;p++){var v=f.edges[p];c.indexOf(this._getConnectedId(v,f.id))>-1&&(s[v.id]=v)}this._cluster(o,s,t,i)}},{key:"_createClusterEdges",value:function(e,t,i,n){for(var o,s,r,a,h,d,l=Object.keys(e),u=[],c=0;c<l.length;c++){r=e[s=l[c]];for(var f=0;f<r.edges.length;f++)o=r.edges[f],void 0===this.clusteredEdges[o.id]&&(o.toId==o.fromId?t[o.id]=o:o.toId==s?(a=i.id,d=h=o.fromId):(a=o.toId,h=i.id,d=a),void 0===e[d]&&u.push({edge:o,fromId:h,toId:a}))}for(var p=[],v=function(e){for(var t=0;t<p.length;t++){var i=p[t],n=e.fromId===i.fromId&&e.toId===i.toId,o=e.fromId===i.toId&&e.toId===i.fromId;if(n||o)return i}return null},m=0;m<u.length;m++){var g=u[m],y=g.edge,b=v(g);null===b?(b=this._createClusteredEdge(g.fromId,g.toId,y,n),p.push(b)):b.clusteringEdgeReplacingIds.push(y.id),this.body.edges[y.id].edgeReplacedById=b.id,this._backupEdgeOptions(y),y.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===e.clusterEdgeProperties&&(e.clusterEdgeProperties={}),void 0===e.clusterNodeProperties&&(e.clusterNodeProperties={}),e}},{key:"_cluster",value:function(e,t,i){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],o=[];for(var s in e)e.hasOwnProperty(s)&&void 0!==this.clusteredNodes[s]&&o.push(s);for(var r=0;r<o.length;++r)delete e[o[r]];if(0!=Object.keys(e).length&&(1!=Object.keys(e).length||1==i.clusterNodeProperties.allowSingleNodeCluster)){var a=pn({},i.clusterNodeProperties);if(void 0!==i.processProperties){var h=[];for(var d in e)if(e.hasOwnProperty(d)){var l=bd.cloneOptions(e[d]);h.push(l)}var u=[];for(var c in t)if(t.hasOwnProperty(c)&&"clusterEdge:"!==c.substr(0,12)){var f=bd.cloneOptions(t[c],"edge");u.push(f)}if(!(a=i.processProperties(a,h,u)))throw new Error("The processProperties function does not return properties!")}void 0===a.id&&(a.id="cluster:"+Xi());var p=a.id;void 0===a.label&&(a.label="cluster");var v=void 0;void 0===a.x&&(v=this._getClusterPosition(e),a.x=v.x),void 0===a.y&&(void 0===v&&(v=this._getClusterPosition(e)),a.y=v.y),a.id=p;var m=this.body.functions.createNode(a,_d);m.containedNodes=e,m.containedEdges=t,m.clusterEdgeProperties=i.clusterEdgeProperties,this.body.nodes[a.id]=m,this._clusterEdges(e,t,a,i.clusterEdgeProperties),a.id=void 0,!0===n&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(e){void 0===this.clusteredEdges[e.id]&&(this.clusteredEdges[e.id]={physics:e.options.physics})}},{key:"_restoreEdge",value:function(e){var t=this.clusteredEdges[e.id];void 0!==t&&(e.setOptions({physics:t.physics}),delete this.clusteredEdges[e.id])}},{key:"isCluster",value:function(e){return void 0!==this.body.nodes[e]?!0===this.body.nodes[e].isCluster:(console.log("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(e){for(var t,i=Object.keys(e),n=e[i[0]].x,o=e[i[0]].x,s=e[i[0]].y,r=e[i[0]].y,a=1;a<i.length;a++)n=(t=e[i[a]]).x<n?t.x:n,o=t.x>o?t.x:o,s=t.y<s?t.y:s,r=t.y>r?t.y:r;return{x:.5*(n+o),y:.5*(s+r)}}},{key:"openCluster",value:function(e,t){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===e)throw new Error("No clusterNodeId supplied to openCluster.");var n=this.body.nodes[e];if(void 0===n)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==n.isCluster||void 0===n.containedNodes||void 0===n.containedEdges)throw new Error("The node:"+e+" is not a valid cluster.");var o=this.findNode(e),s=o.indexOf(e)-1;if(s>=0){var r=o[s],a=this.body.nodes[r];return a._openChildCluster(e),delete this.body.nodes[e],void(!0===i&&this.body.emitter.emit("_dataChanged"))}var h=n.containedNodes,d=n.containedEdges;if(void 0!==t&&void 0!==t.releaseFunction&&"function"==typeof t.releaseFunction){var l={},u={x:n.x,y:n.y};for(var c in h)if(h.hasOwnProperty(c)){var f=this.body.nodes[c];l[c]={x:f.x,y:f.y}}var p=t.releaseFunction(u,l);for(var v in h)if(h.hasOwnProperty(v)){var m=this.body.nodes[v];void 0!==p[v]&&(m.x=void 0===p[v].x?n.x:p[v].x,m.y=void 0===p[v].y?n.y:p[v].y)}}else On(h,(function(e){!1===e.options.fixed.x&&(e.x=n.x),!1===e.options.fixed.y&&(e.y=n.y)}));for(var g in h)if(h.hasOwnProperty(g)){var y=this.body.nodes[g];y.vx=n.vx,y.vy=n.vy,y.setOptions({physics:!0}),delete this.clusteredNodes[g]}for(var b=[],_=0;_<n.edges.length;_++)b.push(n.edges[_]);for(var w=0;w<b.length;w++){for(var k=b[w],x=this._getConnectedId(k,e),S=this.clusteredNodes[x],O=0;O<k.clusteringEdgeReplacingIds.length;O++){var D=k.clusteringEdgeReplacingIds[O],M=this.body.edges[D];if(void 0!==M)if(void 0!==S){var T=this.body.nodes[S.clusterId];T.containedEdges[M.id]=M,delete d[M.id];var E=M.fromId,C=M.toId;M.toId==x?C=S.clusterId:E=S.clusterId,this._createClusteredEdge(E,C,M,T.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(M)}k.remove()}for(var P in d)d.hasOwnProperty(P)&&this._restoreEdge(d[P]);delete this.body.nodes[e],!0===i&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(e){var t=[];if(!0===this.isCluster(e)){var i=this.body.nodes[e].containedNodes;for(var n in i)i.hasOwnProperty(n)&&t.push(this.body.nodes[n].id)}return t}},{key:"findNode",value:function(e){for(var t,i=[],n=0;void 0!==this.clusteredNodes[e]&&n<100;){if(void 0===(t=this.body.nodes[e]))return[];i.push(t.id),e=this.clusteredNodes[e].clusterId,n++}return void 0===(t=this.body.nodes[e])?[]:(i.push(t.id),i.reverse(),i)}},{key:"updateClusteredNode",value:function(e,t){if(void 0===e)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===t)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[e])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[e].setOptions(t),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(e,t){if(void 0===e)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===t)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[e])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(e),n=0;n<i.length;n++){this.body.edges[i[n]].setOptions(t)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(e){for(var t=[],i=0;void 0!==e&&void 0!==this.body.edges[e]&&i<100;)t.push(this.body.edges[e].id),e=this.body.edges[e].edgeReplacedById,i++;return t.reverse(),t}},{key:"getBaseEdge",value:function(e){return this.getBaseEdges(e)[0]}},{key:"getBaseEdges",value:function(e){for(var t=[e],i=[],n=[],o=0;t.length>0&&o<100;){var s=t.pop();if(void 0!==s){var r=this.body.edges[s];if(void 0!==r){o++;var a=r.clusteringEdgeReplacingIds;if(void 0===a)n.push(s);else for(var h=0;h<a.length;++h){var d=a[h];-1===t.indexOf(a)&&-1===i.indexOf(a)&&t.push(d)}i.push(s)}}}return n}},{key:"_getConnectedId",value:function(e,t){return e.toId!=t?e.toId:(e.fromId,e.fromId)}},{key:"_getHubSize",value:function(){for(var e=0,t=0,i=0,n=0,o=0;o<this.body.nodeIndices.length;o++){var s=this.body.nodes[this.body.nodeIndices[o]];s.edges.length>n&&(n=s.edges.length),e+=s.edges.length,t+=Math.pow(s.edges.length,2),i+=1}e/=i;var r=(t/=i)-Math.pow(e,2),a=Math.sqrt(r),h=Math.floor(e+2*a);return h>n&&(h=n),h}},{key:"_createClusteredEdge",value:function(e,t,i,n,o){var s=bd.cloneOptions(i,"edge");pn(s,n),s.from=e,s.to=t,s.id="clusterEdge:"+Xi(),void 0!==o&&pn(s,o);var r=this.body.functions.createEdge(s);return r.clusteringEdgeReplacingIds=[i.id],r.connect(),this.body.edges[r.id]=r,r}},{key:"_clusterEdges",value:function(e,t,i,n){if(t instanceof hd){var o=t,s={};s[o.id]=o,t=s}if(e instanceof zh){var r=e,a={};a[r.id]=r,e=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===n&&(n=i.clusterEdgeProperties),this._createClusterEdges(e,t,i,n),t)if(t.hasOwnProperty(h)&&void 0!==this.body.edges[h]){var d=this.body.edges[h];this._backupEdgeOptions(d),d.setOptions({physics:!1})}for(var l in e)e.hasOwnProperty(l)&&(this.clusteredNodes[l]={clusterId:i.id,node:this.body.nodes[l]},this.body.nodes[l].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(e){if(void 0!==e){var t=this.clusteredNodes[e];if(void 0!==t){var i=t.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(e,t){var i=[];return On(e,(function(e){t(e)&&i.push(e)})),i}},{key:"_updateState",value:function(){var e,t=this,i=[],n={},o=function(e){On(t.body.nodes,(function(t){!0===t.isCluster&&e(t)}))};for(e in this.clusteredNodes){if(this.clusteredNodes.hasOwnProperty(e))void 0===this.body.nodes[e]&&i.push(e)}o((function(e){for(var t=0;t<i.length;t++)delete e.containedNodes[i[t]]}));for(var s=0;s<i.length;s++)delete this.clusteredNodes[i[s]];On(this.clusteredEdges,(function(e){var i=t.body.edges[e];void 0!==i&&i.endPointsValid()||(n[e]=e)})),o((function(e){On(e.containedEdges,(function(e,t){e.endPointsValid()||n[t]||(n[t]=t)}))})),On(this.body.edges,(function(e,i){var o=!0,s=e.clusteringEdgeReplacingIds;if(void 0!==s){var r=0;On(s,(function(e){var i=t.body.edges[e];void 0!==i&&i.endPointsValid()&&(r+=1)})),o=r>0}e.endPointsValid()&&o||(n[i]=i)})),o((function(e){On(n,(function(i){delete e.containedEdges[i],On(e.edges,(function(o,s){o.id!==i?o.clusteringEdgeReplacingIds=t._filter(o.clusteringEdgeReplacingIds,(function(e){return!n[e]})):e.edges[s]=null})),e.edges=t._filter(e.edges,(function(e){return null!==e}))}))})),On(n,(function(e){delete t.clusteredEdges[e]})),On(n,(function(e){delete t.body.edges[e]})),On(Object.keys(this.body.edges),(function(e){var i=t.body.edges[e],n=t._isClusteredNode(i.fromId)||t._isClusteredNode(i.toId);if(n!==t._isClusteredEdge(i.id))if(n){var o=t._getClusterNodeForNode(i.fromId);void 0!==o&&t._clusterEdges(t.body.nodes[i.fromId],i,o);var s=t._getClusterNodeForNode(i.toId);void 0!==s&&t._clusterEdges(t.body.nodes[i.toId],i,s)}else delete t._clusterEdges[e],t._restoreEdge(i)}));for(var r=!1,a=!0,h=function(){var e=[];o((function(t){var i=Object.keys(t.containedNodes).length,n=!0===t.options.allowSingleNodeCluster;(n&&i<1||!n&&i<2)&&e.push(t.id)}));for(var i=0;i<e.length;++i)t.openCluster(e[i],{},!1);a=e.length>0,r=r||a};a;)h();r&&this._updateState()}},{key:"_isClusteredNode",value:function(e){return void 0!==this.clusteredNodes[e]}},{key:"_isClusteredEdge",value:function(e){return void 0!==this.clusteredEdges[e]}}]),e}();var kd,xd=function(){function e(t,i){var n;na(this,e),void 0!==window&&(n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===n?function(e){e()}:n,this.body=t,this.canvas=i,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},ln(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("dragStart",(function(){e.dragging=!0})),this.body.emitter.on("dragEnd",(function(){e.dragging=!1})),this.body.emitter.on("zoom",(function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=window.setTimeout((function(){e.zooming=!1,e._requestRedraw.bind(e)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){e._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===e.renderingActive&&e._redraw()})),this.body.emitter.on("_blockRedraw",(function(){e.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){e.allowRedraw=!0,e.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",this._requestRedraw.bind(this)),this.body.emitter.on("_startRendering",(function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()})),this.body.emitter.on("_stopRendering",(function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,!0===e.requiresTimeout?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()}))}},{key:"setOptions",value:function(e){if(void 0!==e){cn(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,e)}}},{key:"_requestNextFrame",value:function(e,t){if("undefined"!=typeof window){var i,n=window;return!0===this.requiresTimeout?i=n.setTimeout(e,t):n.requestAnimationFrame&&(i=n.requestAnimationFrame(e)),i}}},{key:"_startRendering",value:function(){!0===this.renderingActive&&void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(this._renderStep.bind(this),this.simulationInterval))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var e=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){e._redraw(!1)}),0))}},{key:"_redraw",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1,0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var t=this.canvas.getContext(),i=this.canvas.frame.canvas.clientWidth,n=this.canvas.frame.canvas.clientHeight;if(t.clearRect(0,0,i,n),0===this.canvas.frame.clientWidth)return;t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale),t.beginPath(),this.body.emitter.emit("beforeDrawing",t),t.closePath(),!1===e&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(t),(!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag)&&this._drawNodes(t,e),t.beginPath(),this.body.emitter.emit("afterDrawing",t),t.closePath(),t.restore(),!0===e&&t.clearRect(0,0,i,n)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var e=this.canvas.getContext();e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale);var t,i=this.body.nodes;for(var n in i)i.hasOwnProperty(n)&&((t=i[n]).resize(e),t.updateBoundingBox(e,t.selected));e.restore()}},{key:"_drawNodes",value:function(e){for(var t,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.nodes,o=this.body.nodeIndices,s=[],r=20,a=this.canvas.DOMtoCanvas({x:-r,y:-r}),h=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+r,y:this.canvas.frame.canvas.clientHeight+r}),d={top:a.y,left:a.x,bottom:h.y,right:h.x},l=0;l<o.length;l++)(t=n[o[l]]).isSelected()?s.push(o[l]):!0===i?t.draw(e):!0===t.isBoundingBoxOverlappingWith(d)?t.draw(e):t.updateBoundingBox(e,t.selected);for(var u=0;u<s.length;u++)(t=n[s[u]]).draw(e)}},{key:"_drawEdges",value:function(e){for(var t,i=this.body.edges,n=this.body.edgeIndices,o=0;o<n.length;o++)!0===(t=i[n[o]]).connected&&t.draw(e)}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var e=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,-1!=e.indexOf("msie 9.0")?this.requiresTimeout=!0:-1!=e.indexOf("safari")&&e.indexOf("chrome")<=-1&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}}]),e}(),Sd=t((function(e,t){t.onTouch=function(e,t){t.inputHandler=function(e){e.isFirst&&t(e)},e.on("hammer.input",t.inputHandler)},t.onRelease=function(e,t){return t.inputHandler=function(e){e.isFinal&&t(e)},e.on("hammer.input",t.inputHandler)},t.offTouch=function(e,t){e.off("hammer.input",t.inputHandler)},t.offRelease=t.offTouch,t.disablePreventDefaultVertically=function(e){return e.getTouchAction=function(){return["pan-y"]},e}})),Od=(Sd.onTouch,Sd.onRelease,Sd.offTouch,Sd.offRelease,Sd.disablePreventDefaultVertically,function(){function e(t){na(this,e),this.body=t,this.pixelRatio=1,this.resizeTimer=void 0,this.resizeFunction=this._onResize.bind(this),this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},ln(this.options,this.defaultOptions),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.once("resize",(function(t){0!==t.width&&(e.body.view.translation.x=.5*t.width),0!==t.height&&(e.body.view.translation.y=.5*t.height)})),this.body.emitter.on("setSize",this.setSize.bind(this)),this.body.emitter.on("destroy",(function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()}))}},{key:"setOptions",value:function(e){var t=this;if(void 0!==e){cn(["width","height","autoResize"],this.options,e)}!0===this.options.autoResize&&(this._cleanUp(),this.resizeTimer=setInterval((function(){!0===t.setSize()&&t.body.emitter.emit("_requestRedraw")}),1e3),this.resizeFunction=this._onResize.bind(this),En(window,"resize",this.resizeFunction))}},{key:"_cleanUp",value:function(){void 0!==this.resizeTimer&&clearInterval(this.resizeTimer),Cn(window,"resize",this.resizeFunction),this.resizeFunction=void 0}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/e,this.cameraState.previousHeight=this.frame.canvas.height/e,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/e,y:.5*this.frame.canvas.height/e}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0){var e=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,t=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=e&&1!=t?i=.5*this.cameraState.scale*(e+t):1!=e?i=this.cameraState.scale*e:1!=t&&(i=this.cameraState.scale*t),this.body.view.scale=i;var n=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),o={x:n.x-this.cameraState.position.x,y:n.y-this.cameraState.position.y};this.body.view.translation.x+=o.x*this.body.view.scale,this.body.view.translation.y+=o.y*this.body.view.scale}}},{key:"_prepareValue",value:function(e){if("number"==typeof e)return e+"px";if("string"==typeof e){if(-1!==e.indexOf("%")||-1!==e.indexOf("px"))return e;if(-1===e.indexOf("%"))return e+"px"}throw new Error("Could not use the value supplied for width or height:"+e)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=900,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(e)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var e=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new Kr(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:Kr.DIRECTION_ALL}),Sd.onTouch(this.hammer,(function(t){e.body.eventListeners.onTouch(t)})),this.hammer.on("tap",(function(t){e.body.eventListeners.onTap(t)})),this.hammer.on("doubletap",(function(t){e.body.eventListeners.onDoubleTap(t)})),this.hammer.on("press",(function(t){e.body.eventListeners.onHold(t)})),this.hammer.on("panstart",(function(t){e.body.eventListeners.onDragStart(t)})),this.hammer.on("panmove",(function(t){e.body.eventListeners.onDrag(t)})),this.hammer.on("panend",(function(t){e.body.eventListeners.onDragEnd(t)})),this.hammer.on("pinch",(function(t){e.body.eventListeners.onPinch(t)})),this.frame.canvas.addEventListener("mousewheel",(function(t){e.body.eventListeners.onMouseWheel(t)})),this.frame.canvas.addEventListener("DOMMouseScroll",(function(t){e.body.eventListeners.onMouseWheel(t)})),this.frame.canvas.addEventListener("mousemove",(function(t){e.body.eventListeners.onMouseMove(t)})),this.frame.canvas.addEventListener("contextmenu",(function(t){e.body.eventListeners.onContext(t)})),this.hammerFrame=new Kr(this.frame),Sd.onRelease(this.hammerFrame,(function(t){e.body.eventListeners.onRelease(t)}))}},{key:"setSize",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;e=this._prepareValue(e),t=this._prepareValue(t);var i=!1,n=this.frame.canvas.width,o=this.frame.canvas.height,s=this.pixelRatio;if(this._setPixelRatio(),e!=this.options.width||t!=this.options.height||this.frame.style.width!=e||this.frame.style.height!=t)this._getCameraState(s),this.frame.style.width=e,this.frame.style.height=t,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=e,this.options.height=t,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var r=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===r&&this.frame.canvas.height===a||this._getCameraState(s),this.frame.canvas.width!==r&&(this.frame.canvas.width=r,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(n/this.pixelRatio),oldHeight:Math.round(o/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");var t=1;return"undefined"!=typeof window&&(t=window.devicePixelRatio||1),t/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var e=this.getContext();if(void 0===e)throw new Error("Could not get canvax context");e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(e){return{x:this._XconvertCanvasToDOM(e.x),y:this._YconvertCanvasToDOM(e.y)}}},{key:"DOMtoCanvas",value:function(e){return{x:this._XconvertDOMtoCanvas(e.x),y:this._YconvertDOMtoCanvas(e.y)}}}]),e}()),Dd=function(){function e(t,i){var n=this;na(this,e),this.body=t,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",this.fit.bind(this)),this.body.emitter.on("animationFinished",(function(){n.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",this.releaseNode.bind(this))}return sa(e,[{key:"setOptions",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=e}},{key:"fit",value:function(){var e,t,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{nodes:[]},n=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0!==(i=Object.assign({},i)).nodes&&0!==i.nodes.length||(i.nodes=this.body.nodeIndices),!0===n){var o=0;for(var s in this.body.nodes)if(this.body.nodes.hasOwnProperty(s)){var r=this.body.nodes[s];!0===r.predefinedPosition&&(o+=1)}if(o>.5*this.body.nodeIndices.length)return void this.fit(i,!1);e=bd.getRange(this.body.nodes,i.nodes);var a=this.body.nodeIndices.length;t=12.662/(a+7.4147)+.0964822;var h=Math.min(this.canvas.frame.canvas.clientWidth/600,this.canvas.frame.canvas.clientHeight/600);t*=h}else{this.body.emitter.emit("_resizeNodes"),e=bd.getRange(this.body.nodes,i.nodes);var d=1.1*Math.abs(e.maxX-e.minX),l=1.1*Math.abs(e.maxY-e.minY),u=this.canvas.frame.canvas.clientWidth/d,c=this.canvas.frame.canvas.clientHeight/l;t=u<=c?u:c}t>1?t=1:0===t&&(t=1);var f=bd.findCenter(e),p={position:f,scale:t,animation:i.animation};this.moveTo(p)}},{key:"focus",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[e]){var i={x:this.body.nodes[e].x,y:this.body.nodes[e].y};t.position=i,t.lockedOnNode=e,this.moveTo(t)}else console.log("Node: "+e+" cannot be found.")}},{key:"moveTo",value:function(e){if(void 0!==e){if(null!=e.offset){if(null!=e.offset.x){if(e.offset.x=+e.offset.x,!Number.isFinite(e.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else e.offset.x=0;if(null!=e.offset.y){if(e.offset.y=+e.offset.y,!Number.isFinite(e.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else e.offset.x=0}else e.offset={x:0,y:0};if(null!=e.position){if(null!=e.position.x){if(e.position.x=+e.position.x,!Number.isFinite(e.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else e.position.x=0;if(null!=e.position.y){if(e.position.y=+e.position.y,!Number.isFinite(e.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else e.position.x=0}else e.position=this.getViewPosition();if(null!=e.scale){if(e.scale=+e.scale,!(e.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else e.scale=this.body.view.scale;void 0===e.animation&&(e.animation={duration:0}),!1===e.animation&&(e.animation={duration:0}),!0===e.animation&&(e.animation={}),void 0===e.animation.duration&&(e.animation.duration=1e3),void 0===e.animation.easingFunction&&(e.animation.easingFunction="easeInOutQuad"),this.animateView(e)}else e={}}},{key:"animateView",value:function(e){if(void 0!==e){this.animationEasingFunction=e.animation.easingFunction,this.releaseNode(),!0===e.locked&&(this.lockedOnNodeId=e.lockedOnNode,this.lockedOnNodeOffset=e.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=e.scale,this.body.view.scale=this.targetScale;var t=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),i=t.x-e.position.x,n=t.y-e.position.y;this.targetTranslation={x:this.sourceTranslation.x+i*this.targetScale+e.offset.x,y:this.sourceTranslation.y+n*this.targetScale+e.offset.y},0===e.animation.duration?null!=this.lockedOnNodeId?(this.viewFunction=this._lockedRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction)):(this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw")):(this.animationSpeed=1/(60*e.animation.duration*.001)||1/60,this.animationEasingFunction=e.animation.easingFunction,this.viewFunction=this._transitionRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))}}},{key:"_lockedRedraw",value:function(){var e=this.body.nodes[this.lockedOnNodeId].x,t=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=i.x-e,o=i.y-t,s=this.body.view.translation,r={x:s.x+n*this.body.view.scale+this.lockedOnNodeOffset.x,y:s.y+o*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=r}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===e?1:this.easingTime;var t=to[this.animationEasingFunction](this.easingTime);this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*t,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*t,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*t},this.easingTime>=1&&(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId&&(this.viewFunction=this._lockedRedraw.bind(this),this.body.emitter.on("initRedraw",this.viewFunction)),this.body.emitter.emit("animationFinished"))}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),e}(),Md=function(){function e(t,i){var n=this;na(this,e),this.body=t,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){n.activated=!0,n.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){n.activated=!1,n.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==n.keycharm&&n.keycharm.destroy()})),this.options={}}return sa(e,[{key:"setOptions",value:function(e){void 0!==e&&(this.options=e,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var e=0;e<this.navigationHammers.length;e++)this.navigationHammers[e].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var e=this;this.cleanNavigation(),this.navigationDOM={};var t=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var n=0;n<t.length;n++){this.navigationDOM[t[n]]=document.createElement("div"),this.navigationDOM[t[n]].className="vis-button vis-"+t[n],this.navigationDOM.wrapper.appendChild(this.navigationDOM[t[n]]);var o=new Kr(this.navigationDOM[t[n]]);"_fit"===i[n]?Sd.onTouch(o,this._fit.bind(this)):Sd.onTouch(o,this.bindToRedraw.bind(this,i[n])),this.navigationHammers.push(o)}var s=new Kr(this.canvas.frame);Sd.onRelease(s,(function(){e._stopMovement()})),this.navigationHammers.push(s),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(e){void 0===this.boundFunctions[e]&&(this.boundFunctions[e]=this[e].bind(this),this.body.emitter.on("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(e){void 0!==this.boundFunctions[e]&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[e])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var e in this.boundFunctions)this.boundFunctions.hasOwnProperty(e)&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var e=this.body.view.scale,t=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=t/e,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,s=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=t,this.body.view.translation={x:o,y:s},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var e=this.body.view.scale,t=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=t/e,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,s=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=t,this.body.view.translation={x:o,y:s},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var e=this;void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled&&(!0===this.options.keyboard.bindToWindow?this.keycharm=Wo({container:window,preventDefault:!0}):this.keycharm=Wo({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(this.keycharm.bind("up",(function(){e.bindToRedraw("_moveUp")}),"keydown"),this.keycharm.bind("down",(function(){e.bindToRedraw("_moveDown")}),"keydown"),this.keycharm.bind("left",(function(){e.bindToRedraw("_moveLeft")}),"keydown"),this.keycharm.bind("right",(function(){e.bindToRedraw("_moveRight")}),"keydown"),this.keycharm.bind("=",(function(){e.bindToRedraw("_zoomIn")}),"keydown"),this.keycharm.bind("num+",(function(){e.bindToRedraw("_zoomIn")}),"keydown"),this.keycharm.bind("num-",(function(){e.bindToRedraw("_zoomOut")}),"keydown"),this.keycharm.bind("-",(function(){e.bindToRedraw("_zoomOut")}),"keydown"),this.keycharm.bind("[",(function(){e.bindToRedraw("_zoomOut")}),"keydown"),this.keycharm.bind("]",(function(){e.bindToRedraw("_zoomIn")}),"keydown"),this.keycharm.bind("pageup",(function(){e.bindToRedraw("_zoomIn")}),"keydown"),this.keycharm.bind("pagedown",(function(){e.bindToRedraw("_zoomOut")}),"keydown"),this.keycharm.bind("up",(function(){e.unbindFromRedraw("_moveUp")}),"keyup"),this.keycharm.bind("down",(function(){e.unbindFromRedraw("_moveDown")}),"keyup"),this.keycharm.bind("left",(function(){e.unbindFromRedraw("_moveLeft")}),"keyup"),this.keycharm.bind("right",(function(){e.unbindFromRedraw("_moveRight")}),"keyup"),this.keycharm.bind("=",(function(){e.unbindFromRedraw("_zoomIn")}),"keyup"),this.keycharm.bind("num+",(function(){e.unbindFromRedraw("_zoomIn")}),"keyup"),this.keycharm.bind("num-",(function(){e.unbindFromRedraw("_zoomOut")}),"keyup"),this.keycharm.bind("-",(function(){e.unbindFromRedraw("_zoomOut")}),"keyup"),this.keycharm.bind("[",(function(){e.unbindFromRedraw("_zoomOut")}),"keyup"),this.keycharm.bind("]",(function(){e.unbindFromRedraw("_zoomIn")}),"keyup"),this.keycharm.bind("pageup",(function(){e.unbindFromRedraw("_zoomIn")}),"keyup"),this.keycharm.bind("pagedown",(function(){e.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),e}(),Td=function(){function e(t,i){na(this,e),this.container=t,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return sa(e,[{key:"setPosition",value:function(e,t){this.x=parseInt(e),this.y=parseInt(t)}},{key:"setText",value:function(e){e instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(e)):this.frame.innerHTML=e}},{key:"show",value:function(e){if(void 0===e&&(e=!0),!0===e){var t=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,s=0,r=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-t<this.padding&&(h=!1),this.x+i>o-this.padding&&(a=!0),s=a?this.x-i:this.x,r=h?this.y-t:this.y}else(r=this.y-t)+t+this.padding>n&&(r=n-t-this.padding),r<this.padding&&(r=this.padding),(s=this.x)+i+this.padding>o&&(s=o-i-this.padding),s<this.padding&&(s=this.padding);this.frame.style.left=s+"px",this.frame.style.top=r+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),e}(),Ed=function(){function e(t,i,n){na(this,e),this.body=t,this.canvas=i,this.selectionHandler=n,this.navigationHandler=new Md(t,i),this.body.eventListeners.onTap=this.onTap.bind(this),this.body.eventListeners.onTouch=this.onTouch.bind(this),this.body.eventListeners.onDoubleTap=this.onDoubleTap.bind(this),this.body.eventListeners.onHold=this.onHold.bind(this),this.body.eventListeners.onDragStart=this.onDragStart.bind(this),this.body.eventListeners.onDrag=this.onDrag.bind(this),this.body.eventListeners.onDragEnd=this.onDragEnd.bind(this),this.body.eventListeners.onMouseWheel=this.onMouseWheel.bind(this),this.body.eventListeners.onPinch=this.onPinch.bind(this),this.body.eventListeners.onMouseMove=this.onMouseMove.bind(this),this.body.eventListeners.onRelease=this.onRelease.bind(this),this.body.eventListeners.onContext=this.onContext.bind(this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=this.getPointer.bind(this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},ln(this.options,this.defaultOptions),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("destroy",(function(){clearTimeout(e.popupTimer),delete e.body.functions.getPointer}))}},{key:"setOptions",value:function(e){if(void 0!==e){fn(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,e),Jn(this.options,e,"keyboard"),e.tooltip&&(ln(this.options.tooltip,e.tooltip),e.tooltip.color&&(this.options.tooltip.color=An(e.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(e){return{x:e.x-_n(this.canvas.frame.canvas),y:e.y-kn(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(e){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(e.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect&&(e.changedPointers[0].ctrlKey||e.changedPointers[0].metaKey);this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t)}},{key:"onDoubleTap",value:function(e){var t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("doubleClick",e,t)}},{key:"onHold",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(t,e,i),this.selectionHandler._generateClickEvent("click",e,t),this.selectionHandler._generateClickEvent("hold",e,t)}},{key:"onRelease",value:function(e){if((new Date).valueOf()-this.touchTime>10){var t=this.getPointer(e.center);this.selectionHandler._generateClickEvent("release",e,t),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(e){var t=this.getPointer({x:e.clientX,y:e.clientY});this.selectionHandler._generateClickEvent("oncontext",e,t)}},{key:"checkSelectionChanges",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=this.selectionHandler.getSelection(),o=!1;o=!0===i?this.selectionHandler.selectAdditionalOnPoint(e):this.selectionHandler.selectOnPoint(e);var s=this.selectionHandler.getSelection(),r=this._determineDifference(n,s),a=this._determineDifference(s,n);r.edges.length>0&&(this.selectionHandler._generateClickEvent("deselectEdge",t,e,n),o=!0),r.nodes.length>0&&(this.selectionHandler._generateClickEvent("deselectNode",t,e,n),o=!0),a.nodes.length>0&&(this.selectionHandler._generateClickEvent("selectNode",t,e),o=!0),a.edges.length>0&&(this.selectionHandler._generateClickEvent("selectEdge",t,e),o=!0),!0===o&&this.selectionHandler._generateClickEvent("select",t,e)}},{key:"_determineDifference",value:function(e,t){var i=function(e,t){for(var i=[],n=0;n<e.length;n++){var o=e[n];-1===t.indexOf(o)&&i.push(o)}return i};return{nodes:i(e.nodes,t.nodes),edges:i(e.edges,t.edges)}}},{key:"onDragStart",value:function(e){void 0===this.drag.pointer&&this.onTouch(e);var t=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=ln({},this.body.view.translation),this.drag.nodeId=void 0,void 0!==t&&!0===this.options.dragNodes){this.drag.nodeId=t.id,!1===t.isSelected()&&(this.selectionHandler.unselectAll(),this.selectionHandler.selectObject(t)),this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer);var i=this.selectionHandler.selectionObj.nodes;for(var n in i)if(i.hasOwnProperty(n)){var o=i[n],s={id:o.id,node:o,x:o.x,y:o.y,xFixed:o.options.fixed.x,yFixed:o.options.fixed.y};o.options.fixed.x=!0,o.options.fixed.y=!0,this.drag.selection.push(s)}}else this.selectionHandler._generateClickEvent("dragStart",e,this.drag.pointer,void 0,!0)}},{key:"onDrag",value:function(e){var t=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(e.center),n=this.drag.selection;if(n&&n.length&&!0===this.options.dragNodes){this.selectionHandler._generateClickEvent("dragging",e,i);var o=i.x-this.drag.pointer.x,s=i.y-this.drag.pointer.y;n.forEach((function(e){var i=e.node;!1===e.xFixed&&(i.x=t.canvas._XconvertDOMtoCanvas(t.canvas._XconvertCanvasToDOM(e.x)+o)),!1===e.yFixed&&(i.y=t.canvas._YconvertDOMtoCanvas(t.canvas._YconvertCanvasToDOM(e.y)+s))})),this.body.emitter.emit("startSimulation")}else if(!0===this.options.dragView){if(this.selectionHandler._generateClickEvent("dragging",e,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(e);var r=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+r,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}},{key:"onDragEnd",value:function(e){this.drag.dragging=!1;var t=this.drag.selection;t&&t.length?(t.forEach((function(e){e.node.options.fixed.x=e.xFixed,e.node.options.fixed.y=e.yFixed})),this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler._generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}},{key:"onPinch",value:function(e){var t=this.getPointer(e.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*e.scale;this.zoom(i,t)}},{key:"zoom",value:function(e,t){if(!0===this.options.zoomView){var i=this.body.view.scale;e<1e-5&&(e=1e-5),e>10&&(e=10);var n=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(n=this.canvas.DOMtoCanvas(this.drag.pointer));var o=this.body.view.translation,s=e/i,r=(1-s)*t.x+o.x*s,a=(1-s)*t.y+o.y*s;if(this.body.view.scale=e,this.body.view.translation={x:r,y:a},null!=n){var h=this.canvas.canvasToDOM(n);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<e?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:t}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:t})}}},{key:"onMouseWheel",value:function(e){if(!0===this.options.zoomView){var t=0;if(e.wheelDelta?t=e.wheelDelta/120:e.detail&&(t=-e.detail/3),0!==t){var i=this.body.view.scale,n=t*(this.options.zoomSpeed/10);t<0&&(n/=1-n),i*=1+n;var o=this.getPointer({x:e.clientX,y:e.clientY});this.zoom(i,o)}e.preventDefault()}}},{key:"onMouseMove",value:function(e){var t=this,i=this.getPointer({x:e.clientX,y:e.clientY}),n=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(n=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===n&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=setTimeout((function(){return t._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(e,i)}},{key:"_checkShowPopup",value:function(e){var t=this.canvas._XconvertDOMtoCanvas(e.x),i=this.canvas._YconvertDOMtoCanvas(e.y),n={left:t,top:i,right:t,bottom:i},o=void 0===this.popupObj?void 0:this.popupObj.id,s=!1,r="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,d=this.body.nodes,l=[],u=0;u<h.length;u++)!0===(a=d[h[u]]).isOverlappingWith(n)&&(s=!0,void 0!==a.getTitle()&&l.push(h[u]));l.length>0&&(this.popupObj=d[l[l.length-1]],s=!0)}if(void 0===this.popupObj&&!1===s){for(var c,f=this.body.edgeIndices,p=this.body.edges,v=[],m=0;m<f.length;m++)!0===(c=p[f[m]]).isOverlappingWith(n)&&!0===c.connected&&void 0!==c.getTitle()&&v.push(f[m]);v.length>0&&(this.popupObj=p[v[v.length-1]],r="edge")}void 0!==this.popupObj?this.popupObj.id!==o&&(void 0===this.popup&&(this.popup=new Td(this.canvas.frame)),this.popup.popupTargetType=r,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(e.x+3,e.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(e){var t=this.selectionHandler._pointerToPositionObject(e),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(t))){var n=this.selectionHandler.getNodeAt(e);i=void 0!==n&&n.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(e)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(t));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),e}(),Cd=function(){function e(t,i){var n=this;na(this,e),this.body=t,this.canvas=i,this.selectionObj={nodes:[],edges:[]},this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},ln(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){n.updateSelection()}))}return sa(e,[{key:"setOptions",value:function(e){if(void 0!==e){cn(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,e)}}},{key:"selectOnPoint",value:function(e){var t=!1;if(!0===this.options.selectable){var i=this.getNodeAt(e)||this.getEdgeAt(e);this.unselectAll(),void 0!==i&&(t=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return t}},{key:"selectAdditionalOnPoint",value:function(e){var t=!1;if(!0===this.options.selectable){var i=this.getNodeAt(e)||this.getEdgeAt(e);void 0!==i&&(t=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return t}},{key:"_initBaseEvent",value:function(e,t){var i={};return i.pointer={DOM:{x:t.x,y:t.y},canvas:this.canvas.DOMtoCanvas(t)},i.event=e,i}},{key:"_generateClickEvent",value:function(e,t,i,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],s=this._initBaseEvent(t,i);if(!0===o)s.nodes=[],s.edges=[];else{var r=this.getSelection();s.nodes=r.nodes,s.edges=r.edges}void 0!==n&&(s.previousSelection=n),"click"==e&&(s.items=this.getClickedItems(i)),void 0!==t.controlEdge&&(s.controlEdge=t.controlEdge),this.body.emitter.emit(e,s)}},{key:"selectObject",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;return void 0!==e&&(e instanceof zh&&!0===t&&this._selectConnectedEdges(e),e.select(),this._addToSelection(e),!0)}},{key:"deselectObject",value:function(e){!0===e.isSelected()&&(e.selected=!1,this._removeFromSelection(e))}},{key:"_getAllNodesOverlappingWith",value:function(e){for(var t=[],i=this.body.nodes,n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodeIndices[n];i[o].isOverlappingWith(e)&&t.push(o)}return t}},{key:"_pointerToPositionObject",value:function(e){var t=this.canvas.DOMtoCanvas(e);return{left:t.x-1,top:t.y+1,right:t.x+1,bottom:t.y-1}}},{key:"getNodeAt",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(e),n=this._getAllNodesOverlappingWith(i);return n.length>0?!0===t?this.body.nodes[n[n.length-1]]:n[n.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(e,t){for(var i=this.body.edges,n=0;n<this.body.edgeIndices.length;n++){var o=this.body.edgeIndices[n];i[o].isOverlappingWith(e)&&t.push(o)}}},{key:"_getAllEdgesOverlappingWith",value:function(e){var t=[];return this._getEdgesOverlappingWith(e,t),t}},{key:"getEdgeAt",value:function(e){for(var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(e),n=10,o=null,s=this.body.edges,r=0;r<this.body.edgeIndices.length;r++){var a=this.body.edgeIndices[r],h=s[a];if(h.connected){var d=h.from.x,l=h.from.y,u=h.to.x,c=h.to.y,f=h.edgeType.getDistanceToEdge(d,l,u,c,i.x,i.y);f<n&&(o=a,n=f)}}return null!==o?!0===t?this.body.edges[o]:o:void 0}},{key:"_addToSelection",value:function(e){e instanceof zh?this.selectionObj.nodes[e.id]=e:this.selectionObj.edges[e.id]=e}},{key:"_addToHover",value:function(e){e instanceof zh?this.hoverObj.nodes[e.id]=e:this.hoverObj.edges[e.id]=e}},{key:"_removeFromSelection",value:function(e){e instanceof zh?(delete this.selectionObj.nodes[e.id],this._unselectConnectedEdges(e)):delete this.selectionObj.edges[e.id]}},{key:"unselectAll",value:function(){for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].unselect();for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&this.selectionObj.edges[t].unselect();this.selectionObj={nodes:{},edges:{}}}},{key:"_getSelectedNodeCount",value:function(){var e=0;for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);return e}},{key:"_getSelectedNode",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return this.selectionObj.nodes[e]}},{key:"_getSelectedEdge",value:function(){for(var e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return this.selectionObj.edges[e]}},{key:"_getSelectedEdgeCount",value:function(){var e=0;for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(e+=1);return e}},{key:"_getSelectedObjectCount",value:function(){var e=0;for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(e+=1);for(var i in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(i)&&(e+=1);return e}},{key:"_selectionIsEmpty",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e))return!1;for(var t in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(t))return!1;return!0}},{key:"_clusterInSelection",value:function(){for(var e in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(e)&&this.selectionObj.nodes[e].clusterSize>1)return!0;return!1}},{key:"_selectConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.select(),this._addToSelection(i)}}},{key:"_hoverConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.hover=!0,this._addToHover(i)}}},{key:"_unselectConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.unselect(),this._removeFromSelection(i)}}},{key:"emitBlurEvent",value:function(e,t,i){var n=this._initBaseEvent(e,t);!0===i.hover&&(i.hover=!1,i instanceof zh?(n.node=i.id,this.body.emitter.emit("blurNode",n)):(n.edge=i.id,this.body.emitter.emit("blurEdge",n)))}},{key:"emitHoverEvent",value:function(e,t,i){var n=this._initBaseEvent(e,t),o=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),o=!0,i instanceof zh?(n.node=i.id,this.body.emitter.emit("hoverNode",n)):(n.edge=i.id,this.body.emitter.emit("hoverEdge",n))),o}},{key:"hoverObject",value:function(e,t){var i=this.getNodeAt(t);void 0===i&&(i=this.getEdgeAt(t));var n=!1;for(var o in this.hoverObj.nodes)this.hoverObj.nodes.hasOwnProperty(o)&&(void 0===i||i instanceof zh&&i.id!=o||i instanceof hd)&&(this.emitBlurEvent(e,t,this.hoverObj.nodes[o]),delete this.hoverObj.nodes[o],n=!0);for(var s in this.hoverObj.edges)this.hoverObj.edges.hasOwnProperty(s)&&(!0===n?(this.hoverObj.edges[s].hover=!1,delete this.hoverObj.edges[s]):(void 0===i||i instanceof hd&&i.id!=s||i instanceof zh&&!i.hover)&&(this.emitBlurEvent(e,t,this.hoverObj.edges[s]),delete this.hoverObj.edges[s],n=!0));if(void 0!==i){var r=Object.keys(this.hoverObj.edges).length,a=Object.keys(this.hoverObj.nodes).length;(n||i instanceof hd&&0===r&&0===a||i instanceof zh&&0===r&&0===a)&&(n=this.emitHoverEvent(e,t,i)),i instanceof zh&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===n&&this.body.emitter.emit("_requestRedraw")}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodes(),edges:this.getSelectedEdges()}}},{key:"getSelectedNodes",value:function(){var e=[];if(!0===this.options.selectable)for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&e.push(this.selectionObj.nodes[t].id);return e}},{key:"getSelectedEdges",value:function(){var e=[];if(!0===this.options.selectable)for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&e.push(this.selectionObj.edges[t].id);return e}},{key:"setSelection",value:function(e){var t,i,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!e||!e.nodes&&!e.edges)throw"Selection must be an object with nodes and/or edges properties";if((n.unselectAll||void 0===n.unselectAll)&&this.unselectAll(),e.nodes)for(t=0;t<e.nodes.length;t++){i=e.nodes[t];var o=this.body.nodes[i];if(!o)throw new RangeError('Node with id "'+i+'" not found');this.selectObject(o,n.highlightEdges)}if(e.edges)for(t=0;t<e.edges.length;t++){i=e.edges[t];var s=this.body.edges[i];if(!s)throw new RangeError('Edge with id "'+i+'" not found');this.selectObject(s)}this.body.emitter.emit("_requestRedraw")}},{key:"selectNodes",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({nodes:e},{highlightEdges:t})}},{key:"selectEdges",value:function(e){if(!e||void 0===e.length)throw"Selection must be an array with ids";this.setSelection({edges:e})}},{key:"updateSelection",value:function(){for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(this.body.nodes.hasOwnProperty(e)||delete this.selectionObj.nodes[e]);for(var t in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(t)&&(this.body.edges.hasOwnProperty(t)||delete this.selectionObj.edges[t])}},{key:"getClickedItems",value:function(e){for(var t=this.canvas.DOMtoCanvas(e),i=[],n=this.body.nodeIndices,o=this.body.nodes,s=n.length-1;s>=0;s--){var r=o[n[s]].getItemsOnPoint(t);i.push.apply(i,r)}for(var a=this.body.edgeIndices,h=this.body.edges,d=a.length-1;d>=0;d--){var l=h[a[d]].getItemsOnPoint(t);i.push.apply(i,l)}return i}}]),e}(),Pd=t((function(e,t){!function(e){e.__esModule=!0,e.sort=function(e,i,n,o){if(!Array.isArray(e))throw new TypeError("Can only sort arrays");i?"function"!=typeof i&&(o=n,n=i,i=r):i=r,n||(n=0),o||(o=e.length);var s=o-n;if(!(s<2)){var d=0;if(s<t)return d=a(e,n,o,i),void h(e,n,o,n+d,i);var l=new u(e,i),c=function(e){for(var i=0;e>=t;)i|=1&e,e>>=1;return e+i}(s);do{if((d=a(e,n,o,i))<c){var f=s;f>c&&(f=c),h(e,n,n+f,n+d,i),d=f}l.pushRun(n,d),l.mergeRuns(),s-=d,n+=d}while(0!==s);l.forceMergeRuns()}};var t=32,i=7,n=256,o=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function s(e){return e<1e5?e<100?e<10?0:1:e<1e4?e<1e3?2:3:4:e<1e7?e<1e6?5:6:e<1e9?e<1e8?7:8:9}function r(e,t){if(e===t)return 0;if(~~e===e&&~~t===t){if(0===e||0===t)return e<t?-1:1;if(e<0||t<0){if(t>=0)return-1;if(e>=0)return 1;e=-e,t=-t}var i=s(e),n=s(t),r=0;return i<n?(e*=o[n-i-1],t/=10,r=-1):i>n&&(t*=o[i-n-1],e/=10,r=1),e===t?r:e<t?-1:1}var a=String(e),h=String(t);return a===h?0:a<h?-1:1}function a(e,t,i,n){var o=t+1;if(o===i)return 1;if(n(e[o++],e[t])<0){for(;o<i&&n(e[o],e[o-1])<0;)o++;!function(e,t,i){for(i--;t<i;){var n=e[t];e[t++]=e[i],e[i--]=n}}(e,t,o)}else for(;o<i&&n(e[o],e[o-1])>=0;)o++;return o-t}function h(e,t,i,n,o){for(n===t&&n++;n<i;n++){for(var s=e[n],r=t,a=n;r<a;){var h=r+a>>>1;o(s,e[h])<0?a=h:r=h+1}var d=n-r;switch(d){case 3:e[r+3]=e[r+2];case 2:e[r+2]=e[r+1];case 1:e[r+1]=e[r];break;default:for(;d>0;)e[r+d]=e[r+d-1],d--}e[r]=s}}function d(e,t,i,n,o,s){var r=0,a=0,h=1;if(s(e,t[i+o])>0){for(a=n-o;h<a&&s(e,t[i+o+h])>0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=o,h+=o}else{for(a=o+1;h<a&&s(e,t[i+o-h])<=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=o-h,h=o-d}for(r++;r<h;){var l=r+(h-r>>>1);s(e,t[i+l])>0?r=l+1:h=l}return h}function l(e,t,i,n,o,s){var r=0,a=0,h=1;if(s(e,t[i+o])<0){for(a=o+1;h<a&&s(e,t[i+o-h])<0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=o-h,h=o-d}else{for(a=n-o;h<a&&s(e,t[i+o+h])>=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=o,h+=o}for(r++;r<h;){var l=r+(h-r>>>1);s(e,t[i+l])<0?h=l:r=l+1}return h}var u=function(){function e(t,o){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.array=null,this.compare=null,this.minGallop=i,this.length=0,this.tmpStorageLength=n,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=t,this.compare=o,this.length=t.length,this.length<2*n&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return e.prototype.pushRun=function(e,t){this.runStart[this.stackSize]=e,this.runLength[this.stackSize]=t,this.stackSize+=1},e.prototype.mergeRuns=function(){for(;this.stackSize>1;){var e=this.stackSize-2;if(e>=1&&this.runLength[e-1]<=this.runLength[e]+this.runLength[e+1]||e>=2&&this.runLength[e-2]<=this.runLength[e]+this.runLength[e-1])this.runLength[e-1]<this.runLength[e+1]&&e--;else if(this.runLength[e]>this.runLength[e+1])break;this.mergeAt(e)}},e.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var e=this.stackSize-2;e>0&&this.runLength[e-1]<this.runLength[e+1]&&e--,this.mergeAt(e)}},e.prototype.mergeAt=function(e){var t=this.compare,i=this.array,n=this.runStart[e],o=this.runLength[e],s=this.runStart[e+1],r=this.runLength[e+1];this.runLength[e]=o+r,e===this.stackSize-3&&(this.runStart[e+1]=this.runStart[e+2],this.runLength[e+1]=this.runLength[e+2]),this.stackSize--;var a=l(i[s],i,n,o,0,t);n+=a,0!=(o-=a)&&0!==(r=d(i[n+o-1],i,s,r,r-1,t))&&(o<=r?this.mergeLow(n,o,s,r):this.mergeHigh(n,o,s,r))},e.prototype.mergeLow=function(e,t,n,o){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<t;h++)a[h]=r[e+h];var u=0,c=n,f=e;if(r[f++]=r[c++],0!=--o)if(1!==t){for(var p=this.minGallop;;){var v=0,m=0,g=!1;do{if(s(r[c],a[u])<0){if(r[f++]=r[c++],m++,v=0,0==--o){g=!0;break}}else if(r[f++]=a[u++],v++,m=0,1==--t){g=!0;break}}while((v|m)<p);if(g)break;do{if(0!==(v=l(r[c],a,u,t,0,s))){for(h=0;h<v;h++)r[f+h]=a[u+h];if(f+=v,u+=v,(t-=v)<=1){g=!0;break}}if(r[f++]=r[c++],0==--o){g=!0;break}if(0!==(m=d(a[u],r,c,o,0,s))){for(h=0;h<m;h++)r[f+h]=r[c+h];if(f+=m,c+=m,0==(o-=m)){g=!0;break}}if(r[f++]=a[u++],1==--t){g=!0;break}p--}while(v>=i||m>=i);if(g)break;p<0&&(p=0),p+=2}if(this.minGallop=p,p<1&&(this.minGallop=1),1===t){for(h=0;h<o;h++)r[f+h]=r[c+h];r[f+o]=a[u]}else{if(0===t)throw new Error("mergeLow preconditions were not respected");for(h=0;h<t;h++)r[f+h]=a[u+h]}}else{for(h=0;h<o;h++)r[f+h]=r[c+h];r[f+o]=a[u]}else for(h=0;h<t;h++)r[f+h]=a[u+h]},e.prototype.mergeHigh=function(e,t,n,o){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<o;h++)a[h]=r[n+h];var u=e+t-1,c=o-1,f=n+o-1,p=0,v=0;if(r[f--]=r[u--],0!=--t)if(1!==o){for(var m=this.minGallop;;){var g=0,y=0,b=!1;do{if(s(a[c],r[u])<0){if(r[f--]=r[u--],g++,y=0,0==--t){b=!0;break}}else if(r[f--]=a[c--],y++,g=0,1==--o){b=!0;break}}while((g|y)<m);if(b)break;do{if(0!=(g=t-l(a[c],r,e,t,t-1,s))){for(t-=g,v=1+(f-=g),p=1+(u-=g),h=g-1;h>=0;h--)r[v+h]=r[p+h];if(0===t){b=!0;break}}if(r[f--]=a[c--],1==--o){b=!0;break}if(0!=(y=o-d(r[u],a,0,o,o-1,s))){for(o-=y,v=1+(f-=y),p=1+(c-=y),h=0;h<y;h++)r[v+h]=a[p+h];if(o<=1){b=!0;break}}if(r[f--]=r[u--],0==--t){b=!0;break}m--}while(g>=i||y>=i);if(b)break;m<0&&(m=0),m+=2}if(this.minGallop=m,m<1&&(this.minGallop=1),1===o){for(v=1+(f-=t),p=1+(u-=t),h=t-1;h>=0;h--)r[v+h]=r[p+h];r[f]=a[c]}else{if(0===o)throw new Error("mergeHigh preconditions were not respected");for(p=f-(o-1),h=0;h<o;h++)r[p+h]=a[h]}}else{for(v=1+(f-=t),p=1+(u-=t),h=t-1;h>=0;h--)r[v+h]=r[p+h];r[f]=a[c]}else for(p=f-(o-1),h=0;h<o;h++)r[p+h]=a[h]},e}()}(t)}));(kd=Pd)&&kd.__esModule&&Object.prototype.hasOwnProperty.call(kd,"default")&&kd.default;var Id=Pd,Fd=Id.sort,Nd=function(){function e(){na(this,e)}return sa(e,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(e){return this.fake_use(e),this.abstract()}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(e,t,i),this.abstract()}},{key:"getTreeSize",value:function(e){return this.fake_use(e),this.abstract()}},{key:"sort",value:function(e){this.fake_use(e),this.abstract()}},{key:"fix",value:function(e,t){this.fake_use(e,t),this.abstract()}},{key:"shift",value:function(e,t){this.fake_use(e,t),this.abstract()}}]),e}(),Yd=function(e){function t(e){var i;return na(this,t),(i=ca(this,la(t).call(this))).layout=e,i}return da(t,Nd),sa(t,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(e){return e.x}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.x=t}},{key:"getTreeSize",value:function(e){var t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_x,max:t.max_x}}},{key:"sort",value:function(e){Fd(e,(function(e,t){return e.x-t.x}))}},{key:"fix",value:function(e,t){e.y=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.y=!0}},{key:"shift",value:function(e,t){this.layout.body.nodes[e].x+=t}}]),t}(),Rd=function(e){function t(e){var i;return na(this,t),(i=ca(this,la(t).call(this))).layout=e,i}return da(t,Nd),sa(t,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(e){return e.y}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(e,i),e.y=t}},{key:"getTreeSize",value:function(e){var t=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,e);return{min:t.min_y,max:t.max_y}}},{key:"sort",value:function(e){Fd(e,(function(e,t){return e.y-t.y}))}},{key:"fix",value:function(e,t){e.x=this.layout.options.hierarchical.levelSeparation*t,e.options.fixed.x=!0}},{key:"shift",value:function(e,t){this.layout.body.nodes[e].y+=t}}]),t}();function jd(e,t){var i=new Set;return e.forEach((function(e){e.edges.forEach((function(e){e.connected&&i.add(e)}))})),i.forEach((function(e){var i=e.from.id,n=e.to.id;null==t[i]&&(t[i]=0),(null==t[n]||t[i]>=t[n])&&(t[n]=t[i]+1)})),t}function Ad(e,t,i,n,o){var s=n.length,r=i+"Id",a="to"===i?1:-1,h=!0,d=!1,l=void 0;try{for(var u,c=function(){var h=u.value;if(e(h))return"continue";o[h.id]=0;for(var d=[h],l=0,c=void 0,f=function(){var e=o[c.id]+a;if(c.edges.filter((function(e){return e.connected&&e.to!==e.from&&e[i]!==c})).forEach((function(n){var s=n[r],a=o[s];(null==a||t(e,a))&&(o[s]=e,d.push(n[i]))})),l>s)return{v:{v:jd(n,o)}};++l};c=d.pop();){var p=f();if("object"===ia(p))return p.v}},f=n[Symbol.iterator]();!(h=(u=f.next()).done);h=!0){var p=c();switch(p){case"continue":continue;default:if("object"===ia(p))return p.v}}}catch(e){d=!0,l=e}finally{try{h||null==f.return||f.return()}finally{if(d)throw l}}return o}var zd=function(){function e(){na(this,e),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return sa(e,[{key:"addRelation",value:function(e,t){void 0===this.childrenReference[e]&&(this.childrenReference[e]=[]),this.childrenReference[e].push(t),void 0===this.parentReference[t]&&(this.parentReference[t]=[]),this.parentReference[t].push(e)}},{key:"checkIfTree",value:function(){for(var e in this.parentReference)if(this.parentReference[e].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(e,t){void 0!==t&&void 0===this.trees[e.id]&&(this.trees[e.id]=t,this.treeIndex=Math.max(t,this.treeIndex))}},{key:"ensureLevel",value:function(e){void 0===this.levels[e]&&(this.levels[e]=0)}},{key:"getMaxLevel",value:function(e){var t=this,i={};return function e(n){if(void 0!==i[n])return i[n];var o=t.levels[n];if(t.childrenReference[n]){var s=t.childrenReference[n];if(s.length>0)for(var r=0;r<s.length;r++)o=Math.max(o,e(s[r]))}return i[n]=o,o}(e)}},{key:"levelDownstream",value:function(e,t){void 0===this.levels[t.id]&&(void 0===this.levels[e.id]&&(this.levels[e.id]=0),this.levels[t.id]=this.levels[e.id]+1)}},{key:"setMinLevelToZero",value:function(e){var t=1e9;for(var i in e)e.hasOwnProperty(i)&&void 0!==this.levels[i]&&(t=Math.min(this.levels[i],t));for(var n in e)e.hasOwnProperty(n)&&void 0!==this.levels[n]&&(this.levels[n]-=t)}},{key:"getTreeSize",value:function(e,t){var i=1e9,n=-1e9,o=1e9,s=-1e9;for(var r in this.trees)if(this.trees.hasOwnProperty(r)&&this.trees[r]===t){var a=e[r];i=Math.min(a.x,i),n=Math.max(a.x,n),o=Math.min(a.y,o),s=Math.max(a.y,s)}return{min_x:i,max_x:n,min_y:o,max_y:s}}},{key:"hasSameParent",value:function(e,t){var i=this.parentReference[e.id],n=this.parentReference[t.id];if(void 0===i||void 0===n)return!1;for(var o=0;o<i.length;o++)for(var s=0;s<n.length;s++)if(i[o]==n[s])return!0;return!1}},{key:"inSameSubNetwork",value:function(e,t){return this.trees[e.id]===this.trees[t.id]}},{key:"getLevels",value:function(){return Object.keys(this.distributionOrdering)}},{key:"addToOrdering",value:function(e,t){void 0===this.distributionOrdering[t]&&(this.distributionOrdering[t]=[]);var i=!1,n=this.distributionOrdering[t];for(var o in n)if(n[o]===e){i=!0;break}i||(this.distributionOrdering[t].push(e),this.distributionIndex[e.id]=this.distributionOrdering[t].length-1)}}]),e}(),Bd=function(){function e(t){na(this,e),this.body=t,this.initialRandomSeed=Math.round(1e6*Math.random()),this.randomSeed=this.initialRandomSeed,this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},ln(this.options,this.defaultOptions),this.bindEventListeners()}return sa(e,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("_dataChanged",(function(){e.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){e.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){e.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===e.options.hierarchical.enabled){var t=e.direction.curveType();e.body.emitter.emit("_forceDisableDynamicCurves",t,!1)}}))}},{key:"setOptions",value:function(e,t){if(void 0!==e){var i=this.options.hierarchical,n=i.enabled;if(cn(["randomSeed","improvedLayout","clusterThreshold"],this.options,e),Jn(this.options,e,"hierarchical"),void 0!==e.randomSeed&&(this.initialRandomSeed=e.randomSeed),!0===i.enabled)return!0===n&&this.body.emitter.emit("refresh",!0),"RL"===i.direction||"DU"===i.direction?i.levelSeparation>0&&(i.levelSeparation*=-1):i.levelSeparation<0&&(i.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(t);if(!0===n)return this.body.emitter.emit("refresh"),pn(t,this.optionsBackup)}return t}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(e){if(!0===this.options.hierarchical.enabled){var t=this.optionsBackup.physics;void 0===e.physics||!0===e.physics?(e.physics={enabled:void 0===t.enabled||t.enabled,solver:"hierarchicalRepulsion"},t.enabled=void 0===t.enabled||t.enabled,t.solver=t.solver||"barnesHut"):"object"===ia(e.physics)?(t.enabled=void 0===e.physics.enabled||e.physics.enabled,t.solver=e.physics.solver||"barnesHut",e.physics.solver="hierarchicalRepulsion"):!1!==e.physics&&(t.solver="barnesHut",e.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===e.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges={smooth:!1};else if(void 0===e.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges.smooth=!1;else if("boolean"==typeof e.edges.smooth)this.optionsBackup.edges={smooth:e.edges.smooth},e.edges.smooth={enabled:e.edges.smooth,type:i};else{var n=e.edges.smooth;void 0!==n.type&&"dynamic"!==n.type&&(i=n.type),this.optionsBackup.edges={smooth:void 0===n.enabled||n.enabled,type:void 0===n.type?"dynamic":n.type,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection},e.edges.smooth={enabled:void 0===n.enabled||n.enabled,type:i,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return e}},{key:"seededRandom",value:function(){var e=1e4*Math.sin(this.randomSeed++);return e-Math.floor(e)}},{key:"positionInitially",value:function(e){if(!0!==this.options.hierarchical.enabled){this.randomSeed=this.initialRandomSeed;for(var t=e.length+50,i=0;i<e.length;i++){var n=e[i],o=2*Math.PI*this.seededRandom();void 0===n.x&&(n.x=t*Math.cos(o)),void 0===n.y&&(n.y=t*Math.sin(o))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var e=this.body.nodeIndices,t=0,i=0;i<e.length;i++){!0===this.body.nodes[e[i]].predefinedPosition&&(t+=1)}if(t<.5*e.length){var n=0,o=this.options.clusterThreshold,s={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(e.length>o){for(var r=e.length;e.length>o&&n<=10;){n+=1;var a=e.length;if(n%3==0?this.body.modules.clustering.clusterBridges(s):this.body.modules.clustering.clusterOutliers(s),a==e.length&&n%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*r)})}n>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(e,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<e.length;h++){var d=this.body.nodes[e[h]];!1===d.predefinedPosition&&(d.x+=70*(.5-this.seededRandom()),d.y+=70*(.5-this.seededRandom()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var e=bd.getRangeCore(this.body.nodes,this.body.nodeIndices),t=bd.findCenter(e),i=0;i<this.body.nodeIndices.length;i++){var n=this.body.nodes[this.body.nodeIndices[i]];n.x-=t.x,n.y-=t.y}}},{key:"_declusterAll",value:function(){for(var e=!0;!0===e;){e=!1;for(var t=0;t<this.body.nodeIndices.length;t++)!0===this.body.nodes[this.body.nodeIndices[t]].isCluster&&(e=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[t],{},!1));!0===e&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var e,t,i=!1,n=!1;for(t in this.lastNodeOnLevel={},this.hierarchical=new zd,this.body.nodes)this.body.nodes.hasOwnProperty(t)&&(void 0!==(e=this.body.nodes[t]).options.level?(i=!0,this.hierarchical.levels[t]=e.options.level):n=!0);if(!0===n&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===n){var o=this.options.hierarchical.sortMethod;"hubsize"===o?this._determineLevelsByHubsize():"directed"===o?this._determineLevelsDirected():"custom"===o&&this._determineLevelsCustomCallback()}for(var s in this.body.nodes)this.body.nodes.hasOwnProperty(s)&&this.hierarchical.ensureLevel(s);var r=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(r),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var e=this,t=!1,i={},n=function(t,i){var n=e.hierarchical.trees;for(var o in n)n.hasOwnProperty(o)&&n[o]===t&&e.direction.shift(o,i)},o=function(){for(var t=[],i=0;i<e.hierarchical.numTrees();i++)t.push(e.direction.getTreeSize(i));return t},s=function t(i,n){if(!n[i.id]&&(n[i.id]=!0,e.hierarchical.childrenReference[i.id])){var o=e.hierarchical.childrenReference[i.id];if(o.length>0)for(var s=0;s<o.length;s++)t(e.body.nodes[o[s]],n)}},r=function(t){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,n=1e9,o=1e9,s=1e9,r=-1e9;for(var a in t)if(t.hasOwnProperty(a)){var h=e.body.nodes[a],d=e.hierarchical.levels[h.id],l=e.direction.getPosition(h),u=e._getSpaceAroundNode(h,t),c=va(u,2),f=c[0],p=c[1];n=Math.min(f,n),o=Math.min(p,o),d<=i&&(s=Math.min(l,s),r=Math.max(l,r))}return[s,r,n,o]},a=function(t,i){var n=e.hierarchical.getMaxLevel(t.id),o=e.hierarchical.getMaxLevel(i.id);return Math.min(n,o)},h=function(t,i,n){for(var o=e.hierarchical,s=0;s<i.length;s++){var r=i[s],a=o.distributionOrdering[r];if(a.length>1)for(var h=0;h<a.length-1;h++){var d=a[h],l=a[h+1];o.hasSameParent(d,l)&&o.inSameSubNetwork(d,l)&&t(d,l,n)}}},d=function(i,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=e.direction.getPosition(i),d=e.direction.getPosition(n),l=Math.abs(d-h),u=e.options.hierarchical.nodeSpacing;if(l>u){var c={},f={};s(i,c),s(n,f);var p=a(i,n),v=r(c,p),m=r(f,p),g=v[1],y=m[0],b=m[2],_=Math.abs(g-y);if(_>u){var w=g-y+u;w<-b+u&&(w=-b+u),w<0&&(e._shiftBlock(n.id,w),t=!0,!0===o&&e._centerParent(n))}}},l=function(n,o){for(var a=o.id,h=o.edges,d=e.hierarchical.levels[o.id],l=e.options.hierarchical.levelSeparation*e.options.hierarchical.levelSeparation,u={},c=[],f=0;f<h.length;f++){var p=h[f];if(p.toId!=p.fromId){var v=p.toId==a?p.from:p.to;u[h[f].id]=v,e.hierarchical.levels[v.id]<d&&c.push(p)}}var m=function(t,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==u[i[o].id]){var s=e.direction.getPosition(u[i[o].id])-t;n+=s/Math.sqrt(s*s+l)}return n},g=function(t,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==u[i[o].id]){var s=e.direction.getPosition(u[i[o].id])-t;n-=l*Math.pow(s*s+l,-1.5)}return n},y=function(t,i){for(var n=e.direction.getPosition(o),s={},r=0;r<t;r++){var a=m(n,i),h=g(n,i);if(void 0!==s[n-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;s[n]=r}return n},b=y(n,c);!function(n){var a=e.direction.getPosition(o);if(void 0===i[o.id]){var h={};s(o,h),i[o.id]=h}var d=r(i[o.id]),l=d[2],u=d[3],c=n-a,f=0;c>0?f=Math.min(c,u-e.options.hierarchical.nodeSpacing):c<0&&(f=-Math.min(-c,l-e.options.hierarchical.nodeSpacing)),0!=f&&(e._shiftBlock(o.id,f),t=!0)}(b),function(i){var n=e.direction.getPosition(o),s=va(e._getSpaceAroundNode(o),2),r=s[0],a=s[1],h=i-n,d=n;h>0?d=Math.min(n+(a-e.options.hierarchical.nodeSpacing),i):h<0&&(d=Math.max(n-(r-e.options.hierarchical.nodeSpacing),i)),d!==n&&(e.direction.setPosition(o,d),t=!0)}(b=y(n,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var n=e.hierarchical.getLevels();n=n.reverse();for(var o=0;o<i&&(t=!1,h(d,n,!0),!0===t);o++);}(5),function(){for(var t in e.body.nodes)e.body.nodes.hasOwnProperty(t)&&e._centerParent(e.body.nodes[t])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var n=e.hierarchical.getLevels();n=n.reverse();for(var o=0;o<i;o++){t=!1;for(var s=0;s<n.length;s++)for(var r=n[s],a=e.hierarchical.distributionOrdering[r],h=0;h<a.length;h++)l(1e3,a[h]);if(!0!==t)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var t=e.hierarchical.getLevels();t=t.reverse();for(var i=0;i<t.length;i++)for(var n=t[i],o=e.hierarchical.distributionOrdering[n],s=0;s<o.length;s++)e._centerParent(o[s])}(),function(){for(var t=o(),i=0,s=0;s<t.length-1;s++){i+=t[s].max-t[s+1].min+e.options.hierarchical.treeSpacing,n(s+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(e,t){var i=!0;void 0===t&&(i=!1);var n=this.hierarchical.levels[e.id];if(void 0!==n){var o=this.hierarchical.distributionIndex[e.id],s=this.direction.getPosition(e),r=this.hierarchical.distributionOrdering[n],a=1e9,h=1e9;if(0!==o){var d=r[o-1];if(!0===i&&void 0===t[d.id]||!1===i)a=s-this.direction.getPosition(d)}if(o!=r.length-1){var l=r[o+1];if(!0===i&&void 0===t[l.id]||!1===i){var u=this.direction.getPosition(l);h=Math.min(h,u-s)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(e){if(this.hierarchical.parentReference[e.id])for(var t=this.hierarchical.parentReference[e.id],i=0;i<t.length;i++){var n=t[i],o=this.body.nodes[n],s=this.hierarchical.childrenReference[n];if(void 0!==s){var r=this._getCenterPosition(s),a=this.direction.getPosition(o),h=va(this._getSpaceAroundNode(o),2),d=h[0],l=h[1],u=a-r;(u<0&&Math.abs(u)<l-this.options.hierarchical.nodeSpacing||u>0&&Math.abs(u)<d-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(o,r)}}}},{key:"_placeNodesByHierarchy",value:function(e){for(var t in this.positionedNodes={},e)if(e.hasOwnProperty(t)){var i=Object.keys(e[t]);i=this._indexArrayToNodes(i),this.direction.sort(i);for(var n=0,o=0;o<i.length;o++){var s=i[o];if(void 0===this.positionedNodes[s.id]){var r=this.options.hierarchical.nodeSpacing,a=r*n;n>0&&(a=this.direction.getPosition(i[o-1])+r),this.direction.setPosition(s,a,t),this._validatePositionAndContinue(s,t,a),n++}}}}},{key:"_placeBranchNodes",value:function(e,t){var i=this.hierarchical.childrenReference[e];if(void 0!==i){for(var n=[],o=0;o<i.length;o++)n.push(this.body.nodes[i[o]]);this.direction.sort(n);for(var s=0;s<n.length;s++){var r=n[s],a=this.hierarchical.levels[r.id];if(!(a>t&&void 0===this.positionedNodes[r.id]))return;var h=this.options.hierarchical.nodeSpacing,d=void 0;d=0===s?this.direction.getPosition(this.body.nodes[e]):this.direction.getPosition(n[s-1])+h,this.direction.setPosition(r,d,a),this._validatePositionAndContinue(r,a,d)}var l=this._getCenterPosition(n);this.direction.setPosition(this.body.nodes[e],l,t)}}},{key:"_validatePositionAndContinue",value:function(e,t,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[t]){var n=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[t]]);if(i-n<this.options.hierarchical.nodeSpacing){var o=n+this.options.hierarchical.nodeSpacing-i,s=this._findCommonParent(this.lastNodeOnLevel[t],e.id);this._shiftBlock(s.withChild,o)}}this.lastNodeOnLevel[t]=e.id,this.positionedNodes[e.id]=!0,this._placeBranchNodes(e.id,t)}}},{key:"_indexArrayToNodes",value:function(e){for(var t=[],i=0;i<e.length;i++)t.push(this.body.nodes[e[i]]);return t}},{key:"_getDistribution",value:function(){var e,t,i={};for(e in this.body.nodes)if(this.body.nodes.hasOwnProperty(e)){t=this.body.nodes[e];var n=void 0===this.hierarchical.levels[e]?0:this.hierarchical.levels[e];this.direction.fix(t,n),void 0===i[n]&&(i[n]={}),i[n][e]=t}return i}},{key:"_getActiveEdges",value:function(e){var t=this,i=[];return On(e.edges,(function(e){-1!==t.body.edgeIndices.indexOf(e.id)&&i.push(e)})),i}},{key:"_getHubSizes",value:function(){var e=this,t={};On(this.body.nodeIndices,(function(i){var n=e.body.nodes[i],o=e._getActiveEdges(n).length;t[o]=!0}));var i=[];return On(t,(function(e){i.push(Number(e))})),Id.sort(i,(function(e,t){return t-e})),i}},{key:"_determineLevelsByHubsize",value:function(){for(var e=this,t=function(t,i){e.hierarchical.levelDownstream(t,i)},i=this._getHubSizes(),n=function(n){var o=i[n];if(0===o)return"break";On(e.body.nodeIndices,(function(i){var n=e.body.nodes[i];o===e._getActiveEdges(n).length&&e._crawlNetwork(t,i)}))},o=0;o<i.length;++o){if("break"===n(o))break}}},{key:"_determineLevelsCustomCallback",value:function(){var e=this;this._crawlNetwork((function(t,i,n){var o=e.hierarchical.levels[t.id];void 0===o&&(o=e.hierarchical.levels[t.id]=1e5);var s=(bd.cloneOptions(t,"node"),bd.cloneOptions(i,"node"),void bd.cloneOptions(n,"edge"));e.hierarchical.levels[i.id]=o+s})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var e=this,t=this.body.nodeIndices.map((function(t){return e.body.nodes[t]}));this.hierarchical.levels;"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(e){return Ad((function(e){return!e.edges.every((function(t){return t.from===e}))}),(function(e,t){return t<e}),"to",e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:Object.create(null))}(t,this.hierarchical.levels):this.hierarchical.levels=function(e){return Ad((function(e){return!e.edges.every((function(t){return t.to===e}))}),(function(e,t){return t>e}),"from",e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:Object.create(null))}(t,this.hierarchical.levels),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var e=this;this._crawlNetwork((function(t,i){e.hierarchical.levels[i.id]>e.hierarchical.levels[t.id]&&e.hierarchical.addRelation(t.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var e=this,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,n={},o=function i(o,s){if(void 0===n[o.id]){var r;e.hierarchical.setTreeIndex(o,s),n[o.id]=!0;for(var a=e._getActiveEdges(o),h=0;h<a.length;h++){var d=a[h];!0===d.connected&&(r=d.toId==o.id?d.from:d.to,o.id!=r.id&&(t(o,r,d),i(r,s)))}}};if(void 0===i)for(var s=0,r=0;r<this.body.nodeIndices.length;r++){var a=this.body.nodeIndices[r];if(void 0===n[a]){var h=this.body.nodes[a];o(h,s),s+=1}}else{var d=this.body.nodes[i];if(void 0===d)return void console.error("Node not found:",i);o(d)}}},{key:"_shiftBlock",value:function(e,t){var i=this,n={};!function e(o){if(!n[o]){n[o]=!0,i.direction.shift(o,t);var s=i.hierarchical.childrenReference[o];if(void 0!==s)for(var r=0;r<s.length;r++)e(s[r])}}(e)}},{key:"_findCommonParent",value:function(e,t){var i=this,n={};return function e(t,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var s=0;s<o.length;s++){var r=o[s];t[r]=!0,e(t,r)}}(n,e),function e(t,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var s=0;s<o.length;s++){var r=o[s];if(void 0!==t[r])return{foundParent:r,withChild:n};var a=e(t,r);if(null!==a.foundParent)return a}return{foundParent:null,withChild:n}}(n,t)}},{key:"setDirectionStrategy",value:function(){var e="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=e?new Yd(this):new Rd(this)}},{key:"_getCenterPosition",value:function(e){for(var t=1e9,i=-1e9,n=0;n<e.length;n++){var o=void 0;if(void 0!==e[n].id)o=e[n];else{var s=e[n];o=this.body.nodes[s]}var r=this.direction.getPosition(o);t=Math.min(t,r),i=Math.max(i,r)}return.5*(t+i)}}]),e}(),Ld=function(){function e(t,i,n,o){var s=this;na(this,e),this.body=t,this.canvas=i,this.selectionHandler=n,this.interactionHandler=o,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this.manipulationHammers=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},ln(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){s._clean()})),this.body.emitter.on("_dataChanged",this._restore.bind(this)),this.body.emitter.on("_resetData",this._restore.bind(this))}return sa(e,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(e,t,i){void 0!==t&&(void 0!==t.locale?this.options.locale=t.locale:this.options.locale=i.locale,void 0!==t.locales?this.options.locales=t.locales:this.options.locales=i.locales),void 0!==e&&("boolean"==typeof e?this.options.enabled=e:(this.options.enabled=!0,pn(this.options,e)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var e=this.selectionHandler._getSelectedNodeCount(),t=this.selectionHandler._getSelectedEdgeCount(),i=e+t,n=this.options.locales[this.options.locale],o=!1;!1!==this.options.addNode&&(this._createAddNodeButton(n),o=!0),!1!==this.options.addEdge&&(!0===o?this._createSeperator(1):o=!0,this._createAddEdgeButton(n)),1===e&&"function"==typeof this.options.editNode?(!0===o?this._createSeperator(2):o=!0,this._createEditNodeButton(n)):1===t&&0===e&&!1!==this.options.editEdge&&(!0===o?this._createSeperator(3):o=!0,this._createEditEdgeButton(n)),0!==i&&(e>0&&!1!==this.options.deleteNode?(!0===o&&this._createSeperator(4),this._createDeleteButton(n)):0===e&&!1!==this.options.deleteEdge&&(!0===o&&this._createSeperator(4),this._createDeleteButton(n))),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this)),this._temporaryBindEvent("select",this.showManipulatorToolbar.bind(this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.addDescription||this.options.locales.en.addDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}this._temporaryBindEvent("click",this._performAddNode.bind(this))}},{key:"editNode",value:function(){var e=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var t=this.selectionHandler._getSelectedNode();if(void 0!==t){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==t.isCluster){var i=pn({},t.options,!1);if(i.x=t.x,i.y=t.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(i,(function(t){null!=t&&"editNode"===e.inMode&&e.body.data.nodes.getDataSet().update(t),e.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.edgeDescription||this.options.locales.en.edgeDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}this._temporaryBindUI("onTouch",this._handleConnect.bind(this)),this._temporaryBindUI("onDragEnd",this._finishConnect.bind(this)),this._temporaryBindUI("onDrag",this._dragControlNode.bind(this)),this._temporaryBindUI("onRelease",this._finishConnect.bind(this)),this._temporaryBindUI("onDragStart",this._dragStartEdge.bind(this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==ia(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindHammerToDiv(this.closeDiv,this.toggleEditMode.bind(this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0!==this.edgeBeingEditedId){var t=this.body.edges[this.edgeBeingEditedId],i=this._getNewTargetNode(t.from.x,t.from.y),n=this._getNewTargetNode(t.to.x,t.to.y);this.temporaryIds.nodes.push(i.id),this.temporaryIds.nodes.push(n.id),this.body.nodes[i.id]=i,this.body.nodeIndices.push(i.id),this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id),this._temporaryBindUI("onTouch",this._controlNodeTouch.bind(this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",this._controlNodeDragStart.bind(this)),this._temporaryBindUI("onDrag",this._controlNodeDrag.bind(this)),this._temporaryBindUI("onDragEnd",this._controlNodeDragEnd.bind(this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(e){var o=t.edgeType.findBorderPositions(e);!1===i.selected&&(i.x=o.from.x,i.y=o.from.y),!1===n.selected&&(n.x=o.to.x,n.y=o.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var o=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(o.from.id,o.to.id)}}},{key:"deleteSelected",value:function(){var e=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var t=this.selectionHandler.getSelectedNodes(),i=this.selectionHandler.getSelectedEdges(),n=void 0;if(t.length>0){for(var o=0;o<t.length;o++)if(!0===this.body.nodes[t[o]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(n=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(n=this.options.deleteEdge);if("function"==typeof n){var s={nodes:t,edges:i};if(2!==n.length)throw new Error("The function for delete does not support two arguments (data, callback)");n(s,(function(t){null!=t&&"delete"===e.inMode?(e.body.data.edges.getDataSet().remove(t.edges),e.body.data.nodes.getDataSet().remove(t.nodes),e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar()):(e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(t),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv&&(this.closeDiv=document.createElement("div"),this.closeDiv.className="vis-close",this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(e,t){var i=pn({},this.options.controlNodeStyle);i.id="targetNode"+Xi(),i.hidden=!1,i.physics=!1,i.x=e,i.y=t;var n=this.body.functions.createNode(i);return n.shape.boundingBox={left:e,right:e,top:t,bottom:t},n}},{key:"_createEditButton",value:function(){this._clean(),this.manipulationDOM={},nn(this.editModeDiv);var e=this.options.locales[this.options.locale],t=this._createButton("editMode","vis-button vis-edit vis-edit-mode",e.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(t),this._bindHammerToDiv(t,this.toggleEditMode.bind(this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(nn(this.editModeDiv),nn(this.manipulationDiv),this._cleanManipulatorHammers()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanManipulatorHammers",value:function(){if(0!=this.manipulationHammers.length){for(var e=0;e<this.manipulationHammers.length;e++)this.manipulationHammers[e].destroy();this.manipulationHammers=[]}}},{key:"_removeManipulationDOM",value:function(){this._clean(),nn(this.manipulationDiv),nn(this.editModeDiv),nn(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+e]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+e].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+e])}},{key:"_createAddNodeButton",value:function(e){var t=this._createButton("addNode","vis-button vis-add",e.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.addNodeMode.bind(this))}},{key:"_createAddEdgeButton",value:function(e){var t=this._createButton("addEdge","vis-button vis-connect",e.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.addEdgeMode.bind(this))}},{key:"_createEditNodeButton",value:function(e){var t=this._createButton("editNode","vis-button vis-edit",e.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.editNode.bind(this))}},{key:"_createEditEdgeButton",value:function(e){var t=this._createButton("editEdge","vis-button vis-edit",e.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.editEdgeMode.bind(this))}},{key:"_createDeleteButton",value:function(e){var t;t=this.options.rtl?"vis-button vis-delete-rtl":"vis-button vis-delete";var i=this._createButton("delete",t,e.del||this.options.locales.en.del);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,this.deleteSelected.bind(this))}},{key:"_createBackButton",value:function(e){var t=this._createButton("back","vis-button vis-back",e.back||this.options.locales.en.back);this.manipulationDiv.appendChild(t),this._bindHammerToDiv(t,this.showManipulatorToolbar.bind(this))}},{key:"_createButton",value:function(e,t,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[e+"Div"]=document.createElement("div"),this.manipulationDOM[e+"Div"].className=t,this.manipulationDOM[e+"Label"]=document.createElement("div"),this.manipulationDOM[e+"Label"].className=n,this.manipulationDOM[e+"Label"].innerHTML=i,this.manipulationDOM[e+"Div"].appendChild(this.manipulationDOM[e+"Label"]),this.manipulationDOM[e+"Div"]}},{key:"_createDescription",value:function(e){this.manipulationDiv.appendChild(this._createButton("description","vis-button vis-none",e))}},{key:"_temporaryBindEvent",value:function(e,t){this.temporaryEventFunctions.push({event:e,boundFunction:t}),this.body.emitter.on(e,t)}},{key:"_temporaryBindUI",value:function(e,t){if(void 0===this.body.eventListeners[e])throw new Error("This UI function does not exist. Typo? You tried: "+e+" possible are: "+JSON.stringify(Object.keys(this.body.eventListeners)));this.temporaryUIFunctions[e]=this.body.eventListeners[e],this.body.eventListeners[e]=t}},{key:"_unbindTemporaryUIs",value:function(){for(var e in this.temporaryUIFunctions)this.temporaryUIFunctions.hasOwnProperty(e)&&(this.body.eventListeners[e]=this.temporaryUIFunctions[e],delete this.temporaryUIFunctions[e]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var e=0;e<this.temporaryEventFunctions.length;e++){var t=this.temporaryEventFunctions[e].event,i=this.temporaryEventFunctions[e].boundFunction;this.body.emitter.off(t,i)}this.temporaryEventFunctions=[]}},{key:"_bindHammerToDiv",value:function(e,t){var i=new Kr(e,{});Sd.onTouch(i,t),this.manipulationHammers.push(i)}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var e=0;e<this.temporaryIds.edges.length;e++){this.body.edges[this.temporaryIds.edges[e]].disconnect(),delete this.body.edges[this.temporaryIds.edges[e]];var t=this.body.edgeIndices.indexOf(this.temporaryIds.edges[e]);-1!==t&&this.body.edgeIndices.splice(t,1)}for(var i=0;i<this.temporaryIds.nodes.length;i++){delete this.body.nodes[this.temporaryIds.nodes[i]];var n=this.body.nodeIndices.indexOf(this.temporaryIds.nodes[i]);-1!==n&&this.body.nodeIndices.splice(n,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(e){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=ln({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(e){var t=this.lastTouch,i=this.selectionHandler._pointerToPositionObject(t),n=this.body.nodes[this.temporaryIds.nodes[0]],o=this.body.nodes[this.temporaryIds.nodes[1]],s=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var r=n.isOverlappingWith(i),a=o.isOverlappingWith(i);!0===r?(this.selectedControlNode=n,s.edgeType.from=n):!0===a&&(this.selectedControlNode=o,s.edgeType.to=o),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(e){this.body.emitter.emit("disablePhysics");var t=this.body.functions.getPointer(e.center),i=this.canvas.DOMtoCanvas(t);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(e),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),n=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=o.length-1;r>=0;r--)if(o[r]!==this.selectedControlNode.id){s=this.body.nodes[o[r]];break}if(void 0!==s&&void 0!==this.selectedControlNode)if(!0===s.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(s.id,n.to.id):this._performEditEdge(n.from.id,s.id)}else n.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(e){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=ln({},this.body.view.translation);var t=this.lastTouch,i=this.selectionHandler.getNodeAt(t);if(void 0!==i)if(!0===i.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var n=this._getNewTargetNode(i.x,i.y);this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id);var o=this.body.functions.createEdge({id:"connectionEdge"+Xi(),from:i.id,to:n.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[o.id]=o,this.body.edgeIndices.push(o.id),this.temporaryIds.nodes.push(n.id),this.temporaryIds.edges.push(o.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=o.length-1;r>=0;r--)if(-1===this.temporaryIds.nodes.indexOf(o[r])){s=this.body.nodes[o[r]];break}if(e.controlEdge={from:n,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragging",e,t),void 0!==this.temporaryIds.nodes[0]){var a=this.body.nodes[this.temporaryIds.nodes[0]];a.x=this.canvas._XconvertDOMtoCanvas(t.x),a.y=this.canvas._YconvertDOMtoCanvas(t.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(e)}},{key:"_finishConnect",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=o.length-1;r>=0;r--)if(-1===this.temporaryIds.nodes.indexOf(o[r])){s=this.body.nodes[o[r]];break}this._cleanupTemporaryNodesAndEdges(),void 0!==s&&(!0===s.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[n]&&void 0!==this.body.nodes[s.id]&&this._performAddEdge(n,s.id)),e.controlEdge={from:n,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragEnd",e,t),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(e){var t=this.lastTouch;this.selectionHandler._generateClickEvent("dragStart",e,t,void 0,!0)}},{key:"_performAddNode",value:function(e){var t=this,i={id:Xi(),x:e.pointer.canvas.x,y:e.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(i,(function(e){null!=e&&"addNode"===t.inMode&&t.body.data.nodes.getDataSet().add(e),t.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(i),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(e,t){var i=this,n={from:e,to:t};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(n,(function(e){null!=e&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(e),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(e,t){var i=this,n={id:this.edgeBeingEditedId,from:e,to:t,label:this.body.data.edges._data[this.edgeBeingEditedId].label},o=this.options.editEdge;if("object"===ia(o)&&(o=o.editWithoutDrag),"function"==typeof o){if(2!==o.length)throw new Error("The function for edit does not support two arguments (data, callback)");o(n,(function(e){null==e||"editEdge"!==i.inMode?(i.body.edges[n.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(e),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),e}(),Hd={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},Wd=function(){function e(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;na(this,e),this.pixelRatio=t,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return sa(e,[{key:"insertTo",value:function(e){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=e,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=e}},{key:"setCloseCallback",value:function(e){if("function"!=typeof e)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=e}},{key:"_isColorString",value:function(e){if("string"==typeof e)return Hd[e]}},{key:"setColor",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==e){var i,n=this._isColorString(e);if(void 0!==n&&(e=n),!0===on(e)){if(!0===qn(e)){var o=e.substr(4).substr(0,e.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===Zn(e)){var s=e.substr(5).substr(0,e.length-6).split(",");i={r:s[0],g:s[1],b:s[2],a:s[3]}}else if(!0===Gn(e)){var r=Yn(e);i={r:r.r,g:r.g,b:r.b,a:1}}}else if(e instanceof Object&&void 0!==e.r&&void 0!==e.g&&void 0!==e.b){var a=void 0!==e.a?e.a:"1.0";i={r:e.r,g:e.g,b:e.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+JSON.stringify(e));this._setColor(i,t)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var e=this,t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===t&&(this.previousColor=ln({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",setTimeout((function(){void 0!==e.closeCallback&&(e.closeCallback(),e.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===t&&(this.initialColor=ln({},e)),this.color=e;var i=zn(e.r,e.g,e.b),n=2*Math.PI,o=this.r*i.s,s=this.centerCoordinates.x+o*Math.sin(n*i.h),r=this.centerCoordinates.y+o*Math.cos(n*i.h);this.colorPickerSelector.style.left=s-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=r-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(e)}},{key:"_setOpacity",value:function(e){this.color.a=e/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(e){var t=zn(this.color.r,this.color.g,this.color.b);t.v=e/100;var i=Wn(t.h,t.s,t.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,t=zn(e.r,e.g,e.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-t.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),i.fill(),this.brightnessRange.value=100*t.v,this.opacityRange.value=100*e.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var e=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(t)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(e){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(e){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var i=this;this.opacityRange.onchange=function(){i._setOpacity(this.value)},this.opacityRange.oninput=function(){i._setOpacity(this.value)},this.brightnessRange.onchange=function(){i._setBrightness(this.value)},this.brightnessRange.oninput=function(){i._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=this._hide.bind(this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=this._apply.bind(this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=this._save.bind(this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=this._loadLast.bind(this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var e=this;this.drag={},this.pinch={},this.hammer=new Kr(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),Sd.onTouch(this.hammer,(function(t){e._moveSelector(t)})),this.hammer.on("tap",(function(t){e._moveSelector(t)})),this.hammer.on("panstart",(function(t){e._moveSelector(t)})),this.hammer.on("panmove",(function(t){e._moveSelector(t)})),this.hammer.on("panend",(function(t){e._moveSelector(t)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var e=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)),e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var t,i,n,o,s=this.colorPickerCanvas.clientWidth,r=this.colorPickerCanvas.clientHeight;e.clearRect(0,0,s,r),this.centerCoordinates={x:.5*s,y:.5*r},this.r=.49*s;var a,h=2*Math.PI/360,d=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)t=this.centerCoordinates.x+o*Math.sin(h*n),i=this.centerCoordinates.y+o*Math.cos(h*n),a=Wn(n*(1/360),o*d,1),e.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",e.fillRect(t-.5,i-.5,2,2);e.strokeStyle="rgba(0,0,0,1)",e.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),e.stroke(),this.hueCircle=e.getImageData(0,0,s,r)}this.generated=!0}},{key:"_moveSelector",value:function(e){var t=this.colorPickerDiv.getBoundingClientRect(),i=e.center.x-t.left,n=e.center.y-t.top,o=.5*this.colorPickerDiv.clientHeight,s=.5*this.colorPickerDiv.clientWidth,r=i-s,a=n-o,h=Math.atan2(r,a),d=.98*Math.min(Math.sqrt(r*r+a*a),s),l=Math.cos(h)*d+o,u=Math.sin(h)*d+s;this.colorPickerSelector.style.top=l-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=u-.5*this.colorPickerSelector.clientWidth+"px";var c=h/(2*Math.PI);c=c<0?c+1:c;var f=d/this.r,p=zn(this.color.r,this.color.g,this.color.b);p.h=c,p.s=f;var v=Wn(p.h,p.s,p.v);v.a=this.color.a,this.color=v,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),e}(),Vd=function(){function e(t,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;na(this,e),this.parent=t,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},ln(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Wd(o),this.wrapper=void 0}return sa(e,[{key:"setOptions",value:function(e){if(void 0!==e){this.popupHistory={},this._removePopup();var t=!0;if("string"==typeof e)this.options.filter=e;else if(e instanceof Array)this.options.filter=e.join();else if("object"===ia(e)){if(null==e)throw new TypeError("options cannot be null");void 0!==e.container&&(this.options.container=e.container),void 0!==e.filter&&(this.options.filter=e.filter),void 0!==e.showButton&&(this.options.showButton=e.showButton),void 0!==e.enabled&&(t=e.enabled)}else"boolean"==typeof e?(this.options.filter=!0,t=e):"function"==typeof e&&(this.options.filter=e,t=!0);!1===this.options.filter&&(t=!1),this.options.enabled=t}this._clean()}},{key:"setModuleOptions",value:function(e){this.moduleOptions=e,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var e=this.options.filter,t=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof e?i=(i=e(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==e&&-1===e.indexOf(n)||(i=!0),!1!==i&&(this.allowCreation=!0,t>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),t++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var e=0;e<this.domElements.length;e++)this.wrapper.appendChild(this.domElements[e]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var e=0;e<this.domElements.length;e++)this.wrapper.removeChild(this.domElements[e]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(e){for(var t=this.moduleOptions,i=0;i<e.length;i++){if(void 0===t[e[i]]){t=void 0;break}t=t[e[i]]}return t}},{key:"_makeItem",value:function(e){if(!0===this.allowCreation){var t=document.createElement("div");t.className="vis-configuration vis-config-item vis-config-s"+e.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return n.forEach((function(e){t.appendChild(e)})),this.domElements.push(t),this.domElements.length}return 0}},{key:"_makeHeader",value:function(e){var t=document.createElement("div");t.className="vis-configuration vis-config-header",t.innerHTML=e,this._makeItem([],t)}},{key:"_makeLabel",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+t.length,n.innerHTML=!0===i?"<i><b>"+e+":</b></i>":e+":",n}},{key:"_makeDropdown",value:function(e,t,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==t&&-1!==e.indexOf(t)&&(o=e.indexOf(t));for(var s=0;s<e.length;s++){var r=document.createElement("option");r.value=e[s],s===o&&(r.selected="selected"),r.innerHTML=e[s],n.appendChild(r)}var a=this;n.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,n)}},{key:"_makeRange",value:function(e,t,i){var n=e[0],o=e[1],s=e[2],r=e[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=s}catch(e){}a.step=r;var h="",d=0;if(void 0!==t){t<0&&1.2*t<o?(a.min=Math.ceil(1.2*t),d=a.min,h="range increased"):t/1.2<o&&(a.min=Math.ceil(t/1.2),d=a.min,h="range increased"),1.2*t>s&&1!==s&&(a.max=Math.ceil(1.2*t),d=a.max,h="range increased"),a.value=t}else a.value=n;var l=document.createElement("input");l.className="vis-configuration vis-config-rangeinput",l.value=a.value;var u=this;a.onchange=function(){l.value=this.value,u._update(Number(this.value),i)},a.oninput=function(){l.value=this.value};var c=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,c,a,l);""!==h&&this.popupHistory[f]!==d&&(this.popupHistory[f]=d,this._setupPopup(h,f))}},{key:"_makeButton",value:function(){var e=this;if(!0===this.options.showButton){var t=document.createElement("div");t.className="vis-configuration vis-config-button",t.innerHTML="generate options",t.onclick=function(){e._printOptions()},t.onmouseover=function(){t.className="vis-configuration vis-config-button hover"},t.onmouseout=function(){t.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(t)}}},{key:"_setupPopup",value:function(e,t){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=e,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:t}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var e=this;if(void 0!==this.popupDiv.html){var t=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=t.left+"px",this.popupDiv.html.style.top=t.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=setTimeout((function(){e.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=setTimeout((function(){e._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(e,t,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=e,void 0!==t&&(n.checked=t,t!==e&&("object"===ia(e)?t!==e.enabled&&this.changedOptions.push({path:i,value:t}):this.changedOptions.push({path:i,value:t})));var o=this;n.onchange=function(){o._update(this.checked,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,n)}},{key:"_makeTextInput",value:function(e,t,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=t,t!==e&&this.changedOptions.push({path:i,value:t});var o=this;n.onchange=function(){o._update(this.value,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,n)}},{key:"_makeColorField",value:function(e,t,i){var n=this,o=e[1],s=document.createElement("div");"none"!==(t=void 0===t?o:t)?(s.className="vis-configuration vis-config-colorBlock",s.style.backgroundColor=t):s.className="vis-configuration vis-config-colorBlock none",t=void 0===t?o:t,s.onclick=function(){n._showColorPicker(t,s,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,s)}},{key:"_showColorPicker",value:function(e,t,i){var n=this;t.onclick=function(){},this.colorPicker.insertTo(t),this.colorPicker.show(),this.colorPicker.setColor(e),this.colorPicker.setUpdateCallback((function(e){var o="rgba("+e.r+","+e.g+","+e.b+","+e.a+")";t.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){t.onclick=function(){n._showColorPicker(e,t,i)}}))}},{key:"_handleObject",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=this.options.filter,s=!1;for(var r in e)if(e.hasOwnProperty(r)){n=!0;var a=e[r],h=yn(t,r);if("function"==typeof o&&!1===(n=o(r,t))&&!(a instanceof Array)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,h,!0),this.allowCreation=!1===i),!1!==n){s=!0;var d=this._getValue(h);if(a instanceof Array)this._handleArray(a,d,h);else if("string"==typeof a)this._makeTextInput(a,d,h);else if("boolean"==typeof a)this._makeCheckbox(a,d,h);else if(a instanceof Object){var l=!0;if(-1!==t.indexOf("physics")&&this.moduleOptions.physics.solver!==r&&(l=!1),!0===l)if(void 0!==a.enabled){var u=yn(h,"enabled"),c=this._getValue(u);if(!0===c){var f=this._makeLabel(r,h,!0);this._makeItem(h,f),s=this._handleObject(a,h)||s}else this._makeCheckbox(a,c,h)}else{var p=this._makeLabel(r,h,!0);this._makeItem(h,p),s=this._handleObject(a,h)||s}}else console.error("dont know how to handle",a,r,h)}}return s}},{key:"_handleArray",value:function(e,t,i){"string"==typeof e[0]&&"color"===e[0]?(this._makeColorField(e,t,i),e[1]!==t&&this.changedOptions.push({path:i,value:t})):"string"==typeof e[0]?(this._makeDropdown(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:t})):"number"==typeof e[0]&&(this._makeRange(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:Number(t)}))}},{key:"_update",value:function(e,t){var i=this._constructOptions(e,t);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;e="false"!==(e="true"===e||e)&&e;for(var o=0;o<t.length;o++)"global"!==t[o]&&(void 0===n[t[o]]&&(n[t[o]]={}),o!==t.length-1?n=n[t[o]]:n[t[o]]=e);return i}},{key:"_printOptions",value:function(){var e=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+JSON.stringify(e,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var e={},t=0;t<this.changedOptions.length;t++)this._constructOptions(this.changedOptions[t].value,this.changedOptions[t].path,e);return e}}]),e}(),Ud="string",Gd="boolean",qd="number",Zd="object",Xd=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],$d={configure:{enabled:{boolean:Gd},filter:{boolean:Gd,string:Ud,array:"array",function:"function"},container:{dom:"dom"},showButton:{boolean:Gd},__type__:{object:Zd,boolean:Gd,string:Ud,array:"array",function:"function"}},edges:{arrows:{to:{enabled:{boolean:Gd},scaleFactor:{number:qd},type:{string:Xd},imageHeight:{number:qd},imageWidth:{number:qd},src:{string:Ud},__type__:{object:Zd,boolean:Gd}},middle:{enabled:{boolean:Gd},scaleFactor:{number:qd},type:{string:Xd},imageWidth:{number:qd},imageHeight:{number:qd},src:{string:Ud},__type__:{object:Zd,boolean:Gd}},from:{enabled:{boolean:Gd},scaleFactor:{number:qd},type:{string:Xd},imageWidth:{number:qd},imageHeight:{number:qd},src:{string:Ud},__type__:{object:Zd,boolean:Gd}},__type__:{string:["from","to","middle"],object:Zd}},arrowStrikethrough:{boolean:Gd},background:{enabled:{boolean:Gd},color:{string:Ud},size:{number:qd},dashes:{boolean:Gd,array:"array"},__type__:{object:Zd,boolean:Gd}},chosen:{label:{boolean:Gd,function:"function"},edge:{boolean:Gd,function:"function"},__type__:{object:Zd,boolean:Gd}},color:{color:{string:Ud},highlight:{string:Ud},hover:{string:Ud},inherit:{string:["from","to","both"],boolean:Gd},opacity:{number:qd},__type__:{object:Zd,string:Ud}},dashes:{boolean:Gd,array:"array"},font:{color:{string:Ud},size:{number:qd},face:{string:Ud},background:{string:Ud},strokeWidth:{number:qd},strokeColor:{string:Ud},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:qd},multi:{boolean:Gd,string:Ud},bold:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},boldital:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},ital:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},mono:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},__type__:{object:Zd,string:Ud}},hidden:{boolean:Gd},hoverWidth:{function:"function",number:qd},label:{string:Ud,undefined:"undefined"},labelHighlightBold:{boolean:Gd},length:{number:qd,undefined:"undefined"},physics:{boolean:Gd},scaling:{min:{number:qd},max:{number:qd},label:{enabled:{boolean:Gd},min:{number:qd},max:{number:qd},maxVisible:{number:qd},drawThreshold:{number:qd},__type__:{object:Zd,boolean:Gd}},customScalingFunction:{function:"function"},__type__:{object:Zd}},selectionWidth:{function:"function",number:qd},selfReferenceSize:{number:qd},shadow:{enabled:{boolean:Gd},color:{string:Ud},size:{number:qd},x:{number:qd},y:{number:qd},__type__:{object:Zd,boolean:Gd}},smooth:{enabled:{boolean:Gd},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:qd},forceDirection:{string:["horizontal","vertical","none"],boolean:Gd},__type__:{object:Zd,boolean:Gd}},title:{string:Ud,undefined:"undefined"},width:{number:qd},widthConstraint:{maximum:{number:qd},__type__:{object:Zd,boolean:Gd,number:qd}},value:{number:qd,undefined:"undefined"},__type__:{object:Zd}},groups:{useDefaultGroups:{boolean:Gd},__any__:"get from nodes, will be overwritten below",__type__:{object:Zd}},interaction:{dragNodes:{boolean:Gd},dragView:{boolean:Gd},hideEdgesOnDrag:{boolean:Gd},hideEdgesOnZoom:{boolean:Gd},hideNodesOnDrag:{boolean:Gd},hover:{boolean:Gd},keyboard:{enabled:{boolean:Gd},speed:{x:{number:qd},y:{number:qd},zoom:{number:qd},__type__:{object:Zd}},bindToWindow:{boolean:Gd},__type__:{object:Zd,boolean:Gd}},multiselect:{boolean:Gd},navigationButtons:{boolean:Gd},selectable:{boolean:Gd},selectConnectedEdges:{boolean:Gd},hoverConnectedEdges:{boolean:Gd},tooltipDelay:{number:qd},zoomView:{boolean:Gd},zoomSpeed:{number:qd},__type__:{object:Zd}},layout:{randomSeed:{undefined:"undefined",number:qd},improvedLayout:{boolean:Gd},clusterThreshold:{number:qd},hierarchical:{enabled:{boolean:Gd},levelSeparation:{number:qd},nodeSpacing:{number:qd},treeSpacing:{number:qd},blockShifting:{boolean:Gd},edgeMinimization:{boolean:Gd},parentCentralization:{boolean:Gd},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:Zd,boolean:Gd}},__type__:{object:Zd}},manipulation:{enabled:{boolean:Gd},initiallyActive:{boolean:Gd},addNode:{boolean:Gd,function:"function"},addEdge:{boolean:Gd,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:Zd,boolean:Gd,function:"function"}},deleteNode:{boolean:Gd,function:"function"},deleteEdge:{boolean:Gd,function:"function"},controlNodeStyle:"get from nodes, will be overwritten below",__type__:{object:Zd,boolean:Gd}},nodes:{borderWidth:{number:qd},borderWidthSelected:{number:qd,undefined:"undefined"},brokenImage:{string:Ud,undefined:"undefined"},chosen:{label:{boolean:Gd,function:"function"},node:{boolean:Gd,function:"function"},__type__:{object:Zd,boolean:Gd}},color:{border:{string:Ud},background:{string:Ud},highlight:{border:{string:Ud},background:{string:Ud},__type__:{object:Zd,string:Ud}},hover:{border:{string:Ud},background:{string:Ud},__type__:{object:Zd,string:Ud}},__type__:{object:Zd,string:Ud}},fixed:{x:{boolean:Gd},y:{boolean:Gd},__type__:{object:Zd,boolean:Gd}},font:{align:{string:Ud},color:{string:Ud},size:{number:qd},face:{string:Ud},background:{string:Ud},strokeWidth:{number:qd},strokeColor:{string:Ud},vadjust:{number:qd},multi:{boolean:Gd,string:Ud},bold:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},boldital:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},ital:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},mono:{color:{string:Ud},size:{number:qd},face:{string:Ud},mod:{string:Ud},vadjust:{number:qd},__type__:{object:Zd,string:Ud}},__type__:{object:Zd,string:Ud}},group:{string:Ud,number:qd,undefined:"undefined"},heightConstraint:{minimum:{number:qd},valign:{string:Ud},__type__:{object:Zd,boolean:Gd,number:qd}},hidden:{boolean:Gd},icon:{face:{string:Ud},code:{string:Ud},size:{number:qd},color:{string:Ud},weight:{string:Ud,number:qd},__type__:{object:Zd}},id:{string:Ud,number:qd},image:{selected:{string:Ud,undefined:"undefined"},unselected:{string:Ud,undefined:"undefined"},__type__:{object:Zd,string:Ud}},imagePadding:{top:{number:qd},right:{number:qd},bottom:{number:qd},left:{number:qd},__type__:{object:Zd,number:qd}},label:{string:Ud,undefined:"undefined"},labelHighlightBold:{boolean:Gd},level:{number:qd,undefined:"undefined"},margin:{top:{number:qd},right:{number:qd},bottom:{number:qd},left:{number:qd},__type__:{object:Zd,number:qd}},mass:{number:qd},physics:{boolean:Gd},scaling:{min:{number:qd},max:{number:qd},label:{enabled:{boolean:Gd},min:{number:qd},max:{number:qd},maxVisible:{number:qd},drawThreshold:{number:qd},__type__:{object:Zd,boolean:Gd}},customScalingFunction:{function:"function"},__type__:{object:Zd}},shadow:{enabled:{boolean:Gd},color:{string:Ud},size:{number:qd},x:{number:qd},y:{number:qd},__type__:{object:Zd,boolean:Gd}},shape:{string:["ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},shapeProperties:{borderDashes:{boolean:Gd,array:"array"},borderRadius:{number:qd},interpolation:{boolean:Gd},useImageSize:{boolean:Gd},useBorderWithImage:{boolean:Gd},__type__:{object:Zd}},size:{number:qd},title:{string:Ud,dom:"dom",undefined:"undefined"},value:{number:qd,undefined:"undefined"},widthConstraint:{minimum:{number:qd},maximum:{number:qd},__type__:{object:Zd,boolean:Gd,number:qd}},x:{number:qd},y:{number:qd},__type__:{object:Zd}},physics:{enabled:{boolean:Gd},barnesHut:{gravitationalConstant:{number:qd},centralGravity:{number:qd},springLength:{number:qd},springConstant:{number:qd},damping:{number:qd},avoidOverlap:{number:qd},__type__:{object:Zd}},forceAtlas2Based:{gravitationalConstant:{number:qd},centralGravity:{number:qd},springLength:{number:qd},springConstant:{number:qd},damping:{number:qd},avoidOverlap:{number:qd},__type__:{object:Zd}},repulsion:{centralGravity:{number:qd},springLength:{number:qd},springConstant:{number:qd},nodeDistance:{number:qd},damping:{number:qd},__type__:{object:Zd}},hierarchicalRepulsion:{centralGravity:{number:qd},springLength:{number:qd},springConstant:{number:qd},nodeDistance:{number:qd},damping:{number:qd},avoidOverlap:{number:qd},__type__:{object:Zd}},maxVelocity:{number:qd},minVelocity:{number:qd},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:Gd},iterations:{number:qd},updateInterval:{number:qd},onlyDynamicEdges:{boolean:Gd},fit:{boolean:Gd},__type__:{object:Zd,boolean:Gd}},timestep:{number:qd},adaptiveTimestep:{boolean:Gd},__type__:{object:Zd,boolean:Gd}},autoResize:{boolean:Gd},clickToUse:{boolean:Gd},locale:{string:Ud},locales:{__any__:{any:"any"},__type__:{object:Zd}},height:{string:Ud},width:{string:Ud},__type__:{object:Zd}};$d.groups.__any__=$d.nodes,$d.manipulation.controlNodeStyle=$d.nodes;var Kd={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,1,1,1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01]}},Jd=Object.freeze({__proto__:null,allOptions:$d,configureOptions:Kd}),Qd=function(){function e(){na(this,e)}return sa(e,[{key:"getDistances",value:function(e,t,i){for(var n={},o=e.edges,s=0;s<t.length;s++){var r={};n[t[s]]=r;for(var a=0;a<t.length;a++)r[t[a]]=s==a?0:1e9}for(var h=0;h<i.length;h++){var d=o[i[h]];!0===d.connected&&void 0!==n[d.fromId]&&void 0!==n[d.toId]&&(n[d.fromId][d.toId]=1,n[d.toId][d.fromId]=1)}for(var l=t.length,u=0;u<l;u++)for(var c=t[u],f=n[c],p=0;p<l-1;p++)for(var v=t[p],m=n[v],g=p+1;g<l;g++){var y=t[g],b=n[y],_=Math.min(m[y],m[c]+f[y]);m[y]=_,b[v]=_}return n}}]),e}(),el=function(){function e(t,i,n){na(this,e),this.body=t,this.springLength=i,this.springConstant=n,this.distanceSolver=new Qd}return sa(e,[{key:"setOptions",value:function(e){e&&(e.springLength&&(this.springLength=e.springLength),e.springConstant&&(this.springConstant=e.springConstant))}},{key:"solve",value:function(e,t){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=this.distanceSolver.getDistances(this.body,e,t);this._createL_matrix(n),this._createK_matrix(n),this._createE_matrix();for(var o=.01,s=1,r=0,a=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),h=5,d=1e9,l=0,u=0,c=0,f=0,p=0;d>o&&r<a;){r+=1;var v=this._getHighestEnergyNode(i),m=va(v,4);for(l=m[0],d=m[1],u=m[2],c=m[3],f=d,p=0;f>s&&p<h;){p+=1,this._moveNode(l,u,c);var g=this._getEnergy(l),y=va(g,3);f=y[0],u=y[1],c=y[2]}}}},{key:"_getHighestEnergyNode",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,n=0,o=t[0],s=0,r=0,a=0;a<t.length;a++){var h=t[a];if(!1===i[h].predefinedPosition||!0===i[h].isCluster&&!0===e||!0===i[h].options.fixed.x||!0===i[h].options.fixed.y){var d=va(this._getEnergy(h),3),l=d[0],u=d[1],c=d[2];n<l&&(n=l,o=h,s=u,r=c)}}return[o,n,s,r]}},{key:"_getEnergy",value:function(e){var t=va(this.E_sums[e],2),i=t[0],n=t[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(n,2)),i,n]}},{key:"_moveNode",value:function(e,t,i){for(var n=this.body.nodeIndices,o=this.body.nodes,s=0,r=0,a=0,h=o[e].x,d=o[e].y,l=this.K_matrix[e],u=this.L_matrix[e],c=0;c<n.length;c++){var f=n[c];if(f!==e){var p=o[f].x,v=o[f].y,m=l[f],g=u[f],y=1/Math.pow(Math.pow(h-p,2)+Math.pow(d-v,2),1.5);s+=m*(1-g*Math.pow(d-v,2)*y),r+=m*(g*(h-p)*(d-v)*y),a+=m*(1-g*Math.pow(h-p,2)*y)}}var b=(t/s+i/r)/(r/s-a/r),_=-(r*b+t)/s;o[e].x+=_,o[e].y+=b,this._updateE_matrix(e)}},{key:"_createL_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var n=0;n<t.length;n++){this.L_matrix[t[n]]={};for(var o=0;o<t.length;o++)this.L_matrix[t[n]][t[o]]=i*e[t[n]][t[o]]}}},{key:"_createK_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var n=0;n<t.length;n++){this.K_matrix[t[n]]={};for(var o=0;o<t.length;o++)this.K_matrix[t[n]][t[o]]=i*Math.pow(e[t[n]][t[o]],-2)}}},{key:"_createE_matrix",value:function(){var e=this.body.nodeIndices,t=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<e.length;i++)this.E_matrix[e[i]]=[];for(var n=0;n<e.length;n++){for(var o=e[n],s=t[o].x,r=t[o].y,a=0,h=0,d=n;d<e.length;d++){var l=e[d];if(l!==o){var u=t[l].x,c=t[l].y,f=1/Math.sqrt(Math.pow(s-u,2)+Math.pow(r-c,2));this.E_matrix[o][d]=[this.K_matrix[o][l]*(s-u-this.L_matrix[o][l]*(s-u)*f),this.K_matrix[o][l]*(r-c-this.L_matrix[o][l]*(r-c)*f)],this.E_matrix[l][n]=this.E_matrix[o][d],a+=this.E_matrix[o][d][0],h+=this.E_matrix[o][d][1]}}this.E_sums[o]=[a,h]}}},{key:"_updateE_matrix",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,n=this.E_matrix[e],o=this.K_matrix[e],s=this.L_matrix[e],r=i[e].x,a=i[e].y,h=0,d=0,l=0;l<t.length;l++){var u=t[l];if(u!==e){var c=n[l],f=c[0],p=c[1],v=i[u].x,m=i[u].y,g=1/Math.sqrt(Math.pow(r-v,2)+Math.pow(a-m,2)),y=o[u]*(r-v-s[u]*(r-v)*g),b=o[u]*(a-m-s[u]*(a-m)*g);n[l]=[y,b],h+=y,d+=b;var _=this.E_sums[u];_[0]+=y-f,_[1]+=b-p}}this.E_sums[e]=[h,d]}}]),e}();function tl(e,t,i){var n=this;if(!(this instanceof tl))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:ta,clickToUse:!1},ln(this.options,this.defaultOptions),this.body={container:e,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:this.on.bind(this),off:this.off.bind(this),emit:this.emit.bind(this),once:this.once.bind(this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}}},this.bindEventListeners(),this.images=new ga((function(){return n.body.emitter.emit("_requestRedraw")})),this.groups=new ya,this.canvas=new Od(this.body),this.selectionHandler=new Cd(this.body,this.canvas),this.interactionHandler=new Ed(this.body,this.canvas,this.selectionHandler),this.view=new Dd(this.body,this.canvas),this.renderer=new xd(this.body,this.canvas),this.physics=new yd(this.body),this.layoutEngine=new Bd(this.body),this.clustering=new wd(this.body),this.manipulation=new Ld(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new Bh(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new dd(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new el(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(i),this.setData(t)}i(tl.prototype),tl.prototype.setOptions=function(e){var t=this;if(null===e&&(e=void 0),void 0!==e){!0===Ah.validate(e,$d)&&console.log("%cErrors have been found in the supplied options object.",jh);if(cn(["locale","locales","clickToUse"],this.options,e),e=this.layoutEngine.setOptions(e.layout,e),this.canvas.setOptions(e),this.groups.setOptions(e.groups),this.nodesHandler.setOptions(e.nodes),this.edgesHandler.setOptions(e.edges),this.physics.setOptions(e.physics),this.manipulation.setOptions(e.manipulation,e,this.options),this.interactionHandler.setOptions(e.interaction),this.renderer.setOptions(e.interaction),this.selectionHandler.setOptions(e.interaction),void 0!==e.groups&&this.body.emitter.emit("refreshNodes"),"configure"in e&&(this.configurator||(this.configurator=new Vd(this,this.body.container,Kd,this.canvas.pixelRatio)),this.configurator.setOptions(e.configure)),this.configurator&&!0===this.configurator.options.enabled){var i={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};pn(i.nodes,this.nodesHandler.options),pn(i.edges,this.edgesHandler.options),pn(i.layout,this.layoutEngine.options),pn(i.interaction,this.selectionHandler.options),pn(i.interaction,this.renderer.options),pn(i.interaction,this.interactionHandler.options),pn(i.manipulation,this.manipulation.options),pn(i.physics,this.physics.options),pn(i.global,this.canvas.options),pn(i.global,this.options),this.configurator.setModuleOptions(i)}void 0!==e.clickToUse?!0===e.clickToUse?void 0===this.activator&&(this.activator=new ea(this.canvas.frame),this.activator.on("change",(function(){t.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},tl.prototype._updateVisibleIndices=function(){var e=this.body.nodes,t=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],e)e.hasOwnProperty(i)&&(this.clustering._isClusteredNode(i)||!1!==e[i].options.hidden||this.body.nodeIndices.push(e[i].id));for(var n in t)if(t.hasOwnProperty(n)){var o=t[n],s=e[o.fromId],r=e[o.toId],a=void 0!==s&&void 0!==r;!this.clustering._isClusteredEdge(n)&&!1===o.options.hidden&&a&&!1===s.options.hidden&&!1===r.options.hidden&&this.body.edgeIndices.push(o.id)}},tl.prototype.bindEventListeners=function(){var e=this;this.body.emitter.on("_dataChanged",(function(){e.edgesHandler._updateState(),e.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){e.clustering._updateState(),e._updateVisibleIndices(),e._updateValueRange(e.body.nodes),e._updateValueRange(e.body.edges),e.body.emitter.emit("startSimulation"),e.body.emitter.emit("_requestRedraw")}))},tl.prototype.setData=function(e){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),e&&e.dot&&(e.nodes||e.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(e&&e.options),e&&e.dot){console.log("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var t=Ao.DOTToGraph(e.dot);this.setData(t)}else if(e&&e.gephi){console.log("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=Bo(e.gephi);this.setData(i)}else this.nodesHandler.setData(e&&e.nodes,!0),this.edgesHandler.setData(e&&e.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},tl.prototype.destroy=function(){for(var e in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)this.body.nodes.hasOwnProperty(e)&&delete this.body.nodes[e];for(var t in this.body.edges)this.body.edges.hasOwnProperty(t)&&delete this.body.edges[t];nn(this.body.container)},tl.prototype._updateValueRange=function(e){var t,i=void 0,n=void 0,o=0;for(t in e)if(e.hasOwnProperty(t)){var s=e[t].getValue();void 0!==s&&(i=void 0===i?s:Math.min(s,i),n=void 0===n?s:Math.max(s,n),o+=s)}if(void 0!==i&&void 0!==n)for(t in e)e.hasOwnProperty(t)&&e[t].setValueRange(i,n,o)},tl.prototype.isActive=function(){return!this.activator||this.activator.active},tl.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},tl.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},tl.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},tl.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},tl.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},tl.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},tl.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},tl.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},tl.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},tl.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},tl.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},tl.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},tl.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},tl.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},tl.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},tl.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},tl.prototype.editNodeMode=function(){return console.log("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},tl.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},tl.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},tl.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},tl.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},tl.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},tl.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},tl.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},tl.prototype.getConnectedNodes=function(e){return void 0!==this.body.nodes[e]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},tl.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},tl.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},tl.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},tl.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},tl.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},tl.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},tl.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodes.apply(this.selectionHandler,arguments)},tl.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdges.apply(this.selectionHandler,arguments)},tl.prototype.getNodeAt=function(){var e=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},tl.prototype.getEdgeAt=function(){var e=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==e&&void 0!==e.id?e.id:e},tl.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},tl.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},tl.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.redraw()},tl.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},tl.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},tl.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},tl.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},tl.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},tl.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},tl.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},tl.prototype.getOptionsFromConfigurator=function(){var e={};return this.configurator&&(e=this.configurator.getOptions.apply(this.configurator)),e};var il=t((function(e,t){t.prepareElements=function(e){for(var t in e)e.hasOwnProperty(t)&&(e[t].redundant=e[t].used,e[t].used=[])},t.cleanupElements=function(e){for(var t in e)if(e.hasOwnProperty(t)&&e[t].redundant){for(var i=0;i<e[t].redundant.length;i++)e[t].redundant[i].parentNode.removeChild(e[t].redundant[i]);e[t].redundant=[]}},t.resetElements=function(e){t.prepareElements(e),t.cleanupElements(e),t.prepareElements(e)},t.getSVGElement=function(e,t,i){var n;return t.hasOwnProperty(e)?t[e].redundant.length>0?(n=t[e].redundant[0],t[e].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",e),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",e),t[e]={used:[],redundant:[]},i.appendChild(n)),t[e].used.push(n),n},t.getDOMElement=function(e,t,i,n){var o;return t.hasOwnProperty(e)?t[e].redundant.length>0?(o=t[e].redundant[0],t[e].redundant.shift()):(o=document.createElement(e),void 0!==n?i.insertBefore(o,n):i.appendChild(o)):(o=document.createElement(e),t[e]={used:[],redundant:[]},void 0!==n?i.insertBefore(o,n):i.appendChild(o)),t[e].used.push(o),o},t.drawPoint=function(e,i,n,o,s,r){var a;if("circle"==n.style?((a=t.getSVGElement("circle",o,s)).setAttributeNS(null,"cx",e),a.setAttributeNS(null,"cy",i),a.setAttributeNS(null,"r",.5*n.size)):((a=t.getSVGElement("rect",o,s)).setAttributeNS(null,"x",e-.5*n.size),a.setAttributeNS(null,"y",i-.5*n.size),a.setAttributeNS(null,"width",n.size),a.setAttributeNS(null,"height",n.size)),void 0!==n.styles&&a.setAttributeNS(null,"style",n.styles),a.setAttributeNS(null,"class",n.className+" vis-point"),r){var h=t.getSVGElement("text",o,s);r.xOffset&&(e+=r.xOffset),r.yOffset&&(i+=r.yOffset),r.content&&(h.textContent=r.content),r.className&&h.setAttributeNS(null,"class",r.className+" vis-label"),h.setAttributeNS(null,"x",e),h.setAttributeNS(null,"y",i)}return a},t.drawBar=function(e,i,n,o,s,r,a,h){if(0!=o){o<0&&(i-=o*=-1);var d=t.getSVGElement("rect",r,a);d.setAttributeNS(null,"x",e-.5*n),d.setAttributeNS(null,"y",i),d.setAttributeNS(null,"width",n),d.setAttributeNS(null,"height",o),d.setAttributeNS(null,"class",s),h&&d.setAttributeNS(null,"style",h)}}})),nl=il.prepareElements,ol=il.cleanupElements,sl=il.resetElements,rl=il.getSVGElement,al=il.getDOMElement,hl=il.drawPoint,dl=il.drawBar,ll=Object.freeze({__proto__:null,default:il,__moduleExports:il,prepareElements:nl,cleanupElements:ol,resetElements:sl,getSVGElement:rl,getDOMElement:al,drawPoint:hl,drawBar:dl}),ul=t((function(t,i){t.exports=function(){var i,n;function o(){return i.apply(null,arguments)}function s(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function r(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function a(e){return void 0===e}function h(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function d(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function l(e,t){var i,n=[];for(i=0;i<e.length;++i)n.push(t(e[i],i));return n}function u(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function c(e,t){for(var i in t)u(t,i)&&(e[i]=t[i]);return u(t,"toString")&&(e.toString=t.toString),u(t,"valueOf")&&(e.valueOf=t.valueOf),e}function f(e,t,i,n){return Ft(e,t,i,n,!0).utc()}function p(e){return null==e._pf&&(e._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}),e._pf}function v(e){if(null==e._isValid){var t=p(e),i=n.call(t.parsedDateParts,(function(e){return null!=e})),o=!isNaN(e._d.getTime())&&t.overflow<0&&!t.empty&&!t.invalidMonth&&!t.invalidWeekday&&!t.weekdayMismatch&&!t.nullInput&&!t.invalidFormat&&!t.userInvalidated&&(!t.meridiem||t.meridiem&&i);if(e._strict&&(o=o&&0===t.charsLeftOver&&0===t.unusedTokens.length&&void 0===t.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return o;e._isValid=o}return e._isValid}function m(e){var t=f(NaN);return null!=e?c(p(t),e):p(t).userInvalidated=!0,t}n=Array.prototype.some?Array.prototype.some:function(e){for(var t=Object(this),i=t.length>>>0,n=0;n<i;n++)if(n in t&&e.call(this,t[n],n,t))return!0;return!1};var g=o.momentProperties=[];function y(e,t){var i,n,o;if(a(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),a(t._i)||(e._i=t._i),a(t._f)||(e._f=t._f),a(t._l)||(e._l=t._l),a(t._strict)||(e._strict=t._strict),a(t._tzm)||(e._tzm=t._tzm),a(t._isUTC)||(e._isUTC=t._isUTC),a(t._offset)||(e._offset=t._offset),a(t._pf)||(e._pf=p(t)),a(t._locale)||(e._locale=t._locale),g.length>0)for(i=0;i<g.length;i++)a(o=t[n=g[i]])||(e[n]=o);return e}var b=!1;function _(e){y(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===b&&(b=!0,o.updateOffset(this),b=!1)}function w(e){return e instanceof _||null!=e&&null!=e._isAMomentObject}function k(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function x(e){var t=+e,i=0;return 0!==t&&isFinite(t)&&(i=k(t)),i}function S(e,t,i){var n,o=Math.min(e.length,t.length),s=Math.abs(e.length-t.length),r=0;for(n=0;n<o;n++)(i&&e[n]!==t[n]||!i&&x(e[n])!==x(t[n]))&&r++;return r+s}function O(e){!1===o.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function D(e,t){var i=!0;return c((function(){if(null!=o.deprecationHandler&&o.deprecationHandler(null,e),i){for(var n,s=[],r=0;r<arguments.length;r++){if(n="","object"==typeof arguments[r]){for(var a in n+="\n["+r+"] ",arguments[0])n+=a+": "+arguments[0][a]+", ";n=n.slice(0,-2)}else n=arguments[r];s.push(n)}O(e+"\nArguments: "+Array.prototype.slice.call(s).join("")+"\n"+(new Error).stack),i=!1}return t.apply(this,arguments)}),t)}var M,T={};function E(e,t){null!=o.deprecationHandler&&o.deprecationHandler(e,t),T[e]||(O(t),T[e]=!0)}function C(e){return e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function P(e,t){var i,n=c({},e);for(i in t)u(t,i)&&(r(e[i])&&r(t[i])?(n[i]={},c(n[i],e[i]),c(n[i],t[i])):null!=t[i]?n[i]=t[i]:delete n[i]);for(i in e)u(e,i)&&!u(t,i)&&r(e[i])&&(n[i]=c({},n[i]));return n}function I(e){null!=e&&this.set(e)}o.suppressDeprecationWarnings=!1,o.deprecationHandler=null,M=Object.keys?Object.keys:function(e){var t,i=[];for(t in e)u(e,t)&&i.push(t);return i};var F={};function N(e,t){var i=e.toLowerCase();F[i]=F[i+"s"]=F[t]=e}function Y(e){return"string"==typeof e?F[e]||F[e.toLowerCase()]:void 0}function R(e){var t,i,n={};for(i in e)u(e,i)&&(t=Y(i))&&(n[t]=e[i]);return n}var j={};function A(e,t){j[e]=t}function z(e,t,i){var n=""+Math.abs(e),o=t-n.length;return(e>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,o)).toString().substr(1)+n}var B=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,L=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,H={},W={};function V(e,t,i,n){var o=n;"string"==typeof n&&(o=function(){return this[n]()}),e&&(W[e]=o),t&&(W[t[0]]=function(){return z(o.apply(this,arguments),t[1],t[2])}),i&&(W[i]=function(){return this.localeData().ordinal(o.apply(this,arguments),e)})}function U(e,t){return e.isValid()?(t=G(t,e.localeData()),H[t]=H[t]||function(e){var t,i,n,o=e.match(B);for(t=0,i=o.length;t<i;t++)W[o[t]]?o[t]=W[o[t]]:o[t]=(n=o[t]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(t){var n,s="";for(n=0;n<i;n++)s+=C(o[n])?o[n].call(t,e):o[n];return s}}(t),H[t](e)):e.localeData().invalidDate()}function G(e,t){var i=5;function n(e){return t.longDateFormat(e)||e}for(L.lastIndex=0;i>=0&&L.test(e);)e=e.replace(L,n),L.lastIndex=0,i-=1;return e}var q=/\d/,Z=/\d\d/,X=/\d{3}/,$=/\d{4}/,K=/[+-]?\d{6}/,J=/\d\d?/,Q=/\d\d\d\d?/,ee=/\d\d\d\d\d\d?/,te=/\d{1,3}/,ie=/\d{1,4}/,ne=/[+-]?\d{1,6}/,oe=/\d+/,se=/[+-]?\d+/,re=/Z|[+-]\d\d:?\d\d/gi,ae=/Z|[+-]\d\d(?::?\d\d)?/gi,he=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,de={};function le(e,t,i){de[e]=C(t)?t:function(e,n){return e&&i?i:t}}function ue(e,t){return u(de,e)?de[e](t._strict,t._locale):new RegExp(ce(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(e,t,i,n,o){return t||i||n||o}))))}function ce(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var fe={};function pe(e,t){var i,n=t;for("string"==typeof e&&(e=[e]),h(t)&&(n=function(e,i){i[t]=x(e)}),i=0;i<e.length;i++)fe[e[i]]=n}function ve(e,t){pe(e,(function(e,i,n,o){n._w=n._w||{},t(e,n._w,n,o)}))}function me(e,t,i){null!=t&&u(fe,e)&&fe[e](t,i._a,i,e)}var ge=0,ye=1,be=2,_e=3,we=4,ke=5,xe=6,Se=7,Oe=8;function De(e){return Me(e)?366:365}function Me(e){return e%4==0&&e%100!=0||e%400==0}V("Y",0,0,(function(){var e=this.year();return e<=9999?""+e:"+"+e})),V(0,["YY",2],0,(function(){return this.year()%100})),V(0,["YYYY",4],0,"year"),V(0,["YYYYY",5],0,"year"),V(0,["YYYYYY",6,!0],0,"year"),N("year","y"),A("year",1),le("Y",se),le("YY",J,Z),le("YYYY",ie,$),le("YYYYY",ne,K),le("YYYYYY",ne,K),pe(["YYYYY","YYYYYY"],ge),pe("YYYY",(function(e,t){t[ge]=2===e.length?o.parseTwoDigitYear(e):x(e)})),pe("YY",(function(e,t){t[ge]=o.parseTwoDigitYear(e)})),pe("Y",(function(e,t){t[ge]=parseInt(e,10)})),o.parseTwoDigitYear=function(e){return x(e)+(x(e)>68?1900:2e3)};var Te,Ee=Ce("FullYear",!0);function Ce(e,t){return function(i){return null!=i?(Ie(this,e,i),o.updateOffset(this,t),this):Pe(this,e)}}function Pe(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function Ie(e,t,i){e.isValid()&&!isNaN(i)&&("FullYear"===t&&Me(e.year())&&1===e.month()&&29===e.date()?e._d["set"+(e._isUTC?"UTC":"")+t](i,e.month(),Fe(i,e.month())):e._d["set"+(e._isUTC?"UTC":"")+t](i))}function Fe(e,t){if(isNaN(e)||isNaN(t))return NaN;var i=function(e,t){return(e%t+t)%t}(t,12);return e+=(t-i)/12,1===i?Me(e)?29:28:31-i%7%2}Te=Array.prototype.indexOf?Array.prototype.indexOf:function(e){var t;for(t=0;t<this.length;++t)if(this[t]===e)return t;return-1},V("M",["MM",2],"Mo",(function(){return this.month()+1})),V("MMM",0,0,(function(e){return this.localeData().monthsShort(this,e)})),V("MMMM",0,0,(function(e){return this.localeData().months(this,e)})),N("month","M"),A("month",8),le("M",J),le("MM",J,Z),le("MMM",(function(e,t){return t.monthsShortRegex(e)})),le("MMMM",(function(e,t){return t.monthsRegex(e)})),pe(["M","MM"],(function(e,t){t[ye]=x(e)-1})),pe(["MMM","MMMM"],(function(e,t,i,n){var o=i._locale.monthsParse(e,n,i._strict);null!=o?t[ye]=o:p(i).invalidMonth=e}));var Ne=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Ye="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Re="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function je(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)s=f([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(s,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(s,"").toLocaleLowerCase();return i?"MMM"===t?-1!==(o=Te.call(this._shortMonthsParse,r))?o:null:-1!==(o=Te.call(this._longMonthsParse,r))?o:null:"MMM"===t?-1!==(o=Te.call(this._shortMonthsParse,r))?o:-1!==(o=Te.call(this._longMonthsParse,r))?o:null:-1!==(o=Te.call(this._longMonthsParse,r))?o:-1!==(o=Te.call(this._shortMonthsParse,r))?o:null}function Ae(e,t){var i;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=x(t);else if(!h(t=e.localeData().monthsParse(t)))return e;return i=Math.min(e.date(),Fe(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,i),e}function ze(e){return null!=e?(Ae(this,e),o.updateOffset(this,!0),this):Pe(this,"Month")}var Be=he,Le=he;function He(){function e(e,t){return t.length-e.length}var t,i,n=[],o=[],s=[];for(t=0;t<12;t++)i=f([2e3,t]),n.push(this.monthsShort(i,"")),o.push(this.months(i,"")),s.push(this.months(i,"")),s.push(this.monthsShort(i,""));for(n.sort(e),o.sort(e),s.sort(e),t=0;t<12;t++)n[t]=ce(n[t]),o[t]=ce(o[t]);for(t=0;t<24;t++)s[t]=ce(s[t]);this._monthsRegex=new RegExp("^("+s.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function We(e,t,i,n,o,s,r){var a;return e<100&&e>=0?(a=new Date(e+400,t,i,n,o,s,r),isFinite(a.getFullYear())&&a.setFullYear(e)):a=new Date(e,t,i,n,o,s,r),a}function Ve(e){var t;if(e<100&&e>=0){var i=Array.prototype.slice.call(arguments);i[0]=e+400,t=new Date(Date.UTC.apply(null,i)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)}else t=new Date(Date.UTC.apply(null,arguments));return t}function Ue(e,t,i){var n=7+t-i;return-(7+Ve(e,0,n).getUTCDay()-t)%7+n-1}function Ge(e,t,i,n,o){var s,r,a=1+7*(t-1)+(7+i-n)%7+Ue(e,n,o);return a<=0?r=De(s=e-1)+a:a>De(e)?(s=e+1,r=a-De(e)):(s=e,r=a),{year:s,dayOfYear:r}}function qe(e,t,i){var n,o,s=Ue(e.year(),t,i),r=Math.floor((e.dayOfYear()-s-1)/7)+1;return r<1?n=r+Ze(o=e.year()-1,t,i):r>Ze(e.year(),t,i)?(n=r-Ze(e.year(),t,i),o=e.year()+1):(o=e.year(),n=r),{week:n,year:o}}function Ze(e,t,i){var n=Ue(e,t,i),o=Ue(e+1,t,i);return(De(e)-n+o)/7}function Xe(e,t){return e.slice(t,7).concat(e.slice(0,t))}V("w",["ww",2],"wo","week"),V("W",["WW",2],"Wo","isoWeek"),N("week","w"),N("isoWeek","W"),A("week",5),A("isoWeek",5),le("w",J),le("ww",J,Z),le("W",J),le("WW",J,Z),ve(["w","ww","W","WW"],(function(e,t,i,n){t[n.substr(0,1)]=x(e)})),V("d",0,"do","day"),V("dd",0,0,(function(e){return this.localeData().weekdaysMin(this,e)})),V("ddd",0,0,(function(e){return this.localeData().weekdaysShort(this,e)})),V("dddd",0,0,(function(e){return this.localeData().weekdays(this,e)})),V("e",0,0,"weekday"),V("E",0,0,"isoWeekday"),N("day","d"),N("weekday","e"),N("isoWeekday","E"),A("day",11),A("weekday",11),A("isoWeekday",11),le("d",J),le("e",J),le("E",J),le("dd",(function(e,t){return t.weekdaysMinRegex(e)})),le("ddd",(function(e,t){return t.weekdaysShortRegex(e)})),le("dddd",(function(e,t){return t.weekdaysRegex(e)})),ve(["dd","ddd","dddd"],(function(e,t,i,n){var o=i._locale.weekdaysParse(e,n,i._strict);null!=o?t.d=o:p(i).invalidWeekday=e})),ve(["d","e","E"],(function(e,t,i,n){t[n]=x(e)}));var $e="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Ke="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Je="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function Qe(e,t,i){var n,o,s,r=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)s=f([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(s,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(s,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(s,"").toLocaleLowerCase();return i?"dddd"===t?-1!==(o=Te.call(this._weekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:null:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:"dddd"===t?-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:"ddd"===t?-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:null:-1!==(o=Te.call(this._minWeekdaysParse,r))?o:-1!==(o=Te.call(this._weekdaysParse,r))?o:-1!==(o=Te.call(this._shortWeekdaysParse,r))?o:null}var et=he,tt=he,it=he;function nt(){function e(e,t){return t.length-e.length}var t,i,n,o,s,r=[],a=[],h=[],d=[];for(t=0;t<7;t++)i=f([2e3,1]).day(t),n=this.weekdaysMin(i,""),o=this.weekdaysShort(i,""),s=this.weekdays(i,""),r.push(n),a.push(o),h.push(s),d.push(n),d.push(o),d.push(s);for(r.sort(e),a.sort(e),h.sort(e),d.sort(e),t=0;t<7;t++)a[t]=ce(a[t]),h[t]=ce(h[t]),d[t]=ce(d[t]);this._weekdaysRegex=new RegExp("^("+d.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+r.join("|")+")","i")}function ot(){return this.hours()%12||12}function st(e,t){V(e,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)}))}function rt(e,t){return t._meridiemParse}V("H",["HH",2],0,"hour"),V("h",["hh",2],0,ot),V("k",["kk",2],0,(function(){return this.hours()||24})),V("hmm",0,0,(function(){return""+ot.apply(this)+z(this.minutes(),2)})),V("hmmss",0,0,(function(){return""+ot.apply(this)+z(this.minutes(),2)+z(this.seconds(),2)})),V("Hmm",0,0,(function(){return""+this.hours()+z(this.minutes(),2)})),V("Hmmss",0,0,(function(){return""+this.hours()+z(this.minutes(),2)+z(this.seconds(),2)})),st("a",!0),st("A",!1),N("hour","h"),A("hour",13),le("a",rt),le("A",rt),le("H",J),le("h",J),le("k",J),le("HH",J,Z),le("hh",J,Z),le("kk",J,Z),le("hmm",Q),le("hmmss",ee),le("Hmm",Q),le("Hmmss",ee),pe(["H","HH"],_e),pe(["k","kk"],(function(e,t,i){var n=x(e);t[_e]=24===n?0:n})),pe(["a","A"],(function(e,t,i){i._isPm=i._locale.isPM(e),i._meridiem=e})),pe(["h","hh"],(function(e,t,i){t[_e]=x(e),p(i).bigHour=!0})),pe("hmm",(function(e,t,i){var n=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n)),p(i).bigHour=!0})),pe("hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n,2)),t[ke]=x(e.substr(o)),p(i).bigHour=!0})),pe("Hmm",(function(e,t,i){var n=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n))})),pe("Hmmss",(function(e,t,i){var n=e.length-4,o=e.length-2;t[_e]=x(e.substr(0,n)),t[we]=x(e.substr(n,2)),t[ke]=x(e.substr(o))}));var at,ht=Ce("Hours",!0),dt={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Ye,monthsShort:Re,week:{dow:0,doy:6},weekdays:$e,weekdaysMin:Je,weekdaysShort:Ke,meridiemParse:/[ap]\.?m?\.?/i},lt={},ut={};function ct(e){return e?e.toLowerCase().replace("_","-"):e}function ft(i){var n=null;if(!lt[i]&&t&&t.exports)try{n=at._abbr,e(),pt(n)}catch(e){}return lt[i]}function pt(e,t){var i;return e&&((i=a(t)?mt(e):vt(e,t))?at=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),at._abbr}function vt(e,t){if(null!==t){var i,n=dt;if(t.abbr=e,null!=lt[e])E("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=lt[e]._config;else if(null!=t.parentLocale)if(null!=lt[t.parentLocale])n=lt[t.parentLocale]._config;else{if(null==(i=ft(t.parentLocale)))return ut[t.parentLocale]||(ut[t.parentLocale]=[]),ut[t.parentLocale].push({name:e,config:t}),null;n=i._config}return lt[e]=new I(P(n,t)),ut[e]&&ut[e].forEach((function(e){vt(e.name,e.config)})),pt(e),lt[e]}return delete lt[e],null}function mt(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return at;if(!s(e)){if(t=ft(e))return t;e=[e]}return function(e){for(var t,i,n,o,s=0;s<e.length;){for(t=(o=ct(e[s]).split("-")).length,i=(i=ct(e[s+1]))?i.split("-"):null;t>0;){if(n=ft(o.slice(0,t).join("-")))return n;if(i&&i.length>=t&&S(o,i,!0)>=t-1)break;t--}s++}return at}(e)}function gt(e){var t,i=e._a;return i&&-2===p(e).overflow&&(t=i[ye]<0||i[ye]>11?ye:i[be]<1||i[be]>Fe(i[ge],i[ye])?be:i[_e]<0||i[_e]>24||24===i[_e]&&(0!==i[we]||0!==i[ke]||0!==i[xe])?_e:i[we]<0||i[we]>59?we:i[ke]<0||i[ke]>59?ke:i[xe]<0||i[xe]>999?xe:-1,p(e)._overflowDayOfYear&&(t<ge||t>be)&&(t=be),p(e)._overflowWeeks&&-1===t&&(t=Se),p(e)._overflowWeekday&&-1===t&&(t=Oe),p(e).overflow=t),e}function yt(e,t,i){return null!=e?e:null!=t?t:i}function bt(e){var t,i,n,s,r,a=[];if(!e._d){for(n=function(e){var t=new Date(o.now());return e._useUTC?[t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()]:[t.getFullYear(),t.getMonth(),t.getDate()]}(e),e._w&&null==e._a[be]&&null==e._a[ye]&&function(e){var t,i,n,o,s,r,a,h;if(null!=(t=e._w).GG||null!=t.W||null!=t.E)s=1,r=4,i=yt(t.GG,e._a[ge],qe(Nt(),1,4).year),n=yt(t.W,1),((o=yt(t.E,1))<1||o>7)&&(h=!0);else{s=e._locale._week.dow,r=e._locale._week.doy;var d=qe(Nt(),s,r);i=yt(t.gg,e._a[ge],d.year),n=yt(t.w,d.week),null!=t.d?((o=t.d)<0||o>6)&&(h=!0):null!=t.e?(o=t.e+s,(t.e<0||t.e>6)&&(h=!0)):o=s}n<1||n>Ze(i,s,r)?p(e)._overflowWeeks=!0:null!=h?p(e)._overflowWeekday=!0:(a=Ge(i,n,o,s,r),e._a[ge]=a.year,e._dayOfYear=a.dayOfYear)}(e),null!=e._dayOfYear&&(r=yt(e._a[ge],n[ge]),(e._dayOfYear>De(r)||0===e._dayOfYear)&&(p(e)._overflowDayOfYear=!0),i=Ve(r,0,e._dayOfYear),e._a[ye]=i.getUTCMonth(),e._a[be]=i.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=a[t]=n[t];for(;t<7;t++)e._a[t]=a[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[_e]&&0===e._a[we]&&0===e._a[ke]&&0===e._a[xe]&&(e._nextDay=!0,e._a[_e]=0),e._d=(e._useUTC?Ve:We).apply(null,a),s=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[_e]=24),e._w&&void 0!==e._w.d&&e._w.d!==s&&(p(e).weekdayMismatch=!0)}}var _t=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,wt=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,kt=/Z|[+-]\d\d(?::?\d\d)?/,xt=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],St=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ot=/^\/?Date\((\-?\d+)/i;function Dt(e){var t,i,n,o,s,r,a=e._i,h=_t.exec(a)||wt.exec(a);if(h){for(p(e).iso=!0,t=0,i=xt.length;t<i;t++)if(xt[t][1].exec(h[1])){o=xt[t][0],n=!1!==xt[t][2];break}if(null==o)return void(e._isValid=!1);if(h[3]){for(t=0,i=St.length;t<i;t++)if(St[t][1].exec(h[3])){s=(h[2]||" ")+St[t][0];break}if(null==s)return void(e._isValid=!1)}if(!n&&null!=s)return void(e._isValid=!1);if(h[4]){if(!kt.exec(h[4]))return void(e._isValid=!1);r="Z"}e._f=o+(s||"")+(r||""),Pt(e)}else e._isValid=!1}var Mt=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function Tt(e){var t=parseInt(e,10);return t<=49?2e3+t:t<=999?1900+t:t}var Et={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ct(e){var t,i,n,o,s,r,a,h=Mt.exec(e._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(h){var d=(t=h[4],i=h[3],n=h[2],o=h[5],s=h[6],r=h[7],a=[Tt(t),Re.indexOf(i),parseInt(n,10),parseInt(o,10),parseInt(s,10)],r&&a.push(parseInt(r,10)),a);if(!function(e,t,i){return!e||Ke.indexOf(e)===new Date(t[0],t[1],t[2]).getDay()||(p(i).weekdayMismatch=!0,i._isValid=!1,!1)}(h[1],d,e))return;e._a=d,e._tzm=function(e,t,i){if(e)return Et[e];if(t)return 0;var n=parseInt(i,10),o=n%100;return(n-o)/100*60+o}(h[8],h[9],h[10]),e._d=Ve.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),p(e).rfc2822=!0}else e._isValid=!1}function Pt(e){if(e._f!==o.ISO_8601)if(e._f!==o.RFC_2822){e._a=[],p(e).empty=!0;var t,i,n,s,r,a=""+e._i,h=a.length,d=0;for(n=G(e._f,e._locale).match(B)||[],t=0;t<n.length;t++)s=n[t],(i=(a.match(ue(s,e))||[])[0])&&((r=a.substr(0,a.indexOf(i))).length>0&&p(e).unusedInput.push(r),a=a.slice(a.indexOf(i)+i.length),d+=i.length),W[s]?(i?p(e).empty=!1:p(e).unusedTokens.push(s),me(s,i,e)):e._strict&&!i&&p(e).unusedTokens.push(s);p(e).charsLeftOver=h-d,a.length>0&&p(e).unusedInput.push(a),e._a[_e]<=12&&!0===p(e).bigHour&&e._a[_e]>0&&(p(e).bigHour=void 0),p(e).parsedDateParts=e._a.slice(0),p(e).meridiem=e._meridiem,e._a[_e]=function(e,t,i){var n;return null==i?t:null!=e.meridiemHour?e.meridiemHour(t,i):null!=e.isPM?((n=e.isPM(i))&&t<12&&(t+=12),n||12!==t||(t=0),t):t}(e._locale,e._a[_e],e._meridiem),bt(e),gt(e)}else Ct(e);else Dt(e)}function It(e){var t=e._i,i=e._f;return e._locale=e._locale||mt(e._l),null===t||void 0===i&&""===t?m({nullInput:!0}):("string"==typeof t&&(e._i=t=e._locale.preparse(t)),w(t)?new _(gt(t)):(d(t)?e._d=t:s(i)?function(e){var t,i,n,o,s;if(0===e._f.length)return p(e).invalidFormat=!0,void(e._d=new Date(NaN));for(o=0;o<e._f.length;o++)s=0,t=y({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[o],Pt(t),v(t)&&(s+=p(t).charsLeftOver,s+=10*p(t).unusedTokens.length,p(t).score=s,(null==n||s<n)&&(n=s,i=t));c(e,i||t)}(e):i?Pt(e):function(e){var t=e._i;a(t)?e._d=new Date(o.now()):d(t)?e._d=new Date(t.valueOf()):"string"==typeof t?function(e){var t=Ot.exec(e._i);null===t?(Dt(e),!1===e._isValid&&(delete e._isValid,Ct(e),!1===e._isValid&&(delete e._isValid,o.createFromInputFallback(e)))):e._d=new Date(+t[1])}(e):s(t)?(e._a=l(t.slice(0),(function(e){return parseInt(e,10)})),bt(e)):r(t)?function(e){if(!e._d){var t=R(e._i);e._a=l([t.year,t.month,t.day||t.date,t.hour,t.minute,t.second,t.millisecond],(function(e){return e&&parseInt(e,10)})),bt(e)}}(e):h(t)?e._d=new Date(t):o.createFromInputFallback(e)}(e),v(e)||(e._d=null),e))}function Ft(e,t,i,n,o){var a,h={};return!0!==i&&!1!==i||(n=i,i=void 0),(r(e)&&function(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;var t;for(t in e)if(e.hasOwnProperty(t))return!1;return!0}(e)||s(e)&&0===e.length)&&(e=void 0),h._isAMomentObject=!0,h._useUTC=h._isUTC=o,h._l=i,h._i=e,h._f=t,h._strict=n,(a=new _(gt(It(h))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Nt(e,t,i,n){return Ft(e,t,i,n,!1)}o.createFromInputFallback=D("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))})),o.ISO_8601=function(){},o.RFC_2822=function(){};var Yt=D("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Nt.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:m()})),Rt=D("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Nt.apply(null,arguments);return this.isValid()&&e.isValid()?e>this?this:e:m()}));function jt(e,t){var i,n;if(1===t.length&&s(t[0])&&(t=t[0]),!t.length)return Nt();for(i=t[0],n=1;n<t.length;++n)t[n].isValid()&&!t[n][e](i)||(i=t[n]);return i}var At=["year","quarter","month","week","day","hour","minute","second","millisecond"];function zt(e){var t=R(e),i=t.year||0,n=t.quarter||0,o=t.month||0,s=t.week||t.isoWeek||0,r=t.day||0,a=t.hour||0,h=t.minute||0,d=t.second||0,l=t.millisecond||0;this._isValid=function(e){for(var t in e)if(-1===Te.call(At,t)||null!=e[t]&&isNaN(e[t]))return!1;for(var i=!1,n=0;n<At.length;++n)if(e[At[n]]){if(i)return!1;parseFloat(e[At[n]])!==x(e[At[n]])&&(i=!0)}return!0}(t),this._milliseconds=+l+1e3*d+6e4*h+1e3*a*60*60,this._days=+r+7*s,this._months=+o+3*n+12*i,this._data={},this._locale=mt(),this._bubble()}function Bt(e){return e instanceof zt}function Lt(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function Ht(e,t){V(e,0,0,(function(){var e=this.utcOffset(),i="+";return e<0&&(e=-e,i="-"),i+z(~~(e/60),2)+t+z(~~e%60,2)}))}Ht("Z",":"),Ht("ZZ",""),le("Z",ae),le("ZZ",ae),pe(["Z","ZZ"],(function(e,t,i){i._useUTC=!0,i._tzm=Vt(ae,e)}));var Wt=/([\+\-]|\d\d)/gi;function Vt(e,t){var i=(t||"").match(e);if(null===i)return null;var n=((i[i.length-1]||[])+"").match(Wt)||["-",0,0],o=60*n[1]+x(n[2]);return 0===o?0:"+"===n[0]?o:-o}function Ut(e,t){var i,n;return t._isUTC?(i=t.clone(),n=(w(e)||d(e)?e.valueOf():Nt(e).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+n),o.updateOffset(i,!1),i):Nt(e).local()}function Gt(e){return 15*-Math.round(e._d.getTimezoneOffset()/15)}function qt(){return!!this.isValid()&&this._isUTC&&0===this._offset}o.updateOffset=function(){};var Zt=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Xt=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function $t(e,t){var i,n,o,s,r,a,d=e,l=null;return Bt(e)?d={ms:e._milliseconds,d:e._days,M:e._months}:h(e)?(d={},t?d[t]=e:d.milliseconds=e):(l=Zt.exec(e))?(i="-"===l[1]?-1:1,d={y:0,d:x(l[be])*i,h:x(l[_e])*i,m:x(l[we])*i,s:x(l[ke])*i,ms:x(Lt(1e3*l[xe]))*i}):(l=Xt.exec(e))?(i="-"===l[1]?-1:1,d={y:Kt(l[2],i),M:Kt(l[3],i),w:Kt(l[4],i),d:Kt(l[5],i),h:Kt(l[6],i),m:Kt(l[7],i),s:Kt(l[8],i)}):null==d?d={}:"object"==typeof d&&("from"in d||"to"in d)&&(s=Nt(d.from),r=Nt(d.to),o=s.isValid()&&r.isValid()?(r=Ut(r,s),s.isBefore(r)?a=Jt(s,r):((a=Jt(r,s)).milliseconds=-a.milliseconds,a.months=-a.months),a):{milliseconds:0,months:0},(d={}).ms=o.milliseconds,d.M=o.months),n=new zt(d),Bt(e)&&u(e,"_locale")&&(n._locale=e._locale),n}function Kt(e,t){var i=e&&parseFloat(e.replace(",","."));return(isNaN(i)?0:i)*t}function Jt(e,t){var i={};return i.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(i.months,"M").isAfter(t)&&--i.months,i.milliseconds=+t-+e.clone().add(i.months,"M"),i}function Qt(e,t){return function(i,n){var o;return null===n||isNaN(+n)||(E(t,"moment()."+t+"(period, number) is deprecated. Please use moment()."+t+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),o=i,i=n,n=o),ei(this,$t(i="string"==typeof i?+i:i,n),e),this}}function ei(e,t,i,n){var s=t._milliseconds,r=Lt(t._days),a=Lt(t._months);e.isValid()&&(n=null==n||n,a&&Ae(e,Pe(e,"Month")+a*i),r&&Ie(e,"Date",Pe(e,"Date")+r*i),s&&e._d.setTime(e._d.valueOf()+s*i),n&&o.updateOffset(e,r||a))}$t.fn=zt.prototype,$t.invalid=function(){return $t(NaN)};var ti=Qt(1,"add"),ii=Qt(-1,"subtract");function ni(e,t){var i=12*(t.year()-e.year())+(t.month()-e.month()),n=e.clone().add(i,"months");return-(i+(t-n<0?(t-n)/(n-e.clone().add(i-1,"months")):(t-n)/(e.clone().add(i+1,"months")-n)))||0}function oi(e){var t;return void 0===e?this._locale._abbr:(null!=(t=mt(e))&&(this._locale=t),this)}o.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",o.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var si=D("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(e){return void 0===e?this.localeData():this.locale(e)}));function ri(){return this._locale}var ai=1e3,hi=60*ai,di=60*hi,li=3506328*di;function ui(e,t){return(e%t+t)%t}function ci(e,t,i){return e<100&&e>=0?new Date(e+400,t,i)-li:new Date(e,t,i).valueOf()}function fi(e,t,i){return e<100&&e>=0?Date.UTC(e+400,t,i)-li:Date.UTC(e,t,i)}function pi(e,t){V(0,[e,e.length],0,t)}function vi(e,t,i,n,o){var s;return null==e?qe(this,n,o).year:(t>(s=Ze(e,n,o))&&(t=s),mi.call(this,e,t,i,n,o))}function mi(e,t,i,n,o){var s=Ge(e,t,i,n,o),r=Ve(s.year,0,s.dayOfYear);return this.year(r.getUTCFullYear()),this.month(r.getUTCMonth()),this.date(r.getUTCDate()),this}V(0,["gg",2],0,(function(){return this.weekYear()%100})),V(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),pi("gggg","weekYear"),pi("ggggg","weekYear"),pi("GGGG","isoWeekYear"),pi("GGGGG","isoWeekYear"),N("weekYear","gg"),N("isoWeekYear","GG"),A("weekYear",1),A("isoWeekYear",1),le("G",se),le("g",se),le("GG",J,Z),le("gg",J,Z),le("GGGG",ie,$),le("gggg",ie,$),le("GGGGG",ne,K),le("ggggg",ne,K),ve(["gggg","ggggg","GGGG","GGGGG"],(function(e,t,i,n){t[n.substr(0,2)]=x(e)})),ve(["gg","GG"],(function(e,t,i,n){t[n]=o.parseTwoDigitYear(e)})),V("Q",0,"Qo","quarter"),N("quarter","Q"),A("quarter",7),le("Q",q),pe("Q",(function(e,t){t[ye]=3*(x(e)-1)})),V("D",["DD",2],"Do","date"),N("date","D"),A("date",9),le("D",J),le("DD",J,Z),le("Do",(function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient})),pe(["D","DD"],be),pe("Do",(function(e,t){t[be]=x(e.match(J)[0])}));var gi=Ce("Date",!0);V("DDD",["DDDD",3],"DDDo","dayOfYear"),N("dayOfYear","DDD"),A("dayOfYear",4),le("DDD",te),le("DDDD",X),pe(["DDD","DDDD"],(function(e,t,i){i._dayOfYear=x(e)})),V("m",["mm",2],0,"minute"),N("minute","m"),A("minute",14),le("m",J),le("mm",J,Z),pe(["m","mm"],we);var yi=Ce("Minutes",!1);V("s",["ss",2],0,"second"),N("second","s"),A("second",15),le("s",J),le("ss",J,Z),pe(["s","ss"],ke);var bi,_i=Ce("Seconds",!1);for(V("S",0,0,(function(){return~~(this.millisecond()/100)})),V(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),V(0,["SSS",3],0,"millisecond"),V(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),V(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),V(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),V(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),V(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),V(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),N("millisecond","ms"),A("millisecond",16),le("S",te,q),le("SS",te,Z),le("SSS",te,X),bi="SSSS";bi.length<=9;bi+="S")le(bi,oe);function wi(e,t){t[xe]=x(1e3*("0."+e))}for(bi="S";bi.length<=9;bi+="S")pe(bi,wi);var ki=Ce("Milliseconds",!1);V("z",0,0,"zoneAbbr"),V("zz",0,0,"zoneName");var xi=_.prototype;function Si(e){return e}xi.add=ti,xi.calendar=function(e,t){var i=e||Nt(),n=Ut(i,this).startOf("day"),s=o.calendarFormat(this,n)||"sameElse",r=t&&(C(t[s])?t[s].call(this,i):t[s]);return this.format(r||this.localeData().calendar(s,this,Nt(i)))},xi.clone=function(){return new _(this)},xi.diff=function(e,t,i){var n,o,s;if(!this.isValid())return NaN;if(!(n=Ut(e,this)).isValid())return NaN;switch(o=6e4*(n.utcOffset()-this.utcOffset()),t=Y(t)){case"year":s=ni(this,n)/12;break;case"month":s=ni(this,n);break;case"quarter":s=ni(this,n)/3;break;case"second":s=(this-n)/1e3;break;case"minute":s=(this-n)/6e4;break;case"hour":s=(this-n)/36e5;break;case"day":s=(this-n-o)/864e5;break;case"week":s=(this-n-o)/6048e5;break;default:s=this-n}return i?s:k(s)},xi.endOf=function(e){var t;if(void 0===(e=Y(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(e){case"year":t=i(this.year()+1,0,1)-1;break;case"quarter":t=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=i(this.year(),this.month()+1,1)-1;break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=di-ui(t+(this._isUTC?0:this.utcOffset()*hi),di)-1;break;case"minute":t=this._d.valueOf(),t+=hi-ui(t,hi)-1;break;case"second":t=this._d.valueOf(),t+=ai-ui(t,ai)-1}return this._d.setTime(t),o.updateOffset(this,!0),this},xi.format=function(e){e||(e=this.isUtc()?o.defaultFormatUtc:o.defaultFormat);var t=U(this,e);return this.localeData().postformat(t)},xi.from=function(e,t){return this.isValid()&&(w(e)&&e.isValid()||Nt(e).isValid())?$t({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},xi.fromNow=function(e){return this.from(Nt(),e)},xi.to=function(e,t){return this.isValid()&&(w(e)&&e.isValid()||Nt(e).isValid())?$t({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},xi.toNow=function(e){return this.to(Nt(),e)},xi.get=function(e){return C(this[e=Y(e)])?this[e]():this},xi.invalidAt=function(){return p(this).overflow},xi.isAfter=function(e,t){var i=w(e)?e:Nt(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(t).valueOf())},xi.isBefore=function(e,t){var i=w(e)?e:Nt(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(t).valueOf()<i.valueOf())},xi.isBetween=function(e,t,i,n){var o=w(e)?e:Nt(e),s=w(t)?t:Nt(t);return!!(this.isValid()&&o.isValid()&&s.isValid())&&("("===(n=n||"()")[0]?this.isAfter(o,i):!this.isBefore(o,i))&&(")"===n[1]?this.isBefore(s,i):!this.isAfter(s,i))},xi.isSame=function(e,t){var i,n=w(e)?e:Nt(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=Y(t)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(t).valueOf()<=i&&i<=this.clone().endOf(t).valueOf()))},xi.isSameOrAfter=function(e,t){return this.isSame(e,t)||this.isAfter(e,t)},xi.isSameOrBefore=function(e,t){return this.isSame(e,t)||this.isBefore(e,t)},xi.isValid=function(){return v(this)},xi.lang=si,xi.locale=oi,xi.localeData=ri,xi.max=Rt,xi.min=Yt,xi.parsingFlags=function(){return c({},p(this))},xi.set=function(e,t){if("object"==typeof e)for(var i=function(e){var t=[];for(var i in e)t.push({unit:i,priority:j[i]});return t.sort((function(e,t){return e.priority-t.priority})),t}(e=R(e)),n=0;n<i.length;n++)this[i[n].unit](e[i[n].unit]);else if(C(this[e=Y(e)]))return this[e](t);return this},xi.startOf=function(e){var t;if(void 0===(e=Y(e))||"millisecond"===e||!this.isValid())return this;var i=this._isUTC?fi:ci;switch(e){case"year":t=i(this.year(),0,1);break;case"quarter":t=i(this.year(),this.month()-this.month()%3,1);break;case"month":t=i(this.year(),this.month(),1);break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=i(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=ui(t+(this._isUTC?0:this.utcOffset()*hi),di);break;case"minute":t=this._d.valueOf(),t-=ui(t,hi);break;case"second":t=this._d.valueOf(),t-=ui(t,ai)}return this._d.setTime(t),o.updateOffset(this,!0),this},xi.subtract=ii,xi.toArray=function(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]},xi.toObject=function(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}},xi.toDate=function(){return new Date(this.valueOf())},xi.toISOString=function(e){if(!this.isValid())return null;var t=!0!==e,i=t?this.clone().utc():this;return i.year()<0||i.year()>9999?U(i,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):C(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",U(i,"Z")):U(i,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},xi.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e="moment",t="";this.isLocal()||(e=0===this.utcOffset()?"moment.utc":"moment.parseZone",t="Z");var i="["+e+'("]',n=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",o=t+'[")]';return this.format(i+n+"-MM-DD[T]HH:mm:ss.SSS"+o)},xi.toJSON=function(){return this.isValid()?this.toISOString():null},xi.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},xi.unix=function(){return Math.floor(this.valueOf()/1e3)},xi.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},xi.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},xi.year=Ee,xi.isLeapYear=function(){return Me(this.year())},xi.weekYear=function(e){return vi.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},xi.isoWeekYear=function(e){return vi.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)},xi.quarter=xi.quarters=function(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)},xi.month=ze,xi.daysInMonth=function(){return Fe(this.year(),this.month())},xi.week=xi.weeks=function(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")},xi.isoWeek=xi.isoWeeks=function(e){var t=qe(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")},xi.weeksInYear=function(){var e=this.localeData()._week;return Ze(this.year(),e.dow,e.doy)},xi.isoWeeksInYear=function(){return Ze(this.year(),1,4)},xi.date=gi,xi.day=xi.days=function(e){if(!this.isValid())return null!=e?this:NaN;var t=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(e=function(e,t){return"string"!=typeof e?e:isNaN(e)?"number"==typeof(e=t.weekdaysParse(e))?e:null:parseInt(e,10)}(e,this.localeData()),this.add(e-t,"d")):t},xi.weekday=function(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")},xi.isoWeekday=function(e){if(!this.isValid())return null!=e?this:NaN;if(null!=e){var t=function(e,t){return"string"==typeof e?t.weekdaysParse(e)%7||7:isNaN(e)?null:e}(e,this.localeData());return this.day(this.day()%7?t:t-7)}return this.day()||7},xi.dayOfYear=function(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")},xi.hour=xi.hours=ht,xi.minute=xi.minutes=yi,xi.second=xi.seconds=_i,xi.millisecond=xi.milliseconds=ki,xi.utcOffset=function(e,t,i){var n,s=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null!=e){if("string"==typeof e){if(null===(e=Vt(ae,e)))return this}else Math.abs(e)<16&&!i&&(e*=60);return!this._isUTC&&t&&(n=Gt(this)),this._offset=e,this._isUTC=!0,null!=n&&this.add(n,"m"),s!==e&&(!t||this._changeInProgress?ei(this,$t(e-s,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,o.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?s:Gt(this)},xi.utc=function(e){return this.utcOffset(0,e)},xi.local=function(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(Gt(this),"m")),this},xi.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var e=Vt(re,this._i);null!=e?this.utcOffset(e):this.utcOffset(0,!0)}return this},xi.hasAlignedHourOffset=function(e){return!!this.isValid()&&(e=e?Nt(e).utcOffset():0,(this.utcOffset()-e)%60==0)},xi.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},xi.isLocal=function(){return!!this.isValid()&&!this._isUTC},xi.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},xi.isUtc=qt,xi.isUTC=qt,xi.zoneAbbr=function(){return this._isUTC?"UTC":""},xi.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},xi.dates=D("dates accessor is deprecated. Use date instead.",gi),xi.months=D("months accessor is deprecated. Use month instead",ze),xi.years=D("years accessor is deprecated. Use year instead",Ee),xi.zone=D("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()})),xi.isDSTShifted=D("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!a(this._isDSTShifted))return this._isDSTShifted;var e={};if(y(e,this),(e=It(e))._a){var t=e._isUTC?f(e._a):Nt(e._a);this._isDSTShifted=this.isValid()&&S(e._a,t.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}));var Oi=I.prototype;function Di(e,t,i,n){var o=mt(),s=f().set(n,t);return o[i](s,e)}function Mi(e,t,i){if(h(e)&&(t=e,e=void 0),e=e||"",null!=t)return Di(e,t,i,"month");var n,o=[];for(n=0;n<12;n++)o[n]=Di(e,n,i,"month");return o}function Ti(e,t,i,n){"boolean"==typeof e?(h(t)&&(i=t,t=void 0),t=t||""):(i=t=e,e=!1,h(t)&&(i=t,t=void 0),t=t||"");var o,s=mt(),r=e?s._week.dow:0;if(null!=i)return Di(t,(i+r)%7,n,"day");var a=[];for(o=0;o<7;o++)a[o]=Di(t,(o+r)%7,n,"day");return a}Oi.calendar=function(e,t,i){var n=this._calendar[e]||this._calendar.sameElse;return C(n)?n.call(t,i):n},Oi.longDateFormat=function(e){var t=this._longDateFormat[e],i=this._longDateFormat[e.toUpperCase()];return t||!i?t:(this._longDateFormat[e]=i.replace(/MMMM|MM|DD|dddd/g,(function(e){return e.slice(1)})),this._longDateFormat[e])},Oi.invalidDate=function(){return this._invalidDate},Oi.ordinal=function(e){return this._ordinal.replace("%d",e)},Oi.preparse=Si,Oi.postformat=Si,Oi.relativeTime=function(e,t,i,n){var o=this._relativeTime[i];return C(o)?o(e,t,i,n):o.replace(/%d/i,e)},Oi.pastFuture=function(e,t){var i=this._relativeTime[e>0?"future":"past"];return C(i)?i(t):i.replace(/%s/i,t)},Oi.set=function(e){var t,i;for(i in e)C(t=e[i])?this[i]=t:this["_"+i]=t;this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Oi.months=function(e,t){return e?s(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||Ne).test(t)?"format":"standalone"][e.month()]:s(this._months)?this._months:this._months.standalone},Oi.monthsShort=function(e,t){return e?s(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[Ne.test(t)?"format":"standalone"][e.month()]:s(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Oi.monthsParse=function(e,t,i){var n,o,s;if(this._monthsParseExact)return je.call(this,e,t,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(o=f([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(o,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(o,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(s="^"+this.months(o,"")+"|^"+this.monthsShort(o,""),this._monthsParse[n]=new RegExp(s.replace(".",""),"i")),i&&"MMMM"===t&&this._longMonthsParse[n].test(e))return n;if(i&&"MMM"===t&&this._shortMonthsParse[n].test(e))return n;if(!i&&this._monthsParse[n].test(e))return n}},Oi.monthsRegex=function(e){return this._monthsParseExact?(u(this,"_monthsRegex")||He.call(this),e?this._monthsStrictRegex:this._monthsRegex):(u(this,"_monthsRegex")||(this._monthsRegex=Le),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)},Oi.monthsShortRegex=function(e){return this._monthsParseExact?(u(this,"_monthsRegex")||He.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(u(this,"_monthsShortRegex")||(this._monthsShortRegex=Be),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)},Oi.week=function(e){return qe(e,this._week.dow,this._week.doy).week},Oi.firstDayOfYear=function(){return this._week.doy},Oi.firstDayOfWeek=function(){return this._week.dow},Oi.weekdays=function(e,t){var i=s(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Xe(i,this._week.dow):e?i[e.day()]:i},Oi.weekdaysMin=function(e){return!0===e?Xe(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin},Oi.weekdaysShort=function(e){return!0===e?Xe(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort},Oi.weekdaysParse=function(e,t,i){var n,o,s;if(this._weekdaysParseExact)return Qe.call(this,e,t,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(o=f([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(o,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(o,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(o,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(s="^"+this.weekdays(o,"")+"|^"+this.weekdaysShort(o,"")+"|^"+this.weekdaysMin(o,""),this._weekdaysParse[n]=new RegExp(s.replace(".",""),"i")),i&&"dddd"===t&&this._fullWeekdaysParse[n].test(e))return n;if(i&&"ddd"===t&&this._shortWeekdaysParse[n].test(e))return n;if(i&&"dd"===t&&this._minWeekdaysParse[n].test(e))return n;if(!i&&this._weekdaysParse[n].test(e))return n}},Oi.weekdaysRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(u(this,"_weekdaysRegex")||(this._weekdaysRegex=et),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)},Oi.weekdaysShortRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(u(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=tt),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Oi.weekdaysMinRegex=function(e){return this._weekdaysParseExact?(u(this,"_weekdaysRegex")||nt.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(u(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=it),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Oi.isPM=function(e){return"p"===(e+"").toLowerCase().charAt(0)},Oi.meridiem=function(e,t,i){return e>11?i?"pm":"PM":i?"am":"AM"},pt("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===x(e%100/10)?"th":1===t?"st":2===t?"nd":3===t?"rd":"th")}}),o.lang=D("moment.lang is deprecated. Use moment.locale instead.",pt),o.langData=D("moment.langData is deprecated. Use moment.localeData instead.",mt);var Ei=Math.abs;function Ci(e,t,i,n){var o=$t(t,i);return e._milliseconds+=n*o._milliseconds,e._days+=n*o._days,e._months+=n*o._months,e._bubble()}function Pi(e){return e<0?Math.floor(e):Math.ceil(e)}function Ii(e){return 4800*e/146097}function Fi(e){return 146097*e/4800}function Ni(e){return function(){return this.as(e)}}var Yi=Ni("ms"),Ri=Ni("s"),ji=Ni("m"),Ai=Ni("h"),zi=Ni("d"),Bi=Ni("w"),Li=Ni("M"),Hi=Ni("Q"),Wi=Ni("y");function Vi(e){return function(){return this.isValid()?this._data[e]:NaN}}var Ui=Vi("milliseconds"),Gi=Vi("seconds"),qi=Vi("minutes"),Zi=Vi("hours"),Xi=Vi("days"),$i=Vi("months"),Ki=Vi("years"),Ji=Math.round,Qi={ss:44,s:45,m:45,h:22,d:26,M:11};function en(e,t,i,n,o){return o.relativeTime(t||1,!!i,e,n)}var tn=Math.abs;function nn(e){return(e>0)-(e<0)||+e}function on(){if(!this.isValid())return this.localeData().invalidDate();var e,t,i=tn(this._milliseconds)/1e3,n=tn(this._days),o=tn(this._months);e=k(i/60),t=k(e/60),i%=60,e%=60;var s=k(o/12),r=o%=12,a=n,h=t,d=e,l=i?i.toFixed(3).replace(/\.?0+$/,""):"",u=this.asSeconds();if(!u)return"P0D";var c=u<0?"-":"",f=nn(this._months)!==nn(u)?"-":"",p=nn(this._days)!==nn(u)?"-":"",v=nn(this._milliseconds)!==nn(u)?"-":"";return c+"P"+(s?f+s+"Y":"")+(r?f+r+"M":"")+(a?p+a+"D":"")+(h||d||l?"T":"")+(h?v+h+"H":"")+(d?v+d+"M":"")+(l?v+l+"S":"")}var sn=zt.prototype;return sn.isValid=function(){return this._isValid},sn.abs=function(){var e=this._data;return this._milliseconds=Ei(this._milliseconds),this._days=Ei(this._days),this._months=Ei(this._months),e.milliseconds=Ei(e.milliseconds),e.seconds=Ei(e.seconds),e.minutes=Ei(e.minutes),e.hours=Ei(e.hours),e.months=Ei(e.months),e.years=Ei(e.years),this},sn.add=function(e,t){return Ci(this,e,t,1)},sn.subtract=function(e,t){return Ci(this,e,t,-1)},sn.as=function(e){if(!this.isValid())return NaN;var t,i,n=this._milliseconds;if("month"===(e=Y(e))||"quarter"===e||"year"===e)switch(t=this._days+n/864e5,i=this._months+Ii(t),e){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(t=this._days+Math.round(Fi(this._months)),e){case"week":return t/7+n/6048e5;case"day":return t+n/864e5;case"hour":return 24*t+n/36e5;case"minute":return 1440*t+n/6e4;case"second":return 86400*t+n/1e3;case"millisecond":return Math.floor(864e5*t)+n;default:throw new Error("Unknown unit "+e)}},sn.asMilliseconds=Yi,sn.asSeconds=Ri,sn.asMinutes=ji,sn.asHours=Ai,sn.asDays=zi,sn.asWeeks=Bi,sn.asMonths=Li,sn.asQuarters=Hi,sn.asYears=Wi,sn.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*x(this._months/12):NaN},sn._bubble=function(){var e,t,i,n,o,s=this._milliseconds,r=this._days,a=this._months,h=this._data;return s>=0&&r>=0&&a>=0||s<=0&&r<=0&&a<=0||(s+=864e5*Pi(Fi(a)+r),r=0,a=0),h.milliseconds=s%1e3,e=k(s/1e3),h.seconds=e%60,t=k(e/60),h.minutes=t%60,i=k(t/60),h.hours=i%24,r+=k(i/24),o=k(Ii(r)),a+=o,r-=Pi(Fi(o)),n=k(a/12),a%=12,h.days=r,h.months=a,h.years=n,this},sn.clone=function(){return $t(this)},sn.get=function(e){return e=Y(e),this.isValid()?this[e+"s"]():NaN},sn.milliseconds=Ui,sn.seconds=Gi,sn.minutes=qi,sn.hours=Zi,sn.days=Xi,sn.weeks=function(){return k(this.days()/7)},sn.months=$i,sn.years=Ki,sn.humanize=function(e){if(!this.isValid())return this.localeData().invalidDate();var t=this.localeData(),i=function(e,t,i){var n=$t(e).abs(),o=Ji(n.as("s")),s=Ji(n.as("m")),r=Ji(n.as("h")),a=Ji(n.as("d")),h=Ji(n.as("M")),d=Ji(n.as("y")),l=o<=Qi.ss&&["s",o]||o<Qi.s&&["ss",o]||s<=1&&["m"]||s<Qi.m&&["mm",s]||r<=1&&["h"]||r<Qi.h&&["hh",r]||a<=1&&["d"]||a<Qi.d&&["dd",a]||h<=1&&["M"]||h<Qi.M&&["MM",h]||d<=1&&["y"]||["yy",d];return l[2]=t,l[3]=+e>0,l[4]=i,en.apply(null,l)}(this,!e,t);return e&&(i=t.pastFuture(+this,i)),t.postformat(i)},sn.toISOString=on,sn.toString=on,sn.toJSON=on,sn.locale=oi,sn.localeData=ri,sn.toIsoString=D("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",on),sn.lang=si,V("X",0,0,"unix"),V("x",0,0,"valueOf"),le("x",se),le("X",/[+-]?\d+(\.\d{1,3})?/),pe("X",(function(e,t,i){i._d=new Date(1e3*parseFloat(e,10))})),pe("x",(function(e,t,i){i._d=new Date(x(e))})),o.version="2.24.0",i=Nt,o.fn=xi,o.min=function(){return jt("isBefore",[].slice.call(arguments,0))},o.max=function(){return jt("isAfter",[].slice.call(arguments,0))},o.now=function(){return Date.now?Date.now():+new Date},o.utc=f,o.unix=function(e){return Nt(1e3*e)},o.months=function(e,t){return Mi(e,t,"months")},o.isDate=d,o.locale=pt,o.invalid=m,o.duration=$t,o.isMoment=w,o.weekdays=function(e,t,i){return Ti(e,t,i,"weekdays")},o.parseZone=function(){return Nt.apply(null,arguments).parseZone()},o.localeData=mt,o.isDuration=Bt,o.monthsShort=function(e,t){return Mi(e,t,"monthsShort")},o.weekdaysMin=function(e,t,i){return Ti(e,t,i,"weekdaysMin")},o.defineLocale=vt,o.updateLocale=function(e,t){if(null!=t){var i,n,o=dt;null!=(n=ft(e))&&(o=n._config),t=P(o,t),(i=new I(t)).parentLocale=lt[e],lt[e]=i,pt(e)}else null!=lt[e]&&(null!=lt[e].parentLocale?lt[e]=lt[e].parentLocale:null!=lt[e]&&delete lt[e]);return lt[e]},o.locales=function(){return M(lt)},o.weekdaysShort=function(e,t,i){return Ti(e,t,i,"weekdaysShort")},o.normalizeUnits=Y,o.relativeTimeRounding=function(e){return void 0===e?Ji:"function"==typeof e&&(Ji=e,!0)},o.relativeTimeThreshold=function(e,t){return void 0!==Qi[e]&&(void 0===t?Qi[e]:(Qi[e]=t,"s"===e&&(Qi.ss=t-1),!0))},o.calendarFormat=function(e,t){var i=e.diff(t,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},o.prototype=xi,o.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},o}()})),cl="undefined"!=typeof window&&window.moment||ul,fl=Object.freeze({__proto__:null,default:cl,__moduleExports:cl}),pl={Images:ga,dotparser:zo,gephiParser:Lo,allOptions:Jd,convertDot:jo,convertGephi:Bo},vl=Object.freeze({__proto__:null,network:pl,DOMutil:ll,util:so,data:lh,moment:fl,Hammer:Jr,keycharm:Vo,DataSet:ah,DataView:hh,Queue:Qa,Network:tl});export default vl;export{ll as DOMutil,ah as DataSet,hh as DataView,Jr as Hammer,tl as Network,Qa as Queue,lh as data,Vo as keycharm,fl as moment,pl as network,so as util};
//# sourceMappingURL=vis-network.esm.min.js.map
